#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "test_ball4xi.py">
#<abstract4xi abstract = "tests ball4xi"/>
#<verify4xi verification = "11" target = "ball4xi.py"/>
#<contextualize4xi context = "verb4xi.py"/>
#<use4xi usage = "
# RUN
#    > call t  test_ball4xi > ..\txt\test_ball4xi.txt
#
# SEE with editor
#    test_ball4xi.txt
#
#    trace everything by  OF TEST_BALL4XI or:
#1)  STARTING TEST_BALL4XI
#2)  trace OF TEST_BALL4XI in test_ball4xi.txt
#3)  CREATED QUEUE2BALL, QUEUE2SHOT, QUEUE2CLUSTER, QUEUE2SUPER,  
#4)  CREATED PIPE2BALL_CONSUMER_CHANNEL, CREATED PIPE2SHOT_CONSUMER_CHANNEL, CREATED PIPE2CLUSTER_PUBLISHER_CHANNEL, CREATED PIPE2SUPER_PUBLISHER_CHANNEL
#5)  CREATED PROCESS FOR BALL, CREATED PROCESS FOR SHOT, CREATED PROCESS FOR CLUSTER, CREATED PROCESS FOR SUPER, 
#6)  STARTED BALL PROCESS, STARTED SHOT PROCESS, STARTED CLUSTER PROCESS, STARTED SUPER PROCESS, 
#7)  BALL PROCESS STATUS ... SUPER PROCESS STATUS
#8)  RUN BALL PROCESS ... RUN SUPER PROCESS:
#9)  COMPLETED TRYING TO GET FROM QUEUE2BALL ... COMPLETED TRYING TO GET FROM QUEUE2SUPER
#10) RECEIVED FROM <-- such as PIPE2BALL
#11) SMART SHOOTING <-- trace to see main steps
#12) ALL MULTIPROCESSING4XI TESTS TRIED <-- check ending
#13) ** FAILED <-- se if any
#14) PERFORMED PRINT_TRACE4XI <-- see that trace is ok to build XML! 
#
# VIEW with browser:
#   test_ball4xi.txt
#   sense-test-test-ball4xi.xml
#   reason-test-test-ball4xi.xml
#   ace-test-test-ball4xi.xml
#
# NOTE:
#   have coffee, this test takes some time!
#"
#/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'main',
            'print_trace4xi',
            'test_ball4xi',            
            'set_trace4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "

from ball4xi import Ball4Xi
from ball4xi import init_ball4xi
from ball4xi import set_ball4xi
from ball4xi import get_ball4xi

from current_process4xi import get_current_process4xi            
from current_process4xi import get_identity_current_process4xi
from current_process4xi import get_name_current_process4xi

from dummyprocess4xi import DummyProcess4Xi

from pickle4xi import pickle4xi
from pickle2a4xi import Pickle2a4Xi 
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi

from pipe4xi import Pipe4Xi 
     
from print4xi import Print4Xi
from print4xi import print4xi
from print4xi import set_print_permission4xi

from process4xi import Process4Xi

from queue4xi  import Queue4Xi

from time4xi import time4xi

from xml_trace_sense4xi import xml_trace_sense4xi
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi



#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global t2xi 
global trace_object_count
global PickleKB4Xi

global ack4queues
global nack4queues

global ack4pipes
global nack4pipes

global ack4process
global nack4process

global ack4start
global nack4start   
        
global ack4run
global nack4run

global queue2ball
global pipe2ball_consumer_channel
global pipe2ball_publisher_channel
global process2ball

global queue2shot
global pipe2shot_consumer_channel
global pipe2shot_publisher_channel
global process2shot

global queue2cluster
global pipe2cluster_consumer_channel
global pipe2cluster_publisher_channel
global process2cluster

global queue2super
global pipe2super_consumer_channel
global pipe2super_publisher_channel
global process2super

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi}
       
# -------------------------------------------------------------------------------------------------
# 
# -------------------------------------------------------------------------------------------------       
ack4queues = False
nack4queues = True

ack4pipes = False
nack4pipes = True

ack4process = False
nack4process = True

ack4start = False
nack4start = True   
 
ack4run = False
nack4run = True       

queue2ball = None
pipe2ball_consumer_channel = None
pipe2ball_publisher_channel = None
process2ball = None

queue2shot = None
pipe2shot_consumer_channel = None
pipe2shot_publisher_channel = None
process2shot = None

queue2cluster = None
pipe2cluster_consumer_channel = None
pipe2cluster_publisher_channel = None
process2cluster = None

queue2super = None
pipe2super_consumer_channel = None
pipe2super_publisher_channel = None
process2super = None
                         
        
#"
#"/>
    
# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4xi" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 0A/33) OF SET2TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 0B/33) OF SET2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4XI - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4xi" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) of DENY2TRACE4XI: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 01B/33) OF DENY2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4XI - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4XI - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4XI - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4XI - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4XI *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4XI - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4XI - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 033/33) OF SET2TRACE4XI - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 001A/33) OF TAILOR2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
        'Pipe4Xi': 'NACK4TRACE',
        'PipeConnection4Xi': 'NACK4TRACE',      
        'Popen4Xi': 'NACK4TRACE',
        'Process4Xi': 'NACK4TRACE',
        'Queue4Xi': 'NACK4TRACE',
        '_MainProcess4Xi': 'NACK4TRACE',
        '_ConnectionBase4Xi': 'NACK4TRACE'        
        }                             

    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # 
        
    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    #

    
#</function4xi>       

     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print_trace4xi" usage = "
# prints trace for ball4xi
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(t2xi):
       

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': '..\\..\\xml\\sense-test-ball4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi2.com/sense/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing Ball in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">Classes, Methods and Messages for Ball in Multiprocessing.</rdfs:comment>\n'}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..\\..\\xml\\reason-test-ball4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for Ball in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations Ball in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n'}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..\\..\\xml\\ace-test-ball4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Ball in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Ball in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n'}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
                   
    
             
# -----------------------------------------------------------------------------------------------------
#<function4xi function = "shoot2ball" usage = "
#   shoots to ball
#"> 
# -----------------------------------------------------------------------------------------------------
       
def shoot2ball(target, queue, pipe):
    
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    
    target2shoot = target
    
    print('=' *33)
    print("(STEP 1/6) OF SHOOTBALL TARGET2SHOOT: ", target2shoot) 
    print('=' *33)
    #1 {'0x0y0z': {'x2ball': 0, 'z2ball': 0, 'color2ball': '#F5E8E8', 'y2ball': 0, 'id2ball': '0x0y0z', 'verb2ball': 'skeletonize'}}  
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     

    queue2shoot = queue
    
    print('~' *33)
    print("(STEP 2/6) OF SHOOTBALL QUEUE2SHOOT: ", queue2shoot)
    print('~' *33)
    #1 <queue4xi.Queue4Xi object at 0x02EF0970> 
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    
    pipe_publisher_channel2shoot = pipe    
    
    print('~' *33)
    print("(STEP 3/6) OF SHOOTBALL PIPE PUBLISHER CHANNEL 2SHOOT: ", pipe_publisher_channel2shoot)
    print('~' *33)
    #1 <read-write PipeConnection, handle 332> 
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
        
    queue2shoot.put(['shoot2ball4xi', target2shoot]) 
    
    
    print('~' *33)
    print("(STEP 4/6) OF SHOOTBALL QUEUE2SHOOT: ", queue2shoot)
    print('~' *33)
    #1 <queue4xi.Queue4Xi object at 0x02EF0970>
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    
    print('~' *33)
    print("(STEP 4/6) OF SHOOTBALL SENDING DATA TO THE PIPE PUBLISHER END", pipe_publisher_channel2shoot)
    print('~' *33)
    # <read-write PipeConnection, handle 332> 
         
    # ---------------------------------------------------------------------------------------------
    # send data to the pipe's publisher end 
    # ---------------------------------------------------------------------------------------------
    pipe_publisher_channel2shoot.send(['shot2ball4xi', target2shoot])

    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    
    print('=' *33)
    print("(STEP 5/6) OF SHOOTBALL SENT ALL DATA TO THE PIPE PUBLISHER END", pipe_publisher_channel2shoot)
    print('=' *33)
    # <read-write PipeConnection, handle 332> 
    
    print('=' *33)
    print("(STEP 6/6) OF SHOOTBALL DONE TARGET: ", target2shoot)
    print('=' *33)
    # {'0x0y0z': {'x2ball': 0, 'z2ball': 0, 'color2ball': '#F5E8E8', 'y2ball': 0, 'id2ball': '0x0y0z', 'verb2ball': 'skeletonize'}}
    
#</function4xi>

             
# -----------------------------------------------------------------------------------------------------
#<function4xi function = "shoot2shot" usage = "
#   shooting shots
#"> 
# -----------------------------------------------------------------------------------------------------
       
def shoot2shot(target, queue, pipe):
    
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    
    target2shoot = target
    
    print('=' *33)
    print("(STEP 1/6) OF SHOOT2SHOT TARGET2SHOOT: ", target2shoot) 
    print('=' *33)
    # {'0x14y14z': {'x2shot': 0, 'verb2shot': '0', 'area2shot': 1256.6370614359173, 'id2shot': '0x14y14z', 'distance2shot': 20, 'z2shot': 14, 'color2shot': '#F3881C', 'y2shot': 14}}  
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     

    queue2shoot = queue
    
    print('~' *33)
    print("(STEP 2/6) OF SHOOT2SHOT QUEUE2SHOOT: ", queue2shoot)
    print('~' *33)
    # <queue4xi.Queue4Xi object at 0x02DF9B10>
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    
    pipe_publisher_channel2shoot = pipe    
    
    print('~' *33)
    print("(STEP 3/6) OF SHOOT2SHOT PIPE PUBLISHER CHANNEL 2SHOOT: ", pipe_publisher_channel2shoot)
    print('~' *33)
    # <read-write PipeConnection, handle 340>
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
        
    queue2shoot.put(['shoot2shot4xi', target2shoot]) 
    
    
    print('~' *33)
    print("(STEP 4/6) OF SHOOT2SHOT QUEUE2SHOOT: ", queue2shoot)
    print('~' *33)
    # <queue4xi.Queue4Xi object at 0x02DF9B10>
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    
    print('~' *33)
    print("(STEP 4/6) OF SHOOT2SHOT SENDING DATA TO THE PIPE PUBLISHER END", pipe_publisher_channel2shoot)
    print('~' *33)
    # <read-write PipeConnection, handle 340>
         
    # ---------------------------------------------------------------------------------------------
    # send data to the pipe's publisher end 
    # ---------------------------------------------------------------------------------------------
    pipe_publisher_channel2shoot.send(['shot2shot4xi', target2shoot])

    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    
    print('=' *33)
    print("(STEP 5/6) OF SHOOT2SHOT SENT ALL DATA TO THE PIPE PUBLISHER END", pipe_publisher_channel2shoot)
    print('=' *33)
    # <read-write PipeConnection, handle 340> 
    
    print('=' *33)
    print("(STEP 6/6) OF SHOOT2SHOT DONE TARGET: ", target2shoot)
    print('=' *33)
    # 
    
#</function4xi>
 
             
# -----------------------------------------------------------------------------------------------------
#<function4xi function = "shoot2cluster" usage = "
#   shoots to cluster
#"> 
# -----------------------------------------------------------------------------------------------------
       
def shoot2cluster(target, queue, pipe):
    
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    
    target2shoot = target
    
    print('=' *33)
    print("(STEP 1/6) OF SHOOT2CLUSTER TARGET2SHOOT: ", target2shoot) 
    print('=' *33)
    # {'0x70y70z': {'x2shot': 0, 'verb2shot': '0', 'area2shot': 31415.926535897932, 'id2shot': '0x70y70z', 'distance2shot': 100, 'z2shot': 70, 'color2shot': '#F3881C', 'y2shot': 70}} 
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     

    queue2shoot = queue
    
    print('~' *33)
    print("(STEP 2/6) OF SHOOT2CLUSTER QUEUE2SHOOT: ", queue2shoot)
    print('~' *33)
    #
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    
    pipe_publisher_channel2shoot = pipe    
    
    print('~' *33)
    print("(STEP 3/6) OF SHOOT2CLUSTER PIPE PUBLISHER CHANNEL 2SHOOT: ", pipe_publisher_channel2shoot)
    print('~' *33)
    #
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
        
    queue2shoot.put(['shoot2cluster4xi', target2shoot]) 
    
    
    print('~' *33)
    print("(STEP 4/6) OF SHOOT2CLUSTER QUEUE2SHOOT: ", queue2shoot)
    print('~' *33)
    #
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    
    print('~' *33)
    print("(STEP 4/6) OF SHOOT2CLUSTER SENDING DATA TO THE PIPE PUBLISHER END", pipe_publisher_channel2shoot)
    print('~' *33)
    # 
         
    # ---------------------------------------------------------------------------------------------
    # send data to the pipe's publisher end 
    # ---------------------------------------------------------------------------------------------
    pipe_publisher_channel2shoot.send(['shot2cluster4xi', target2shoot])

    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    
    print('=' *33)
    print("(STEP 5/6) OF SHOOT2CLUSTER SENT ALL DATA TO THE PIPE PUBLISHER END", pipe_publisher_channel2shoot)
    print('=' *33)
    #
    
    print('=' *33)
    print("(STEP 6/6) OF SHOOT2CLUSTER DONE TARGET: ", target2shoot)
    print('=' *33)
    # 
    
#</function4xi>
             
# -----------------------------------------------------------------------------------------------------
#<function4xi function = "shoot2super" usage = "
#   shoots to super
#"> 
# -----------------------------------------------------------------------------------------------------
       
def shoot2super(target, queue, pipe):
    
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    
    target2shoot = target
    
    print('=' *33)
    print("(STEP 1/6) OF SHOOT2SUPER TARGET2SHOOT: ", target2shoot) 
    print('=' *33)
    # {'0x707y707z': {'x2shot': 0, 'verb2shot': '0', 'area2shot': 3141592.653589793, 'id2shot': '0x707y707z', 'distance2shot': 1000, 'z2shot': 707, 'color2shot': '#F3881C', 'y2shot': 707}} 
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     

    queue2shoot = queue
    
    print('~' *33)
    print("(STEP 2/6) OF SHOOT2SUPER QUEUE2SHOOT: ", queue2shoot)
    print('~' *33)
    #
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    
    pipe_publisher_channel2shoot = pipe    
    
    print('~' *33)
    print("(STEP 3/6) OF SHOOT2SUPER PIPE PUBLISHER CHANNEL 2SHOOT: ", pipe_publisher_channel2shoot)
    print('~' *33)
    #
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
        
    queue2shoot.put(['shoot2super4xi', target2shoot]) 
    
    
    print('~' *33)
    print("(STEP 4/6) OF SHOOT2SUPER QUEUE2SHOOT: ", queue2shoot)
    print('~' *33)
    #
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    
    print('~' *33)
    print("(STEP 4/6) OF SHOOT2SUPER SENDING DATA TO THE PIPE PUBLISHER END", pipe_publisher_channel2shoot)
    print('~' *33)
    # 
         
    # ---------------------------------------------------------------------------------------------
    # send data to the pipe's publisher end 
    # ---------------------------------------------------------------------------------------------
    pipe_publisher_channel2shoot.send(['shot2super4xi', target2shoot])

    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    
    print('=' *33)
    print("(STEP 5/6) OF SHOOT2SUPER SENT ALL DATA TO THE PIPE PUBLISHER END", pipe_publisher_channel2shoot)
    print('=' *33)
    #
    
    print('=' *33)
    print("(STEP 6/6) OF SHOOT2SUPER DONE TARGET: ", target2shoot)
    print('=' *33)
    # 
    
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "shoot4xi" usage = "creating balls">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def shoot4xi(start2distance = None, interval2distance = None, max2layer = None, marginal2layer = None, max2count = None,
             marginal2count = None, sign2x = None, sign2y = None, sign2z = None, max2iterate = None,
             start2plusa = None, max2plusa = None, min2plusa = None, start2minusa = None, max2minusa = None, min2minusa = None,
             start2pluse = None, max2pluse = None, min2pluse = None, start2minuse = None, max2minuse = None, min2minuse = None,
             increase2distance = None, change2a = None, change2e = None, increase2a = None, increase2e = None ):
    '''
    shoots according to required parameters
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    print("\n (STEP 1A/33) OF SHOOT4XI - STARTED TIME: ", time2start) 
    print("\n (STEP 1B1/33) OF TEST_BALL4XI - START TO DISTANCE: ", start2distance) 
    print("\n (STEP 1B2/33) OF TEST_BALL4XI - INTERVAL TO DISTANCE: ", interval2distance)
    print("\n (STEP 1B3/33) MAX TO LAYER: ", max2layer)    
    print("\n (STEP 1B4/33) MARGINAL TO LAYER: ", marginal2layer)
    print("\n (STEP 1B5/33) SIGN TO X: ", sign2x)       
    print("\n (STEP 1B6/33) SIGN TO Y: ", sign2y)
    print("\n (STEP 1B7/33) SIGN TO Z: ", sign2z)    
    print("\n (STEP 1B8/33) OF TEST_BALL4XI - START TO PLUS AZIMUTH: ", start2plusa)
    print("\n (STEP 1B9/33) MAX TO PLUS AZIMUTH: ", max2plusa)       
    print("\n (STEP 1B10/33) MIN TO PLUS AZIMUTH: ", min2plusa)
    print("\n (STEP 1B11/33) OF TEST_BALL4XI - START TO MINUS AZIMUTH: ", start2minusa)
    print("\n (STEP 1B12/33) MAX TO MINUS AZIMUTH: ", max2minusa)
    print("\n (STEP 1B13/33) MIN TO MINUS AZIMUTH: ", min2minusa)    
    print("\n (STEP 1B14/33) OF TEST_BALL4XI - START TO PLUS ELEVATION: ", start2pluse)
    print("\n (STEP 1B15/33) MAX TO PLUS ELEVATION: ", max2pluse)
    print("\n (STEP 1B16/33) MIN TO PLUS ELEVATION: ", min2pluse)
    print("\n (STEP 1B17/33) OF TEST_BALL4XI - START TO MINUS ELEVATION: ", start2minuse) 
    print("\n (STEP 1B18/33) MAX TO MINUS ELEVATION: ", max2minuse)
    print("\n (STEP 1B19/33) MIN TO MINUS ELEVATION: ", min2minuse)
    print("\n (STEP 1B20/33) INCREASE TO DISTANCE: ", increase2distance)
    print("\n (STEP 1B21/33) CHANGE TO AZIMUTH: ", change2a) 
    print("\n (STEP 1B22/33) CHANGE TO ELEVATION: ", change2e)           
    print("\n (STEP 1B23/33) INCREASE TO AZIMUTH: ", increase2a)  
    print("\n (STEP 1B24/33) INCREASE TO ELEVATION: ", increase2e)  
                                                      
    # =================================================================================================                   
    # INITIALIZATIONS
    # =================================================================================================         
    print("\n (STEP 2A/33) OF SHOOT4XI - INITIALIZING BALL4XI ") 
        
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # BALL
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ball2xi = Ball4Xi(message2ball = "shoot4xi")
    print("\n (STEP 2B/33) OF SHOOT4XI - INITIALIZED BALL4XI")
     

    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # DISTANCE
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                        
    if start2distance is None:
        start2distance = 100
    start2distance4xi = int(start2distance)
    print("\n (STEP 3B/33) OF SHOOT4XI - START2DISTANCE4XI: ", start2distance4xi)
    # 100
    
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # INTERVAL
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                     
    if interval2distance is None:
        interval2distance = 100
    interval2distance4xi = int(interval2distance)  
    print("\n (STEP 4B/33) OF SHOOT4XI - INTERVAL TO DISTANCE: ", interval2distance4xi)
    # 100
    
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # MAX PER LAYER WITH MARGINAL
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    if max2layer is None:
        max2layer = 100
    max2layer4xi = int(max2layer)
    
    if marginal2layer is None:                              
        marginal2layer = 1.2
    marginal2layer4xi = marginal2layer
        
    omax2layer4xi = max2layer4xi
    
    max2layer4xi = int(marginal2layer4xi * max2layer4xi)
    print("\n (STEP 5A/33) OF SHOOT4XI - MAXIMUM SHOTS PER LAYER: ", max2layer4xi, " WITH MARGINAL TO LAYER: ", marginal2layer4xi) 
    # 120  WITH MARGINAL TO LAYER:  1.2
                                  
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # MAX SHOTS WITH MARGINAL
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    if max2count is None:
        max2count = 100
    max2count4xi = int(max2count) 
         
    if marginal2count is None:    
        marginal2count = 1.2
    marginal2count4xi = marginal2count     
        
    omax2count4xi = max2count4xi
    
    max2count4xi = int(marginal2count4xi * max2count4xi)
            
    print("\n (STEP 6A/33) OF SHOOT4XI - MAXIMUM SHOTS: ", max2count4xi, " MARGINAL TO COUNT: ", marginal2count4xi) 
    # 120  MARGINAL TO COUNT:  1.2

    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # TIME
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                    
    time2start4xi = time4xi()                        
    print("\n (STEP 7A/33) OF SHOOT4XI - START TIME: ", time2start4xi)
   
                                                                               
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # REQUIRED SIGNS FOR (X,Y,Z)
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    if sign2x is None:
        sign2x = '+' 
    sign2x4xi = sign2x
           
    if sign2y is None:
        sign2y = '+'
    sign2y4xi = sign2y    
    if sign2z is None:    
        sign2z = '+'
    sign2z4xi = sign2z
        
    print("\n (STEP 8A/33) OF SHOOT4XI - X-SIGN: ", sign2x4xi, 'Y-SIGN: ', sign2y4xi, 'Z-SIGN: ', sign2z4xi)
    # X-SIGN:  + Y-SIGN:  + Z-SIGN:  +     
         
                              
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # ITERATIONS 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                    
    if max2iterate is None:
        max2iterate = max2count * 21                                # success ratio may be less than 9% 
    max2iterate4xi = max2iterate
    print("\n (STEP 9A/33) OF SHOOT4XI - MAXIMUM TO ITERATIONS: ", max2iterate4xi) 
    # 
      
    # =================================================================================================                   
    # AZIMUTH
    # =================================================================================================                
                          
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # azimuth and elevation angle initialized
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # ref: http://en.wikipedia.org/wiki/Radian#Conversion_between_radians_and_degrees
    # one radian is equal to 180/p degrees <=> 1 deg = rad * 180 / pi                             
    # pi/6 = 30, pi/4 = 45, pi/3 = 60, pi/2 = 90, 2/3*pi = 120, 3/4pi=135, 5/6*pi = 150, pi = 180
    # 7/6*pi = 210, 5/4*pi = 225...3*pi/2 = 270, 5*pi/3 = 300 ... 2*pi = 0 or 360 degrees
    # I   = 0...90    (0...pi/2) :     sin+, cos+
    # II  = 90...180  (pi/2...pi):     sin+, cos- 
    # III = 180...270 (pi...3*pi/2):   sin-, cos-
    # IV  = 270...360 (3*pi/2...2*pi): sin-, cos+
    # ref: http://en.wikipedia.org/wiki/Azimuth
                                                            
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
    if start2plusa is None:
        start2plusa = pi/6                      # start plus azimuth 30 degrees - iterates smaller
    start2plusa4xi = start2plusa                                                               
    print("\n (STEP 10A/33) OF SHOOT4XI - START TO PLUS AZIMUTH: ", start2plusa4xi) 
    # 0.523598775598
                                     
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
    if max2plusa is None:
        max2plusa = 2*pi                        # extreme plus azimuth 360 degrees around sideways
    max2plusa4xi = max2plusa    
    print("\n (STEP 10B/33) OF SHOOT4XI - MAX TO PLUS AZIMUTH: ", max2plusa4xi) 
    # 6.28318530718
                                                         
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
    if min2plusa is None:
        min2plusa = pi/240                      # minum positive azimuth 0.75 degrees sideways 
    min2plusa4xi = min2plusa    
    print("\n (STEP 10C/33) OF SHOOT4XI - MIN TO PLUS AZIMUTH: ", min2plusa4xi) 
    # 0.01308996939                                      
                              
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
    if start2minusa is None:
        start2minusa = -pi/6                    # start minus azimuth -30 degrees sideways 
    start2minusa4xi = start2minusa
                                                                  
    print("\n (STEP 10D/33) OF SHOOT4XI - START TO MINUS AZIMUTH: ", start2minusa4xi) 
    # -0.523598775598
                  
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
    if max2minusa is None:
        max2minusa = -0.98*2*pi                 # extreme minus azimuth almost -360 degrees 
    max2minusa4xi = max2minusa    
    print("\n (STEP 10E/33) OF SHOOT4XI - MAX TO MINUS AZIMUTH: ", max2minusa4xi) 
    # -6.15752160104
                                                            
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
    if min2minusa is None:
        min2minusa = -pi/240                    # nearest to zero minus to azimuth
    min2minusa4xi = min2minusa    
    print("\n (STEP 10F/33) MIN TO MINUS AZIMUTH: ", min2minusa4xi) 
    # -0.01308996939

    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
    if increase2a is None:
        increase2a = 0.01                       # increase to azimuth
    increase2a4xi = increase2a    
    print("\n (STEP 10G/33) INCREASE2A4XI: ", increase2a4xi)     
    
                                                          
    # =================================================================================================                   
    # ELEVATION
    # =================================================================================================                
                                      
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
    if start2pluse is None:
        start2pluse = pi/6                      # start plus elevation 30 degrees up 
    start2pluse4xi = start2pluse    
    print("\n (STEP 11A/33) OF SHOOT4XI - START TO PLUS ELEVATION: ", start2pluse4xi) 
    # 0.523598775598
                                          
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
    if max2pluse is None:
        max2pluse = pi                          # most flexible elevation 180 degrees 
    max2pluse4xi = max2pluse    
    print("\n (STEP 11B/33) OF SHOOT4XI - MAX TO PLUS ELEVATION: ", max2pluse4xi) 
    # 3.14159265359
                      
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
    if min2pluse is None:
        min2pluse = pi/240                      # lowest plus to elevation 0.75 degrees                          
    min2pluse4xi = min2pluse    
    print("\n (STEP 11C/33) OF SHOOT4XI - MIN TO PLUS ELEVATION: ", min2pluse4xi) 
    # 0.01308996939
                                   
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
    if start2minuse is None:
        start2minuse = -pi/6                    # start minus elevation -30 degrees down                                                
    start2minuse4xi = start2minuse    
    print("\n (STEP 11D/33) OF SHOOT4XI - START TO MINUS ELEVATION: ", start2minuse4xi) 
    # -0.523598775598
    
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                      
    if max2minuse is None:
        max2minuse = -0.98*pi                   # most painful minus elevation almost -180 degrees
    max2minuse4xi = max2minuse    
    print("\n (STEP 11E/33) OF SHOOT4XI - MAX TO MINUS ELEVATION: ", max2minuse4xi) 
    # -3.07876080052
                                                
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
    if min2minuse is None:
        min2minuse = -pi/240                    # least painful minus elevation -0.75 degrees
    min2minuse4xi = min2minuse                                  
    print("\n (STEP 11F/33) OF SHOOT4XI - MIN TO MINUS ELEVATION: ", min2minuse4xi) 
    # -0.01308996939  


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
    if increase2e is None:
        increase2e = 0.01                       # increase to elevation
    increase2e4xi = increase2e    
    print("\n (STEP 11G/33) INCREASE2E4XI: ", increase2e4xi)     
        
                                               
    # =================================================================================================      
    # ALGORITHM TUNING 
    # =================================================================================================      
                                         
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # DISTANCE INCREMENTS 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        
    if increase2distance is None:
        increase2distance = 1                   # used to control number of shots per layer
    increase2distance4xi = increase2distance    
    print("\n (STEP 12A/33) OF SHOOT4XI - INCREASE TO DISTANCE: ", increase2distance4xi) 
    # 0
                                         
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # AZIMUTH CHANGES 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    
    if change2a is None: 
        change2a = pi / 60                      # 3 degrees change to azimuth
    change2a4xi = change2a    
    print("\n (STEP 12B/33) OF SHOOT4XI - CHANGE TO AZIMUTH: ", change2a4xi) 
    # 0.0523598775598 
                                        
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # ELEVATION CHANGES 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    if change2e is None:
        change2e = pi / 60                      # 3 degrees change to elevation
    change2e4xi = change2e    
    print("\n (STEP 12C/33) OF SHOOT4XI - CHANGE TO ELEVATION: ", change2e4xi) 
    # 0.0523598775598
                                                                                                                                      
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # AZIMUTH SETTINGS BASED ON SIGN, WHICH MIGHT GET TUNED TO OPPOSITE SIGN LATER ON
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    sign2a4xi = '+'
    if sign2a4xi == '+':
        start2a4xi = start2plusa4xi
        min2a4xi = min2plusa4xi
        max2a4xi = max2plusa4xi
    else:
        start2a4xi = start2minusa4xi
        min2a4xi = min2minusa4xi
        max2a4xi = max2minusa4xi
        
    print("\n (STEP 14/33) OF SHOOT4XI - START AZIMUTH: ", start2a4xi, 'MIN AZIMUTH: ', min2a4xi, 'MAX AZIMUTH: ', max2a4xi) 
    # 0.523598775598 MIN AZIMUTH:  0.01308996939 MAX AZIMUTH:  6.28318530718
                                                                                                                   
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # ELEVATION SETTINGS BASED ON SIGN, WHICH MIGHT GET TUNED TO OPPOSITE SIGN LATER ON
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    sign2e4xi = '+'
    if sign2e4xi == '+':
       start2e4xi = start2pluse4xi
       min2e4xi = min2pluse4xi
       max2e4xi = max2pluse4xi
    else:
       start2e4xi = start2minuse4xi
       min2e4xi = min2minuse4xi
       max2e4xi = max2minuse4xi
            
    print("\n (STEP 15/33) OF SHOOT4XI - START ELEVATION: ", start2e4xi, 'MIN ELEVATION: ', min2e4xi, 'MAX ELEVATION: ', max2e4xi) 
    # 0.523598775598 MIN ELEVATION:  0.01308996939 MAX ELEVATION:  3.14159265359
                                                                                                                    
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # AZIMUTH START SETTING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                              
    a2shot4xi = start2a4xi 
                                                                                                                    
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # ELEVATION START SETTING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                              
    e2shot4xi = start2e4xi                            
                                                                                                              
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # DISTANCE START SETTING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                          
    d2shot4xi = start2distance4xi

    print("\n (STEP 16/33) OF SHOOT4XI - START AZIMUTH: ", a2shot4xi, ' START ELEVATION: ', e2shot4xi, ' START DISTANCE: ', d2shot4xi) 
    # 0.523598775598  START ELEVATION:  0.523598775598  START DISTANCE:  100
           
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # initializations for while loop 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    count2shot = 0                                   # shots
    
    count2layer = 1                                  # layers                                                           
    
    count2ok = 0                                     # ok shots with all of (x,y,z) ok 
    
    count2distance = 0                               # measures shot per layer                       
    
    count2iterate = 0                                # hunting for right (x,y,z) combination
    
    count2rejected = 0                               # rejected
    
    ack2x = False                                    # validation for x-coordinate
    nack2x = True
    
    ack2y = False                                    # validation for y-coordinate
    nack2y = True                    
    
    ack2z = False                                    # validation for z-coordinate
    nack2z = True
    
    print("\n (STEP 17A/33) OF SHOOT4XI - START TIME OF SHOOTING: ", time4xi(), " FOR ", max2count4xi, " SHOTS")
    # 06:18:02 06/10/10 Pacific Daylight Time  FOR  120  SHOTS
    print("\n (STEP 17B/33) OF SHOOT4XI - COUNT2OK: ", count2ok, " MAX2COUNT4XI: ", max2count4xi, " COUNT2ITERATE: ", count2iterate, " MAX2ITERATE4XI: ", max2iterate4xi)
    # COUNT2OK:  0  MAX2COUNT4XI:  120  COUNT2ITERATE:  0  MAX2ITERATE4XI:  1500
       
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                             
    while ((count2ok <= max2count4xi) and (count2iterate < max2iterate4xi)):   
        # ok shots staying less or equal to that of required amount & iterations not exceeding maximum  
            
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # 
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        count2iterate = count2iterate + 1    
        
        
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # AZIMUTH CHANGES
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        if a2shot4xi >= 0:        
            a2shot4xi = a2shot4xi + change2a4xi
            if a2shot4xi >= max2a4xi:
                start2a4xi = start2a4xi * 1.01
                a2shot4xi = start2a4xi 
                print("\n (STEP 18A/33) OF SHOOT4XI - AZIMUTH BECAME BIGGER THAN MAXIMUM: ", max2a4xi , " NEW AZIMUTH: ", a2shot4xi)    
        else:
            a2shot4xi = a2shot4xi - change2a4xi
            if a2shot4xi <= min2a4xi:
                start2a4xi = start2a4xi * 1.01
                a2shot4xi = start2a4xi  
                print("\n (STEP 18B/33) OF SHOOT4XI - AZIMUTH BECAME SMALLER THAN MINIMUM: ", min2a4xi , " NEW AZIMUTH: ", a2shot4xi)  
        
        print("\n (STEP 18C/33) OF SHOOT4XI - AZIMUTH CHANGES CHECKED ")  
                
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # AZIMUTH ALGORITM CHECKING AGAINST MAXIMUM ALLOWED - RESTART WITH TUNING, IF NECESSARY
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
        if (a2shot4xi >= 2*pi):
            sign2a4xi = '-'                                          # switch to negative
            change2a4xi = 0.98 * change2a4xi                         # change2a always positive
            start2a4xi = change2a4xi * start2minusa4xi               # new minus azimuth start
            a2shot4xi = start2a4xi                                   # new azimuth
            min2a4xi = min2minusa4xi                                 # new minimum to azimuth
            max2a4xi = max2minusa4xi                                 # new maximum to azimuth
            print("\n (STEP 19/33) OF SHOOT4XI - AZIMUTH BECAME BIGGER THAN 2*PI , NEW AZIMUTH: ", a2shot4xi) 
             
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # AZIMUTH ALGORITM CHECKING AGAINST MINIMUM ALLOWED- RESTART WITH TUNING, IF NECESSARY
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                             
        if (a2shot4xi <= -2*pi):
            sign2a4xi = '+'                                          # switch to positive
            change2a4xi = 0.98 * change2a4xi                         # change2a always positive
            start2a4xi = change2a4xi * start2plusa4xi                # new positive azimuth start
            a2shot4xi = start2a4xi                                   # new azimuth
            min2a4xi = min2plusa4xi                                  # new minimum to azimuth
            max2a4xi = max2plusa4xi                                  # new maximum to azimuth
            print("\n (STEP 20A/33) OF SHOOT4XI - AZIMUTH BECAME LESS THAN -2*PI, NEW AZIMUTH: ", a2shot4xi) 
        
        print("\n (STEP 20B/33) OF SHOOT4XI - AZIMUTH MAX AND MINIMUM CHANGES CHECKED ")       
    
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # ELEVATION CHANGES
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        if e2shot4xi <= 0:
            e2shot4xi = e2shot4xi - increase2e4xi
            if e2shot4xi <= min2e4xi:
                change2e4xi = 1.02 * change2e4xi
                start2e4xi = change2e4xi * start2e4xi
                e2shot4xi = start2e4xi
                print("\n (STEP 21/33) OF SHOOT4XI - ELEVATION BECAME LESS THAN MINIMUM: ", min2e4xi, " NEW ELEVATION: ", e2shot4xi)                                   
        else:
            e2shot4xi = e2shot4xi + increase2e4xi
            if e2shot4xi >= max2e4xi:
                change2e4xi = 1.08 * change2e4xi
                start2e4xi = change2e4xi * start2e4xi
                e2shot4xi = start2e4xi
                print("\n (STEP 22A/33) OF SHOOT4XI - ELEVATION BECAME BIGGER THAN MAXIMUM: ", max2e4xi, " NEW ELEVATION: ", e2shot4xi)  
        
        print("\n (STEP 22B/33) OF SHOOT4XI - ELEVATION CHANGES CHECKED ")                                                        
        
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # ELEVATION ALGORITM CHECKING AGAINST MAXIMUM ALLOWED - RESTART WITH TUNING, IF NECESSARY
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                                                   
        if (e2shot4xi >= pi):
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            # start again with a new elevation and new elevation change
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            sign2e4xi = '-'                                             # switch to negative
            change2e4xi = 0.98 * change2e4xi                            # change2e always positive
            start2e4xi = change2e4xi * start2minuse4xi                  # new minus elevation start
            e2shot4xi = start2e4xi                                      # new azimuth
            min2e4xi = min2minuse4xi                                    # new minimum to elevation
            max2e4xi = max2minuse4xi                                    # new maximum to elevation
            print("\n (STEP 23A/33) OF SHOOT4XI - ELEVATION BECAME BIGGER THAN PI, NEW ELEVATION: ", e2shot4xi)
            
        print("\n (STEP 23B/33) OF SHOOT4XI - ELEVATION MAX CHANGE CHECKED ") 
                        
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # ELEVATION ALGORITM CHECKING AGAINST MINIMUM ALLOWED- RESTART WITH TUNING, IF NECESSARY
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
        
        if (e2shot4xi <= -pi):
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            # start again with a new elevation and new elevation change
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                            
            sign2e4xi = '+'                                             # switch to positive
            change2e4xi = 0.98 * change2e4xi                            # change2e always positive
            start2e4xi = change2e4xi * start2pluse4xi                   # new positive elevation start
            e2shot4xi = start2e4xi                                      # new azimuth
            min2e4xi = min2pluse4xi                                     # new minimum to elevation
            max2e4xi = max2pluse4xi                                     # new maximum to elevation        
            print("\n (STEP 24A/33) OF SHOOT4XI - ELEVATION BECAME LESS THAN -PI, NEW ELEVATION: ", e2shot4xi)
            
        print("\n (STEP 24B/33) OF SHOOT4XI - ELEVATION MIN CHANGE CHECKED ")         
    
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # SHOOT
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        print("\n (STEP 25A/33) OF SHOOT4XI - COMMANDING TO SET WITH BALL2XI: ", ball2xi)  
        print("\n A2SHOT4XI: ", a2shot4xi)                       # 0.575958653158
        print("\n E2SHOT4XI: ", e2shot4xi)                       # 0.533598775598  
        print("\n D2SHOT4XI: ", d2shot4xi)                       # 100  
        print("\n INTERVAL2DISTANCE4XI: ", interval2distance4xi) # 100
                                                                                 
        ball2xi.set(azimuth2shot = a2shot4xi, elevation2shot = e2shot4xi, distance2shot = d2shot4xi, area2shot = int(4*pi*d2shot4xi**2/interval2distance4xi))
        
        print("\n (STEP 25B/33) OF SHOOT4XI - PERFORMED SET WITH BALL2XI: ", ball2xi)  
        # <ball4xi.Ball4Xi object at 0x02AADE10>
            
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # CHECK THE SHOT 
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        print("\n (STEP 25C/33) OF SHOOT4XI - COMMANDING TO GET WITH BALL2XI: ", ball2xi)  
        shot2examine = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes', area2shot = 'Yes')
        
        print("\n (STEP 25D/33) OF SHOOT4XI - PERFORMED COMMAND TO GET WITH BALL2XI: ", ball2xi)  
        # <ball4xi.Ball4Xi object at 0x02B6DE50>
        
        print("\n (STEP 25E/33) OF SHOOT4XI - SHOT TO EXAMINE ", count2shot, ": ", shot2examine)  
        # 0 :  {'42x27y86z': {'x2shot': 42, 'azimuth2shot': 0.5759586531581287, 'area2shot': 1256, 'id2shot': '42x27y86z', 'distance2shot': 100, 'z2shot': 86, 'elevation2shot': 0.5335987755982988, 'y2shot': 27}}  
         
        keys2examine = shot2examine.keys()
        print("\n (STEP 26A/33) OF SHOOT4XI - KEYS2EXAMINE: ", keys2examine)   
        # dict_keys(['42x27y86z'])
        
        for key2examine in sorted(keys2examine):
            print("\n (STEP 26B/33) OF SHOOT4XI - KEY2EXAMINE ", key2examine)  
            # 42x27y86z 
            
            ack2x = False 
            nack2x = True                                  
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            # X OK ?
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
            try:
                index2x=str.find(key2examine,'x')                               
                x2coordinate = int(key2examine[0:index2x])
                if x2coordinate >= 0:
                    if sign2x4xi == '+':
                        ack2x = True
                        nack2x = False
                        print("\n (STEP 27A/33) OF SHOOT4XI - X2COORDINATE ACK: ", ack2x) 
                else:
                    if sign2x4xi == '-':
                        ack2x = True
                        nack2x = False
                        print("\n (STEP 27B/33) OF SHOOT4XI - X2COORDINATE ACK: ", ack2x)
                         
            except:
                print("\n (STEP 27C/33) OF TEST_BALL4XI *** FAILED  WITH KEY2EXAMINE: ", key2examine)
                print("\n (STEP 27D/33) OF SHOOT4XI -INDEX2X: ", index2x)
                
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            # Y OK ?
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
            ack2y = False 
            nack2y = True     
            try:
                index2y=str.find(key2examine,'y')                               
                y2coordinate = int(key2examine[index2x+1:index2y])
                if y2coordinate >= 0:
                    if sign2y4xi == '+':
                        ack2y = True
                        nack2y = False
                        print("\n (STEP 27E/33) OF SHOOT4XI - Y2COORDINATE ACK: ", ack2y)                                         
                else:
                    if sign2y4xi == '-':
                        ack2y = True
                        nack2y = False
                        print("\n (STEP 27F/33) OF SHOOT4XI - Y2COORDINATE ACK: ", ack2y)                               
            except:
                print("\n (STEP 27G/33) OF SHOOT4XI - *** FAILED WITH KEY2EXAMINE: ", key2examine)
                print("\n (STEP 27H/33) OF SHOOT4XI - INDEX2Y: ", index2y)
                
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            # Z OK ?
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
            ack2z = False 
            nack2z = True                                 
            try:
                index2z=str.find(key2examine,'z')                               
                z2coordinate = int(key2examine[index2y+1:index2z])
                if z2coordinate >= 0:
                    if sign2z4xi == '+':
                        ack2z = True
                        nack2z = False
                        print("\n (STEP 27I/33) OF SHOOT4XI - Z2COORDINATE ACK: ", ack2z)                                               
                else:
                    if sign2z4xi == '-':
                        ack2z = True
                        nack2z = False
                        print("\n (STEP 27J/33) OF SHOOT4XI - Z2COORDINATE ACK: ", ack2z)                                  
            except:
                print("\n (STEP 27K/33) OF SHOOT4XI - *** FAILED WITH KEY2EXAMINE: ", key2examine)
                print("\n (STEP 27L/33) OF SHOOT4XI - INDEX2Z: ", index2z)
                
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            # (X,Y,Z) OK ?
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
            try:                                                           
                if ((ack2x is True) and (ack2y is True) and (ack2z is True)):
                    print("\n (STEP 27M1/33) OF SHOOT4XI - OK: (" , x2coordinate, ",", y2coordinate, ",", z2coordinate, ")") 
                    # ( 42 , 27 , 86 )
                    print("\n (STEP 27M2/33) OF SHOOT4XI - EXPECTED: (" , sign2x4xi, ",", sign2y4xi, ",", sign2z4xi, ")") 
                    # ( + , + , + )
                    count2ok = count2ok + 1 
                    print("\n (STEP 27M3/33) OF SHOOT4XI - COUNT2OK: " , count2ok, " MAX2LAYER4Xi: ", max2layer4xi) 
                    
                    count2distance = count2distance + increase2distance4xi      # one more shot for this layer and distance
                    print("\n (STEP 27M4/33) OF SHOOT4XI - COUNT2DISTANCE: " , count2distance, " MAX2LAYER4Xi: ", max2layer4xi)
                    # COUNT2DISTANCE:  120  MAX2LAYER4Xi:  120
                    
                    if count2distance >= max2layer4xi:
                        d2shot4xi = d2shot4xi + interval2distance4xi            # distance for the next layer
                        count2distance = 0
                        count2layer = count2layer + 1 
                        print("\n (STEP 27M5/33) OF SHOOT4XI - NEW LAYER NUMBER: ", count2layer, ' NEW DISTANCE: ', d2shot4xi)
                        # NEW LAYER NUMBER:  2  NEW DISTANCE:  200
                    else:
                        pass 

                else:
                    print("\n (STEP 27P/33) OF SHOOT4XI - REJECTED: (" , x2coordinate, ",", y2coordinate, ",", z2coordinate, ")")
                    print("\n (STEP 27Q/33) OF SHOOT4XI - EXPECTED: (" , sign2x4xi, ",", sign2y4xi, ",", sign2z4xi, ")")
                    
                    count2rejected = count2rejected + 1
                    # ( 42 , 27 , 86 )
                    # ( + , + , - )  
                    
                    
                    
                                        
            except:
                print("\n (STEP 27S/33) OF SHOOT4XI - *** FAILED WITH KEY2EXAMINE: ", key2examine)
                print("\n (STEP 27T/33) OF SHOOT4XI - INDEX2Z: ", index2z)
        
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # CONTINUE WHILE
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                    
        print("\n (STEP 28A/33) OF SHOOT4XI - CONTINUING WHILE WITH:")
        print("\n COUNT2OK:", count2ok)
        print("\n COUNT2DISTANCE:", count2distance)   
        print("\n MAX2COUNT:", max2count4xi)                        
        print("\n COUNT2ITERATE:", count2iterate)
        print("\n MAX2ITERATE:", max2iterate4xi)                        

        
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # END OF WHILE
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
             
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # EXAMINE RESULTS AFTER WHILE
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    time2end = time4xi()           
    print("\n (STEP 30A1/33) OF SHOOT4XI - STATISTICS FOR SHOOTING, WHICH ENDED: ", time2end)                           
    print("\n SHOTS OK: ", count2ok, " = ", int(100 * count2ok/max2count4xi), " %")                              
    print("\n SHOTS ORIGINALLY REQUIRED: ", omax2count4xi)      
    print("\n ITERATIONS NEEDED: ", count2iterate)                              
    print("\n ITERATIONS ALLOWED: ", max2iterate4xi) 
    print("\n REJECTED: ", count2rejected, " = ", int(100 * count2rejected/count2iterate), " %") 

    #( + , + , + )
    #  (STEP 30A1/33) OF SHOOT4XI - STATISTICS FOR SHOOTING, WHICH ENDED:  07:48:24 06/11/10 Pacific Daylight Time
    #  SHOTS OK:  241  =  100  %
    #  SHOTS ORIGINALLY REQUIRED:  200
    #  ITERATIONS NEEDED:  2494
    #  ITERATIONS ALLOWED:  4200
    #  REJECTED:  2253  =  90  %
    #  (STEP 30B1/33) OF SHOOT4XI - WHOLE BALL AFTER ALL OPERATIONS AND WITH MAX2COUNT:  240 TIME PRINTED:  07:48:24 06/11/10 Pacific Daylight Time
    #  (STEP 30B3/33) OF SHOOT4XI - SHOOTING SAMPLE OF :  240  SHOTS NUMBER OF LAYERS:  3  LATEST DISTANCE:  300  INTERVAL2DISTANCE:  100
    #  (STEP 31/33) OF SHOOT4XI - ACCEPTANCE:  1  SHOT:  1407 : 100x165y49z  EXPECTED SIGNS: ( + , + , + )
    #  (STEP 31/33) OF SHOOT4XI - ACCEPTANCE:  2  SHOT:  1409 : 102x153y76z  EXPECTED SIGNS: ( + , + , + )
    
    #( + , - , - )
    # SHOTS OK:  241  =  100  %
    # SHOTS ORIGINALLY REQUIRED:  200
    # ITERATIONS NEEDED:  1500
    # ITERATIONS ALLOWED:  4200
    # REJECTED:  1259  =  83  %
    # (STEP 30B1/33) OF SHOOT4XI - WHOLE BALL AFTER ALL OPERATIONS AND WITH MAX2COUNT:  240 TIME PRINTED:  07:49:02 06/11/10 Pacific Daylight Time
    # (STEP 30B3/33) OF SHOOT4XI - SHOOTING SAMPLE OF :  240  SHOTS NUMBER OF LAYERS:  3  LATEST DISTANCE:  300  INTERVAL2DISTANCE:  100
    
    #( + , + , - )
    # (STEP 30A1/33) OF SHOOT4XI - STATISTICS FOR SHOOTING, WHICH ENDED:  07:50:47 06/11/10 Pacific Daylight Time
    # SHOTS OK:  241  =  100  %
    # ITERATIONS NEEDED:  2521
    # ITERATIONS ALLOWED:  4200
    # REJECTED:  2280  =  90  %
    # (STEP 30B1/33) OF SHOOT4XI - WHOLE BALL AFTER ALL OPERATIONS AND WITH MAX2COUNT:  240 TIME PRINTED:  07:50:47 06/11/10 Pacific Daylight Time
    # (STEP 30B3/33) OF SHOOT4XI - SHOOTING SAMPLE OF :  240  SHOTS NUMBER OF LAYERS:  3  LATEST DISTANCE:  300  INTERVAL2DISTANCE:  100
    
    # ( + , - , + )    
    #  (STEP 30A1/33) OF SHOOT4XI - STATISTICS FOR SHOOTING, WHICH ENDED:  07:50:53 06/11/10 Pacific Daylight Time
    #  SHOTS OK:  241  =  100  %
    #  SHOTS ORIGINALLY REQUIRED:  200
    #  ITERATIONS NEEDED:  570
    #  ITERATIONS ALLOWED:  4200
    #  REJECTED:  329  =  57  %
    #  (STEP 30B1/33) OF SHOOT4XI - WHOLE BALL AFTER ALL OPERATIONS AND WITH MAX2COUNT:  240 TIME PRINTED:  07:50:53 06/11/10 Pacific Daylight Time
    #  (STEP 30B3/33) OF SHOOT4XI - SHOOTING SAMPLE OF :  240  SHOTS NUMBER OF LAYERS:  3  LATEST DISTANCE:  300  INTERVAL2DISTANCE:  100   

    #  ( - , + , + )    
    #  (STEP 30A1/33) OF SHOOT4XI - STATISTICS FOR SHOOTING, WHICH ENDED:  07:51:34 06/11/10 Pacific Daylight Time
    #  SHOTS OK:  241  =  100  %
    #  SHOTS ORIGINALLY REQUIRED:  200
    #  ITERATIONS NEEDED:  1569
    #  ITERATIONS ALLOWED:  4200
    #  REJECTED:  1328  =  84  %
    #  (STEP 30B1/33) OF SHOOT4XI - WHOLE BALL AFTER ALL OPERATIONS AND WITH MAX2COUNT:  240 TIME PRINTED:  07:51:34 06/11/10 Pacific Daylight Time
    #  (STEP 30B3/33) OF SHOOT4XI - SHOOTING SAMPLE OF :  240  SHOTS NUMBER OF LAYERS:  3  LATEST DISTANCE:  300  INTERVAL2DISTANCE:  100    

    #  ( - , + , - )    
    #  (STEP 30A1/33) OF SHOOT4XI - STATISTICS FOR SHOOTING, WHICH ENDED:  07:52:03 06/11/10 Pacific Daylight Time
    #  SHOTS OK:  241  =  100  %
    #  SHOTS ORIGINALLY REQUIRED:  200
    #  ITERATIONS NEEDED:  1323
    #  ITERATIONS ALLOWED:  4200
    #  REJECTED:  1082  =  81  %
    #  (STEP 30B1/33) OF SHOOT4XI - WHOLE BALL AFTER ALL OPERATIONS AND WITH MAX2COUNT:  240 TIME PRINTED:  07:52:03 06/11/10 Pacific Daylight Time
    #  (STEP 30B3/33) OF SHOOT4XI - SHOOTING SAMPLE OF :  240  SHOTS NUMBER OF LAYERS:  3  LATEST DISTANCE:  300  INTERVAL2DISTANCE:  100                

    #  ( - , - , + )    
    #  (STEP 30A1/33) OF SHOOT4XI - STATISTICS FOR SHOOTING, WHICH ENDED:  07:52:28 06/11/10 Pacific Daylight Time
    #  SHOTS OK:  241  =  100  %
    #  SHOTS ORIGINALLY REQUIRED:  200
    #  ITERATIONS NEEDED:  1206
    #  ITERATIONS ALLOWED:  4200
    #  REJECTED:  965  =  80  %
    #  (STEP 30B1/33) OF SHOOT4XI - WHOLE BALL AFTER ALL OPERATIONS AND WITH MAX2COUNT:  240 TIME PRINTED:  07:52:28 06/11/10 Pacific Daylight Time
    #  (STEP 30B3/33) OF SHOOT4XI - SHOOTING SAMPLE OF :  240  SHOTS NUMBER OF LAYERS:  3  LATEST DISTANCE:  300  INTERVAL2DISTANCE:  100
    
    # ( - , - , - )
    # (STEP 30A1/33) OF SHOOT4XI - STATISTICS FOR SHOOTING, WHICH ENDED:  07:52:45 06/11/10 Pacific Daylight Time
    # SHOTS OK:  241  =  100  %
    # SHOTS ORIGINALLY REQUIRED:  200
    # ITERATIONS NEEDED:  1021
    # ITERATIONS ALLOWED:  4200
    # REJECTED:  780  =  76  %
    # (STEP 30B1/33) OF SHOOT4XI - WHOLE BALL AFTER ALL OPERATIONS AND WITH MAX2COUNT:  240 TIME PRINTED:  07:52:45 06/11/10 Pacific Daylight Time
    # (STEP 30B3/33) OF SHOOT4XI - SHOOTING SAMPLE OF :  240  SHOTS NUMBER OF LAYERS:  3  LATEST DISTANCE:  300  INTERVAL2DISTANCE:  100
    
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # SHOW RESULTS
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
           
    print("\n (STEP 30B1/33) OF SHOOT4XI - WHOLE BALL AFTER ALL OPERATIONS AND WITH MAX2COUNT: ", max2count4xi, 'TIME PRINTED: ', time4xi())  
    
    ball2return = {}                                                 # only ok shots returned
     
    ball2show = ball2xi.get()
    dict2keys = ball2show.keys()
    # print("\n (STEP 30B2/33) OF SHOOT4XI - KEYS2BALL: ", dict2keys)
     
    print("\n (STEP 30B3/33) OF SHOOT4XI - SHOOTING SAMPLE OF : ", max2count4xi, " SHOTS", "NUMBER OF LAYERS: ", count2layer, ' LATEST DISTANCE: ', d2shot4xi, ' INTERVAL2DISTANCE: ', interval2distance4xi)    
    # 

    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    
    count2plusx = 0
    count2plusy = 0
    count2plusz = 0
           
    count2minusx = 0
    count2minusy = 0
    count2minusz = 0
    
    count2accepted = 0
    count2rejected = 0
    
    order2key = 1
    
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # ANALYZE SUCCEEDED SHOTS
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
             
    for key2dict in sorted(dict2keys):
    
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # 
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            
        try:
            index2x=str.find(key2dict,'x')                               
            x2coordinate = int(key2dict[0:index2x])
            # print("\n (STEP 31/33/33) OF TEST_BALL4XI - X2COORDINATE: ",  x2coordinate)
            if x2coordinate >= 0:
                count2plusx = count2plusx + 1
            else:
                count2minusx = count2minusx + 1    
        except:
            print("\n (STEP 31A/33) OF SHOOT4XI - *** FAILED WITH KEY2DICT: ", key2dict)
            print("\n (STEP 31B/33) OF SHOOT4XI - INDEX2X: ", index2x)
            
    
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # 
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                 
        try:                                   
            index2y=str.find(key2dict,'y')
            y2coordinate = int(key2dict[index2x+1:index2y])
            # print("\n (STEP 31/33) OF TEST_BALL4XI - Y2COORDINATE: ",  y2coordinate)
            if y2coordinate >= 0:
                count2plusy = count2plusy + 1
            else:
                count2minusy = count2minusy + 1  
        except:
            print("\n (STEP 31C/33) OF SHOOT4XI - : *** FAILED WITH KEY2DICT: ", key2dict) 
            print("\n (STEP 31D/33) OF SHOOT4XI - INDEX2X: ", index2x)
            print("\n (STEP 31E/33) OF SHOOT4XI - INDEX2Y: ", index2y)
    
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # 
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
             
        try:                                                                         
            index2z=str.find(key2dict,'z') 
            z2coordinate = int(key2dict[index2y+1:index2z])
            # print("\n (STEP 31/33) OF TEST_BALL4XI - Z2COORDINATE: ",  z2coordinate)
            if z2coordinate >= 0:
                count2plusz = count2plusz + 1
            else:
                count2minusz = count2minusz + 1
        except:
            print("\n (STEP 31F/33) OF SHOOT4XI - *** FAILED WITH KEY2DICT: ", key2dict)
            print("\n (STEP 31G/33) OF SHOOT4XI - INDEX2X: ", index2x)
            print("\n (STEP 31H/33) OF SHOOT4XI - INDEX2Y: ", index2y)
            print("\n (STEP 31I/33) OF SHOOT4XI - INDEX2Z: ", index2z)
    
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # 
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
             
        ack2x = False    
        if ((x2coordinate >= 0) and (sign2x4xi == '+')):
            ack2x = True
        if ((x2coordinate <= 0) and (sign2x4xi == '-')):
            ack2x = True                        
    
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # 
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
             
        ack2y = False    
        if ((y2coordinate >= 0) and (sign2y4xi == '+')):
            ack2y = True
        if ((y2coordinate <= 0) and (sign2y4xi == '-')):
            ack2y = True     
    
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # 
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
             
        ack2z = False    
        if ((z2coordinate >= 0) and (sign2z4xi == '+')):
            ack2z = True
        if ((z2coordinate <= 0) and (sign2z4xi == '-')):
            ack2z = True     
        
        if ((ack2x is True) and (ack2y is True) and (ack2z is True)                                 # (x,y,z) combination ok
            and((fabs(x2coordinate) > 1) or (fabs(y2coordinate) > 1) or (fabs(z2coordinate) > 1))): # core and skeleton coordinates omitted
            count2accepted = count2accepted + 1                                                                                                      
            print("\n (STEP 31/33) OF SHOOT4XI - ACCEPTANCE: ", count2accepted, " SHOT: ", order2key, ":", key2dict, " EXPECTED SIGNS: (" , sign2x4xi, ",", sign2y4xi, ",", sign2z4xi, ")") 
            # 1278 : 100x159y66z  EXPECTED SIGNS: ( + , + , + )
            
            ball2return[key2dict] = ball2show[key2dict]
            
        else:
            count2rejected = count2rejected + 1
            # print("\n REJECTION: ", count2rejected, " SHOT ", order2key, ":", key2dict, " EXPECTED SIGNS: (" , sign2x, ",", sign2y, ",", sign2z, ")")   
                                        
        order2key = order2key +1 
    
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # end of for loop
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
          

    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # STATISTICS
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                  
    count2tried = count2accepted + count2rejected 
    
    sum2plus = count2plusz + count2plusy+ count2plusz
    sum2minus = count2minusx + count2minusy+ count2minusz
    sum2total = count2plusx + count2minusx # same also with y and z - coordinate exists only once
            
    print('=' *80)
    print("\n (STEP 32/33) OF SHOOT4XI - STATISTICS FOR REQUIRED: ", max2count4xi, " SHOTS")     
    print("\n START TIME: ", time2start)
    print("\n ACCEPTED: ", count2accepted, " = ", int(100*count2accepted/order2key), " %")
    print("\n REJECTED: ", count2rejected, " = ", int(100*count2rejected/order2key), " %")
   
    print("\n DISTIBUTION OF X, Y AND Z: ") 
    print("\n +X: ", count2plusx, " = ", int(100*count2plusx/sum2total), " %")
    print("\n -X: ", count2minusx, " = ", int(100*count2minusx/sum2total), " %") 
   
    print("\n +Y: ", count2plusy, " = ", int(100*count2plusy/sum2total), " %")
    print("\n -Y: ", count2minusy, " = ", int(100*count2minusy/sum2total), " %") 
   
    print("\n +Z: ", count2plusz, " = ", int(100*count2plusz/sum2total), " %")
    print("\n -Z: ", count2minusz, " = ", int(100*count2minusz/sum2total), " %") 
              
    
    print("\n SUM2TOTAL: ", sum2total, "SUCCESS-RATIO: ", int(100*count2accepted/max2count4xi), " %", " COUNT2LAYER: ", count2layer)
    print("\n START2DISTANCE: ", start2distance4xi, " INTERVAL2DISTANCE: ", interval2distance4xi, " MAX2LAYER: ", max2layer4xi, " MAX2COUNT : ", max2count4xi)
    print("\n EXPECTED COORDINATE SIGNS: (X"  , sign2x4xi, ",Y", sign2y4xi, ",Z", sign2z4xi, ")") 
    
    print("\n REASONING: ")
    if count2accepted >= omax2count4xi:
        print("\n OK SHOOTING: ACCEPTED SHOTS ", count2accepted, " >= ", omax2count4xi, " ORIGINALLY REQUIRED, MARIGINAL: ", marginal2count4xi)
    else:
        print("\n *** FAILED SHOOTING: ACCEPTED SHOT ONLY: ", count2accepted, " < ", omax2count4xi, " REQUIRED !")                                    
    
    print("\n END TIME OF SHOOT4XI: ", time2end)
    print('=' *80)
    # ================================================================================
    #  (STEP 32/33) OF SHOOT4XI - STATISTICS FOR REQUIRED:  240  SHOTS
    #  START TIME:  05:36:55 06/11/10 Pacific Daylight Time
    #  ACCEPTED:  207  =  9  %
    #  REJECTED:  2075  =  90  %
    #  DISTIBUTION OF X, Y AND Z: 
    #  +X:  1050  =  46  %
    #  -X:  1232  =  53  %
    #  +Y:  1054  =  46  %
    #  -Y:  1228  =  53  %
    #  +Z:  1197  =  52  %
    #  -Z:  1085  =  47  %
    #  SUM2TOTAL:  2282 SUCCESS-RATIO:  86  %  COUNT2LAYER:  3
    #  START2DISTANCE:  100  INTERVAL2DISTANCE:  100  MAX2LAYER:  120  MAX2COUNT :  240
    #  EXPECTED COORDINATE SIGNS: (X + ,Y + ,Z + )
    #  REASONING: 
    #  OK SHOOTING: ACCEPTED SHOTS  207  >=  200  ORIGINALLY REQUIRED, MARIGINAL:  1.2
    #  END TIME OF SHOOT4XI:  05:38:22 06/11/10 Pacific Daylight Time
    # ================================================================================

    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # RETURN
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    keys2ok = ball2return.keys()
    
    print("\n (STEP 33/33) OF SHOOT4XI - RETURNING KEYS: ")
    for key2ok in sorted(keys2ok):
        print("\n ", key2ok)
    
    return ball2return
       
#</function4xi>

              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "test-ball4xi" usage = "
#   tests ball4xi
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def test_ball4xi():

    global ack4queues
    global nack4queues
    
    global ack4pipes
    global nack4pipes
    
    global ack4process
    global nack4process
    
    global ack4start
    global nack4start   
            
    global ack4run
    global nack4run

    global queue2ball
    global pipe2ball_consumer_channel
    global pipe2ball_publisher_channel
    global process2ball
    
    global queue2shot
    global pipe2shot_consumer_channel
    global pipe2shot_publisher_channel
    global process2shot
    
    global queue2cluster
    global pipe2cluster_consumer_channel
    global pipe2cluster_publisher_channel
    global process2cluster
    
    global queue2super
    global pipe2super_consumer_channel
    global pipe2super_publisher_channel
    global process2super
    
    global t2xi
    global trace_object_count    
          
    # --------------------------------------------------------------------------------------------- 
    # INITIALIZE TRACE
    # ---------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    print("(STEP 0/33) OF TEST_BALL4XI - SET T2XI TO: ", t2xi)
    # 
    set2trace4xi()                                                                                               # trace all classes and functions in the system
    deny2trace4xi()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                            # tailor trace for this test   
    
    try:
                  
        # ---------------------------------------------------------------------------------------------
        # START OF TESTS                          
        # ---------------------------------------------------------------------------------------------    
        
        print('=' *33)          
        print('STARTING TEST_BALL4XI ', time4xi())
        print('=' *33)   
        
        debug2function = True
         
        if debug2function is True:
            # -----------------------------------------------------------------------------------------
            # INITIALIZE BALL WITH FUNCTION                          
            # -----------------------------------------------------------------------------------------    
            print('=' *33)          
            print('(STEP 1A/33) OF TEST_BALL4XI - INITIALIZE BY FUNCTION AND WITHOUT PARAMETERS')
            print('=' *33)      
             
            init_ball4xi()
            
            print('=' *33) 
            print("(STEP 1B/33) OF TEST_BALL4XI - GOT BY FUNCTION AFTER INITIALIZATION BY FUNCTION AND WITHOUT PARAMETERS:") 
            
            print(get_ball4xi())
            # {'0x0y1z': {'time2shot': 0, 'accerelation2shot': 0, 'x2shot': 0, 'azimuth2shot': 0, 'velocity2shot': 0, 'verb2shot': 'skeletonizing', 'y2shot': 0, 'z2shot': 1, 'elevation2shot': 0, 'color2shot': 0},
            #  '0x0y0z': {'radius2ball': 1, 'x2ball': 0, 'z2ball': 0, 'area2ball': 12.566370614359172, 'color2ball': '#F5E8E8', 'y2ball': 0, 'id2ball': '0x0y0z', 'verb2ball': 'skeletonize', 'time2ball': 0, 'volume2ball': 4.1887902047863905}}

            
            # -----------------------------------------------------------------------------------------
            # SET BALL WITH FUNCTION                          
            # ----------------------------------------------------------------------------------------- 
            set_ball4xi(x2ball = None,y2ball = None, z2ball = None, radius2ball = None, color2ball = None, verb2ball = None, time2ball = None, 
                        accerelation2shot = None, azimuth2shot = None, color2shot = None, elevation2shot = None, time2shot = None, velocity2shot = None, x2shot = None, y2shot = None, z2shot = None)
            print('=' *33) 
            print("(STEP 1C/33) OF TEST_BALL4XI - GOT BY FUNCTION AFTER SETTING WITH ALL NONE:") 
            print(get_ball4xi())
            # {'0x0y1z': {'time2shot': 0, 'accerelation2shot': 0, 'x2shot': 0, 'azimuth2shot': 0, 'velocity2shot': 0, 'verb2shot': 'skeletonizing', 'y2shot': 0, 'z2shot': 1, 'elevation2shot': 0, 'color2shot': 0}, 
            #  '0x0y0z': {'radius2ball': 1, 'x2ball': 0, 'z2ball': 0, 'area2ball': 12.566370614359172, 'color2ball': '#F5E8E8', 'y2ball': 0, 'id2ball': '0x0y0z', 'verb2ball': 'skeletonize', 'time2ball': 0, 'volume2ball': 4.1887902047863905}}
            
            
            # -----------------------------------------------------------------------------------------
            # SET NEW BALL WITH FUNCTION                           
            # ----------------------------------------------------------------------------------------- 
            set_ball4xi(x2ball = 100,y2ball = 200, z2ball = 300, radius2ball = 50, color2ball = '#FFFFFFF', verb2ball = 'activated', time2ball = None, 
                        accerelation2shot = None, azimuth2shot = None, color2shot = None, elevation2shot = None, time2shot = None, velocity2shot = None, x2shot = None, y2shot = None, z2shot = None)
            print('=' *33) 
            print("(STEP 1D/33) OF TEST_BALL4XI - NEW BALL :") 
            print(get_ball4xi())
            # {     '0x0y1z': {'time2shot': 0, 'accerelation2shot': 0, 'x2shot': 0, 'azimuth2shot': 0, 'velocity2shot': 0, 'verb2shot': 'skeletonizing', 'y2shot': 0, 'z2shot': 1, 'elevation2shot': 0, 'color2shot': 0}, 
            #      '0x0y50z': {'time2shot': 0, 'accerelation2shot': 0, 'x2shot': 0, 'azimuth2shot': 0, 'velocity2shot': 0, 'verb2shot': 'skeletonizing', 'y2shot': 0, 'z2shot': 50, 'elevation2shot': 0, 'color2shot': 0}, 
            # '100x300y300z': {'radius2ball': 50, 'x2ball': 100, 'z2ball': 300, 'area2ball': 31415.926535897932, 'color2ball': '#FFFFFFF', 'y2ball': 200, 'id2ball': '100x300y300z', 'verb2ball': 'activated', 'time2ball': 0, 'volume2ball': 523598.7755982988}, 
            #       '0x0y0z': {'radius2ball': 1, 'x2ball': 0, 'z2ball': 0, 'area2ball': 12.566370614359172, 'color2ball': '#F5E8E8', 'y2ball': 0, 'id2ball': '0x0y0z', 'verb2ball': 'skeletonize', 'time2ball': 0, 'volume2ball': 4.1887902047863905}}

            # -----------------------------------------------------------------------------------------
            # CHANGE AZIMUTH AND ELEVATION OF SHOT WITH FUNCTION                          
            # ----------------------------------------------------------------------------------------- 
            set_ball4xi(azimuth2shot = pi/3, elevation2shot = pi/4)
            print('=' *33) 
            print("(STEP 1E/33) OF TEST_BALL4XI - AZIMUTH AND ELEVATION  :") 
            print(get_ball4xi())
            # { '17x30y35z': {'time2shot': 0, 'accerelation2shot': 0, 'x2shot': 17, 'azimuth2shot': 1.0471975511965976, 'velocity2shot': 0, 'verb2shot': 'skeletonizing', 'y2shot': 30, 'z2shot': 35, 'elevation2shot': 0.7853981633974483, 'color2shot': 0}, 
            #      '0x0y1z': {'time2shot': 0, 'accerelation2shot': 0, 'x2shot': 0, 'azimuth2shot': 0, 'velocity2shot': 0, 'verb2shot': 'skeletonizing', 'y2shot': 0, 'z2shot': 1, 'elevation2shot': 0, 'color2shot': 0}, 
            #     '0x0y50z': {'time2shot': 0, 'accerelation2shot': 0, 'x2shot': 0, 'azimuth2shot': 0, 'velocity2shot': 0, 'verb2shot': 'skeletonizing', 'y2shot': 0, 'z2shot': 50, 'elevation2shot': 0, 'color2shot': 0}, 
            #'100x300y300z': {'radius2ball': 50, 'x2ball': 100, 'z2ball': 300, 'area2ball': 31415.926535897932, 'color2ball': '#FFFFFFF', 'y2ball': 200, 'id2ball': '100x300y300z', 'verb2ball': 'activated', 'time2ball': 0, 'volume2ball': 523598.7755982988}, 
            #      '0x0y0z': {'radius2ball': 1, 'x2ball': 0, 'z2ball': 0, 'area2ball': 12.566370614359172, 'color2ball': '#F5E8E8', 'y2ball': 0, 'id2ball': '0x0y0z', 'verb2ball': 'skeletonize', 'time2ball': 0, 'volume2ball': 4.1887902047863905}}

            # -----------------------------------------------------------------------------------------
            # SECOND SHOT                          
            # ----------------------------------------------------------------------------------------- 
            set_ball4xi(azimuth2shot = -pi/3, elevation2shot = -pi/4, time2shot = 2)
            print('=' *33) 
            print("(STEP 1F/33) OF TEST_BALL4XI - SECOND AZIMUTH AND ELEVATION  :") 
            print(get_ball4xi())
            # {'100x300y300z': {'radius2ball': 50, 'x2ball': 100, 'z2ball': 300, 'area2ball': 31415.926535897932, 'color2ball': '#FFFFFFF', 'y2ball': 200, 'id2ball': '100x300y300z', 'verb2ball': 'activated', 'time2ball': 0, 'volume2ball': 523598.7755982988}, 
            #        '0x0y0z': {'radius2ball': 1, 'x2ball': 0, 'z2ball': 0, 'area2ball': 12.566370614359172, 'color2ball': '#F5E8E8', 'y2ball': 0, 'id2ball': '0x0y0z', 'verb2ball': 'skeletonize', 'time2ball': 0, 'volume2ball': 4.1887902047863905}, 
            #     '17x30y35z': {'time2shot': 0, 'accerelation2shot': 0, 'x2shot': 17, 'azimuth2shot': 1.0471975511965976, 'velocity2shot': 0, 'verb2shot': 'skeletonizing', 'y2shot': 30, 'z2shot': 35, 'elevation2shot': 0.7853981633974483, 'color2shot': 0}, 
            #        '0x0y1z': {'time2shot': 0, 'accerelation2shot': 0, 'x2shot': 0, 'azimuth2shot': 0, 'velocity2shot': 0, 'verb2shot': 'skeletonizing', 'y2shot': 0, 'z2shot': 1, 'elevation2shot': 0, 'color2shot': 0}, 
            #       '0x0y50z': {'time2shot': 0, 'accerelation2shot': 0, 'x2shot': 0, 'azimuth2shot': 0, 'velocity2shot': 0, 'verb2shot': 'skeletonizing', 'y2shot': 0, 'z2shot': 50, 'elevation2shot': 0, 'color2shot': 0}, 
            #    '-17x30y35z': {'time2shot': 2, 'accerelation2shot': 0, 'x2shot': -17, 'azimuth2shot': -1.0471975511965976, 'velocity2shot': 0, 'verb2shot': 'skeletonizing', 'y2shot': 30, 'z2shot': 35, 'elevation2shot': -0.7853981633974483, 'color2shot': 0}}

                                       
        else:
            print('~' *33)          
            print('(STEP 2K/33) OF TEST_BALL4XI - ** SKIPPED FUNCTION TESTS - DEBUG2FUNCTION SET TO FALSE - SET TO TRUE, IF YOY WANT IT **')
            print('~' *33)              
              

        debug2class = True
        
        if debug2class is True:
            # -----------------------------------------------------------------------------------------
            # CREATE BALL OBJECT AND COMMAND IT                      
            # -----------------------------------------------------------------------------------------    
            b2xi = Ball4Xi()
            print('=' *33) 
            print('(STEP 3A/6) OF TEST_BALL4XI - INITIALIZED SPHERE WITHOUT ANY PARAMETERS:' ) 
            print(b2xi.get())
            #                  6                 1                  9                 2               7                    8                            10           5                    12                 11                4                   3  
            # {'0x0y1z': {'time2shot': 0, 'accerelation2shot': 0, 'x2shot': 0, 'azimuth2shot': 0, 'velocity2shot': 0, 'verb2shot': 'skeletonizing', 'y2shot': 0, 'id2shot': '0x0y1z', 'distance2shot': 1, 'z2shot': 1, 'elevation2shot': 0, 'color2shot': '#F3881C'}
            #                  4               8             10           1                                2                      9              3                    6                            5               7                     
            #  '0x0y0z': {'radius2ball': 1, 'x2ball': 0, 'z2ball': 0, 'area2ball': 12.566370614359172, 'color2ball': '#F5E8E8', 'y2ball': 0, 'id2ball': '0x0y0z', 'verb2ball': 'skeletonize', 'time2ball': 0, 'volume2ball': 4.1887902047863905}}
            
            # -----------------------------------------------------------------------------------------
            # GET THE WHOLE SHOT                    
            # ----------------------------------------------------------------------------------------- 
            print('=' *33) 
            print('(STEP 3B/6) OF TEST_BALL4XI - WHOLE SHOT:' )
            print(b2xi.get(accerelation2shot = 'Yes', azimuth2shot = 'Yes', color2shot = 'Yes', elevation2shot = 'Yes', id2shot = 'Yes', time2shot = 'Yes', velocity2shot = 'Yes', verb2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', distance2shot = 'Yes'))
            # {'0x0y1z': {'time2shot': 0, 'accerelation2shot': 0, 'x2shot': 0, 'azimuth2shot': 0, 'velocity2shot': 0, 'verb2shot': 'skeletonizing', 'y2shot': 0, 'id2shot': '0x0y1z', 'distance2shot': 1, 'z2shot': 1, 'elevation2shot': 0, 'color2shot': '#F3881C'}}

            # -----------------------------------------------------------------------------------------
            # GET PART OF SHOT              
            # -----------------------------------------------------------------------------------------                 
            print('=' *33) 
            print('(STEP 3C/6) OF TEST_BALL4XI - PART OF SHOT:' )
            print(b2xi.get(id2shot = 'Yes', color2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', distance2shot = 'Yes'))
            # {'0x0y1z': {'distance2shot': 1, 'id2shot': '0x0y1z', 'x2shot': 0, 'z2shot': 1, 'color2shot': '#F3881C', 'y2shot': 0}} 
            
            # -----------------------------------------------------------------------------------------
            # GET WHOLE BALL           
            # ----------------------------------------------------------------------------------------- 
            print('=' *33) 
            print('(STEP 3D/6) OF TEST_BALL4XI - WHOLE BALL:' )            
            print(b2xi.get(area2ball='Yes', color2ball='Yes', id2ball='Yes', radius2ball='Yes', time2ball = 'Yes', verb2ball='Yes', volume2ball='Yes', x2ball='Yes',y2ball='Yes',z2ball='Yes'))
            # {'0x0y0z': {'radius2ball': 1, 'x2ball': 0, 'z2ball': 0, 'area2ball': 12.566370614359172, 'color2ball': '#F5E8E8', 'y2ball': 0, 'id2ball': '0x0y0z', 'verb2ball': 'skeletonize', 'time2ball': 0, 'volume2ball': 4.1887902047863905}}
       
            # -----------------------------------------------------------------------------------------
            # GET PART OF BALL          
            # -----------------------------------------------------------------------------------------     
            print('=' *33) 
            print('(STEP 3E/6) OF TEST_BALL4XI - PART OF BALL:' )            
            print(b2xi.get(color2ball='Yes', id2ball='Yes', radius2ball='Yes', verb2ball='Yes', x2ball='Yes',y2ball='Yes',z2ball='Yes'))
            # {'0x0y0z': {'radius2ball': 1, 'x2ball': 0, 'z2ball': 0, 'color2ball': '#F5E8E8', 'y2ball': 0, 'id2ball': '0x0y0z', 'verb2ball': 'skeletonize'}}
            
            # -----------------------------------------------------------------------------------------
            # FIRST SHOT WITH CHANGED AZIMUTH, ELEVATION AND RADIUS                
            # ----------------------------------------------------------------------------------------- 
            b2xi.set(azimuth2shot = pi/2, elevation2shot = pi/4, radius2ball = 2)
            print('=' *33) 
            print("(STEP 3F/6) OF TEST_BALL4XI - FIRST SHOT WITH CHANGED AZIMUTH, ELEVATION AND RADIUS:") 
            print(b2xi.get(id2shot = 'Yes', color2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', verb2shot = 'Yes', distance2shot = 'Yes'))
            # {'0x0y1z': {'x2shot': 0, 'verb2shot': 'skeletonizing', 'id2shot': '0x0y1z', 'distance2shot': 1, 'z2shot': 0, 'color2shot': '#F3881C', 'y2shot': 0}}
            
            # -----------------------------------------------------------------------------------------
            # SECOND SHOT WITH CHANGED RANGE, AZIMUTH AND ELEVATION                    
            # ----------------------------------------------------------------------------------------- 
            b2xi.set(azimuth2shot = pi/3, elevation2shot = pi/3, radius2ball = 3)
            print('=' *33) 
            print("(STEP 3G/6) OF TEST_BALL4XI - SECOND SHOT WITH CHANGED RANGE, AZIMUTH AND ELEVATION:") 
            print(b2xi.get(id2shot = 'Yes', color2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', verb2shot = 'Yes', distance2shot = 'Yes'))
            # {'0x0y1z': {'x2shot': 0, 'verb2shot': 'skeletonizing', 'id2shot': '0x0y1z', 'distance2shot': 1, 'z2shot': 0, 'color2shot': '#F3881C', 'y2shot': 0}} 
                         
            # -----------------------------------------------------------------------------------------
            # THIRD SHOT WITH MAX AZIMUTH 360 DEGREES AND NEW RADIUS AND DISTANCE                     
            # ----------------------------------------------------------------------------------------- 
            b2xi.set(azimuth2shot = 2*pi, elevation2shot = pi/4, radius2ball = 100, distance2shot = 100)
            print('=' *33) 
            print("(STEP 3H/6) OF TEST_BALL4XI - THIRD SHOT WITH MAX AZIMUTH 360 DEGREES AND NEW RADIUS AND DISTANCE:") 
            print(b2xi.get(x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', distance2shot = 'Yes'))
            # {'70x0y70z': {'distance2shot': 100, 'z2shot': 70, 'x2shot': 70, 'y2shot': 0}}     

            # ----------------------------------------------------------------------------------------------------------
            # FOURTH SHOT WITH MAX AZIMUTH 360, MAX ELEVATION 180 DEGREES AND NEW SHOT DISTANCE WHILE RADOUS IS THE SAME                     
            # ---------------------------------------------------------------------------------------------------------- 
            b2xi.set(azimuth2shot = 2*pi, elevation2shot = pi, distance2shot = 200 )
            print('=' *33) 
            print("(STEP 3I/6) OF TEST_BALL4XI - FOURTH SHOT WITH MAX AZIMUTH 360, MAX ELEVATION 180 DEGREES AND NEW SHOT DISTANCE WHILE RADOUS IS THE SAME:") 
            print(b2xi.get(x2ball = 'Yes', y2ball = 'Yes', z2ball = 'Yes', radius2ball = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', distance2shot = 'Yes'))
            # {'0x0y-200z': {'distance2shot': 200, 'z2shot': -200, 'x2shot': 0, 'y2shot': 0}, 
            #     '0x0y0z': {'radius2ball': 100, 'x2ball': 0, 'y2ball': 0, 'z2ball': 0}}
 
            # -----------------------------------------------------------------------------------------
            # INITIALIZE                     
            # ----------------------------------------------------------------------------------------- 
            b2xi.init()
            print("(STEP 3K/6) OF TEST_BALL4XI - AFTER RESET:") 
            print(b2xi.get())
            # {'0x0y1z': {'time2shot': 0, 'accerelation2shot': 0, 'x2shot': 0, 'azimuth2shot': 0, 
            #          'message2shot': '{ _MainProcess4Xi : __init__ ; (Step 11/11b) activated; mainprocess2xi-of-MainProcess4Xi-activated: ; time: 03:41:54 05/23/10 Pacific Daylight Time}', 
            #         'velocity2shot': 0, 'verb2shot': 'skeletonizing', 'y2shot': 0, 'id2shot': '0x0y1z', 'distance2shot': 1, 'z2shot': 1, 'elevation2shot': 0, 'color2shot': '#F3881C'}, 
            # '0x0y0z':  {'radius2ball': 1, 'x2ball': 0, 'z2ball': 0, 'area2ball': 12.566370614359172, 'color2ball': '#F5E8E8', 'y2ball': 0, 'id2ball': '0x0y0z', 'verb2ball': 'skeletonize', 'time2ball': 0, 
            #            'message2ball': '{ CurrentProcess4Xi : __init__ ; borning; currentprocess2xi-of-CurrentProcess4Xi-borning: 03:41:54 05/23/10 Pacific Daylight Time}', 'volume2ball': 4.1887902047863905}}

            # -----------------------------------------------------------------------------------------
            # GET                     
            # -----------------------------------------------------------------------------------------                                  
            b2xi.set(message2ball = 'Core of Verbs4Xi', message2shot = 'First shot for verbs')       
            print("(STEP 3L/8) OF TEST_BALL4XI - AFTER MESSAGE SETTINGS:")
            print(b2xi.get(message2ball = 'Yes', message2shot = 'Yes'))
            # {'0x0y1z': {'message2shot': 'First shot for verbs'}, '0x0y0z': {'message2ball': 'Core of Verbs4Xi'}}
            
                                             
            # ---------------------------------------------------------------------------------------------
            # SENSE                     
            # ---------------------------------------------------------------------------------------------    
            ack2sense = True
            if ack2sense is True:
                print('=' *33)          
                print('(STEP 4A/6) OF TEST_BALL4XI - SENSE BY CLASS')
                print('=' *33)      
                
                kb2xi = b2xi.sense()          #  {               'ack2volume': True, 
                                              #                    'ack2area': True, 
                                              #            'color-of-Ball4Xi': '#F08C27',
                                              #                      'object': <ball4xi.Ball4Xi object at 0x02C13D30>, 
                                              #  'backgroundcolor-of-Ball4Xi': '#37332E', 
                                              #     'time-sensing-of-Ball4Xi': '01:00:59 05/19/10 Pacific Daylight Time', 
                                              #                  'ack2sphere': True}


                print("(STEP 4B/6) OF TEST_BALL4XI - SENSED BY CLASS KNOWLEDGE = ", kb2xi)
                
            else:
                print('~' *33)          
                print('(STEP 4C/6) OF TEST_BALL4XI - ** SKIPPED SENSE BY CLASS - ACK2SENSE SET TO FALSE - SET TO TRUE, IF YOY WANT IT**')
                print('~' *33)                 
    

        
            # ---------------------------------------------------------------------------------------------
            # REASON                
            # ---------------------------------------------------------------------------------------------    
            ack2reason = True
                    
            if ack2reason is True:
                print('=' *33)          
                print('(STEP 5A/6) OF TEST_BALL4XI - REASON BY CLASS')
                print('=' *33)       
                
                kb4xi = b2xi.reason()           # {        'object-reason-object4xi': <ball4xi.Ball4Xi object at 0x029BEDD0>, 
                                                        #'time-reasoning-of-Ball4Xi': '01:12:05 05/19/10 Pacific Daylight Time', 
                                                        #                 'reasoned': 'ALL CALCULATED VALES FOR SPHERE WERE OK'}


                print("(STEP 5B/6) OF TEST_BALL4XI - REASONED BY CLASS KNOWLEDGE = ", kb4xi)
            else:
                print('~' *33)          
                print('(STEP 5C/6) OF TEST_BALL4XI - ** SKIPPED REASON BY CLASS - ACK2REASON SET TO FALSE - SET TO TRUE, IF YOY WANT IT**')
                print('~' *33)
                             
            # ---------------------------------------------------------------------------------------------
            # ACE                     
            # ---------------------------------------------------------------------------------------------    
            ack2ace = True
            
            if ack2ace is True:
                print('=' *33)          
                print('(STEP 6A/6) OF TEST_BALL4XI - ACE BY CLASS')
                print('=' *33)       
                
                kb8xi = b2xi.ace()              # {'time-acing-of-Ball4Xi': '01:12:05 05/19/10 Pacific Daylight Time', 
                                                #                   'aced': 'SPHERE TO ACE', 
                                                #              'object8xi': <ball4xi.Ball4Xi object at 0x029BEDD0>}
                print("(STEP 6B/6) OF TEST_BALL4XI - ACED BY CLASS KNOWLEDGE = ", kb8xi)
            else:
                print('~' *33)          
                print('(STEP 6C/6) OF TEST_BALL4XI - ** SKIPPED ACE BY CLASS - ACK2ACE SET TO FALSE - SET TO TRUE, IF YOY WANT IT**')
                print('~' *33)
                        

            # ---------------------------------------------------------------------------------------------
            # DONE                          
            # ---------------------------------------------------------------------------------------------    
            print('=' *33)          
            print('(STEP 6/6) OF TEST_BALL4XI - DONE!')
            print('=' *33)
            # =================================
            # SENSED ACTIVE -  test-dragonized-multiprocessing4xi
            # <statistics4xi>
            #     <active4xi>
            #         <object4xi> Ball4Xi </object4xi>
            #         <object4xi> ace_object4xi </object4xi>
            #         <object4xi> get_ball4xi </object4xi>
            #         <object4xi> init_ball4xi </object4xi>
            #         <object4xi> reason_object4xi </object4xi>
            #         <object4xi> sense_object4xi </object4xi>
            #         <object4xi> set_ball4xi </object4xi>
            #     </active4xi>
            # </statistics4xi>
            # =================================
            # SENSED TOTAL -  test-dragonized-multiprocessing4xi
            # <statistics4xi>
            #     <total4xi>
            #         <passiveones4xi> 536 </passiveones4xi>
            #         <activeones4xi> 7 </activeones4xi>
            #         <allones4xi> 543 </allones4xi>
            #         <totalones4xi> 543 </totalones4xi>
            #     </total4xi>
            # </statistics4xi>
            # =================================            
                                    
        else:
            print('~' *33)          
            print('(STEP 6V)  OF TEST_BALL4XI - ** SKIPPED CLASS TESTS - DEBUG2CLASS SET TO FALSE - SET TO TRUE, IF YOY WANT IT **')
            print('~' *33)
            
        # ----------------------------------------------------------------------------------------------------
        #                       
        # ----------------------------------------------------------------------------------------------------                                
        debug2multicore = True
        
        if debug2multicore is True:
            
            # ------------------------------------------------------------------------------------------------
            # MULTIPROCESSING TESTS WANTED                      
            # ------------------------------------------------------------------------------------------------                
            
            try:
                # -------------------------------------------------------------------------------------------
                # MULTIPROCESSING TRIALS                      
                # --------------------------------------------------------------------------------------------                
                print('~' *33)          
                print('(STEP 0B1/33) OF TEST_BALL4XI - STEP MULTIPROCESSING TESTS STARTING')
                
                ack4queues = False
                nack4queues = True 
                
                print('~' *33)
                print("\n (STEP 0B2/33) OF TEST_BALL4XI - CREATING QUEUES")
                
                # --------------------------------------------------------------------------------------------
                # A MULTIPROCESSING TRIAL                      
                # --------------------------------------------------------------------------------------------                  
                try:
                
                    # ----------------------------------------------------------------------------------------    
                    #  (Step 7B/33):
                    # ----------------------------------------------------------------------------------------     
                    
                    print('=' *33)    
                    print("\n (STEP 1B1/33) OF TEST_BALL4XI - CREATING QUEUE2BALL")
                    print('=' *33)           
                         
                    queue2ball = Queue4Xi()
                    
                    print('=' *33)    
                    print("\n (STEP 1B2/33) OF TEST_BALL4XI - CREATED QUEUE2BALL")
                    print('=' *33)           
                    
                    print(queue2ball)
                    # <queue4xi.Queue4Xi object at 0x02F82450>
                    
                    queue2shot = Queue4Xi()
                    
                    print('=' *33)    
                    print("\n (STEP 1B3/33) OF TEST_BALL4XI - CREATED QUEUE2SHOT")
                    print('=' *33)           
                    
                    print(queue2shot)
                    # <queue4xi.Queue4Xi object at 0x02F06750> 
                                        
                    queue2cluster = Queue4Xi()
                    
                    print('=' *33)    
                    print("\n (STEP 1B4/33) OF TEST_BALL4XI - CREATED QUEUE2CLUSTER")
                    print('=' *33)           
                    
                    print(queue2cluster)
                    # <queue4xi.Queue4Xi object at 0x02F219D0>               
                                        
                    queue2super = Queue4Xi()
                    
                    print('=' *33)    
                    print("\n (STEP 1B5/33) OF TEST_BALL4XI - CREATED QUEUE2SUPER")
                    print('=' *33)           
                    
                    print(queue2super)
                    # <queue4xi.Queue4Xi object at 0x02F91610>                
                                                              
                    ack4queues = True 
                    nack4queues = False
                except:
                    # -----------------------------------------------------------------------------------------    
                    #
                    # -----------------------------------------------------------------------------------------     
                    print("\n (STEP 1BZ/33) OF TEST_BALL4XI *** FAILED TO CREATE QUEUES ***")
                
                print('~' *33)
                print("\n (STEP 8/33) OF TEST_BALL4XI - CREATING PIPES")
                
                # --------------------------------------------------------------------------------------------
                # ESTABLISH PIPE AND QUEUE COMMUNICATION MECHANISM                      
                # --------------------------------------------------------------------------------------------                 
                try:
                
                    # -----------------------------------------------------------------------------------------    
                    # (Step 2/33)
                    # -----------------------------------------------------------------------------------------     
                    print("\n (STEP 2A/33) OF TEST_BALL4XI - CREATING PIPES WITH CONSUMER AND PUBLISHER ENDS")
                    ack4pipes = False
                    nack4pipes = True
                    try:
                        # -----------------------------------------------------------------------------------------    
                        # BALL PIPE
                        # -----------------------------------------------------------------------------------------     
                              
                        pipe2ball_consumer_channel, pipe2ball_publisher_channel = Pipe4Xi()
                        
                        print("\n (STEP 2B/33) OF TEST_BALL4XI - CREATED PIPE2BALL_CONSUMER_CHANNEL")   
                        print(pipe2ball_consumer_channel)
                        # <pipeconnection4xi.PipeConnection4Xi object at 0x0000000003632CC0>
                        
                        print("\n (STEP 2C/33) OF TEST_BALL4XI - CREATED PIPE2BALL_PUBLISHER_CHANNEL")  
                        print(pipe2ball_publisher_channel)
                        # <pipeconnection4xi.PipeConnection4Xi object at 0x0000000003632BE0>                         
                       
                        print("\n (STEP 2D/33) OF TEST_BALL4XI - CREATED PIPE2BALL WITH CONSUMER AND PUBLISHER ENDS")
                        
                        ack4pipes = True
                        nack4pipes = False
                    except:
                        # -----------------------------------------------------------------------------------------    
                        #
                        # -----------------------------------------------------------------------------------------     
                        print("\n (STEP 2Z/33) OF TEST_BALL4XI *** FAILED TO CREATE PIPE2BALL ***")
                
                    try:
                        # -----------------------------------------------------------------------------------------    
                        # SHOT PIPE 
                        # -----------------------------------------------------------------------------------------     
                              
                        pipe2shot_consumer_channel, pipe2shot_publisher_channel = Pipe4Xi()
                        
                        print("\n (STEP 2F/33) OF TEST_BALL4XI - CREATED PIPE2SHOT_CONSUMER_CHANNEL")   
                        print(pipe2shot_consumer_channel)
                        # <pipeconnection4xi.PipeConnection4Xi object at 0x0000000003632D30>
                        
                        print("\n (STEP 2G/33) OF TEST_BALL4XI - CREATED PIPE2SHOT_PUBLISHER_CHANNEL")  
                        print(pipe2shot_publisher_channel)
                        # pipeconnection4xi.PipeConnection4Xi object at 0x0000000002E2A080>                
                       
                        print("\n (STEP 2H/33) OF TEST_BALL4XI - CREATED PIPE2SHOT WITH CONSUMER AND PUBLISHER ENDS")
                        
                        ack4pipes = True
                        nack4pipes = False
                    except:
                        # -----------------------------------------------------------------------------------------    
                        #
                        # -----------------------------------------------------------------------------------------     
                        print("\n (STEP 2I/33) OF TEST_BALL4XI *** FAILED TO CREATE PIPE2SHOT ***")
                
                    try:
                        # -----------------------------------------------------------------------------------------    
                        # CLUSTER PIPE
                        # -----------------------------------------------------------------------------------------     
                              
                        pipe2cluster_consumer_channel, pipe2cluster_publisher_channel = Pipe4Xi()
                        
                        print("\n (STEP 2J/33) OF TEST_BALL4XI - CREATED PIPE2CLUSTER_CONSUMER_CHANNEL")   
                        print(pipe2cluster_consumer_channel)
                        # <pipeconnection4xi.PipeConnection4Xi object at 0x0000000003632DA0>
                        
                        print("\n (STEP 2K/33) OF TEST_BALL4XI - CREATED PIPE2CLUSTER_PUBLISHER_CHANNEL")  
                        print(pipe2cluster_publisher_channel)
                        # <pipeconnection4xi.PipeConnection4Xi object at 0x0000000003632C50>                   
                       
                        print("\n (STEP 2L/33) OF TEST_BALL4XI - CREATED PIPE2CLUSTER WITH CONSUMER AND PUBLISHER ENDS")
                        
                        ack4pipes = True
                        nack4pipes = False
                    except:
                        # -----------------------------------------------------------------------------------------    
                        #
                        # -----------------------------------------------------------------------------------------     
                        print("\n (STEP 2M/33) OF TEST_BALL4XI *** FAILED TO CREATE PIPE2SHOT ***")
                
                    try:
                        # -----------------------------------------------------------------------------------------    
                        # SUPER CLUSTER PIPE 
                        # -----------------------------------------------------------------------------------------     
                              
                        pipe2super_consumer_channel, pipe2super_publisher_channel = Pipe4Xi()
                        
                        print("\n (STEP 2N/33) OF TEST_BALL4XI - CREATED PIPE2SUPER_CONSUMER_CHANNEL")   
                        print(pipe2super_consumer_channel)
                        # <pipeconnection4xi.PipeConnection4Xi object at 0x0000000003632E80>
                        
                        print("\n (STEP 2O/33) OF TEST_BALL4XI - CREATED PIPE2SUPER_PUBLISHER_CHANNEL")  
                        print(pipe2super_publisher_channel)
                        # <pipeconnection4xi.PipeConnection4Xi object at 0x0000000003632EB8>          
                       
                        print("\n (STEP 2P/33) OF TEST_BALL4XI - CREATED PIPE2SUPER WITH CONSUMER AND PUBLISHER ENDS")
                        
                        ack4pipes = True
                        nack4pipes = False
                    except:
                        # -----------------------------------------------------------------------------------------    
                        #
                        # -----------------------------------------------------------------------------------------     
                        print("\n (STEP 2Q/33) OF TEST_BALL4XI *** FAILED TO CREATE PIPE2SHOT ***")
                                                                                                                     
                except:
                        # -----------------------------------------------------------------------------------------    
                        #
                        # -----------------------------------------------------------------------------------------     
                        print("\n (STEP 2R/33) OF TEST_BALL4XI *** FAILED TO CREATE PIPES WITH CONSUMER AND PUBLISHER ENDS ***")
                                    
                # ---------------------------------------------------------------------------------------------
                # CREATE PROCESSES                   
                # ---------------------------------------------------------------------------------------------                         
                ack2dummy = True      # use dummy processes which are threads and allow you to continue immediatelly!
                # ack2dummy = False   # usea real processes in which case target function shoul use DummyProcess4Xi! 
                
                try:
                    # -----------------------------------------------------------------------------------------    
                    # (STEP 3/33)
                    # -----------------------------------------------------------------------------------------     
                     
                    print("\n (STEP 3/33): CREATING PROCESSES ")  
                    
                    try:
               
                        # -------------------------------------------------------------------------------------    
                        # BALL PROCESS - (0,0,0)
                        # -------------------------------------------------------------------------------------     
                        ball2xi = Ball4Xi(x2ball=0, y2ball=0, z2ball=0, radius2ball=10)
                        
                        coordinate2ball = ball2xi.get(id2ball = 'Yes', color2ball = 'Yes', x2ball = 'Yes', y2ball = 'Yes', z2ball = 'Yes', verb2ball = 'Yes')
                        print("\n (STEP 3B1/33) OF TEST_BALL4XI - CREATED COORDINATE2BALL: ", coordinate2ball)
                        # {'0x0y0z': {'x2ball': 0, 'z2ball': 0, 'color2ball': '#F5E8E8', 'y2ball': 0, 'id2ball': '0x0y0z', 'verb2ball': 'skeletonize'}}
                        if ack2dummy is False:
                            p2ball = Process4Xi(target=shoot2ball, args=(coordinate2ball, queue2ball, pipe2ball_publisher_channel))
                        else:
                            p2ball = DummyProcess4Xi(target=shoot2ball, args=(coordinate2ball, queue2ball, pipe2ball_publisher_channel))    
                                                     
                        print("\n (STEP 3B2/33) OF TEST_BALL4XI - CREATED PROCESS FOR BALL: ", str(p2ball))    
                        # <Process4Xi(Process4Xi-1, initial)>
                        # <DummyProcess4Xi(Thread-1, initial)> 
                        name2ball = "unknown"
                        try:
                            name2ball = p2ball.name
                            print("\n (STEP 3B3/33) OF TEST_BALL4XI - NAME2BALL: ", name2ball)
                            # Process4Xi-1
                            # Thread-1 
                        except:
                            print("\n (STEP 3B4/33) OF TEST_BALL4XI *** FAILED TO GET NAME FROM PROCESS: ", str(p2ball)) 
                            
                        ball2xi.set(message2ball = name2ball, verb2ball = 'ball')
                        
                        coordinate2ball = ball2xi.get(id2ball = 'Yes', color2ball = 'Yes', x2ball = 'Yes', y2ball = 'Yes', z2ball = 'Yes', verb2ball = 'Yes', message2ball = 'Yes', radius2ball = 'Yes', area2ball = 'Yes')
                        print("\n (STEP 3B5/33) OF TEST_BALL4XI - UPGRADED COORDINATE2BALL: ", coordinate2ball)  
                        # {'0x0y0z': {'radius2ball': 10, 'x2ball': 0, 'z2ball': 0, 'area2ball': 1256.6370614359173, 'color2ball': '#F5E8E8', 'y2ball': 0, 'id2ball': '0x0y0z', 'verb2ball': 'ball', 'message2ball': 'Process4Xi-1'}}

                        ack4process = True
                        nack4process = False
                    except:
                        # -------------------------------------------------------------------------------------    
                        #
                        # -------------------------------------------------------------------------------------     
                        print("\n (STEP 3B2/33) OF TEST_BALL4XI *** FAILED TO CREATE PROCESS FOR BALL *** ")
                        nack4process = True
                        ack4process = False                        
                        
                    try:
               
                        # -------------------------------------------------------------------------------------    
                        # SHOT PROCESS - (10,10,10)
                        # -------------------------------------------------------------------------------------     
                        shot2xi = Ball4Xi(x2ball=10, y2ball=10, z2ball=10, radius2ball=10)
                        
                        shot2xi.set(x2ball=10, y2ball=10, z2ball=10, distance2shot = 20, azimuth2shot = pi/2, elevation2shot = pi/4)
                        
                        coordinate2shot = shot2xi.get(id2shot = 'Yes', color2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', verb2shot = 'Yes', distance2shot = 'Yes', area2shot = 'Yes')
                        print("\n (STEP 3C1/33) OF TEST_BALL4XI - COORDINATE2SHOT: ", coordinate2shot)    
                        # {'0x14y14z': {'x2shot': 0, 'verb2shot': '0', 'area2shot': 1256.6370614359173, 'id2shot': '0x14y14z', 'distance2shot': 20, 'z2shot': 14, 'color2shot': '#F3881C', 'y2shot': 14}}
                        if ack2dummy is False:
                            p2shot = Process4Xi(target=shoot2shot, args=(coordinate2shot, queue2shot, pipe2shot_publisher_channel))
                        else:
                            p2shot = DummyProcess4Xi(target=shoot2shot, args=(coordinate2shot, queue2shot, pipe2shot_publisher_channel))    
                        
                        
                        print("\n (STEP 3C2/33) OF TEST_BALL4XI - CREATED PROCESS FOR SHOT: ", str(p2shot)) 
                        # <Process4Xi(Process4Xi-2, initial)> 
                        # <DummyProcess4Xi(Thread-2, initial)>
                        name2shot = "unknown"
                        try:
                            name2shot = p2shot.name
                            print("\n (STEP 3C3/33) OF TEST_BALL4XI - NAME2SHOT: ", name2shot)
                            # Process4Xi-2
                            # Thread-2 
                        except:
                            print("\n (STEP 3C4/33) OF TEST_BALL4XI *** FAILED TO GET NAME FROM PROCESS: ", str(p2shot)) 
                            
                        shot2xi.set(message2shot = name2shot, verb2shot = 'shoot')
                        
                        coordinate2shot = shot2xi.get(id2shot = 'Yes', color2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', verb2shot = 'Yes', distance2shot = 'Yes', message2shot = 'Yes', area2shot = 'Yes')
                        print("\n (STEP 3C5/33) OF TEST_BALL4XI - UPGRADED COORDINATE2SHOT: ", coordinate2shot) 
                        # {'0x14y14z': {'x2shot': 0, 'message2shot': 'Process4Xi-2', 'verb2shot': 'shoot', 'area2shot': 1256.6370614359173, 'id2shot': '0x14y14z', 'distance2shot': 20, 'z2shot': 14, 'color2shot': '#F3881C', 'y2shot': 14}}

                        ack4process = True
                        nack4process = False
                    except:
                        # -------------------------------------------------------------------------------------    
                        #
                        # -------------------------------------------------------------------------------------     
                        print("\n (STEP 3C2/33) OF TEST_BALL4XI *** FAILED TO CREATE PROCESS FOR SHOT *** ")
                        nack4process = True
                        ack4process = False                        
                    try:
               
                        # -------------------------------------------------------------------------------------    
                        # CLUSTER PROCESS (100,100,100)
                        # -------------------------------------------------------------------------------------     
                        cluster2xi = Ball4Xi(x2ball=100, y2ball=100, z2ball=100, radius2ball=100)
                        
                        cluster2xi.set(azimuth2shot = pi/2, elevation2shot = pi/4, distance2shot=100)
                        
                        coordinate2cluster = cluster2xi.get(id2shot = 'Yes', color2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', verb2shot = 'Yes', distance2shot = 'Yes', area2shot = 'Yes')
                        print("\n (STEP 3D1/33) OF TEST_BALL4XI - COORDINATE2CLUSTER: ", coordinate2cluster)
                        # {'0x70y70z': {'x2shot': 0, 'verb2shot': '0', 'area2shot': 31415.926535897932, 'id2shot': '0x70y70z', 'distance2shot': 100, 'z2shot': 70, 'color2shot': '#F3881C', 'y2shot': 70}}
 
                        if ack2dummy is False:
                            p2cluster = Process4Xi(target=shoot2cluster, args=(coordinate2cluster, queue2cluster, pipe2cluster_publisher_channel))
                        else:
                            p2cluster = DummyProcess4Xi(target=shoot2cluster, args=(coordinate2cluster, queue2cluster, pipe2cluster_publisher_channel))    
                        
                        
                        print("\n (STEP 3D2/33) OF TEST_BALL4XI - CREATED PROCESS FOR CLUSTER: ", str(p2cluster))
                        # <Process4Xi(Process4Xi-3, initial)> 
                        # <DummyProcess4Xi(Thread-3, initial)>
                        name2cluster = "unknown"
                        try:
                            name2cluster = p2cluster.name
                            print("\n (STEP 3D3/33) OF TEST_BALL4XI - NAME2CLUSTER: ", name2cluster)
                            # Process4Xi-3
                            # Thread-3
                        except:
                            print("\n (STEP 3D4/33) OF TEST_BALL4XI *** FAILED TO GET NAME FROM PROCESS: ", str(p2cluster)) 
                            
                        cluster2xi.set(message2shot = name2cluster, verb2shot = 'cluster')
                        
                        coordinate2cluster = cluster2xi.get(id2shot = 'Yes', color2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', verb2shot = 'Yes', distance2shot = 'Yes', message2shot = 'Yes', area2shot = 'Yes')
                        print("\n (STEP 3D5/33) OF TEST_BALL4XI - UPGRADED COORDINATE2CLUSTER: ", coordinate2cluster) 
                        # {'0x70y70z': {'x2shot': 0, 'message2shot': 'Process4Xi-3', 'verb2shot': 'cluster', 'area2shot': 31415.926535897932, 'id2shot': '0x70y70z', 'distance2shot': 100, 'z2shot': 70, 'color2shot': '#F3881C', 'y2shot': 70}}
                                 
                        ack4process = True
                        nack4process = False
                    except:
                        # -------------------------------------------------------------------------------------    
                        #
                        # -------------------------------------------------------------------------------------     
                        print("\n (STEP 3D2/33) OF TEST_BALL4XI *** FAILED TO CREATE PROCESS FOR CLUSTER *** ")
                        nack4process = True
                        ack4process = False                        
                    try:
               
                        # -------------------------------------------------------------------------------------    
                        # SUPER CLUSTER PROCESS - (1000,1000,1000)
                        # -------------------------------------------------------------------------------------     
                        super2xi = Ball4Xi(x2ball=1000, y2ball=1000, z2ball=1000, radius2ball=1000)
                        
                        super2xi.set(azimuth2shot = pi/2, elevation2shot = pi/4, distance2shot=1000)
                        
                        coordinate2super = super2xi.get(id2shot = 'Yes', color2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', verb2shot = 'Yes', distance2shot = 'Yes', area2shot = 'Yes')                      
                        print("\n (STEP 3E1/33) OF TEST_BALL4XI - COORDINATE2SUPER: ", coordinate2super)
                        # {'0x707y707z': {'x2shot': 0, 'verb2shot': '0', 'area2shot': 3141592.653589793, 'id2shot': '0x707y707z', 'distance2shot': 1000, 'z2shot': 707, 'color2shot': '#F3881C', 'y2shot': 707}}
                        if ack2dummy is False:
                            p2super = Process4Xi(target=shoot2super, args=(coordinate2super, queue2super, pipe2super_publisher_channel))
                        else:
                            p2super = DummyProcess4Xi(target=shoot2super, args=(coordinate2super, queue2super, pipe2super_publisher_channel))    
                        
                        
                        print("\n (STEP 3E2/33) OF TEST_BALL4XI - CREATED PROCESS FOR SUPER: ", str(p2super))
                        # <Process4Xi(Process4Xi-4, initial)> 
                        # <DummyProcess4Xi(Thread-4, initial)>
                        name2super = "unknown"
                        try:
                            name2super = p2super.name
                            print("\n (STEP 3E3/33) OF TEST_BALL4XI - NAME2SUPER: ", name2super)
                            # Process4Xi-4
                            # Thread-4
                        except:
                            print("\n (STEP 3E4/33) OF TEST_BALL4XI *** FAILED TO GET NAME FROM PROCESS: ", str(p2super)) 
                            
                        super2xi.set(message2shot = name2super, verb2shot = 'dragonize')
                        
                        coordinate2super = super2xi.get(id2shot = 'Yes', color2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', verb2shot = 'Yes', distance2shot = 'Yes', message2shot = 'Yes', area2shot = 'Yes')
                        print("\n (STEP 3E5/33) OF TEST_BALL4XI - UPGRADED COORDINATE2SUPER: ", coordinate2super) 
                        # {'0x707y707z': {'x2shot': 0, 'message2shot': 'Process4Xi-4', 'verb2shot': 'dragonize', 'area2shot': 3141592.653589793, 'id2shot': '0x707y707z', 'distance2shot': 1000, 'z2shot': 707, 'color2shot': '#F3881C', 'y2shot': 707}}
                    
                        ack4process = True
                        nack4process = False
                    except:
                        # -------------------------------------------------------------------------------------    
                        #
                        # -------------------------------------------------------------------------------------     
                        print("\n (STEP 3E2/33) OF TEST_BALL4XI *** FAILED TO CREATE PROCESS FOR SUPER *** ")
                        nack4process = True
                        ack4process = False                                                                                                                          
                        
                except:
                    # -----------------------------------------------------------------------------------------    
                    #
                    # -----------------------------------------------------------------------------------------     
                    print("\n (STEP 3F/33) OF TEST_BALL4XI *** FAILED TO CREATE PROCESSES ***")
                                            
                # ---------------------------------------------------------------------------------------------
                # START PROCESSES                      
                # ---------------------------------------------------------------------------------------------  
                if ack4process is True:
                    print("\n (STEP 4/33) OF TEST_BALL4XI - STARTING PROCESSES")
                    ack4start = True
                    nack4start = False        
                    
                    try:
                        p2ball.start() 
                        print("\n (STEP 4A/33) OF TEST_BALL4XI - STARTED BALL PROCESS: ", str(p2ball))
                        # <Process4Xi(Process4Xi-1, stopped)>
                        # <DummyProcess4Xi(Thread-1, started 4000)>
                    except:
                        print("\n (STEP 4B/33) OF TEST_BALL4XI *** FAILED TO START BALL PROCESS: ", str(p2ball))                
                        nack4start = True
                        ack4start = False      
    
                    try:
                        p2shot.start() 
                        print("\n (STEP 4C/33) OF TEST_BALL4XI - STARTED SHOT PROCESS: ", str(p2shot))
                        # <Process4Xi(Process4Xi-2, stopped)>
                        # <DummyProcess4Xi(Thread-2, started 3996)>
                    except:
                        print("\n (STEP 4D/33) OF TEST_BALL4XI *** FAILED TO START SHOT PROCESS: ", str(p2shot))                
                        nack4start = True
                        ack4start = False  
    
                    try:
                        p2cluster.start() 
                        print("\n (STEP 4E/33) OF TEST_BALL4XI - STARTED CLUSTER PROCESS: ", str(p2cluster))
                        # <Process4Xi(Process4Xi-3, stopped)>
                        # <DummyProcess4Xi(Thread-3, started 4276)>
                    except:
                        print("\n (STEP 4F/33) OF TEST_BALL4XI *** FAILED TO START CLUSTER PROCESS: ", str(p2cluster))                
                        nack4start = True
                        ack4start = False   

                    try:
                        p2super.start() 
                        print("\n (STEP 4G/33) OF TEST_BALL4XI - STARTED SUPER PROCESS: ", str(p2super))
                        # <Process4Xi(Process4Xi-4, stopped)>
                        # <DummyProcess4Xi(Thread-4, started 4120)>
                    except:
                        print("\n (STEP 4H/33) OF TEST_BALL4XI *** FAILED TO START SUPER PROCESS: ", str(p2super))                
                        nack4start = True
                        ack4start = False
                                                                           
                    if ack4start is True:
                        print("\n (STEP 4I/33) OF TEST_BALL4XI - STARTED ALL PROCESSES")
                    else:
                        print("\n (STEP 4J/33) OF TEST_BALL4XI *** FAILED TO START ALL PROCESSES ***") 
                else:
                    print("\n (STEP 4K/33) OF TEST_BALL4XI ** SKIPPED STARTING PROCESSES ACK4PROCESS: ", ack4process) 
                    nack4start = True
                    ack4start = False
                                            
                # ---------------------------------------------------------------------------------------------
                # CHECK WHETHER PROCESSES ARE ALIVE                       
                # ---------------------------------------------------------------------------------------------  
                if ack4process is True:
                    print("\n (STEP 5/33) OF TEST_BALL4XI - CHECKING WHETHER PROCESSES ARE ALIVE") 
                    
                    try:
                        status2ball = p2ball.is_alive()
                        print("\n (STEP 5A/33) OF TEST_BALL4XI - BALL PROCESS STATUS: ", status2ball)
                        # 
                    except:
                        print("\n (STEP 5B/33) OF TEST_BALL4XI *** FAILED TO CHECK BALL PROCESS ALIVE STATUS: ", str(p2ball))                
                        status2ball = False   
    
                    try:
                        status2shot = p2shot.is_alive()
                        print("\n (STEP 5C/33) OF TEST_BALL4XI - SHOT PROCESS STATUS: ", p2shot.is_alive())
                        # 
                                                
                    except:
                        print("\n (STEP 5D/33) OF TEST_BALL4XI *** FAILED TO CHECK  SHOT PROCESS ALIVE STATUS: ", str(p2shot))                
                        # 
                        status2shot = False
    
                    try:
                        status2cluster = p2cluster.is_alive()
                        print("\n (STEP 5E/33) OF TEST_BALL4XI - CLUSTER PROCESS STATUS: ", p2cluster.is_alive())
                        # True
                        
                    except:
                        print("\n (STEP 5F/33) OF TEST_BALL4XI *** FAILED TO CHECK CLUSTER PROCESS ALIVE STATUS: ", str(p2cluster))                
                        # 
                        status2cluster = False   

                    try:
                        status2super = p2super.is_alive()
                        print("\n (STEP 5G/33) OF TEST_BALL4XI - SUPER PROCESS STATUS: ", p2super.is_alive())
                        # True 
                        
                    except:
                        print("\n (STEP 5H/33) OF TEST_BALL4XI *** FAILED TO CHECK SUPER PROCESS ALIVE STATUS: ", str(p2super))                
                        # 
                        status2super = False
                                                                           
                    if ((status2ball is True) and (status2shot is True) and (status2cluster is True) and (status2super is True)):
                        print("\n (STEP 5I/33) OF TEST_BALL4XI - ALL PROCESSES FOUND TO BE ALIVE")
                        print("STATUS2BALL: ", status2ball, "STATUS2SHOT: ", status2shot, "STATUS2CLUSTER: ", status2cluster, "STATUS2SUPER: ", status2super)
                        # STATUS2BALL:  True STATUS2SHOT:  True STATUS2CLUSTER:  True STATUS2SUPER:  True  
                    else:
                        print("\n (STEP 5J/33) OF TEST_BALL4XI *** SOME PROCESSES FOUND TO BE NOT ALIVE ***")
                        print("STATUS2BALL: ", status2ball, "STATUS2SHOT: ", status2shot, "STATUS2CLUSTER: ", status2cluster, "STATUS2SUPER: ", status2super)
                        # STATUS2BALL:  True STATUS2SHOT:  False STATUS2CLUSTER:  True STATUS2SUPER:  True   
                else:
                    print("\n (STEP 5K/33) OF TEST_BALL4XI ** SKIPPED CHECKING WHETHER PROCESSES ARE ALIVE, ACK4PROCESS: ", ack4process) 
                    nack4start = True
                    ack4start = False
                
                if ack2dummy is False:                                                                                   
                    # ---------------------------------------------------------------------------------------------
                    # RUN PROCESSES                     
                    # ---------------------------------------------------------------------------------------------  
                    if ack4start is True:
        
                   
                        print("\n (STEP 6/33) OF TEST_BALL4XI - RUNNING PROCESSES")
                        nack4run = False
                        ack4run = True  
                        
                        try:
                            p2ball.run() 
                            print("\n (STEP 6A/33) OF TEST_BALL4XI - RUN BALL PROCESS: ", str(p2ball))
                            # <Process4Xi(Process4Xi-1, stopped)> 
                            
                        except:
                            print("\n (STEP 6B/33) OF TEST_BALL4XI *** FAILED TO RUN BALL PROCESS: ", str(p2ball))                
                            ack4run = False
                            nack4run = True    
        
                        try:
                            p2shot.run() 
                            print("\n (STEP 6C/33) OF TEST_BALL4XI - RUN SHOT PROCESS: ", str(p2shot))
                            # <Process4Xi(Process4Xi-2, stopped)>  
                            
                        except:
                            print("\n (STEP 6D/33) OF TEST_BALL4XI *** FAILED TO RUN SHOT PROCESS: ", str(p2shot))                
                            ack4run = False
                            nack4run = True    
        
                        try:
                            p2cluster.run() 
                            print("\n (STEP 6E/33) OF TEST_BALL4XI - RUN CLUSTER PROCESS: ", str(p2cluster))
                            # <Process4Xi(Process4Xi-3, stopped)> 
                            
                        except:
                            print("\n (STEP 6F/33) OF TEST_BALL4XI *** FAILED TO RUN CLUSTER PROCESS: ", str(p2cluster))                
                            ack4run = False
                            nack4run = True     
    
                        try:
                            p2super.run() 
                            print("\n (STEP 6G/33) OF TEST_BALL4XI - RUN SUPER PROCESS: ", str(p2super))
                            # <Process4Xi(Process4Xi-4, stopped)> 
                            
                        except:
                            print("\n (STEP 6H/33) OF TEST_BALL4XI *** FAILED TO RUN SUPER PROCESS: ", str(p2super))                
                            ack4run = False
                            nack4run = True    
                                                                               
                        if ack4run is True:
                            print("\n (STEP 6I/33) OF TEST_BALL4XI - RUN ALL PROCESSES")
                        else:
                            print("\n (STEP 6J/33) OF TEST_BALL4XI *** FAILED TO RUN ALL PROCESSES ***") 
                    else:
                        print("\n (STEP 6K/33) OF TEST_BALL4XI ** SKIPPED RUNNING PROCESSES ACK4START: ", ack4start) 
                        ack4run = False
                        nack4run = True                      
                else:
                    print("\n (STEP 6L/33) OF TEST_BALL4XI - SKIPPED RUNNING PROCESSES ACK4DUMMY: ", ack2dummy) 
                    # True
                            
                # ---------------------------------------------------------------------------------------------
                # GET FROM QUEUES                     
                # ---------------------------------------------------------------------------------------------
                if ack4process is True:
                    print("\n (STEP 7A/33) OF TEST_BALL4XI - GETTING FROM QUEUES")
                
                    # ---------------------------------------------------------------------------------------------    
                    # BALL QUEUE GETTING
                    # ---------------------------------------------------------------------------------------------                     
                    ack4queue = False
                    nack4queue = True    
                    count2try = 0
                    try:  
                        # -----------------------------------------------------------------------------------------    
                        # 
                        # -----------------------------------------------------------------------------------------                           
                        while ((count2try < 3) and (ack4queue is False)):
                            # -------------------------------------------------------------------------------------    
                            # 
                            # -------------------------------------------------------------------------------------     
                            try:         
                                print("\n (STEP 7A/33) OF TEST_BALL4XI - GOT FROM QUEUE2BALL: ")  
                                print (queue2ball.get())
                                ack4queue = True
                                nack4queue = False                             
                                # ['shoot2ball4xi', {'0x0y0z': {'x2ball': 0, 'z2ball': 0, 'color2ball': '#F5E8E8', 'y2ball': 0, 'id2ball': '0x0y0z', 'verb2ball': 'skeletonize'}}]
                                
                            except:
                                # ---------------------------------------------------------------------------------    
                                #
                                # ---------------------------------------------------------------------------------     
                                print("\n (STEP 7B/33) OF TEST_BALL4XI ** RE-TRIAL FROM QUEUE2BALL WAS NEEDED ** ")
                                count2try = count2try + 1
                                nack4queue = True
                                ack4queue = False 
                        # -----------------------------------------------------------------------------------------    
                        # 
                        # -----------------------------------------------------------------------------------------                                 
                    except:
                        # -----------------------------------------------------------------------------------------    
                        #
                        # -----------------------------------------------------------------------------------------     
                        print("\n (STEP 7C/33) OF TEST_BALL4XI ** FAILED TO GET FROM QUEUE2BALL *** ")
                        nack4queue = True
                        ack4queue = False
                    finally:
                        print("\n (STEP 7D/33) OF TEST_BALL4XI - COMPLETED TRYING TO GET FROM QUEUE2BALL")
                                     
                    # ---------------------------------------------------------------------------------------------    
                    # SHOT QUEUE GETTING
                    # ---------------------------------------------------------------------------------------------                     
                    ack4queue = False
                    nack4queue = True                        
                    count2try = 0
                    try:  
                        # -----------------------------------------------------------------------------------------    
                        # 
                        # -----------------------------------------------------------------------------------------                           
                        while ((count2try < 3) and (ack4queue is False)):
                            # -------------------------------------------------------------------------------------    
                            # 
                            # -------------------------------------------------------------------------------------     
                            try:         
                                print("\n (STEP 8A/33) OF TEST_BALL4XI - GOT FROM QUEUE2SHOT: ")
                                print (queue2shot.get())
                                ack4queue = True
                                nack4queue = False                             
                                # ['shoot2shot4xi', {'0x14y14z': {'distance2shot': 20, 'verb2shot': '0', 'area2shot': 1256.6370614359173, 'id2shot': '0x14y14z', 'x2shot': 0, 'z2shot': 14, 'y2shot': 14, 'color2shot': '#F3881C'}}]
 
                            except:
                                # ---------------------------------------------------------------------------------    
                                #
                                # ---------------------------------------------------------------------------------     
                                print("\n (STEP 8B/33) OF TEST_BALL4XI ** RE-TRIAL FROM QUEUE2SHOT WAS NEEDED ** ")
                                count2try = count2try + 1
                                nack4queue = True
                                ack4queue = False 
                        # -----------------------------------------------------------------------------------------    
                        # 
                        # -----------------------------------------------------------------------------------------                                 
                    except:
                        # -----------------------------------------------------------------------------------------    
                        #
                        # -----------------------------------------------------------------------------------------     
                        print("\n (STEP 8C/33) OF TEST_BALL4XI ** FAILED TO GET FROM QUEUE2SHOT *** ")
                        nack4queue = True
                        ack4queue = False
                    finally:
                        print("\n (STEP 8D/33) OF TEST_BALL4XI - COMPLETED TRYING TO GET FROM QUEUE2SHOT")       
                                     
                    # ---------------------------------------------------------------------------------------------    
                    # CLUSTER QUEUE GETTING
                    # ---------------------------------------------------------------------------------------------                     
                    ack4queue = False
                    nack4queue = True                        
                    count2try = 0
                    try:  
                        # -----------------------------------------------------------------------------------------    
                        # 
                        # -----------------------------------------------------------------------------------------                           
                        while ((count2try < 3) and (ack4queue is False)):
                            # -------------------------------------------------------------------------------------    
                            # 
                            # -------------------------------------------------------------------------------------     
                            try:         
                                print("\n (STEP 9A/33) OF TEST_BALL4XI - GOT FROM QUEUE2CLUSTER: ")
                                print (queue2cluster.get())
                                ack4queue = True
                                nack4queue = False                             
                                # ['shoot2cluster4xi', {'0x70y70z': {'distance2shot': 100, 'verb2shot': '0', 'area2shot': 31415.926535897932, 'id2shot': '0x70y70z', 'x2shot': 0, 'z2shot': 70, 'y2shot': 70, 'color2shot': '#F3881C'}}]
                                
                            except:
                                # ---------------------------------------------------------------------------------    
                                #
                                # ---------------------------------------------------------------------------------     
                                print("\n (STEP 9B/33) OF TEST_BALL4XI ** RE-TRIAL FROM QUEUE2CLUSTER WAS NEEDED ** ")
                                count2try = count2try + 1
                                nack4queue = True
                                ack4queue = False 
                        # -----------------------------------------------------------------------------------------    
                        # 
                        # -----------------------------------------------------------------------------------------                                 
                    except:
                        # -----------------------------------------------------------------------------------------    
                        #
                        # -----------------------------------------------------------------------------------------     
                        print("\n (STEP 9C/33) OF TEST_BALL4XI ** FAILED TO GET FROM QUEUE2CLUSTER *** ")
                        nack4queue = True
                        ack4queue = False
                    finally:
                        print("\n (STEP 9D/33) OF TEST_BALL4XI - COMPLETED TRYING TO GET FROM QUEUE2CLUSTER")       
                                     
                    # ---------------------------------------------------------------------------------------------    
                    # SUPER QUEUE GETTING
                    # ---------------------------------------------------------------------------------------------                     
                    ack4queue = False
                    nack4queue = True                        
                    count2try = 0
                    try:  
                        # -----------------------------------------------------------------------------------------    
                        # 
                        # -----------------------------------------------------------------------------------------                           
                        while ((count2try < 3) and (ack4queue is False)):
                            # -------------------------------------------------------------------------------------    
                            # 
                            # -------------------------------------------------------------------------------------     
                            try:         
                                print("\n (STEP 10A/33) OF TEST_BALL4XI - GOT FROM QUEUE2SUPER: ")
                                print (queue2super.get())
                                ack4queue = True
                                nack4queue = False                             
                                # ['shoot2super4xi', {'0x707y707z': {'distance2shot': 1000, 'verb2shot': '0', 'area2shot': 3141592.653589793, 'id2shot': '0x707y707z', 'x2shot': 0, 'z2shot': 707, 'y2shot': 707, 'color2shot': '#F3881C'}}] 
                                 
                            except:
                                # ---------------------------------------------------------------------------------    
                                #
                                # ---------------------------------------------------------------------------------     
                                print("\n (STEP 10B/33) OF TEST_BALL4XI ** RE-TRIAL FROM QUEUE2SUPER WAS NEEDED ** ")
                                count2try = count2try + 1
                                nack4queue = True
                                ack4queue = False 
                        # -----------------------------------------------------------------------------------------    
                        # 
                        # -----------------------------------------------------------------------------------------                                 
                    except:
                        # -----------------------------------------------------------------------------------------    
                        #
                        # -----------------------------------------------------------------------------------------     
                        print("\n (STEP 10C/33) OF TEST_BALL4XI ** FAILED TO GET FROM QUEUE2SUPER *** ")
                        nack4queue = True
                        ack4queue = False
                    finally:
                        print("\n (STEP 10D/33) OF TEST_BALL4XI - COMPLETED TRYING TO GET FROM QUEUE2SUPER")                                                                                                                                                                                                                   
                else:
                    print("\n (STEP 10E/33) OF TEST_BALL4XI *** SKIPPED GET FROM QUEUES ACK4RUN: ", ack4run) 
                
                ack2bytes4receiving = False  # alter if you want to explore how data is received via pipes!
                               
                # ---------------------------------------------------------------------------------------------
                # RECEIVE FROM PIPES                     
                # ---------------------------------------------------------------------------------------------  
                if ack4process is True:
                    print("\n (STEP 11A/33) OF TEST_BALL4XI - RECEIVING FROM PIPES")
                
                    # ---------------------------------------------------------------------------------------------    
                    # BALL PIPE RECEIVING
                    # ---------------------------------------------------------------------------------------------                     
                    ack4pipes = False
                    nackpipes = True    
                    try:  
                        # -----------------------------------------------------------------------------------------    
                        # 
                        # -----------------------------------------------------------------------------------------                           
                        if ack2bytes4receiving is True:
                            received4pipe2ball = pipe2ball_consumer_channel.recv_bytes()
                            ack4pipes = True
                            nack4pipes = False  
                            print("\n (STEP 11A/33) OF TEST_BALL4XI - RECEIVED FROM PIPE2BALL: ", received4pipe2ball)
                            # b'\x80\x03]q\x00(X\x0c\x00\x00\x00shot2ball4xiq\x01}q\x02X\x06\x00\x00\  ...  
                        else:
                            received4pipe2ball = pipe2ball_consumer_channel.recv()
                            ack4pipes = True
                            nack4pipes = False  
                            print("\n (STEP 11B/33) OF TEST_BALL4XI - RECEIVED FROM PIPE2BALL: ", received4pipe2ball)
                            # ['shot2ball4xi', {'0x0y0z': {'color2ball': '#F5E8E8', 'y2ball': 0, 'z2ball': 0, 'x2ball': 0, 'verb2ball': 'skeletonize', 'id2ball': '0x0y0z'}}]
                                                             
                    except:
                        # -----------------------------------------------------------------------------------------    
                        #
                        # -----------------------------------------------------------------------------------------     
                        print("\n (STEP 11Z/33) OF TEST_BALL4XI ** FAILED TO RECEIVE FROM PIPE2BALL *** ")
                        nack4pipes = True
                        ack4pipes = False
                
                    # ---------------------------------------------------------------------------------------------    
                    # SHOT PIPE RECEIVING
                    # ---------------------------------------------------------------------------------------------                     
                    ack4pipes = False
                    nackpipes = True    
                    try:  
                        # -----------------------------------------------------------------------------------------    
                        # 
                        # -----------------------------------------------------------------------------------------                           
                        if ack2bytes4receiving is True:
                            received4pipe2shot = pipe2shot_consumer_channel.recv_bytes()        
                                    
                            print("\n (STEP 12A/33) OF TEST_BALL4XI - RECEIVED FROM PIPE2SHOT: ", received4pipe2shot)
                            ack4pipes = True
                            nack4pipes = False                             
                            # b'\x80\x03]q\x00(X\x0c\x00\x00\x00shot2shot4xiq\x01}q\x02X\x08\x00\x00\x000x14y1 ... <-- if  recv_bytes 
                        else:
                            received4pipe2shot = pipe2shot_consumer_channel.recv()        
                                    
                            print("\n (STEP 12B/33) OF TEST_BALL4XI - RECEIVED FROM PIPE2SHOT: ", received4pipe2shot)
                            ack4pipes = True
                            nack4pipes = False                             
                            # ['shot2shot4xi', {'0x14y14z': {'distance2shot': 20, 'verb2shot': '0', 'y2shot': 14, 'color2shot': '#F3881C', 'x2shot': 0, 'z2shot': 14, 'id2shot': '0x14y14z', 'area2shot': 1256.6370614359173}}]
                                                          
                    except:
                        # -----------------------------------------------------------------------------------------    
                        #
                        # -----------------------------------------------------------------------------------------     
                        print("\n (STEP 12C/33) OF TEST_BALL4XI ** FAILED TO RECEIVE FROM PIPE2SHOT *** ")
                        nack4pipes = True
                        ack4pipes = False        

                        
                    # ---------------------------------------------------------------------------------------------    
                    # CLUSTER PIPE RECEIVING
                    # ---------------------------------------------------------------------------------------------                     
                    ack4pipes = False
                    nackpipes = True    
                    try:  
                        # -----------------------------------------------------------------------------------------    
                        # 
                        # -----------------------------------------------------------------------------------------                           
                        if ack2bytes4receiving is True:
                            received4pipe2cluster = pipe2cluster_consumer_channel.recv_bytes()  
                            
                            print("\n (STEP 13A/33) OF TEST_BALL4XI - RECEIVED FROM PIPE2CLUSTER: ", received4pipe2cluster) 
                            ack4pipes = True
                            nack4pipes = False                             
                            # b'\x80\x03]q\x00(X\x0f\x00\x00\x00shot2cluster4xiq\x01}q\x02X\x08\x00\x00\x000x70 ... <-- recv_bytes 
                        else:
                            received4pipe2cluster = pipe2cluster_consumer_channel.recv()
                            
                            print("\n (STEP 13B/33) OF TEST_BALL4XI - RECEIVED FROM PIPE2CLUSTER: ", received4pipe2cluster) 
                            ack4pipes = True
                            nack4pipes = False                             
                            # ['shot2cluster4xi', {'0x70y70z': {'distance2shot': 100, 'verb2shot': '0', 'y2shot': 70, 'color2shot': '#F3881C',
                            #  'x2shot': 0, 'z2shot': 70, 'id2shot': '0x70y70z', 'area2shot': 31415.926535897932}}]
       
                    except:
                        # -----------------------------------------------------------------------------------------    
                        #
                        # -----------------------------------------------------------------------------------------     
                        print("\n (STEP 13C/33) OF TEST_BALL4XI ** FAILED TO RECEIVE FROM PIPE2CLUSTER *** ")
                        nack4pipes = True
                        ack4pipes = False                
       
                        
                    # ---------------------------------------------------------------------------------------------    
                    # SUPER PIPE RECEIVING
                    # ---------------------------------------------------------------------------------------------                     
                    ack4pipes = False
                    nackpipes = True    
                    try:
                        if ack2bytes4receiving is True:  
                            received4pipe2super = pipe2super_consumer_channel.recv_bytes()  
                            
                            print("\n (STEP 14A/33) OF TEST_BALL4XI - RECEIVED FROM PIPE2SUPER: ", received4pipe2super)
                            ack4pipes = True
                            nack4pipes = False                             
                            # b'\x80\x03]q\x00(X\r\x00\x00\x00shot2super4xiq\x01}q\x02X\n\x00\x00\x000x707y707 ...
                        else:
                            received4pipe2super = pipe2super_consumer_channel.recv()  
                            
                            print("\n (STEP 14B/33) OF TEST_BALL4XI - RECEIVED FROM PIPE2SUPER: ", received4pipe2super)
                            ack4pipes = True
                            nack4pipes = False                             
                            # ['shot2super4xi', {'0x707y707z': {'distance2shot': 1000, 'verb2shot': '0', 'y2shot': 707, 'color2shot': '#F3881C', 
                            #  'x2shot': 0, 'z2shot': 707, 'id2shot': '0x707y707z', 'area2shot': 3141592.653589793}}]

                                                     
                    except:
                        # -----------------------------------------------------------------------------------------    
                        #
                        # -----------------------------------------------------------------------------------------     
                        print("\n (STEP 14C/33) OF TEST_BALL4XI ** FAILED TO RECEIVE FROM PIPE2SUPER *** ")
                        nack4pipes = True
                        ack4pipes = False                
                
                else:
                    print("\n (STEP 14E/33) OF TEST_BALL4XI *** SKIPPED RECEIVING FROM PIPES - ACK4PROCESS: ", ack4process)   
                         
                # ---------------------------------------------------------------------------------------------
                # SHOOT SEVERAL SHOTS PER PROCESS                      
                # ---------------------------------------------------------------------------------------------  
                if ack4process is True:
                    try:
                        print("\n (STEP 15/33) OF TEST_BALL4XI - STARTING TO SHOOT SEVERAL SHOTS PER PROCESS ", time4xi())   
                        # -------------------------------------------------------------------------------------    
                        # BALL PROCESS - SHOOT INTO BALL
                        # -------------------------------------------------------------------------------------     
                        ball2xi.init(radius2ball = 100, distance2shot = 100)
                        status2ball = ball2xi.get()
                        print("\n (STEP 15A0/33) OF TEST_BALL4XI - BALL BEFORE SHOTS: ", status2ball)   
                        #  (STEP 15A0/33) BALL BEFORE SHOTS:
                        #   {'0x0y100z': {'time2shot': '04:08:03 05/30/10 Pacific Daylight Time', 'accerelation2shot': 0, 'x2shot': 0, 'azimuth2shot': 0, 'message2shot': 'CurrentProcess4Xi', 'velocity2shot': 0, 'verb2shot': 'skeletonizing', 'area2shot': 31415.926535897932, 'y2shot': 0, 'id2shot': '0x0y100z', 'distance2shot': 100, 'z2shot': 100, 'elevation2shot': 0, 'color2shot': '#F3881C'}, 
                        #      '0x0y0z': {'radius2ball': 100, 'x2ball': 0, 'z2ball': 0, 'area2ball': 125663.70614359173, 'color2ball': '#F5E8E8', 'y2ball': 0, 'id2ball': '0x0y0z', 'verb2ball': 'skeletonize', 'time2ball': '04:08:03 05/30/10 Pacific Daylight Time', 'message2ball': 'Process4Xi-1', 'volume2ball': 4188790.2047863905}}

                                                
                        #[A] TOWARDS (Z+) KEEPING ELEVATION ZERO; X AND Y REMAIN ZERO 
                        ball2xi.set(azimuth2shot = pi/4, elevation2shot = 0, distance2shot = 110)     # 45 right
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15A1/33) OF TEST_BALL4XI - STATUS: ", status2ball)   
                        # {'0x0y110z': {'x2shot': 0, 'azimuth2shot': 0.7853981633974483, 'id2shot': '0x0y110z', 'distance2shot': 110, 'z2shot': 110, 'elevation2shot': 0, 'y2shot': 0}}
                        
                        ball2xi.set(azimuth2shot = pi/3, elevation2shot = 0, distance2shot = 120)     # 60 right
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15A2/33) OF TEST_BALL4XI - STATUS: ", status2ball)   
                        # {'0x0y120z': {'x2shot': 0, 'azimuth2shot': 1.0471975511965976, 'id2shot': '0x0y120z', 'distance2shot': 120, 'z2shot': 120, 'elevation2shot': 0, 'y2shot': 0}}  
                                                
                        ball2xi.set(azimuth2shot = pi/2, elevation2shot = 0, distance2shot = 130)     # 90 right
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15A3/33) OF TEST_BALL4XI - STATUS: ", status2ball)   
                        # {'0x0y130z': {'x2shot': 0, 'azimuth2shot': 1.5707963267948966, 'id2shot': '0x0y130z', 'distance2shot': 130, 'z2shot': 130, 'elevation2shot': 0, 'y2shot': 0}}  
                        
                        ball2xi.set(azimuth2shot = 3*pi/4, elevation2shot = 0, distance2shot = 140)   # 135 right
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15A4/33) OF TEST_BALL4XI - STATUS: ", status2ball)                         
                        # {'0x0y140z': {'x2shot': 0, 'azimuth2shot': 2.356194490192345, 'id2shot': '0x0y140z', 'distance2shot': 140, 'z2shot': 140, 'elevation2shot': 0, 'y2shot': 0}}
                        
                        ball2xi.set(azimuth2shot = pi, elevation2shot = 0, distance2shot = 150)       # 180 right
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15A6/33) OF TEST_BALL4XI - STATUS: ", status2ball)                         
                        # {'0x0y150z': {'x2shot': 0, 'azimuth2shot': 3.141592653589793, 'id2shot': '0x0y150z', 'distance2shot': 150, 'z2shot': 150, 'elevation2shot': 0, 'y2shot': 0}} 
                        
                        #[B] TOWARDS (Z+) KEEPING ELEVATION ZERO; X AND Y REMAIN ZERO
                        ball2xi.set(azimuth2shot = -pi/4, elevation2shot = 0, distance2shot = 160)    # 45 left
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15B1/33) OF TEST_BALL4XI - STATUS: ", status2ball)   
                        # {'0x0y160z': {'x2shot': 0, 'azimuth2shot': -0.7853981633974483, 'id2shot': '0x0y160z', 'distance2shot': 160, 'z2shot': 160, 'elevation2shot': 0, 'y2shot': 0}} 
                                                
                        ball2xi.set(azimuth2shot = -pi/3, elevation2shot = 0, distance2shot = 170)    # 60 left
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15B2/33) OF TEST_BALL4XI - STATUS: ", status2ball)   
                        # {'0x0y170z': {'x2shot': 0, 'azimuth2shot': -1.0471975511965976, 'id2shot': '0x0y170z', 'distance2shot': 170, 'z2shot': 170, 'elevation2shot': 0, 'y2shot': 0}}
                                                  
                        ball2xi.set(azimuth2shot = -pi/2, elevation2shot = 0, distance2shot = 180)    # 90 left
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15B3/33) OF TEST_BALL4XI - STATUS: ", status2ball)   
                        # {'0x0y180z': {'x2shot': 0, 'azimuth2shot': -1.5707963267948966, 'id2shot': '0x0y180z', 'distance2shot': 180, 'z2shot': 180, 'elevation2shot': 0, 'y2shot': 0}}                         
 
                        ball2xi.set(azimuth2shot = -3*pi/4, elevation2shot = 0, distance2shot = 190)  # 135 left
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15B4/33) OF TEST_BALL4XI - STATUS: ", status2ball)                           
                        # {'0x0y190z': {'x2shot': 0, 'azimuth2shot': -2.356194490192345, 'id2shot': '0x0y190z', 'distance2shot': 190, 'z2shot': 190, 'elevation2shot': 0, 'y2shot': 0}}
                        
                        ball2xi.set(azimuth2shot = -pi, elevation2shot = 0, distance2shot = 200)      # 180 left
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15B5/33) OF TEST_BALL4XI - STATUS: ", status2ball)                           
                        # {'0x0y200z': {'x2shot': 0, 'azimuth2shot': -3.141592653589793, 'id2shot': '0x0y200z', 'distance2shot': 200, 'z2shot': 200, 'elevation2shot': 0, 'y2shot': 0}}

                        #[C] BACKWARDS (X-) KEEPING AZIMUTH ZERO
                        ball2xi.set(azimuth2shot = 0, elevation2shot = pi/4, distance2shot = 210)     # 45 up
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15C1/33) OF TEST_BALL4XI - STATUS: ", status2ball)   
                        # {'-148x0y148z': {'x2shot': -148, 'azimuth2shot': -3.141592653589793, 'id2shot': '-148x0y148z', 'distance2shot': 210, 'z2shot': 148, 'elevation2shot': 0.7853981633974483, 'y2shot': 0}}
                                                                         
                        ball2xi.set(azimuth2shot = 0, elevation2shot = pi/3, distance2shot = 220)     # 60 up
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15C2/33) OF TEST_BALL4XI - STATUS: ", status2ball)   
                        # {'-190x0y110z': {'x2shot': -190, 'azimuth2shot': -3.141592653589793, 'id2shot': '-190x0y110z', 'distance2shot': 220, 'z2shot': 110, 'elevation2shot': 1.0471975511965976, 'y2shot': 0}} 
                                                  
                        ball2xi.set(azimuth2shot = 0, elevation2shot = pi/2, distance2shot = 230)     # 90 up
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15C3/33) OF TEST_BALL4XI - STATUS: ", status2ball)   
                        # {'-230x0y0z': {'x2shot': -230, 'azimuth2shot': -3.141592653589793, 'id2shot': '-230x0y0z', 'distance2shot': 230, 'z2shot': 0, 'elevation2shot': 1.5707963267948966, 'y2shot': 0}}                      
                        
                        ball2xi.set(azimuth2shot = 0, elevation2shot = 3*pi/4, distance2shot = 240)   # 135 up
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15C4/33) OF TEST_BALL4XI - STATUS: ", status2ball)
                        # {'-169x0y-169z': {'x2shot': -169, 'azimuth2shot': -3.141592653589793, 'id2shot': '-169x0y-169z', 'distance2shot': 240, 'z2shot': -169, 'elevation2shot': 2.356194490192345, 'y2shot': 0}}
                        
                        ball2xi.set(azimuth2shot = 0, elevation2shot = pi, distance2shot = 250)       # 180 up
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15C5/33) OF TEST_BALL4XI - STATUS: ", status2ball)
                        # {'0x0y-250z': {'x2shot': 0, 'azimuth2shot': -3.141592653589793, 'id2shot': '0x0y-250z', 'distance2shot': 250, 'z2shot': -250, 'elevation2shot': 3.141592653589793, 'y2shot': 0}}
                                       
                        
                        #[D] DOWN KEEPING AZIMUTH ZERO; Y REMAINS ZERO
                        ball2xi.set(azimuth2shot = 0, elevation2shot = -pi/4, distance2shot = 260)     # 45 down
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15D1/33) OF TEST_BALL4XI - STATUS: ", status2ball)   
                        # {'183x0y183z': {'x2shot': 183, 'azimuth2shot': -3.141592653589793, 'id2shot': '183x0y183z', 'distance2shot': 260, 'z2shot': 183, 'elevation2shot': -0.7853981633974483, 'y2shot': 0}}                        
                        
                        ball2xi.set(azimuth2shot = 0, elevation2shot = -pi/3, distance2shot = 270)     # 60 down
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15D2/33) OF TEST_BALL4XI - STATUS: ", status2ball)   
                        # {'233x0y135z': {'x2shot': 233, 'azimuth2shot': -3.141592653589793, 'id2shot': '233x0y135z', 'distance2shot': 270, 'z2shot': 135, 'elevation2shot': -1.0471975511965976, 'y2shot': 0}}                         
                             
                        ball2xi.set(azimuth2shot = 0, elevation2shot = -pi/2, distance2shot = 280)     # 90 down
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15D3/33) OF TEST_BALL4XI - STATUS: ", status2ball)   
                        # {'280x0y0z': {'x2shot': 280, 'azimuth2shot': -3.141592653589793, 'id2shot': '280x0y0z', 'distance2shot': 280, 'z2shot': 0, 'elevation2shot': -1.5707963267948966, 'y2shot': 0}} 
                        
                        ball2xi.set(azimuth2shot = 0, elevation2shot = -3*pi/4, distance2shot = 290)   # 135 down
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15D4/33) OF TEST_BALL4XI - STATUS: ", status2ball)                               
                        # {'205x0y-205z': {'x2shot': 205, 'azimuth2shot': -3.141592653589793, 'id2shot': '205x0y-205z', 'distance2shot': 290, 'z2shot': -205, 'elevation2shot': -2.356194490192345, 'y2shot': 0}}
                        
                        ball2xi.set(azimuth2shot = 0, elevation2shot = -pi, distance2shot = 300)        # 180 down
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15D5/33) OF TEST_BALL4XI - STATUS: ", status2ball)                               
                        # {'0x0y-300z': {'x2shot': 0, 'azimuth2shot': -3.141592653589793, 'id2shot': '0x0y-300z', 'distance2shot': 300, 'z2shot': -300, 'elevation2shot': -3.141592653589793, 'y2shot': 0}} 
                        
                        #[E] RIGHT AND UP
                        ball2xi.set(azimuth2shot = pi/4, elevation2shot = pi/4, distance2shot = 310)   # 45 right & up
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15E1/33) OF TEST_BALL4XI - STATUS: ", status2ball)   
                        # {'155x154y219z': {'x2shot': 155, 'azimuth2shot': 0.7853981633974483, 'id2shot': '155x154y219z', 'distance2shot': 310, 'z2shot': 219, 'elevation2shot': 0.7853981633974483, 'y2shot': 154}}                         
                             
                        ball2xi.set(azimuth2shot = pi/3, elevation2shot = pi/3, distance2shot = 320)   # 60 right & up
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15E2/33) OF TEST_BALL4XI - STATUS: ", status2ball)   
                        # {'138x239y160z': {'x2shot': 138, 'azimuth2shot': 1.0471975511965976, 'id2shot': '138x239y160z', 'distance2shot': 320, 'z2shot': 160, 'elevation2shot': 1.0471975511965976, 'y2shot': 239}}                            
                                            
                        ball2xi.set(azimuth2shot = pi/2, elevation2shot = pi/2, distance2shot = 330)   # 90 right & up
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15E3/33) OF TEST_BALL4XI - STATUS: ", status2ball)   
                        # {'0x330y0z': {'x2shot': 0, 'azimuth2shot': 1.5707963267948966, 'id2shot': '0x330y0z', 'distance2shot': 330, 'z2shot': 0, 'elevation2shot': 1.5707963267948966, 'y2shot': 330}}                          
                    
                                            
                        ball2xi.set(azimuth2shot = 3*pi/4, elevation2shot = 3*pi/4, distance2shot = 340)# 135 right & up
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15E4/33) OF TEST_BALL4XI - STATUS: ", status2ball)                              
                        # {'-170x170y-240z': {'x2shot': -170, 'azimuth2shot': 2.356194490192345, 'id2shot': '-170x170y-240z', 'distance2shot': 340, 'z2shot': -240, 'elevation2shot': 2.356194490192345, 'y2shot': 170}}
                                                                    
                        ball2xi.set(azimuth2shot = pi, elevation2shot = pi, distance2shot = 350)        # 180 right & up
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15E5/33) OF TEST_BALL4XI - STATUS: ", status2ball)                              
                        # {'0x0y-350z': {'x2shot': 0, 'azimuth2shot': 3.141592653589793, 'id2shot': '0x0y-350z', 'distance2shot': 350, 'z2shot': -350, 'elevation2shot': 3.141592653589793, 'y2shot': 0}}  
   
                        #[F] LEFT AND UP
                        ball2xi.set(azimuth2shot = -pi/4, elevation2shot = pi/4, distance2shot = 360)   # 45 left & up
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15F1/33) OF TEST_BALL4XI - STATUS: ", status2ball)   
                        # {'180x-179y254z': {'x2shot': 180, 'azimuth2shot': -0.7853981633974483, 'id2shot': '180x-179y254z', 'distance2shot': 360, 'z2shot': 254, 'elevation2shot': 0.7853981633974483, 'y2shot': -179}}  
                                                                        
                        ball2xi.set(azimuth2shot = -pi/3, elevation2shot = pi/3, distance2shot = 370)   # 60 left & up
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15F2/33) OF TEST_BALL4XI - STATUS: ", status2ball)   
                        # {'160x-277y185z': {'x2shot': 160, 'azimuth2shot': -1.0471975511965976, 'id2shot': '160x-277y185z', 'distance2shot': 370, 'z2shot': 185, 'elevation2shot': 1.0471975511965976, 'y2shot': -277}} 
                              
                        ball2xi.set(azimuth2shot = -pi/2, elevation2shot = pi/2, distance2shot = 380)   # 90 left & up
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15F3/33) OF TEST_BALL4XI - STATUS: ", status2ball)   
                        # {'0x-380y0z': {'x2shot': 0, 'azimuth2shot': -1.5707963267948966, 'id2shot': '0x-380y0z', 'distance2shot': 380, 'z2shot': 0, 'elevation2shot': 1.5707963267948966, 'y2shot': -380}} 

                        ball2xi.set(azimuth2shot = -3*pi/4, elevation2shot = 3*pi/4, distance2shot = 390)   # 135 left & up
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15F4/33) OF TEST_BALL4XI - STATUS: ", status2ball)                           
                        # 
                           
                        ball2xi.set(azimuth2shot = -pi, elevation2shot = pi, distance2shot = 400)       # 180 left & up
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15F5/33) OF TEST_BALL4XI - STATUS: ", status2ball)                            
                        # {'-195x-195y-275z': {'x2shot': -195, 'azimuth2shot': -2.356194490192345, 'id2shot': '-195x-195y-275z', 'distance2shot': 390, 'z2shot': -275, 'elevation2shot': 2.356194490192345, 'y2shot': -195}} 
                           
                        #[G] LEFT AND DOWN
                        ball2xi.set(azimuth2shot = -pi/4, elevation2shot = -pi/4, distance2shot = 410)       # 45 left & down
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15G1/33) OF TEST_BALL4XI - STATUS: ", status2ball)   
                        # {'-204x204y289z': {'x2shot': -204, 'azimuth2shot': -0.7853981633974483, 'id2shot': '-204x204y289z', 'distance2shot': 410, 'z2shot': 289, 'elevation2shot': -0.7853981633974483, 'y2shot': 204}} 
                        
                        ball2xi.set(azimuth2shot = -pi/3, elevation2shot = -pi/3, distance2shot = 420)       # 60 left & down
                        print("\n (STEP 15G2/33) OF TEST_BALL4XI - STATUS: ", status2ball)   
                        # {'-204x204y289z': {'x2shot': -204, 'azimuth2shot': -0.7853981633974483, 'id2shot': '-204x204y289z', 'distance2shot': 410, 'z2shot': 289, 'elevation2shot': -0.7853981633974483, 'y2shot': 204}} 
                                               
                        ball2xi.set(azimuth2shot = -pi/2, elevation2shot = -pi/2, distance2shot = 430)       # 90 left & down
                        print("\n (STEP 15G3/33) OF TEST_BALL4XI - STATUS: ", status2ball)   
                        # {'-204x204y289z': {'x2shot': -204, 'azimuth2shot': -0.7853981633974483, 'id2shot': '-204x204y289z', 'distance2shot': 410, 'z2shot': 289, 'elevation2shot': -0.7853981633974483, 'y2shot': 204}}  
                                               
                        ball2xi.set(azimuth2shot = -3*pi/4, elevation2shot = -3*pi/4, distance2shot = 440)   # 135 left & down
                        print("\n (STEP 15G4/33) OF TEST_BALL4XI - STATUS: ", status2ball)
                        # {'-204x204y289z': {'x2shot': -204, 'azimuth2shot': -0.7853981633974483, 'id2shot': '-204x204y289z', 'distance2shot': 410, 'z2shot': 289, 'elevation2shot': -0.7853981633974483, 'y2shot': 204}} 
                                                  
                        ball2xi.set(azimuth2shot = -pi, elevation2shot = -pi, distance2shot = 450)           # 180 left & down
                        print("\n (STEP 15G5/33) OF TEST_BALL4XI - STATUS: ", status2ball)                        
                        # {'-204x204y289z': {'x2shot': -204, 'azimuth2shot': -0.7853981633974483, 'id2shot': '-204x204y289z', 'distance2shot': 410, 'z2shot': 289, 'elevation2shot': -0.7853981633974483, 'y2shot': 204}} 
                           
                        #[H] MAX ANGLES
                        ball2xi.set(azimuth2shot = pi, elevation2shot = pi, distance2shot = 460)        # 180, 180 
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15H1/33) OF TEST_BALL4XI - STATUS: ", status2ball)   
                        # {'0x0y-460z': {'x2shot': 0, 'azimuth2shot': 3.141592653589793, 'id2shot': '0x0y-460z', 'distance2shot': 460, 'z2shot': -460, 'elevation2shot': 3.141592653589793, 'y2shot': 0}} 
                        
                        ball2xi.set(azimuth2shot = -pi, elevation2shot = -pi, distance2shot = 470)      # -180, -180 
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15H2/33) OF TEST_BALL4XI - STATUS: ", status2ball)   
                        # {'0x0y-470z': {'x2shot': 0, 'azimuth2shot': -3.141592653589793, 'id2shot': '0x0y-470z', 'distance2shot': 470, 'z2shot': -470, 'elevation2shot': -3.141592653589793, 'y2shot': 0}}
                                                
                        ball2xi.set(azimuth2shot = 2* pi, elevation2shot = 2* pi, distance2shot = 480)  # 360, 360 
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15H3/33) OF TEST_BALL4XI - STATUS: ", status2ball)   
                        # {'0x0y480z': {'x2shot': 0, 'azimuth2shot': 6.283185307179586, 'id2shot': '0x0y480z', 'distance2shot': 480, 'z2shot': 480, 'elevation2shot': 6.283185307179586, 'y2shot': 0}} 
                        
                        ball2xi.set(azimuth2shot = -2* pi, elevation2shot = -2* pi, distance2shot = 490)# -360, -360 
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15H4/33) OF TEST_BALL4XI - STATUS: ", status2ball)   
                        # {'0x0y490z': {'x2shot': 0, 'azimuth2shot': -6.283185307179586, 'id2shot': '0x0y490z', 'distance2shot': 490, 'z2shot': 490, 'elevation2shot': -6.283185307179586, 'y2shot': 0}} 

                        #[I] MAX ANGLES AND INCREASING DISTANCE
                        ball2xi.set(azimuth2shot = pi, elevation2shot = pi, distance2shot = 500)        # 180, 180 
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15I1/33) OF TEST_BALL4XI - STATUS: ", status2ball)   
                        # {'0x0y-500z': {'x2shot': 0, 'azimuth2shot': 3.141592653589793, 'id2shot': '0x0y-500z', 'distance2shot': 500, 'z2shot': -500, 'elevation2shot': 3.141592653589793, 'y2shot': 0}} 
                        
                        ball2xi.set(azimuth2shot = -pi, elevation2shot = -pi, distance2shot = 510)      # -180, -180 
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15I2/33) OF TEST_BALL4XI - STATUS: ", status2ball)   
                        # {'0x0y-510z': {'x2shot': 0, 'azimuth2shot': -3.141592653589793, 'id2shot': '0x0y-510z', 'distance2shot': 510, 'z2shot': -510, 'elevation2shot': -3.141592653589793, 'y2shot': 0}} 
                                                
                        ball2xi.set(azimuth2shot = 2* pi, elevation2shot = 2* pi, distance2shot = 520)  # 360, 360 
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15I3/33) OF TEST_BALL4XI - STATUS: ", status2ball)   
                        # {'0x0y520z': {'x2shot': 0, 'azimuth2shot': 6.283185307179586, 'id2shot': '0x0y520z', 'distance2shot': 520, 'z2shot': 520, 'elevation2shot': 6.283185307179586, 'y2shot': 0}} 
                        
                        ball2xi.set(azimuth2shot = -2* pi, elevation2shot = -2* pi, distance2shot = 530)# -360, -360 
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                        print("\n (STEP 15I4/33) OF TEST_BALL4XI - STATUS: ", status2ball)   
                        # {'0x0y530z': {'x2shot': 0, 'azimuth2shot': -6.283185307179586, 'id2shot': '0x0y530z', 'distance2shot': 530, 'z2shot': 530, 'elevation2shot': -6.283185307179586, 'y2shot': 0}} 
                        
                        
                        # -------------------------------------------------------------------------------------    
                        # [J] TRY ALL POSITIVE WITH 10 SHOTS
                        # -------------------------------------------------------------------------------------                                                                                     

                        print("\n (STEP 15J1/33) OF TEST_BALL4XI - TRYING ALL POSITIVE WITH 10 SHOTS ", time4xi())  
                        d2shot = 540
                            
                        coefficient2a = 0.25
                        coefficient2e = 0.25
                            
                        a2shot = coefficient2a * pi
                        e2shot = coefficient2e * pi
                            
                        increase2distance = 10
                        increase2a = 0.01
                        increase2e = 0.01
                             
                        count2shot = 0
                        max2count = 9
             
                            
                        while count2shot < max2count:
                            count2shot = count2shot + 1
                            
                            d2shot = d2shot + increase2distance
                            
                            coefficient2a = coefficient2a + increase2a
                            coefficient2e = coefficient2e + increase2e  
                                
                            a2shot = coefficient2a * pi
                            e2shot = coefficient2e * pi        
                            
                            ball2xi.set(azimuth2shot = a2shot, elevation2shot = e2shot, distance2shot = d2shot)
                            
                            status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes')
                            print("\n (STEP 15J2/33) OF TEST_BALL4XI - STATUS: ", status2ball) 
                            # {'274x292y376z': {'x2shot': 274, 'azimuth2shot': 0.8168140899333463, 'id2shot': '274x292y376z', 'distance2shot': 550, 'z2shot': 376, 'elevation2shot': 0.8168140899333463, 'y2shot': 292}}
                            # {'277x315y370z': {'x2shot': 277, 'azimuth2shot': 0.8482300164692442, 'id2shot': '277x315y370z', 'distance2shot': 560, 'z2shot': 370, 'elevation2shot': 0.8482300164692442, 'y2shot': 315}}
                            # {'279x338y363z': {'x2shot': 279, 'azimuth2shot': 0.8796459430051422, 'id2shot': '279x338y363z', 'distance2shot': 570, 'z2shot': 363, 'elevation2shot': 0.8796459430051422, 'y2shot': 338}}
                            # {'280x362y355z': {'x2shot': 280, 'azimuth2shot': 0.9110618695410401, 'id2shot': '280x362y355z', 'distance2shot': 580, 'z2shot': 355, 'elevation2shot': 0.9110618695410401, 'y2shot': 362}}
                            # {'280x386y346z': {'x2shot': 280, 'azimuth2shot': 0.942477796076938, 'id2shot': '280x386y346z', 'distance2shot': 590, 'z2shot': 346, 'elevation2shot': 0.942477796076938, 'y2shot': 386}}
                            # {'278x410y337z': {'x2shot': 278, 'azimuth2shot': 0.973893722612836, 'id2shot': '278x410y337z', 'distance2shot': 600, 'z2shot': 337, 'elevation2shot': 0.973893722612836, 'y2shot': 410}}
                            # {'275x434y326z': {'x2shot': 275, 'azimuth2shot': 1.0053096491487339, 'id2shot': '275x434y326z', 'distance2shot': 610, 'z2shot': 326, 'elevation2shot': 1.0053096491487339, 'y2shot': 434}}
                            # {'271x459y315z': {'x2shot': 271, 'azimuth2shot': 1.0367255756846319, 'id2shot': '271x459y315z', 'distance2shot': 620, 'z2shot': 315, 'elevation2shot': 1.0367255756846319, 'y2shot': 459}}
                            # {'265x483y303z': {'x2shot': 265, 'azimuth2shot': 1.0681415022205298, 'id2shot': '265x483y303z', 'distance2shot': 630, 'z2shot': 303, 'elevation2shot': 1.0681415022205298, 'y2shot': 483}}
                           
                        
                        
                        # ---------------------------------------------------------------------------------------------    
                        # [K] TRY LAYERS LETTING -360 < AZIMUT < 360 AND -360 < ELEVATION < 360
                        # ---------------------------------------------------------------------------------------------                                                                                     
                        
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # new ball
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        ball2xi = Ball4Xi()
                        
                        start2distance = 100
                        interval2distance = 100  
                        max2layer = 100               #1000 (also all to the same layer), 100/33/20 OK  i.e. no shots several times to the same (x,y,z)                
                        max2count = 100          
                        time2start = time4xi()
                        
                        # ================================================================================
                        #  (STEP 15K12/33) OF TEST_BALL4XI - STATISTICS: SHOT TIMES:  1000 TIME:  03:22:57 06/02/10 Pacific Daylight Time
                        #  +X:  476  =  48  %
                        #  -X:  515  =  51  %
                        #  +Y:  532  =  53  %
                        #  -Y:  459  =  46  %
                        #  +Z:  529  =  53  %
                        #  -Z:  462  =  46  %
                        #  SUM2TOTAL:  991 SUCCESS-RATIO:  99  %  COUNT2LAYER:  1
                        #  START2DISTANCE:  100  INTERVAL2DISTANCE:  100  MAX2LAYER:  1000  MAX2COUNT :  1000
                        # ================================================================================                        
                        
                        # ================================================================================
                        # 
                        # (STEP 15K12/33) OF TEST_BALL4XI - STATISTICS:  3000  SHOTS - START TIME:  04:30:22 06/02/10 Pacific Daylight Time
                        #  +X:  1478  =  49  %
                        #  -X:  1524  =  50  %
                        #  +Y:  1511  =  50  %
                        #  -Y:  1491  =  49  %
                        #  +Z:  1481  =  49  %
                        #  -Z:  1521  =  50  %
                        #  SUM2TOTAL:  3002 SUCCESS-RATIO:  100  %  COUNT2LAYER:  30 <--- alphabets + cluster + super + core
                        #  START2DISTANCE:  100  INTERVAL2DISTANCE:  100  MAX2LAYER:  100  MAX2COUNT :  3000
                        #  END TIME:  04:32:53 06/02/10 Pacific Daylight Time
                        # ================================================================================
                                                   
                        if max2count > 1000:
                            trace2set = False # <-- turn trace off with a large max2count !
                                                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # 
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                               
                        print("\n (STEP 15K1/33) OF TEST_BALL4XI - TRYING LAYERS STARTING WITH DISTANCE: ", d2shot, 'INTERVAL2DISTANCE: ', interval2distance)   
                        
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # azimuth and elevation angle initialized
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # ref: http://en.wikipedia.org/wiki/Radian#Conversion_between_radians_and_degrees
                        # one radian is equal to 180/p degrees <=> 1 deg = rad * 180 / pi                             
                        # pi/6 = 30, pi/4 = 45, pi/3 = 60, pi/2 = 90, 2/3*pi = 120, 3/4pi=135, 5/6*pi = 150, pi = 180
                        # 7/6*pi = 210, 5/4*pi = 235...3*pi/2 = 270, 5*pi/3 = 300 ... 2*pi = 0 or 360 degrees
                        # I   = 0...90    (0...pi/2) :     sin+, cos+
                        # II  = 90...180  (pi/2...pi):     sin+, cos- 
                        # III = 180...270 (pi...3*pi/2):   sin-, cos-
                        # IV  = 270...360 (3*pi/2...2*pi): sin-, cos+
                        
                        # ref: http://en.wikipedia.org/wiki/Azimuth

                        
                        start2a = pi/3                              # start azimuth
                        start2e = pi / 4                            # start elevation        
                           
                          
                        a2shot = start2a                          
                        e2shot = start2e                            
                        
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # increments for algorithm 
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                    
                        increase2distance = 0                       # zero with laeyrs, only new layer increases
                        
                        change2a = pi / 60                          # 3 degrees change to azimuth, decrease this
                        change2e = pi / 120                         # 1,5 degrees change to elevation, increase it
                        
                        min2a = pi / 12                             # 15 degrees minumum to azimuth
                        min2e = pi / 24                             # 7.5 degrees minimum to elevation                       
                        
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # shots
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        count2layer = 0                                                           
                        count2shot = 0
                        count2distance = 0                        
                        
                        d2shot = start2distance
                             
                        
                        print("\n (STEP 15K2/33) OF TEST_BALL4XI - SHOTS: ", max2count, 'TIME SHOOTING STARTED: ', time4xi()) 
                        # 01:48:56 05/31/10 Pacific Daylight Time 
                                 
                        ack2azimuth = True
                        nack2azimuth = False
                        
                        ack2elevation = True
                        nack2elevation = False
                        
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # 
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                   
                        while count2shot < max2count:
                        
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # 
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                
                            count2shot = count2shot + 1
                        
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # distance
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                
                            d2shot = d2shot + increase2distance                           #remains the same for a laeyr

                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # azimuth
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            if a2shot >= 0:        
                                a2shot = a2shot + change2a

                            else:
                                a2shot = a2shot - change2a
                                if a2shot < min2a:
                                    a2shot = change2a* start2a
                                    print("\n (STEP 15K4A/33) OF TEST_BALL4XI - AZIMUTH BECAME LESS THAN MINIMUM, NEW AZIMUTH: ", a2shot)  
                                    
                            if (a2shot >= 2 * pi):
                                change2a = 0.92 * change2a
                                start2a = (pi / 4) * change2a
                                a2shot = start2a
                                print("\n (STEP 15K4C/33) OF TEST_BALL4XI - AZIMUTH BECAME BIGGER THAN 2 * PI , NEW AZIMUTH: ", a2shot) 
                                nack2azimuth = True
                                ack2azimuth = False
                                
                            if (a2shot <= -2 * pi):
                                change2a = 0.98 * change2a
                                start2a = -change2a * (pi / 4)
                                a2shot = change2a * start2a
                                print("\n (STEP 15K4D/33) OF TEST_BALL4XI - AZIMUTH BECAME LESS THAN -2 * PI , NEW AZIMUTH: ", a2shot) 
                                nack2azimuth = True
                                ack2azimuth = False
                            
                        
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # elevation
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            if e2shot <= 0:
                                e2shot = e2shot - increase2e
                                if e2shot < min2e:
                                    e2shot = change2e * start2e
                                    print("\n (STEP 15K4E/33) OF TEST_BALL4XI - ELEVATION BECAME LESS THAN MINIMUM, NEW ELEVATION: ", e2shot) 
                            else:
                                e2shot = e2shot + increase2e            

                                                                    
                            if (e2shot >= pi):
                                # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                # start again with a new elevation
                                # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                change2e = 1.08 * change2e
                                start2e = (pi / 6) * change2e
                                e2shot = start2e
                                print("\n (STEP 15K4F/33) OF TEST_BALL4XI - ELEVATION BECAME BIGGER THAN PI, NEW ELEVATION: ", e2shot)
                                
                                nack2elevation = True
                                ack2elevation = False
                                
                            if (e2shot <= -pi):
                                # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                # start again with a new elevation and new elevation change
                                change2e = 1.02 * change2e
                                start2e = -(pi / 6) * change2e
                                e2shot = start2e                      
                                print("\n (STEP 15K4G/33) OF TEST_BALL4XI - ELEVATION BECAME LESSA THAN -* PI, NEW ELEVATION: ", e2shot)
                                
                                nack2elevation = True
                                ack2elevation = False
                                
                        
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # shoot
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                                                   
                            ball2xi.set(azimuth2shot = a2shot, elevation2shot = e2shot, distance2shot = d2shot, area2shot = int(4*pi*d2shot**2/interval2distance))
                            
                        
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # distance
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes', area2shot = 'Yes')
                            print("\n (STEP 15K4/33) OF TEST_BALL4XI - SHOT ", count2shot, ": ", status2ball)  
                                
                            count2distance = count2distance + 1
                            if count2distance > max2layer:
                                d2shot = d2shot + interval2distance
                                count2distance = 0
                                count2layer = count2layer + 1 

                                print("\n (STEP 15K3/33) OF TEST_BALL4XI - NEW LAYER NUMBER: ", count2layer, ' NEW DISTANCE: ', d2shot)
                                
                            else:
                                pass    
                                                         
                            # {'332x458y411z':   {'x2shot': 332, 'azimuth2shot': 0.9424777960769379, 'id2shot': '332x458y411z', 'distance2shot': 700, 'z2shot': 411, 'elevation2shot': 0.9424777960769379, 'y2shot': 458}}
                            # {'283x555y317z':   {'x2shot': 282, 'azimuth2shot': 1.0995574287564276, 'id2shot': '283x555y317z', 'distance2shot': 700, 'z2shot': 317, 'elevation2shot': 1.0995574287564276, 'y2shot': 555}}
                            # ... 
                        
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # 
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        time2end = time4xi()           
                        print("\n (STEP 15K5/33) OF TEST_BALL4XI - SHOTS: ", max2count, 'TIME SHOOTING ENDED: ', time2end)                         
                        # 01:49:40 05/31/10 Pacific Daylight Time - started 01:48:56 05/31/10 Pacific Daylight Time before i.e. 10 000 shots in 44 sec i.e. 227 shots in second 
                                                                                                      
                        if ack2azimuth is True:
                            print("\n (STEP 15K6/33) OF TEST_BALL4XI - AZIMUTH NEEDED NO ADJUSTEMENTS - ACK2AZIMUTH: ", ack2azimuth)
                            # True 
                        else:
                            print("\n (STEP 15K6/33) OF TEST_BALL4XI - AZIMUTH NEEDED ADJUSTEMENTS - NACK2AZIMUTH: ", nack2azimuth)
                        
                        if ack2elevation is True:
                            print("\n (STEP 15K7/33) OF TEST_BALL4XI - ELEVATION NEEDED NO ADJUSTEMENTS - ACK2ELEVATION: ", ack2elevation)
                            # True
                        else:
                            print("\n (STEP 15K7/33) OF TEST_BALL4XI - ELEVATION NEEDED ADJUSTEMENTS - NACK2ELEVATION: ", nack2elevation)                            
                        
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # 
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                               
                        print("\n (STEP 15K8/33) OF TEST_BALL4XI - WHOLE BALL AFTER ALL OPERATIONS AND WITH MAX2COUNT: ", max2count, 'TIME PRINTED: ', time4xi())  
                        
                        ball2show = ball2xi.get()
                        dict2keys = ball2show.keys()
                        print("\n (STEP 15K9/33) OF TEST_BALL4XI - KEYS2BALL: ", dict2keys)
                        # dict_keys(['160x-277y185z', '332x458y411z', '-205x633y-216z', '280x0y0z', '0x0y120z', '283x555y317z', '-190x0y110z', '-283x555y-317z', '0x0y130z', '0x0y140z', '0x0y520z', '0x0y-500z', '-148x0y148z', '0x0y150z', '0x0y530z', '279x338y363z', '138x239y160z', '0x0y160z', '155x154y219z', '0x0y480z', '280x386y346z', '0x0y170z', '183x0y183z', '0x0y-510z', '0x0y-300z', '0x430y0z', '-332x458y-411z', '280x362y355z', '-108x682y-109z', '205x0y-205z', '0x0y490z', '205x633y216z', '0x0y-400z', '278x410y337z', '275x434y326z', '0x0y-450z', '0x0y0z', '265x483y303z', '277x315y370z', '0x700y0z', '108x682y109z', '271x459y315z', '-204x204y289z', '0x0y100z', '-230x0y0z', '0x0y200z', '233x0y135z', '-169x0y-169z', '0x0y110z', '0x-380y0z', '-181x314y210z', '0x330y0z', '220x220y-311z', '-170x170y-240z', '0x0y190z', '0x0y-250z', '-350x349y-494z', '274x292y376z', '-195x-195y-275z', '0x0y-460z', '180x-179y254z', '0x0y-350z', '0x0y-470z', '0x0y180z'])

                        print("\n (STEP 15K10/33) OF TEST_BALL4XI - SHOOTING SAMPLE OF : ", max2count, " SHOTS", "NUMBER OF LAYERS: ", count2layer, ' LATEST DISTANCE: ', d2shot, ' INTERVAL2DISTANCE: ', interval2distance)    
                        # 2900  SHOTS NUMBER OF LAYERS:  29  LATEST DISTANCE:  2900  INTERVAL2DISTANCE:  100 
                        
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # 
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        count2plusx = 0
                        count2plusy = 0
                        count2plusz = 0
                               
                        count2minusx = 0
                        count2minusy = 0
                        count2minusz = 0
                        
                        order2key = 1
                        for key2dict in sorted(dict2keys):
                            try:
                                index2x=str.find(key2dict,'x')                               
                                x2coordinate = int(key2dict[0:index2x])
                                # print("\n (STEP 15K11/33/33) OF TEST_BALL4XI - X2COORDINATE: ",  x2coordinate)
                                if x2coordinate >= 0:
                                    count2plusx = count2plusx + 1
                                else:
                                    count2minusx = count2minusx + 1    
                            except:
                                print("\n (STEP 15K11/33X) OF TEST_BALL4XI *** FAILED WITH KEY2DICT: ", key2dict)
                                print("\n (STEP 15K11/33X) OF TEST_BALL4XI - INDEX2X: ", index2x)
                                
                                
                            try:                                   
                                index2y=str.find(key2dict,'y')
                                y2coordinate = int(key2dict[index2x+1:index2y])
                                # print("\n (STEP 15K11/33) OF TEST_BALL4XI - Y2COORDINATE: ",  y2coordinate)
                                if y2coordinate >= 0:
                                    count2plusy = count2plusy + 1
                                else:
                                    count2minusy = count2minusy + 1  
                            except:
                                print("\n (STEP 15K11/33Y) OF TEST_BALL4XI *** FAILED WITH KEY2DICT: ", key2dict) 
                                print("\n (STEP 15K11/33Y) OF TEST_BALL4XI - INDEX2X: ", index2x)
                                print("\n (STEP 15K11/33Y) OF TEST_BALL4XI - INDEX2Y: ", index2y)
                            
                            try:                                                                         
                                index2z=str.find(key2dict,'z') 
                                z2coordinate = int(key2dict[index2y+1:index2z])
                                # print("\n (STEP 15K11/33) OF TEST_BALL4XI - Z2COORDINATE: ",  z2coordinate)
                                if z2coordinate >= 0:
                                    count2plusz = count2plusz + 1
                                else:
                                    count2minusz = count2minusz + 1
                            except:
                                print("\n (STEP 15K11/33Z) OF TEST_BALL4XI *** FAILED WITH KEY2DICT: ", key2dict)
                                print("\n (STEP 15K11/33Z) OF TEST_BALL4XI - INDEX2X: ", index2x)
                                print("\n (STEP 15K11/33Z) OF TEST_BALL4XI - INDEX2Y: ", index2y)
                                print("\n (STEP 15K11/33Z) OF TEST_BALL4XI - INDEX2Z: ", index2z)
                                                                      
                            print("\n SHOT ", order2key, ":", key2dict)
                            order2key = order2key +1 
         
                            # SHOT 1    : -1001x2128y1107z
                            # SHOT 1602 : 1152x1534y-1441z
                            # SHOT 2876 : 9x99y9z

                        
                        sum2plus = count2plusx + count2plusy+ count2plusz
                        sum2minus = count2minusx + count2minusy+ count2minusz
                        sum2total = count2plusx + count2minusx # same also with y and z - coordinate exists only once
                                
                        print('=' *80)
                        print("\n (STEP 15K12/33) OF TEST_BALL4XI - STATISTICS: ", max2count, " SHOTS - START TIME: ", time2start)

                        print("\n +X: ", count2plusx, " = ", int(100*count2plusx/sum2total), " %")
                        print("\n -X: ", count2minusx, " = ", int(100*count2minusx/sum2total), " %") 
                       
                        print("\n +Y: ", count2plusy, " = ", int(100*count2plusy/sum2total), " %")
                        print("\n -Y: ", count2minusy, " = ", int(100*count2minusy/sum2total), " %") 
                       
                        print("\n +Z: ", count2plusz, " = ", int(100*count2plusz/sum2total), " %")
                        print("\n -Z: ", count2minusz, " = ", int(100*count2minusz/sum2total), " %") 
                                  
                        count2layer = count2layer + 1 
                        print("\n SUM2TOTAL: ", sum2total, "SUCCESS-RATIO: ", int(100*sum2total/max2count), " %", " COUNT2LAYER: ", count2layer)
                        print("\n START2DISTANCE: ", start2distance, " INTERVAL2DISTANCE: ", interval2distance, " MAX2LAYER: ", max2layer, " MAX2COUNT : ", max2count)
                        print("\n END TIME: ", time2end)
                        print('=' *80)
                        
                        # ================================================================================
                        # 
                        # (STEP 15K12/33) OF TEST_BALL4XI - STATISTICS:  3000  SHOTS - START TIME:  04:30:22 06/02/10 Pacific Daylight Time
                        #  +X:  1478  =  49  %
                        #  -X:  1524  =  50  %
                        #  +Y:  1511  =  50  %
                        #  -Y:  1491  =  49  %
                        #  +Z:  1481  =  49  %
                        #  -Z:  1521  =  50  %
                        #  SUM2TOTAL:  3002 SUCCESS-RATIO:  100  %  COUNT2LAYER:  30
                        #  START2DISTANCE:  100  INTERVAL2DISTANCE:  100  MAX2LAYER:  100  MAX2COUNT :  3000
                        #  END TIME:  04:32:53 06/02/10 Pacific Daylight Time
                        # ================================================================================
                                                 
                            
                    except:
                        # -------------------------------------------------------------------------------------    
                        #
                        # -------------------------------------------------------------------------------------     
                        print("\n (STEP 15L1/33) OF TEST_BALL4XI *** FAILED  IN SHOOTING WITH BALL *** ")
                
                else:
                    pass #no processes
                    
                
                                          
                # ---------------------------------------------------------------------------------------------
                # JOIN REAL PROCESSES - NOT DUMMY ONES                      
                # ---------------------------------------------------------------------------------------------  
                if ((ack4process is True) and(ack2dummy is False)):
    
                    print("\n (STEP 16/33) OF TEST_BALL4XI - JOINING PROCESSES")
                    ack4join = True
                    nack4join = False    
                    
                    try:
                        p2ball.join() 
                        print("\n (STEP 16A/33) OF TEST_BALL4XI - JOINED BALL PROCESS: ", str(p2ball))
                        # <Process4Xi(Process4Xi-1, stopped)>
                       
                    except:
                        print("\n (STEP 16B/33) OF TEST_BALL4XI *** FAILED TO JOIN BALL PROCESS: ", str(p2ball))                
                        nack4join = True
                        ack4join = False   
                        
                    try:
                        p2shot.join() 
                        print("\n (STEP 16C/33) OF TEST_BALL4XI - JOINED SHOT PROCESS: ", str(p2shot))
                        # <Process4Xi(Process4Xi-2, stopped)>
                        
                    except:
                        print("\n (STEP 16D/33) OF TEST_BALL4XI *** FAILED TO JOIN SHOT PROCESS: ", str(p2shot))                
                        nack4join = True
                        ack4join = False   
                   
                    try:
                        p2cluster.join() 
                        print("\n (STEP 16E/33) OF TEST_BALL4XI - JOINED CLUSTER PROCESS: ", str(p2cluster))
                          
                    except:
                        print("\n (STEP 16F/33) OF TEST_BALL4XI *** FAILED TO JOIN CLUSTER PROCESS: ", str(p2cluster))                
                        nack4join = True
                        ack4join = False   
                   
                    try:
                        p2super.join() 
                        print("\n (STEP 16G/33) OF TEST_BALL4XI - JOINED SUPER PROCESS: ", str(p2super))
                        # <Process4Xi(Process4Xi-4, stopped)>
                                                  
                    except:
                        print("\n (STEP 16H/33) OF TEST_BALL4XI *** FAILED TO JOIN SUPER PROCESS: ", str(p2super))                
                        nack4join = True
                        ack4join = False   
                                                      
                    if ack4join is True:
                        print("\n (STEP 16I/33) OF TEST_BALL4XI - JOINED ALL PROCESSES")
                        # OK 
                    else:
                        print("\n (STEP 16J/33) OF TEST_BALL4XI *** FAILED TO JOIN ALL PROCESSES ***") 
                else:
                    print("\n (STEP 16K/33) OF TEST_BALL4XI ** SKIPPED JOINING PROCESSES ACK4PROCESS: ", ack4process, " ACK2DUMMY: ", ack2dummy) 
                  
                # ---------------------------------------------------------------------------------------------
                # TERMINATE REAL PROCESSES - NOT DUMMY ONES                      
                # ---------------------------------------------------------------------------------------------  
                if ((ack4process is True) and (ack2dummy is False)):
    
                    ack4terminate = True
                    nack4terminate = False                 
                    print("\n (STEP 17/33) OF TEST_BALL4XI - TERMINATING PROCESSES")

                    try:
                        p2ball.terminate() 
                        print("\n (STEP 17A/33) OF TEST_BALL4XI - TERMINATED BALL PROCESS: ", str(p2ball))
                        # <Process4Xi(Process4Xi-1, stopped)> 
                          
                    except:
                        print("\n (STEP 17B/33) OF TEST_BALL4XI *** FAILED TO TERMINATE BALL PROCESS: ", str(p2ball))                
                        nack4terminate = True
                        ack4terminate = False 
                    
                    try:
                        p2shot.terminate() 
                        print("\n (STEP 17C/33) OF TEST_BALL4XI - TERMINATED SHOT PROCESS: ", str(p2shot))
                        # <Process4Xi(Process4Xi-2, stopped)> 
                         
                    except:
                        print("\n (STEP 17D/33) OF TEST_BALL4XI *** FAILED TO TERMINATE SHOT PROCESS: ", str(p2shot))                
                        nack4terminate = True
                        ack4terminate = False 
                    
                    try:
                        p2cluster.terminate() 
                        print("\n (STEP 17E/33) OF TEST_BALL4XI - TERMINATED CLUSTER PROCESS: ", str(p2cluster))
                        # <Process4Xi(Process4Xi-3, stopped)>
                    
                    except:
                        print("\n (STEP 17F/33) OF TEST_BALL4XI *** FAILED TO TERMINATE CLUSTER PROCESS: ", str(p2cluster))                
                        nack4terminate = True
                        ack4terminate = False 
                    
                    try:
                        p2super.terminate() 
                        print("\n (STEP 17G/33) OF TEST_BALL4XI - TERMINATED SUPER PROCESS: ", str(p2super))
                        # <Process4Xi(Process4Xi-4, stopped)>
                                               
                    except:
                        print("\n (STEP 17H/33) OF TEST_BALL4XI *** FAILED TO TERMINATE SUPER PROCESS: ", str(p2super))                
                        nack4terminate = True
                        ack4terminate = False 
                                                             
                    if ack4terminate is True:
                        print("\n (STEP 17I/33) OF TEST_BALL4XI - TERMINATED ALL PROCESSES")
                    else:
                        print("\n (STEP 17J/33) OF TEST_BALL4XI *** FAILED TO TERMINATE ALL PROCESSES ***") 
                else:
                    print("\n (STEP 17K/33) OF TEST_BALL4XI ** SKIPPED TERMINATING PROCESSES ACK4PROCESS: ", ack4process, " ACK2DUMMY: ", ack2dummy)                 
                        
                # ---------------------------------------------------------------------------------------------
                # GET THE NAME OF THIS TEST PROCESS                      
                # ---------------------------------------------------------------------------------------------  
                try:
                    cp2xi = get_current_process4xi()        
                    print("\n (STEP 18A/33) OF TEST_BALL4XI - CURRENT PROCESS: ", cp2xi) 
                    # <_MainProcess4Xi(MainProcess4Xi, started)>
                    
                    id2xi = get_identity_current_process4xi()
                    print("\n (STEP 18B/33) OF TEST_BALL4XI - IDENTITY OF CURRENT PROCESS: ", id2xi) 
                    # ()
                    name2xi = get_name_current_process4xi()
                    print("\n (STEP 18C/33) OF TEST_BALL4XI - NAME OF CURRENT PROCESS: ", name2xi) 
                    # MainProcess4Xi
                    
                except:
                    print("\n (STEP 18D/33) OF TEST_BALL4XI *** FAILED TO GET CURRENT PROCESS ***")                
                  
                         
                # ---------------------------------------------------------------------------------------------
                # SHOOT AIMING TO 8 SLOTS SYSTEMATICALLY - THIS PHASE DOES NOT NEED PROCESSES                      
                # ---------------------------------------------------------------------------------------------  
                print("\n (STEP 16A/33) OF TEST_BALL4XI - TRYING TO SHOOT (X+,Y+,Z+) - EAST, SOUTH, TOWARDS")   
                try:        

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # NEW BALL - SHOOT X+,Y+,Z+ - EAST, SOUTH, TOWARDS
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    ball2xi = Ball4Xi(message2ball = name2xi)
                    
                    start2distance = 100
                    interval2distance = 100  
                    max2layer = 100                          
                    max2count = 100          
                    
                    # ================================================================================
                    # (STEP 16Y/33) OF TEST_BALL4XI - STATISTICS:  1000  SHOTS
                    #  START TIME:  05:45:49 06/02/10 Pacific Daylight Time
                    #  +X:  926  =  100  %
                    #  -X:  0  =  0  %
                    #  +Y:  926  =  100  %
                    #  -Y:  0  =  0  %
                    #  +Z:  926  =  100  %
                    #  -Z:  0  =  0  %
                    #  SUM2TOTAL:  926 SUCCESS-RATIO:  92  %  COUNT2LAYER:  1
                    #  START2DISTANCE:  100  INTERVAL2DISTANCE:  100  MAX2LAYER:  1000  MAX2COUNT :  1000
                    #  MAX2AZMUTH:  1.25663706144  MAX2ELEVATION:  1.25663706144  CHANGE2AZMUTH:  0.0116729201457  CHANGE2ELEVATION :  0.0484572395911
                    #  END TIME:  05:46:05 06/02/10 Pacific Daylight Time
                    # ================================================================================
                                        
                    time2start = time4xi()
                    if max2count > 1000:
                        trace2set = False # <-- turn trace off with a large max2count !
                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                           
                    print("\n (STEP 16B/33) OF TEST_BALL4XI - TRYING LAYERS STARTING WITH DISTANCE: ", d2shot, 'INTERVAL2DISTANCE: ', interval2distance)   
                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # AZIMUTH AND ELEVATION ANGLE INITIALIZED
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # ref: http://en.wikipedia.org/wiki/Radian#Conversion_between_radians_and_degrees
                    # one radian is equal to 180/p degrees <=> 1 deg = rad * 180 / pi                             
                    # pi/6 = 30, pi/4 = 45, pi/3 = 60, pi/2 = 90, 2/3*pi = 120, 3/4pi=135, 5/6*pi = 150, pi = 180
                    # 7/6*pi = 210, 5/4*pi = 235...3*pi/2 = 270, 5*pi/3 = 300 ... 2*pi = 0 or 360 degrees
                    # I   = 0...90    (0...pi/2) :     sin+, cos+
                    # II  = 90...180  (pi/2...pi):     sin+, cos- 
                    # III = 180...270 (pi...3*pi/2):   sin-, cos-
                    # IV  = 270...360 (3*pi/2...2*pi): sin-, cos+
                    
                    # ref: http://en.wikipedia.org/wiki/Azimuth
                     
                    start2a = pi/8                              # start azimuth 
                    start2e = pi/4                              # start elevation        
                    
                    max2a = 0.8 * pi/2                          # azimuth to keep all positive (+)   
                    max2e = 0.8 * pi/2                          # elevation to keep all positive
                      
                    a2shot = start2a                          
                    e2shot = start2e                            
                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # INCREMENTS FOR ALGORITHM 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                
                    increase2distance = 0                       # zero with laeyrs, only new layer increases
                    
                    change2a = pi / 60                          # 3 degrees change to azimuth, decrease this
                    change2e = pi / 120                         # 1,5 degrees change to elevation, increase it
                    
                    min2a = pi / 12                             # 15 degrees minumum to azimuth
                    min2e = pi / 24                             # 7.5 degrees minimum to elevation                       
                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # SHOTS
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    count2layer = 0                                                           
                    count2shot = 0
                    count2distance = 0                        
                    
                    d2shot = start2distance
                         
                    
                    print("\n (STEP 16C/33) OF TEST_BALL4XI - SHOTS: ", max2count, 'TIME SHOOTING STARTED: ', time4xi()) 
                    
                             
                    ack2azimuth = True
                    nack2azimuth = False
                    
                    ack2elevation = True
                    nack2elevation = False
                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                               
                    while count2shot < max2count:
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # 
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            
                        count2shot = count2shot + 1
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # DISTANCE
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            
                        d2shot = d2shot + increase2distance                           #remains the same for a laeyr
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # AZIMUTH
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        if a2shot >= 0:        
                            a2shot = a2shot + change2a
                        else:
                            a2shot = a2shot - change2a
                            if a2shot < min2a:
                                a2shot = change2a* start2a
                                print("\n (STEP 16D/33) OF TEST_BALL4XI - AZIMUTH BECAME LESS THAN MINIMUM, NEW AZIMUTH: ", a2shot)  
                                
                        if (a2shot >= max2a):
                            change2a = 0.92 * change2a
                            start2a = (pi / 4) * change2a
                            a2shot = start2a
                            print("\n (STEP 16E/33) OF TEST_BALL4XI - AZIMUTH BECAME BIGGER THAN 2 * PI , NEW AZIMUTH: ", a2shot) 
                            nack2azimuth = True
                            ack2azimuth = False
                            
                        if (a2shot <= -2 * pi):
                            change2a = 0.98 * change2a
                            start2a = -change2a * (pi / 4)
                            a2shot = change2a * start2a
                            print("\n (STEP 16F/33) OF TEST_BALL4XI - AZIMUTH BECAME LESS THAN -2 * PI , NEW AZIMUTH: ", a2shot) 
                            nack2azimuth = True
                            ack2azimuth = False
                        
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # ELEVATION
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        if e2shot <= 0:
                            e2shot = e2shot - increase2e
                            if e2shot < min2e:
                                e2shot = change2e * start2e
                                print("\n (STEP 16G/33) OF TEST_BALL4XI - ELEVATION BECAME LESS THAN MINIMUM, NEW ELEVATION: ", e2shot) 
                        else:
                            e2shot = e2shot + increase2e            
                                                                 
                        if (e2shot >= max2e):
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # START AGAIN WITH A NEW ELEVATION
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            change2e = 1.08 * change2e
                            start2e = (pi / 6) * change2e
                            e2shot = start2e
                            print("\n (STEP 16H/33) OF TEST_BALL4XI - ELEVATION BECAME BIGGER THAN PI, NEW ELEVATION: ", e2shot)
                            
                            nack2elevation = True
                            ack2elevation = False
                            
                        if (e2shot <= -pi):
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # START AGAIN WITH A NEW ELEVATION AND NEW ELEVATION CHANGE
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            change2e = 1.02 * change2e
                            start2e = -(pi / 6) * change2e
                            e2shot = start2e                      
                            print("\n (STEP 16I/33) OF TEST_BALL4XI - ELEVATION BECAME LESS THAN -* PI, NEW ELEVATION: ", e2shot)
                            
                            nack2elevation = True
                            ack2elevation = False
                            
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # SHOOT
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                                               
                        ball2xi.set(azimuth2shot = a2shot, elevation2shot = e2shot, distance2shot = d2shot, area2shot = int(4*pi*d2shot**2/interval2distance))
                        
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # DISTANCE
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes', area2shot = 'Yes')
                        print("\n (STEP 16J/33) OF TEST_BALL4XI - SHOT ", count2shot, ": ", status2ball)  
                            
                        count2distance = count2distance + 1
                        if count2distance > max2layer:
                            d2shot = d2shot + interval2distance
                            count2distance = 0
                            count2layer = count2layer + 1 
                            print("\n (STEP 16K/33) OF TEST_BALL4XI - NEW LAYER NUMBER: ", count2layer, ' NEW DISTANCE: ', d2shot)
                        else:
                            pass    

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    time2end = time4xi()           
                    print("\n (STEP 16L/33) OF TEST_BALL4XI - SHOTS: ", max2count, 'TIME SHOOTING ENDED: ', time2end)                         
                    
                                                                                                  
                    if ack2azimuth is True:
                        print("\n (STEP 16M/33) OF TEST_BALL4XI - AZIMUTH NEEDED NO ADJUSTEMENTS - ACK2AZIMUTH: ", ack2azimuth)
                    else:
                        print("\n (STEP 16N/33) OF TEST_BALL4XI - AZIMUTH NEEDED ADJUSTEMENTS - NACK2AZIMUTH: ", nack2azimuth)
                    
                    if ack2elevation is True:
                        print("\n (STEP 16O/33) OF TEST_BALL4XI - ELEVATION NEEDED NO ADJUSTEMENTS - ACK2ELEVATION: ", ack2elevation)
                    else:
                        print("\n (STEP 16P/33) OF TEST_BALL4XI - ELEVATION NEEDED ADJUSTEMENTS - NACK2ELEVATION: ", nack2elevation)                            
                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                           
                    print("\n (STEP 16Q/33) OF TEST_BALL4XI - WHOLE BALL AFTER ALL OPERATIONS AND WITH MAX2COUNT: ", max2count, 'TIME PRINTED: ', time4xi())  
                    
                    ball2show = ball2xi.get()
                    dict2keys = ball2show.keys()
                    print("\n (STEP 16R/33) OF TEST_BALL4XI - KEYS2BALL: ", dict2keys)
                    # 
                    print("\n (STEP 16S/33) OF TEST_BALL4XI - SHOOTING SAMPLE OF : ", max2count, " SHOTS", "NUMBER OF LAYERS: ", count2layer, ' LATEST DISTANCE: ', d2shot, ' INTERVAL2DISTANCE: ', interval2distance)    
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    count2plusx = 0
                    count2plusy = 0
                    count2plusz = 0
                           
                    count2minusx = 0
                    count2minusy = 0
                    count2minusz = 0
                    
                    order2key = 1
                    for key2dict in sorted(dict2keys):
                        try:
                            index2x=str.find(key2dict,'x')                               
                            x2coordinate = int(key2dict[0:index2x])
                            # print("\n (STEP 15L11/33/33) OF TEST_BALL4XI - X2COORDINATE: ",  x2coordinate)
                            if x2coordinate >= 0:
                                count2plusx = count2plusx + 1
                            else:
                                count2minusx = count2minusx + 1    
                        except:
                            print("\n (STEP 16T/33) OF TEST_BALL4XI *** FAILED WITH KEY2DICT: ", key2dict)
                            print("\n (STEP 16T/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            
                            
                        try:                                   
                            index2y=str.find(key2dict,'y')
                            y2coordinate = int(key2dict[index2x+1:index2y])
                            # print("\n (STEP 15L11/33) OF TEST_BALL4XI - Y2COORDINATE: ",  y2coordinate)
                            if y2coordinate >= 0:
                                count2plusy = count2plusy + 1
                            else:
                                count2minusy = count2minusy + 1  
                        except:
                            print("\n (STEP 16U/33) OF TEST_BALL4XI - *** FAILED WITH KEY2DICT: ", key2dict) 
                            print("\n (STEP 16U/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            print("\n (STEP 16U/33) OF TEST_BALL4XI - INDEX2Y: ", index2y)
                        
                        try:                                                                         
                            index2z=str.find(key2dict,'z') 
                            z2coordinate = int(key2dict[index2y+1:index2z])
                            # print("\n (STEP 16V/33) OF TEST_BALL4XI - Z2COORDINATE: ",  z2coordinate)
                            if z2coordinate >= 0:
                                count2plusz = count2plusz + 1
                            else:
                                count2minusz = count2minusz + 1
                        except:
                            print("\n (STEP 16X/33) OF TEST_BALL4XI *** FAILED WITH KEY2DICT: ", key2dict)
                            print("\n (STEP 16X/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            print("\n (STEP 16X/33) OF TEST_BALL4XI - INDEX2Y: ", index2y)
                            print("\n (STEP 16X/33) OF TEST_BALL4XI - INDEX2Z: ", index2z)
                                                                  
                        print("\n SHOT ", order2key, ":", key2dict)
                        order2key = order2key +1 

                     
                    sum2plus = count2plusx + count2plusy+ count2plusz
                    sum2minus = count2minusx + count2minusy+ count2minusz
                    sum2total = count2plusx + count2minusx # same also with y and z - coordinate exists only once
                            
                    print('=' *80)
                    print("\n (STEP 16Y/33) OF TEST_BALL4XI - STATISTICS: ", max2count, " SHOTS")
                    print("\n START TIME: ", time2start)
                    print("\n +X: ", count2plusx, " = ", int(100*count2plusx/sum2total), " %")
                    print("\n -X: ", count2minusx, " = ", int(100*count2minusx/sum2total), " %") 
                   
                    print("\n +Y: ", count2plusy, " = ", int(100*count2plusy/sum2total), " %")
                    print("\n -Y: ", count2minusy, " = ", int(100*count2minusy/sum2total), " %") 
                   
                    print("\n +Z: ", count2plusz, " = ", int(100*count2plusz/sum2total), " %")
                    print("\n -Z: ", count2minusz, " = ", int(100*count2minusz/sum2total), " %") 
                              
                    count2layer = count2layer + 1 
                    print("\n SUM2TOTAL: ", sum2total, "SUCCESS-RATIO: ", int(100*sum2total/max2count), " %", " COUNT2LAYER: ", count2layer)
                    print("\n START2DISTANCE: ", start2distance, " INTERVAL2DISTANCE: ", interval2distance, " MAX2LAYER: ", max2layer, " MAX2COUNT : ", max2count)
                    print("\n MAX2AZMUTH: ", max2a, " MAX2ELEVATION: ", max2e, " CHANGE2AZMUTH: ", change2a, " CHANGE2ELEVATION : ", change2e)
                    print("\n END TIME: ", time2end)
                    print('=' *80)
                    # ================================================================================
                    # (STEP 16Y/33) OF TEST_BALL4XI - STATISTICS:  1000  SHOTS
                    #  START TIME:  05:31:14 06/02/10 Pacific Daylight Time
                    #  +X:  1002  =  100  %
                    #  -X:  0  =  0  %
                    #  +Y:  1002  =  100  %
                    #  -Y:  0  =  0  %
                    #  +Z:  1002  =  100  %
                    #  -Z:  0  =  0  %
                    #  SUM2TOTAL:  1002 SUCCESS-RATIO:  100  %  COUNT2LAYER:  10
                    #  START2DISTANCE:  100  INTERVAL2DISTANCE:  100  MAX2LAYER:  100  MAX2COUNT :  1000
                    #  MAX2AZMUTH:  1.25663706144  MAX2ELEVATION:  1.25663706144  CHANGE2AZMUTH:  0.0116729201457  CHANGE2ELEVATION :  0.0484572395911
                    #  END TIME:  05:31:31 06/02/10 Pacific Daylight Time
                    # ================================================================================                
                    
                except:
                    # -------------------------------------------------------------------------------------    
                    #
                    # -------------------------------------------------------------------------------------     
                    print("\n (STEP 16Z/33) OF TEST_BALL4XI *** FAILED IN SHOOTING X+,Y+,Z+ - EAST, SOUTH, TOWARDS *** ")
                    
                                        
                        
                # ---------------------------------------------------------------------------------------------
                # SHOOT (-X,+Y,+Z) - WEST SOUTH TOWARDS                      
                # ---------------------------------------------------------------------------------------------  
                print("\n (STEP 17A/33) OF TEST_BALL4XI - TRYING TO SHOOT (-X,+Y,+Z) - WEST SOUTH TOWARDS  ")   
                try:        

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # NEW BALL - SHOOT X+,Y+,Z+
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    ball2xi = Ball4Xi(message2ball = name2xi)
                    
                    start2distance = 100
                    interval2distance = 100  
                    max2layer = 100                          
                    max2count = 100          
                    

                    time2start = time4xi()
                    if max2count > 1000:
                        trace2set = False # <-- turn trace off with a large max2count !
                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                           
                    print("\n (STEP 17B/33) OF TEST_BALL4XI - TRYING LAYERS STARTING WITH DISTANCE: ", d2shot, 'INTERVAL2DISTANCE: ', interval2distance)   
                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # azimuth and elevation angle initialized
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # ref: http://en.wikipedia.org/wiki/Radian#Conversion_between_radians_and_degrees
                    # one radian is equal to 180/p degrees <=> 1 deg = rad * 180 / pi                             
                    # pi/6 = 30, pi/4 = 45, pi/3 = 60, pi/2 = 90, 2/3*pi = 120, 3/4pi=135, 5/6*pi = 150, pi = 180
                    # 7/6*pi = 210, 5/4*pi = 225...3*pi/2 = 270, 5*pi/3 = 300 ... 2*pi = 0 or 360 degrees
                    # I   = 0...90    (0...pi/2) :     sin+, cos+
                    # II  = 90...180  (pi/2...pi):     sin+, cos- 
                    # III = 180...270 (pi...3*pi/2):   sin-, cos-
                    # IV  = 270...360 (3*pi/2...2*pi): sin-, cos+
                    
                    # ref: http://en.wikipedia.org/wiki/Azimuth
                     
                    start2a = 1.59                                                                                              
                    start2e = pi / 4                            # start elevation        
                    
                    max2a = 3.0                                 # maximum azimuth 
                    max2e = 0.8 * pi/2                          # maximum elevation 

                    min2a = 0.069613609709                      # minumum to azimuth
                    min2e = pi / 24                             # minimum to elevation                          
                                          
                    a2shot = start2a                          
                    e2shot = start2e                            
                    
                    # ================================================================================
                    # (STEP 17Y/33) OF TEST_BALL4XI - STATISTICS:  100  SHOTS
                    #  START TIME:  07:04:04 06/02/10 Pacific Daylight Time
                    #  +X:  4  =  3  % <-- zero
                    #  -X:  98  =  96  %
                    #  +Y:  102  =  100  %
                    #  -Y:  0  =  0  %
                    #  +Z:  102  =  100  %
                    #  -Z:  0  =  0  %
                    #  SUM2TOTAL:  102 SUCCESS-RATIO:  102  %  COUNT2LAYER:  1
                    #  START2DISTANCE:  100  INTERVAL2DISTANCE:  100  MAX2LAYER:  100  MAX2COUNT :  100
                    #  MAX2AZMUTH:  3.0  MAX2ELEVATION:  1.25663706144  CHANGE2AZMUTH:  0.10471975512  CHANGE2ELEVATION :  0.0282743338823
                    #  END TIME:  07:04:04 06/02/10 Pacific Daylight Time
                    # ================================================================================    
                                        
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # increments for algorithm 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                
                    increase2distance = 0                       # zero with laeyrs, only new layer increases
                    
                    change2a = pi / 30                          # 9 degrees change to azimuth, -X: 56% 
                    change2e = pi / 120                         # 1,5 degrees change to elevation, increase it
                    
              
                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # shots
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    count2layer = 0                                                           
                    count2shot = 0
                    count2distance = 0                        
                    
                    d2shot = start2distance
                         
                    
                    print("\n (STEP 17C/33) OF TEST_BALL4XI - SHOTS: ", max2count, 'TIME SHOOTING STARTED: ', time4xi()) 
                    
                             
                    ack2azimuth = True
                    nack2azimuth = False
                    
                    ack2elevation = True
                    nack2elevation = False
                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                               
                    while count2shot < max2count:
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # 
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            
                        count2shot = count2shot + 1
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # distance
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            
                        d2shot = d2shot + increase2distance                           #remains the same for a laeyr
                         # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # azimuth
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        if a2shot >= 0:        
                            a2shot = a2shot + change2a
                        else:
                            a2shot = a2shot - change2a
                            if a2shot < min2a:
                                a2shot = change2a* start2a
                                print("\n (STEP 17D/33) OF TEST_BALL4XI - AZIMUTH BECAME LESS THAN MINIMUM, NEW AZIMUTH: ", a2shot)  
                                
                        if (a2shot >= max2a):
                            
                            start2a = start2a * 1.01
                            a2shot = start2a
                            print("\n (STEP 17E/33) OF TEST_BALL4XI - AZIMUTH BECAME TOO BIG , NEW AZIMUTH: ", a2shot) 
                            nack2azimuth = True
                            ack2azimuth = False
                            
                        if (a2shot <= -2 * pi):
                            change2a = 0.98 * change2a
                            start2a = -change2a * (pi / 4)
                            a2shot = change2a * start2a
                            print("\n (STEP 17F/33) OF TEST_BALL4XI - AZIMUTH BECAME LESS THAN MINIMUM, NEW AZIMUTH: ", a2shot) 
                            nack2azimuth = True
                            ack2azimuth = False
                        
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # elevation
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        if e2shot <= 0:
                            e2shot = e2shot - increase2e
                            if e2shot < min2e:
                                e2shot = change2e * start2e
                                print("\n (STEP 17G/33) OF TEST_BALL4XI - ELEVATION BECAME LESS THAN MINIMUM, NEW ELEVATION: ", e2shot) 
                        else:
                            e2shot = e2shot + increase2e            
                                                                 
                        if (e2shot >= max2e):
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # start again with a new elevation
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            change2e = 1.08 * change2e
                            start2e = (pi / 6) * change2e
                            e2shot = start2e
                            print("\n (STEP 17H/33) OF TEST_BALL4XI - ELEVATION BECAME BIGGER THAN PI, NEW ELEVATION: ", e2shot)
                            
                            nack2elevation = True
                            ack2elevation = False
                            
                        if (e2shot <= -pi):
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # start again with a new elevation and new elevation change
                            change2e = 1.02 * change2e
                            start2e = -(pi / 6) * change2e
                            e2shot = start2e                      
                            print("\n (STEP 17I/33) OF TEST_BALL4XI - ELEVATION BECAME LESSA THAN -* PI, NEW ELEVATION: ", e2shot)
                            
                            nack2elevation = True
                            ack2elevation = False
                            
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # shoot
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                                               
                        ball2xi.set(azimuth2shot = a2shot, elevation2shot = e2shot, distance2shot = d2shot, area2shot = int(4*pi*d2shot**2/interval2distance))
                        
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # distance
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes', area2shot = 'Yes')
                        print("\n (STEP 17J/33) OF TEST_BALL4XI - SHOT ", count2shot, ": ", status2ball)  
                            
                        count2distance = count2distance + 1
                        if count2distance > max2layer:
                            d2shot = d2shot + interval2distance
                            count2distance = 0
                            count2layer = count2layer + 1 
                            print("\n (STEP 17K/33) OF TEST_BALL4XI - NEW LAYER NUMBER: ", count2layer, ' NEW DISTANCE: ', d2shot)
                        else:
                            pass    

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    time2end = time4xi()           
                    print("\n (STEP 17L/33) OF TEST_BALL4XI - SHOTS: ", max2count, 'TIME SHOOTING ENDED: ', time2end)                         
                    
                                                                                                  
                    if ack2azimuth is True:
                        print("\n (STEP 17M/33) OF TEST_BALL4XI - AZIMUTH NEEDED NO ADJUSTEMENTS - ACK2AZIMUTH: ", ack2azimuth)
                    else:
                        print("\n (STEP 17N/33) OF TEST_BALL4XI - AZIMUTH NEEDED ADJUSTEMENTS - NACK2AZIMUTH: ", nack2azimuth)
                    
                    if ack2elevation is True:
                        print("\n (STEP 17O/33) OF TEST_BALL4XI - ELEVATION NEEDED NO ADJUSTEMENTS - ACK2ELEVATION: ", ack2elevation)
                    else:
                        print("\n (STEP 17P/33) OF TEST_BALL4XI - ELEVATION NEEDED ADJUSTEMENTS - NACK2ELEVATION: ", nack2elevation)                            
                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                           
                    print("\n (STEP 17Q/33) OF TEST_BALL4XI - WHOLE BALL AFTER ALL OPERATIONS AND WITH MAX2COUNT: ", max2count, 'TIME PRINTED: ', time4xi())  
                    
                    ball2show = ball2xi.get()
                    dict2keys = ball2show.keys()
                    print("\n (STEP 17R/33) OF TEST_BALL4XI - KEYS2BALL: ", dict2keys)
                    # 
                    print("\n (STEP 17S/33) OF TEST_BALL4XI - SHOOTING SAMPLE OF : ", max2count, " SHOTS", "NUMBER OF LAYERS: ", count2layer, ' LATEST DISTANCE: ', d2shot, ' INTERVAL2DISTANCE: ', interval2distance)    
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    count2plusx = 0
                    count2plusy = 0
                    count2plusz = 0
                           
                    count2minusx = 0
                    count2minusy = 0
                    count2minusz = 0
                    
                    order2key = 1
                    for key2dict in sorted(dict2keys):
                        try:
                            index2x=str.find(key2dict,'x')                               
                            x2coordinate = int(key2dict[0:index2x])
                            # print("\n (STEP 15L11/33/33) OF TEST_BALL4XI - X2COORDINATE: ",  x2coordinate)
                            if x2coordinate >= 0:
                                count2plusx = count2plusx + 1
                            else:
                                count2minusx = count2minusx + 1    
                        except:
                            print("\n (STEP 17T/33) OF TEST_BALL4XI *** FAILED WITH KEY2DICT: ", key2dict)
                            print("\n (STEP 17T/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            
                            
                        try:                                   
                            index2y=str.find(key2dict,'y')
                            y2coordinate = int(key2dict[index2x+1:index2y])
                            # print("\n (STEP 15L11/33) OF TEST_BALL4XI - Y2COORDINATE: ",  y2coordinate)
                            if y2coordinate >= 0:
                                count2plusy = count2plusy + 1
                            else:
                                count2minusy = count2minusy + 1  
                        except:
                            print("\n (STEP 17U/33) OF TEST_BALL4XI *** FAILED WITH KEY2DICT: ", key2dict) 
                            print("\n (STEP 17U/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            print("\n (STEP 17U/33) OF TEST_BALL4XI - INDEX2Y: ", index2y)
                        
                        try:                                                                         
                            index2z=str.find(key2dict,'z') 
                            z2coordinate = int(key2dict[index2y+1:index2z])
                            # print("\n (STEP 17V/33) OF TEST_BALL4XI - Z2COORDINATE: ",  z2coordinate)
                            if z2coordinate >= 0:
                                count2plusz = count2plusz + 1
                            else:
                                count2minusz = count2minusz + 1
                        except:
                            print("\n (STEP 17X/33) OF TEST_BALL4XI *** FAILED  WITH KEY2DICT: ", key2dict)
                            print("\n (STEP 17X/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            print("\n (STEP 17X/33) OF TEST_BALL4XI - INDEX2Y: ", index2y)
                            print("\n (STEP 17X/33) OF TEST_BALL4XI - INDEX2Z: ", index2z)
                                                                  
                        print("\n SHOT ", order2key, ":", key2dict)
                        order2key = order2key +1 

                     
                    sum2plus = count2plusx + count2plusy+ count2plusz
                    sum2minus = count2minusx + count2minusy+ count2minusz
                    sum2total = count2plusx + count2minusx # same also with y and z - coordinate exists only once
                            
                    print('=' *80)
                    print("\n (STEP 17Y/33) OF TEST_BALL4XI - STATISTICS: ", max2count, " SHOTS")
                    print("\n START TIME: ", time2start)
                    print("\n +X: ", count2plusx, " = ", int(100*count2plusx/sum2total), " %")
                    print("\n -X: ", count2minusx, " = ", int(100*count2minusx/sum2total), " %") 
                   
                    print("\n +Y: ", count2plusy, " = ", int(100*count2plusy/sum2total), " %")
                    print("\n -Y: ", count2minusy, " = ", int(100*count2minusy/sum2total), " %") 
                   
                    print("\n +Z: ", count2plusz, " = ", int(100*count2plusz/sum2total), " %")
                    print("\n -Z: ", count2minusz, " = ", int(100*count2minusz/sum2total), " %") 
                              
                    count2layer = count2layer + 1 
                    print("\n SUM2TOTAL: ", sum2total, "SUCCESS-RATIO: ", int(100*sum2total/max2count), " %", " COUNT2LAYER: ", count2layer)
                    print("\n START2DISTANCE: ", start2distance, " INTERVAL2DISTANCE: ", interval2distance, " MAX2LAYER: ", max2layer, " MAX2COUNT : ", max2count)
                    print("\n MAX2AZMUTH: ", max2a, " MAX2ELEVATION: ", max2e, " CHANGE2AZMUTH: ", change2a, " CHANGE2ELEVATION : ", change2e)
                    print("\n END TIME: ", time2end)
                    print('=' *80)
                    # ================================================================================
                    # (STEP 17Y/33) OF TEST_BALL4XI - STATISTICS:  100  SHOTS
                    #  START TIME:  07:04:04 06/02/10 Pacific Daylight Time
                    #  +X:  4  =  3  %
                    #  -X:  98  =  96  %
                    #  +Y:  102  =  100  %
                    #  -Y:  0  =  0  %
                    #  +Z:  102  =  100  %
                    #  -Z:  0  =  0  %
                    #  SUM2TOTAL:  102 SUCCESS-RATIO:  102  %  COUNT2LAYER:  1
                    #  START2DISTANCE:  100  INTERVAL2DISTANCE:  100  MAX2LAYER:  100  MAX2COUNT :  100
                    #  MAX2AZMUTH:  3.0  MAX2ELEVATION:  1.25663706144  CHANGE2AZMUTH:  0.10471975512  CHANGE2ELEVATION :  0.0282743338823
                    #  END TIME:  07:04:04 06/02/10 Pacific Daylight Time
                    # ================================================================================        
                    
                except:
                    # -------------------------------------------------------------------------------------    
                    #
                    # -------------------------------------------------------------------------------------     
                    print("\n (STEP 17Z/33) OF TEST_BALL4XI *** FAILED TO SHOOT (-X,+Y,+Z) - WEST SOUTH TOWARDS *** ") 
                    
             
                # ---------------------------------------------------------------------------------------------
                # SHOOT (-X,-Y,-Z) - WEST NORTH BACKWARDS                     
                # ---------------------------------------------------------------------------------------------  
                print("\n (STEP 18A/33) OF TEST_BALL4XI - TRYING TO SHOOT (-X,-Y,-Z) - WEST NORTH BACKWARDS")   
                try:        

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # NEW BALL - SHOOT (-X,-Y,-Z)
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    ball2xi = Ball4Xi(message2ball = name2xi)
                    
                    start2distance = 100
                    interval2distance = 100  
                    max2layer = 100                          
                    max2count = 100          
                    

                    time2start = time4xi()
                    if max2count > 1000:
                        trace2set = False # <-- turn trace off with a large max2count !
                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                           
                    print("\n (STEP 18B/33) OF TEST_BALL4XI - TRYING LAYERS STARTING WITH DISTANCE: ", d2shot, 'INTERVAL2DISTANCE: ', interval2distance)   
                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # azimuth and elevation angle initialized
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # ref: http://en.wikipedia.org/wiki/Radian#Conversion_between_radians_and_degrees
                    # one radian is equal to 180/p degrees <=> 1 deg = rad * 180 / pi                             
                    # pi/6 = 30, pi/4 = 45, pi/3 = 60, pi/2 = 90, 2/3*pi = 120, 3/4pi=135, 5/6*pi = 150, pi = 180
                    # 7/6*pi = 210, 5/4*pi = 225...3*pi/2 = 270, 5*pi/3 = 300 ... 2*pi = 0 or 360 degrees
                    # I   = 0...90    (0...pi/2) :     sin+, cos+
                    # II  = 90...180  (pi/2...pi):     sin+, cos- 
                    # III = 180...270 (pi...3*pi/2):   sin-, cos-
                    # IV  = 270...360 (3*pi/2...2*pi): sin-, cos+
                    # ref: http://en.wikipedia.org/wiki/Azimuth
                     
                    start2a = -pi / 2                           # start azimuth                                                             
                    start2e = pi / 2                            # start elevation 
                    
                    max2a = 2 * pi                              # maximum azimuth 
                    max2e = pi                                  # maximum elevation 

                    min2a = -pi                                 # minumum to azimuth
                    min2e = pi / 6                              # minimum to elevation                          
                                          
                    a2shot = start2a                          
                    e2shot = start2e                            
                    # ================================================================================
                    # (STEP 18Y/33) OF TEST_BALL4XI - STATISTICS:  100  SHOTS
                    # START TIME:  06:25:39 06/03/10 Pacific Daylight Time
                    #  +X:  2  =  1  %
                    #  -X:  100  =  98  %
                    #  +Y:  2  =  1  %
                    #  -Y:  100  =  98  %
                    #  +Z:  3  =  2  %
                    #  -Z:  99  =  97  %
                    #  SUM2TOTAL:  102 SUCCESS-RATIO:  102  %  COUNT2LAYER:  1
                    #  START2DISTANCE:  100  INTERVAL2DISTANCE:  100  MAX2LAYER:  100  MAX2COUNT :  100
                    #  MAX2AZMUTH:  6.28318530718  MAX2ELEVATION:  3.14159265359  CHANGE2AZMUTH:  0.10471975512  CHANGE2ELEVATION :  0.0261799387799
                    #  END TIME:  06:25:39 06/03/10 Pacific Daylight Time
                    # ================================================================================
                    # Notes: positive ones are zero in the above statistics
                                        
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # increments for algorithm 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                
                    increase2distance = 0                       # zero with laeyrs, only new layer increases
                    
                    change2a = pi / 30                          # 9 degrees change to azimuth, -X: 56% 
                    change2e = pi / 120                         # 1,5 degrees change to elevation, increase it
                    
              
                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # shots
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    count2layer = 0                                                           
                    count2shot = 0
                    count2distance = 0                        
                    
                    d2shot = start2distance
                         
                    
                    print("\n (STEP 18C/33) OF TEST_BALL4XI - SHOTS: ", max2count, 'TIME SHOOTING STARTED: ', time4xi()) 
                    
                             
                    ack2azimuth = True
                    nack2azimuth = False
                    
                    ack2elevation = True
                    nack2elevation = False
                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                               
                    while count2shot < max2count:
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # 
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            
                        count2shot = count2shot + 1
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # distance
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            
                        d2shot = d2shot + increase2distance                           #remains the same for a laeyr
                        
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # azimuth
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        if a2shot >= 0:        
                            a2shot = a2shot + change2a
                            if a2shot >= max2a:
                                start2a = start2a * 1.01
                                a2shot = start2a 
                                print("\n (STEP 18D/33) OF TEST_BALL4XI - AZIMUTH BECAME BIGGER THAN MAXIMUM: ", max2a , " NEW AZIMUTH: ", a2shot)    
                        else:
                            a2shot = a2shot - change2a
                            if a2shot <= min2a:
                                start2a = start2a * 1.01
                                a2shot = start2a  
                                print("\n (STEP 18E/33) OF TEST_BALL4XI - AZIMUTH BECAME SMALLER THAN MINIMUM: ", min2a , " NEW AZIMUTH: ", a2shot)  
                        
                        if (a2shot >= 2*pi):
                            start2a = start2a * 1.01
                            a2shot = start2a
                            print("\n (STEP 18F/33) OF TEST_BALL4XI - AZIMUTH BECAME BIGGER THAN 2*PI , NEW AZIMUTH: ", a2shot) 
                            nack2azimuth = True
                            ack2azimuth = False
                            
                        if (a2shot <= -2*pi):
                            change2a = 0.98 * change2a
                            start2a = -change2a * start2a
                            a2shot = change2a * start2a
                            print("\n (STEP 18G/33) OF TEST_BALL4XI - AZIMUTH BECAME LESS THAN -2*PI, NEW AZIMUTH: ", a2shot) 
                            nack2azimuth = True
                            ack2azimuth = False
                        
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # elevation
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        if e2shot <= 0:
                            e2shot = e2shot - increase2e
                            if e2shot <= min2e:
                                change2e = 1.02 * change2e
                                start2e = change2e * start2e
                                e2shot = start2e
                                print("\n (STEP 18H/33) OF TEST_BALL4XI - ELEVATION BECAME LESS THAN MINIMUM: ", min2e, " NEW ELEVATION: ", e2shot)                                   
                        else:
                            e2shot = e2shot + increase2e
                            if e2shot >= max2e:
                                change2e = 1.08 * change2e
                                start2e = change2e * start2e
                                e2shot = start2e
                                print("\n (STEP 18I/33) OF TEST_BALL4XI - ELEVATION BECAME BIGGER THAN MAXIMUM: ", max2e, " NEW ELEVATION: ", e2shot)                                        
                                                                 
                        if (e2shot >= pi):
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # start again with a new elevation and new elevation change
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            change2e = 1.08 * change2e
                            start2e = change2e * start2e
                            e2shot = start2e
                            print("\n (STEP 18H/33) OF TEST_BALL4XI - ELEVATION BECAME BIGGER THAN PI, NEW ELEVATION: ", e2shot)
                            
                            nack2elevation = True
                            ack2elevation = False
                            
                        if (e2shot <= -pi):
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # start again with a new elevation and new elevation change
                            change2e = 1.02 * change2e
                            start2e = change2e * start2e
                            e2shot = start2e                      
                            print("\n (STEP 18I/33) OF TEST_BALL4XI - ELEVATION BECAME LESS THAN -PI, NEW ELEVATION: ", e2shot)
                            
                            nack2elevation = True
                            ack2elevation = False
                            
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # shoot
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                                               
                        ball2xi.set(azimuth2shot = a2shot, elevation2shot = e2shot, distance2shot = d2shot, area2shot = int(4*pi*d2shot**2/interval2distance))
                        
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # distance
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes', area2shot = 'Yes')
                        print("\n (STEP 18J/33) OF TEST_BALL4XI - SHOT ", count2shot, ": ", status2ball)  
                            
                        count2distance = count2distance + 1
                        if count2distance > max2layer:
                            d2shot = d2shot + interval2distance
                            count2distance = 0
                            count2layer = count2layer + 1 
                            print("\n (STEP 18K/33) OF TEST_BALL4XI - NEW LAYER NUMBER: ", count2layer, ' NEW DISTANCE: ', d2shot)
                        else:
                            pass    

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    time2end = time4xi()           
                    print("\n (STEP 18L/33) OF TEST_BALL4XI - SHOTS: ", max2count, 'TIME SHOOTING ENDED: ', time2end)                         
                    
                                                                                                  
                    if ack2azimuth is True:
                        print("\n (STEP 18M/33) OF TEST_BALL4XI - AZIMUTH NEEDED NO ADJUSTEMENTS - ACK2AZIMUTH: ", ack2azimuth)
                    else:
                        print("\n (STEP 18N/33) OF TEST_BALL4XI - AZIMUTH NEEDED ADJUSTEMENTS - NACK2AZIMUTH: ", nack2azimuth)
                    
                    if ack2elevation is True:
                        print("\n (STEP 18O/33) OF TEST_BALL4XI - ELEVATION NEEDED NO ADJUSTEMENTS - ACK2ELEVATION: ", ack2elevation)
                    else:
                        print("\n (STEP 18P/33) OF TEST_BALL4XI - ELEVATION NEEDED ADJUSTEMENTS - NACK2ELEVATION: ", nack2elevation)                            
                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                           
                    print("\n (STEP 18Q/33) OF TEST_BALL4XI - WHOLE BALL AFTER ALL OPERATIONS AND WITH MAX2COUNT: ", max2count, 'TIME PRINTED: ', time4xi())  
                    
                    ball2show = ball2xi.get()
                    dict2keys = ball2show.keys()
                    print("\n (STEP 18R/33) OF TEST_BALL4XI - KEYS2BALL: ", dict2keys)
                    # 
                    print("\n (STEP 18S/33) OF TEST_BALL4XI - SHOOTING SAMPLE OF : ", max2count, " SHOTS", "NUMBER OF LAYERS: ", count2layer, ' LATEST DISTANCE: ', d2shot, ' INTERVAL2DISTANCE: ', interval2distance)    
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    count2plusx = 0
                    count2plusy = 0
                    count2plusz = 0
                           
                    count2minusx = 0
                    count2minusy = 0
                    count2minusz = 0
                    
                    order2key = 1
                    for key2dict in sorted(dict2keys):
                        try:
                            index2x=str.find(key2dict,'x')                               
                            x2coordinate = int(key2dict[0:index2x])
                            # print("\n (STEP 15L11/33/33) OF TEST_BALL4XI - X2COORDINATE: ",  x2coordinate)
                            if x2coordinate >= 0:
                                count2plusx = count2plusx + 1
                            else:
                                count2minusx = count2minusx + 1    
                        except:
                            print("\n (STEP 18T/33) OF TEST_BALL4XI *** FAILED  WITH KEY2DICT: ", key2dict)
                            print("\n (STEP 18T/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            
                            
                        try:                                   
                            index2y=str.find(key2dict,'y')
                            y2coordinate = int(key2dict[index2x+1:index2y])
                            # print("\n (STEP 15L11/33) OF TEST_BALL4XI - Y2COORDINATE: ",  y2coordinate)
                            if y2coordinate >= 0:
                                count2plusy = count2plusy + 1
                            else:
                                count2minusy = count2minusy + 1  
                        except:
                            print("\n (STEP 18U/33) OF TEST_BALL4XI *** FAILED  WITH KEY2DICT: ", key2dict) 
                            print("\n (STEP 18U/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            print("\n (STEP 18U/33) OF TEST_BALL4XI - INDEX2Y: ", index2y)
                        
                        try:                                                                         
                            index2z=str.find(key2dict,'z') 
                            z2coordinate = int(key2dict[index2y+1:index2z])
                            # print("\n (STEP 18V/33) OF TEST_BALL4XI - Z2COORDINATE: ",  z2coordinate)
                            if z2coordinate >= 0:
                                count2plusz = count2plusz + 1
                            else:
                                count2minusz = count2minusz + 1
                        except:
                            print("\n (STEP 18X/33) OF TEST_BALL4XI *** FAILED  WITH KEY2DICT: ", key2dict)
                            print("\n (STEP 18X/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            print("\n (STEP 18X/33) OF TEST_BALL4XI - INDEX2Y: ", index2y)
                            print("\n (STEP 18X/33) OF TEST_BALL4XI - INDEX2Z: ", index2z)
                                                                  
                        print("\n SHOT ", order2key, ":", key2dict)
                        order2key = order2key +1 

                     
                    sum2plus = count2plusx + count2plusy+ count2plusz
                    sum2minus = count2minusx + count2minusy+ count2minusz
                    sum2total = count2plusx + count2minusx # same also with y and z - coordinate exists only once
                            
                    print('=' *80)
                    print("\n (STEP 18Y/33) OF TEST_BALL4XI - STATISTICS: ", max2count, " SHOTS")
                    print("\n START TIME: ", time2start)
                    print("\n +X: ", count2plusx, " = ", int(100*count2plusx/sum2total), " %")
                    print("\n -X: ", count2minusx, " = ", int(100*count2minusx/sum2total), " %") 
                   
                    print("\n +Y: ", count2plusy, " = ", int(100*count2plusy/sum2total), " %")
                    print("\n -Y: ", count2minusy, " = ", int(100*count2minusy/sum2total), " %") 
                   
                    print("\n +Z: ", count2plusz, " = ", int(100*count2plusz/sum2total), " %")
                    print("\n -Z: ", count2minusz, " = ", int(100*count2minusz/sum2total), " %") 
                              
                    count2layer = count2layer + 1 
                    print("\n SUM2TOTAL: ", sum2total, "SUCCESS-RATIO: ", int(100*sum2total/max2count), " %", " COUNT2LAYER: ", count2layer)
                    print("\n START2DISTANCE: ", start2distance, " INTERVAL2DISTANCE: ", interval2distance, " MAX2LAYER: ", max2layer, " MAX2COUNT : ", max2count)
                    print("\n MAX2AZMUTH: ", max2a, " MAX2ELEVATION: ", max2e, " CHANGE2AZMUTH: ", change2a, " CHANGE2ELEVATION : ", change2e)
                    print("\n END TIME: ", time2end)
                    print('=' *80)
  
                    
                except:
                    # -------------------------------------------------------------------------------------    
                    #
                    # -------------------------------------------------------------------------------------     
                    print("\n (STEP 18Z/33) OF TEST_BALL4XI *** FAILED TO SHOOT (-X,-Y,-Z) - WEST, NORTH, BACKWARDS  *** ") 
                    
                                                       
                # ---------------------------------------------------------------------------------------------
                # SHOOT (+X,-Y,-Z) - EAST, NORTH, BACKWARDS              
                # ---------------------------------------------------------------------------------------------  
                print("\n (STEP 19A/33) OF TEST_BALL4XI - TRYING TO SHOOT (+X,-Y,-Z) - EAST, NORTH, BACKWARDS")   
                
                try:        

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # NEW BALL - SHOOT (-X,-Y,-Z)
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    ball2xi = Ball4Xi(message2ball = name2xi)
                    
                    start2distance = 100
                    interval2distance = 100  
                    max2layer = 100                          
                    max2count = 100          
                    

                    time2start = time4xi()
                    if max2count > 1000:
                        trace2set = False # <-- turn trace off with a large max2count !
                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                           
                    print("\n (STEP 19B/33) OF TEST_BALL4XI - TRYING LAYERS STARTING WITH DISTANCE: ", d2shot, 'INTERVAL2DISTANCE: ', interval2distance)   
                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # azimuth and elevation angle initialized
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # ref: http://en.wikipedia.org/wiki/Radian#Conversion_between_radians_and_degrees
                    # one radian is equal to 180/p degrees <=> 1 deg = rad * 180 / pi                             
                    # pi/6 = 30, pi/4 = 45, pi/3 = 60, pi/2 = 90, 2/3*pi = 120, 3/4pi=135, 5/6*pi = 150, pi = 180
                    # 7/6*pi = 210, 5/4*pi = 225...3*pi/2 = 270, 5*pi/3 = 300 ... 2*pi = 0 or 360 degrees
                    # I   = 0...90    (0...pi/2) :     sin+, cos+
                    # II  = 90...180  (pi/2...pi):     sin+, cos- 
                    # III = 180...270 (pi...3*pi/2):   sin-, cos-
                    # IV  = 270...360 (3*pi/2...2*pi): sin-, cos+
                    # ref: http://en.wikipedia.org/wiki/Azimuth
                     
                    start2a = 3*pi/2                            # start azimuth                                                             
                    start2e = 2/3*pi                            # start elevation 
                    
                    max2a = 2 * pi                              # maximum azimuth 
                    max2e = pi                                  # maximum elevation 

                    min2a = 0.01                                # minumum to azimuth
                    min2e = 0.01                                # minimum to elevation                          
                                          
                    a2shot = start2a                          
                    e2shot = start2e                            

                                        
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # increments for algorithm 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                
                    increase2distance = 0                       # zero with laeyrs, only new layer increases
                    
                    change2a = pi / 15                          # 18 degrees change to azimuth
                    change2e = pi / 12                          # 15 degrees change to elevation
                    
              
                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # shots
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    count2layer = 0                                                           
                    count2shot = 0
                    count2distance = 0                        
                    
                    d2shot = start2distance
                         
                    
                    print("\n (STEP 19C/33) OF TEST_BALL4XI - SHOTS: ", max2count, 'TIME SHOOTING STARTED: ', time4xi()) 
                    
                             
                    ack2azimuth = True
                    nack2azimuth = False
                    
                    ack2elevation = True
                    nack2elevation = False
                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                               
                    while count2shot < max2count:
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # 
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            
                        count2shot = count2shot + 1
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # distance
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            
                        d2shot = d2shot + increase2distance                           #remains the same for a laeyr
                        
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # azimuth
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        if a2shot >= 0:        
                            a2shot = a2shot + change2a
                            if a2shot >= max2a:
                                start2a = start2a * 1.01
                                a2shot = start2a 
                                print("\n (STEP 19D/33) OF TEST_BALL4XI - AZIMUTH BECAME BIGGER THAN MAXIMUM: ", max2a , " NEW AZIMUTH: ", a2shot)    
                        else:
                            a2shot = a2shot - change2a
                            if a2shot <= min2a:
                                start2a = start2a * 1.01
                                a2shot = start2a  
                                print("\n (STEP 19E/33) OF TEST_BALL4XI - AZIMUTH BECAME SMALLER THAN MINIMUM: ", min2a , " NEW AZIMUTH: ", a2shot)  
                        
                        if (a2shot >= 2*pi):
                            start2a = start2a * 1.01
                            a2shot = start2a
                            print("\n (STEP 19F/33) OF TEST_BALL4XI - AZIMUTH BECAME BIGGER THAN 2*PI , NEW AZIMUTH: ", a2shot) 
                            nack2azimuth = True
                            ack2azimuth = False
                            
                        if (a2shot <= -2*pi):
                            change2a = 0.98 * change2a
                            start2a = -change2a * start2a
                            a2shot = change2a * start2a
                            print("\n (STEP 19G/33) OF TEST_BALL4XI - AZIMUTH BECAME LESS THAN -2*PI, NEW AZIMUTH: ", a2shot) 
                            nack2azimuth = True
                            ack2azimuth = False
                        
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # elevation
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        if e2shot <= 0:
                            e2shot = e2shot - increase2e
                            if e2shot <= min2e:
                                change2e = 1.02 * change2e
                                start2e = change2e * start2e
                                e2shot = start2e
                                print("\n (STEP 19H/33) OF TEST_BALL4XI - ELEVATION BECAME LESS THAN MINIMUM: ", min2e, " NEW ELEVATION: ", e2shot)                                   
                        else:
                            e2shot = e2shot + increase2e
                            if e2shot >= max2e:
                                change2e = 1.08 * change2e
                                start2e = change2e * start2e
                                e2shot = start2e
                                print("\n (STEP 19I/33) OF TEST_BALL4XI - ELEVATION BECAME BIGGER THAN MAXIMUM: ", max2e, " NEW ELEVATION: ", e2shot)                                        
                                                                 
                        if (e2shot >= pi):
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # start again with a new elevation and new elevation change
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            change2e = 1.08 * change2e
                            start2e = change2e * start2e
                            e2shot = start2e
                            print("\n (STEP 19H/33) OF TEST_BALL4XI - ELEVATION BECAME BIGGER THAN PI, NEW ELEVATION: ", e2shot)
                            
                            nack2elevation = True
                            ack2elevation = False
                            
                        if (e2shot <= -pi):
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # start again with a new elevation and new elevation change
                            change2e = 1.02 * change2e
                            start2e = change2e * start2e
                            e2shot = start2e                      
                            print("\n (STEP 19I/33) OF TEST_BALL4XI - ELEVATION BECAME LESS THAN -PI, NEW ELEVATION: ", e2shot)
                            
                            nack2elevation = True
                            ack2elevation = False
                            
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # shoot
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                                               
                        ball2xi.set(azimuth2shot = a2shot, elevation2shot = e2shot, distance2shot = d2shot, area2shot = int(4*pi*d2shot**2/interval2distance))
                        
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # distance
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        status2ball = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes', area2shot = 'Yes')
                        print("\n (STEP 19J/33) OF TEST_BALL4XI - SHOT ", count2shot, ": ", status2ball)  
                            
                        count2distance = count2distance + 1
                        if count2distance > max2layer:
                            d2shot = d2shot + interval2distance
                            count2distance = 0
                            count2layer = count2layer + 1 
                            print("\n (STEP 19K/33) OF TEST_BALL4XI - NEW LAYER NUMBER: ", count2layer, ' NEW DISTANCE: ', d2shot)
                        else:
                            pass    

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    time2end = time4xi()           
                    print("\n (STEP 19L/33) OF TEST_BALL4XI - SHOTS: ", max2count, 'TIME SHOOTING ENDED: ', time2end)                         
                    
                                                                                                  
                    if ack2azimuth is True:
                        print("\n (STEP 19M/33) OF TEST_BALL4XI - AZIMUTH NEEDED NO ADJUSTEMENTS - ACK2AZIMUTH: ", ack2azimuth)
                    else:
                        print("\n (STEP 19N/33) OF TEST_BALL4XI - AZIMUTH NEEDED ADJUSTEMENTS - NACK2AZIMUTH: ", nack2azimuth)
                    
                    if ack2elevation is True:
                        print("\n (STEP 19O/33) OF TEST_BALL4XI - ELEVATION NEEDED NO ADJUSTEMENTS - ACK2ELEVATION: ", ack2elevation)
                    else:
                        print("\n (STEP 19P/33) OF TEST_BALL4XI - ELEVATION NEEDED ADJUSTEMENTS - NACK2ELEVATION: ", nack2elevation)                            
                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                           
                    print("\n (STEP 19Q/33) OF TEST_BALL4XI - WHOLE BALL AFTER ALL OPERATIONS AND WITH MAX2COUNT: ", max2count, 'TIME PRINTED: ', time4xi())  
                    
                    ball2show = ball2xi.get()
                    dict2keys = ball2show.keys()
                    print("\n (STEP 19R/33) OF TEST_BALL4XI - KEYS2BALL: ", dict2keys)
                    # 
                    print("\n (STEP 19S/33) OF TEST_BALL4XI - SHOOTING SAMPLE OF : ", max2count, " SHOTS", "NUMBER OF LAYERS: ", count2layer, ' LATEST DISTANCE: ', d2shot, ' INTERVAL2DISTANCE: ', interval2distance)    
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    count2plusx = 0
                    count2plusy = 0
                    count2plusz = 0
                           
                    count2minusx = 0
                    count2minusy = 0
                    count2minusz = 0
                    
                    order2key = 1
                    for key2dict in sorted(dict2keys):
                        try:
                            index2x=str.find(key2dict,'x')                               
                            x2coordinate = int(key2dict[0:index2x])
                            # print("\n (STEP 15L11/33/33) OF TEST_BALL4XI - X2COORDINATE: ",  x2coordinate)
                            if x2coordinate >= 0:
                                count2plusx = count2plusx + 1
                            else:
                                count2minusx = count2minusx + 1    
                        except:
                            print("\n (STEP 19T/33) OF TEST_BALL4XI *** FAILED  WITH KEY2DICT: ", key2dict)
                            print("\n (STEP 19T/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            
                            
                        try:                                   
                            index2y=str.find(key2dict,'y')
                            y2coordinate = int(key2dict[index2x+1:index2y])
                            # print("\n (STEP 15L11/33) OF TEST_BALL4XI - Y2COORDINATE: ",  y2coordinate)
                            if y2coordinate >= 0:
                                count2plusy = count2plusy + 1
                            else:
                                count2minusy = count2minusy + 1  
                        except:
                            print("\n (STEP 19U/33) OF TEST_BALL4XI *** FAILED  WITH KEY2DICT: ", key2dict) 
                            print("\n (STEP 19U/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            print("\n (STEP 19U/33) OF TEST_BALL4XI - INDEX2Y: ", index2y)
                        
                        try:                                                                         
                            index2z=str.find(key2dict,'z') 
                            z2coordinate = int(key2dict[index2y+1:index2z])
                            # print("\n (STEP 19V/33) OF TEST_BALL4XI - Z2COORDINATE: ",  z2coordinate)
                            if z2coordinate >= 0:
                                count2plusz = count2plusz + 1
                            else:
                                count2minusz = count2minusz + 1
                        except:
                            print("\n (STEP 19X/33) OF TEST_BALL4XI *** FAILED  WITH KEY2DICT: ", key2dict)
                            print("\n (STEP 19X/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            print("\n (STEP 19X/33) OF TEST_BALL4XI - INDEX2Y: ", index2y)
                            print("\n (STEP 19X/33) OF TEST_BALL4XI - INDEX2Z: ", index2z)
                                                                  
                        print("\n SHOT ", order2key, ":", key2dict)
                        order2key = order2key +1 

                     
                    sum2plus = count2plusx + count2plusy+ count2plusz
                    sum2minus = count2minusx + count2minusy+ count2minusz
                    sum2total = count2plusx + count2minusx # same also with y and z - coordinate exists only once
                            
                    print('=' *80)
                    print("\n (STEP 19Y/33) OF TEST_BALL4XI - STATISTICS: ", max2count, " SHOTS")
                    print("\n START TIME: ", time2start)
                    print("\n +X: ", count2plusx, " = ", int(100*count2plusx/sum2total), " %")
                    print("\n -X: ", count2minusx, " = ", int(100*count2minusx/sum2total), " %") 
                   
                    print("\n +Y: ", count2plusy, " = ", int(100*count2plusy/sum2total), " %")
                    print("\n -Y: ", count2minusy, " = ", int(100*count2minusy/sum2total), " %") 
                   
                    print("\n +Z: ", count2plusz, " = ", int(100*count2plusz/sum2total), " %")
                    print("\n -Z: ", count2minusz, " = ", int(100*count2minusz/sum2total), " %") 
                              
                    count2layer = count2layer + 1 
                    print("\n SUM2TOTAL: ", sum2total, "SUCCESS-RATIO: ", int(100*sum2total/max2count), " %", " COUNT2LAYER: ", count2layer)
                    print("\n START2DISTANCE: ", start2distance, " INTERVAL2DISTANCE: ", interval2distance, " MAX2LAYER: ", max2layer, " MAX2COUNT : ", max2count)
                    print("\n MAX2AZMUTH: ", max2a, " MAX2ELEVATION: ", max2e, " CHANGE2AZMUTH: ", change2a, " CHANGE2ELEVATION : ", change2e)
                    print("\n END TIME: ", time2end)
                    print('=' *80)
                    # ================================================================================
                    #  STEP 19Y/33) OF TEST_BALL4XI - STATISTICS:  100  SHOTS
                    #  START TIME:  06:56:53 06/03/10 Pacific Daylight Time
                    #  +X:  102  =  100  %
                    #  -X:  0  =  0  %
                    #  +Y:  5  =  4  %
                    #  -Y:  97  =  95  %
                    #  +Z:  2  =  1  %
                    #  -Z:  100  =  98  %
                    #  SUM2TOTAL:  102 SUCCESS-RATIO:  102  %  COUNT2LAYER:  1
                    #  START2DISTANCE:  100  INTERVAL2DISTANCE:  100  MAX2LAYER:  100  MAX2COUNT :  100
                    #  MAX2AZMUTH:  6.28318530718  MAX2ELEVATION:  3.14159265359  CHANGE2AZMUTH:  0.209439510239  CHANGE2ELEVATION :  0.261799387799
                    #  END TIME:  06:56:53 06/03/10 Pacific Daylight Time
                    # ================================================================================  
                    
                except:
                    # -------------------------------------------------------------------------------------    
                    #
                    # -------------------------------------------------------------------------------------     
                    print("\n (STEP 19Z/33) OF TEST_BALL4XI *** FAILED TO SHOOT (+X,-Y,-Z) - EAST, NORTH, BACKWARDS *** ") 
                    

                                                                                                       
                # ---------------------------------------------------------------------------------------------
                # SMART SHOOTING (+X,+Y,-Z) - EAST, SOUTH, BACKWARDS                
                # ---------------------------------------------------------------------------------------------                                                               
                print("\n (STEP 20A/33) OF TEST_BALL4XI - TRYING SMART SHOOTING (+X,+Y,-Z) - EAST, SOUTH, BACKWARDS")   
                
                try:        

                    # =============================================================================================                   
                    # INITIALIZATIONS
                    # =============================================================================================                
      
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    ball2xi = Ball4Xi(message2ball = name2xi)

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                        
                    start2distance = 100
                    print("\n (STEP 20B1/33) OF TEST_BALL4XI - DISTANCE: ", d2shot)   

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                     
                    interval2distance = 100  
                    print("\n (STEP 20B2/33) OF TEST_BALL4XI - INTERVAL TO DISTANCE: ", interval2distance)   
                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    max2layer = 100                          
                    marginal2layer = 1.2
                    omax2layer = max2layer
                    max2layer = int(marginal2layer * max2layer)
                    print("\n (STEP 20B3/33) OF TEST_BALL4XI - MAXIMUM SHOTS PER LAYER: ", max2layer, " MARGINAL TO LAYER: ", marginal2layer) 
                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    max2count = 100
                    marginal2count = 1.2
                    omax2count = max2count
                    max2count = int(marginal2count * max2count)
                            
                    print("\n (STEP 20B4/33) OF TEST_BALL4XI - MAXIMUM SHOTS: ", max2count, " MARGINAL TO COUNT: ", marginal2count) 
                    if max2count > 1000:
                        trace2set = False # <-- turn trace off with a large max !

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                    
                    time2start = time4xi()                        
                    print("\n (STEP 20B5/33) OF TEST_BALL4XI - START TIME: ", time2start) 
                                                                                            
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # required signs for (x,y,z)
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    sign2x = '+'    
                    sign2y = '+'
                    sign2z = '-'
                    print("\n (STEP 20B6/33) OF TEST_BALL4XI - X-SIGN: ", sign2x, 'Y-SIGN: ', sign2y, 'Z-SIGN: ', sign2z) 
                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                    
                    max2iterate = 1000
                    print("\n (STEP 20B7/33) OF TEST_BALL4XI - MAXIMUM TO ITERATIONS: ", max2iterate) 
                    if max2iterate > 1000:
                        trace2set = False # <-- turn trace off with a large max !  
                                          
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # azimuth and elevation angle initialized
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # ref: http://en.wikipedia.org/wiki/Radian#Conversion_between_radians_and_degrees
                    # one radian is equal to 180/p degrees <=> 1 deg = rad * 180 / pi                             
                    # pi/6 = 30, pi/4 = 45, pi/3 = 60, pi/2 = 90, 2/3*pi = 120, 3/4pi=135, 5/6*pi = 150, pi = 180
                    # 7/6*pi = 210, 5/4*pi = 225...3*pi/2 = 270, 5*pi/3 = 300 ... 2*pi = 0 or 360 degrees
                    # I   = 0...90    (0...pi/2) :     sin+, cos+
                    # II  = 90...180  (pi/2...pi):     sin+, cos- 
                    # III = 180...270 (pi...3*pi/2):   sin-, cos-
                    # IV  = 270...360 (3*pi/2...2*pi): sin-, cos+
                    # ref: http://en.wikipedia.org/wiki/Azimuth

                    # =============================================================================================                   
                    # AZIMUTH
                    # =============================================================================================                
                                                                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                    start2plusa = pi/6                          # start plus azimuth 30 degrees - iterates smaller                                                           
                    print("\n (STEP 20B8/33) OF TEST_BALL4XI - START2PLUSA: ", start2plusa) 
                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
                    max2plusa = 2*pi                            # extreme plus azimuth 360 degrees around sideways
                    print("\n (STEP 20B8/33) OF TEST_BALL4XI - MAX2PLUSA: ", max2plusa) 

                                                                        
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
                    min2plusa = pi/240                          # minum positive azimuth 0.75 degrees sideways 
                    print("\n (STEP 20B8/33) OF TEST_BALL4XI - MIN2PLUSA: ", min2plusa) 
                                                          
                                              
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                    start2minusa = -pi/6                        # start minus azimuth -30 degrees sideways                                                           
                    print("\n (STEP 20B8/33) OF TEST_BALL4XI - START2MINUSA: ", start2minusa) 
                                  
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
                    max2minusa = -0.98*2*pi                     # extreme minus azimuth almost -360 degrees 
                    print("\n (STEP 20B8/33) OF TEST_BALL4XI - MAX2MINUSA: ", max2minusa) 
                                                                            
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
                    min2minusa = -pi/240                        # nearest to zero minus to azimuth
                    print("\n (STEP 20B8/33) OF TEST_BALL4XI - MIN2MINUSA: ", min2minusa) 
                                                                    
                    # =============================================================================================                   
                    # ELEVATION
                    # =============================================================================================                
                                                      
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                    start2pluse = pi/6                          # start plus elevation 30 degrees up 
                    print("\n (STEP 20B8/33) OF TEST_BALL4XI - START2PLUSE: ", start2pluse) 
                                                          
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
                    max2pluse = pi                              # most flexible elevation 180 degrees 
                    print("\n (STEP 20B8/33) OF TEST_BALL4XI - MAX2PLUSE: ", max2pluse) 
                                      
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
                    min2pluse = pi/240                          # lowest plus to elevation 0.75 degrees                          
                    print("\n (STEP 20B8/33) OF TEST_BALL4XI - MIN2PLUSE: ", min2pluse) 
                                                   
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                    start2minuse = -pi/6                        # start minus elevation -30 degrees down                                                
                    print("\n (STEP 20B8/33) OF TEST_BALL4XI - START2MINUSE: ", start2minuse) 
                  
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
                    max2minuse = -0.98*pi                       # most painful minus elevation almost -180 degrees
                    print("\n (STEP 20B8/33) OF TEST_BALL4XI - MAX2MINUSE: ", max2minuse) 
                                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
                    min2minuse = -pi/240                        # least painful minus elevation -0.75 degrees                              
                    print("\n (STEP 20B8/33) OF TEST_BALL4XI - MIN2MINUSE: ", min2minuse) 
                                                         
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # increments for algorithm 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    increase2distance = 0                       # zero with laeyrs, only new layer increases
                    print("\n (STEP 20B8/33) OF TEST_BALL4XI - INCREASE2DISTANCE: ", increase2distance) 
                                                         
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # increments for algorithm 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    change2a = pi / 60                          # 3 degrees change to azimuth
                    print("\n (STEP 20B8/33) OF TEST_BALL4XI -CHANGE2A: ", change2a) 
                                                         
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # increments for algorithm 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    change2e = pi / 60                          # 3 degrees change to elevation
                    print("\n (STEP 20B8/33) OF TEST_BALL4XI - CHANGE2E: ", change2e) 
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # azimuth settings based on sign, which might get tuned to opposite sign later on
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    sign2a = '+'

                    if sign2a == '+':
                        start2a = start2plusa
                        min2a = min2plusa
                        max2a = max2plusa
                    else:
                        start2a = start2minusa
                        min2a = min2minusa
                        max2a = max2minusa
                        
                    print("\n (STEP 20B9/33) OF TEST_BALL4XI - START AZIMUTH: ", start2a, 'MIN AZIMUTH: ', min2a, 'MAX AZIMUTH: ', max2a) 
                    
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # elevation values used based on sign
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    sign2e = '+'

                    if sign2e == '+':
                        start2e = start2pluse
                        min2e = min2pluse
                        max2e = max2pluse
                    else:
                        start2e = start2minuse
                        min2e = min2minuse
                        max2e = max2minuse
                        
                    print("\n (STEP 20B10/33) OF TEST_BALL4XI - START ELEVATION: ", start2e, 'MIN ELEVATION: ', min2e, 'MAX ELEVATION: ', max2e) 
                    
                  
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # azimuth start setting
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                              
                    a2shot = start2a 
                    
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # elevation start setting
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                              
                    e2shot = start2e                            
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # distance start setting
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                          
                    d2shot = start2distance
            
                                  
                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # initializations for while loop 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    count2layer = 1                                  # layers                                                           
                    
                    count2ok = 0                                     # ok shots with all of (x,y,z) ok 
                    
                    count2distance = 0                               # for none layers when distance increased                        
                    
                    count2iterate = 0                                # hunt for right (x,y,z) combination
                    
                    count2rejected = 0                               # rejected
                  
                    ack2x = False                                    # validation for x-coordinate
                    nack2x = True
                    
                    ack2y = False                                    # validation for y-coordinate
                    nack2y = True                    
                    
                    ack2z = False                                    # validation for z-coordinate
                    nack2z = True
                    
                    ack2layer = False                                # validation for layer
                    nack2layer = True                    
                    
                    print("\n (STEP 20F/33) OF TEST_BALL4XI - START TIME OF SHOOTING: ", time4xi(), " FOR ", max2count, " SHOTS") 
                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                                             
                    while ((count2ok <= max2count) and (count2iterate < max2iterate)   
                           and (ack2layer is False)): 
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # 
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        count2iterate = count2iterate + 1    
                        
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # distance
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        d2shot = d2shot + increase2distance                          # remains the same for a laeyr
                        
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # azimuth changes
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        if a2shot >= 0:        
                            a2shot = a2shot + change2a
                            if a2shot >= max2a:
                                start2a = start2a * 1.01
                                a2shot = start2a 
                                print("\n (STEP 20G/33) OF TEST_BALL4XI - AZIMUTH BECAME BIGGER THAN MAXIMUM: ", max2a , " NEW AZIMUTH: ", a2shot)    
                        else:
                            a2shot = a2shot - change2a
                            if a2shot <= min2a:
                                start2a = start2a * 1.01
                                a2shot = start2a  
                                print("\n (STEP 20H/33) OF TEST_BALL4XI - AZIMUTH BECAME SMALLER THAN MINIMUM: ", min2a , " NEW AZIMUTH: ", a2shot)  
                                
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # azimuth algoritm checking against maximum allowed - restart with tuning, if necessary
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                        if (a2shot >= 2*pi):
                            sign2a = '-'                                             # switch to negative
                            change2a = 0.98 * change2a                               # change2a always positive
                            start2a = change2a * start2minusa                        # new minus azimuth start
                            a2shot = start2a                                         # new azimuth
                            min2a = min2minusa                                       # new minimum to azimuth
                            max2a = max2minusa                                       # new maximum to azimuth
                            print("\n (STEP 20I/33) OF TEST_BALL4XI - AZIMUTH BECAME BIGGER THAN 2*PI , NEW AZIMUTH: ", a2shot) 

                            
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # azimuth algoritm checking against minimum allowed- restart with tuning, if necessary
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                             
                        if (a2shot <= -2*pi):
                            sign2a = '+'                                             # switch to positive
                            change2a = 0.98 * change2a                               # change2a always positive
                            start2a = change2a * start2plusa                         # new positive azimuth start
                            a2shot = start2a                                         # new azimuth
                            min2a = min2plusa                                        # new minimum to azimuth
                            max2a = max2plusa                                        # new maximum to azimuth
                            print("\n (STEP 20J/33) OF TEST_BALL4XI - AZIMUTH BECAME LESS THAN -2*PI, NEW AZIMUTH: ", a2shot) 

                        
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # elevation changes
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        if e2shot <= 0:
                            e2shot = e2shot - increase2e
                            if e2shot <= min2e:
                                change2e = 1.02 * change2e
                                start2e = change2e * start2e
                                e2shot = start2e
                                print("\n (STEP 20K/33) OF TEST_BALL4XI - ELEVATION BECAME LESS THAN MINIMUM: ", min2e, " NEW ELEVATION: ", e2shot)                                   
                        else:
                            e2shot = e2shot + increase2e
                            if e2shot >= max2e:
                                change2e = 1.08 * change2e
                                start2e = change2e * start2e
                                e2shot = start2e
                                print("\n (STEP 20L/33) OF TEST_BALL4XI - ELEVATION BECAME BIGGER THAN MAXIMUM: ", max2e, " NEW ELEVATION: ", e2shot)  
                                                                      
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # elevation algoritm checking against maximum allowed - restart with tuning, if necessary
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                                                   
                        if (e2shot >= pi):
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # start again with a new elevation and new elevation change
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            sign2e = '-'                                             # switch to negative
                            change2e = 0.98 * change2e                               # change2e always positive
                            start2e = change2e * start2minuse                        # new minus elevation start
                            e2shot = start2e                                         # new azimuth
                            min2e = min2minuse                                       # new minimum to elevation
                            max2e = max2minuse                                       # new maximum to elevation
                            print("\n (STEP 20M/33) OF TEST_BALL4XI - ELEVATION BECAME BIGGER THAN PI, NEW ELEVATION: ", e2shot)
                            

                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # elevation algoritm checking against minimum allowed- restart with tuning, if necessary
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
                        
                        if (e2shot <= -pi):
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # start again with a new elevation and new elevation change
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                            
                            sign2e = '+'                                             # switch to positive
                            change2e = 0.98 * change2e                               # change2e always positive
                            start2e = change2e * start2pluse                         # new positive elevation start
                            e2shot = start2e                                         # new azimuth
                            min2e = min2pluse                                        # new minimum to elevation
                            max2e = max2pluse                                        # new maximum to elevation        
                            print("\n (STEP 20N/33) OF TEST_BALL4XI - ELEVATION BECAME LESS THAN -PI, NEW ELEVATION: ", e2shot)
                            

                            
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # shoot
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                                               
                        ball2xi.set(azimuth2shot = a2shot, elevation2shot = e2shot, distance2shot = d2shot, area2shot = int(4*pi*d2shot**2/interval2distance))
                        
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # check shot 
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        shot2examine = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes', area2shot = 'Yes')
                        print("\n (STEP 20OA/33) OF TEST_BALL4XI - SHOT TO EXAMINE ", count2shot, ": ", shot2examine)  
                        # {'42x27y86z': {'x2shot': 42, 'azimuth2shot': 0.5759586531581287, 'area2shot': 1256, 'id2shot': '42x27y86z', 'distance2shot': 100, 'z2shot': 86, 'elevation2shot': 0.5335987755982988, 'y2shot': 27}}
                         
                        keys2examine = shot2examine.keys()
                        print("\n (STEP 20OB1/33) OF TEST_BALL4XI - KEYS2EXAMINE: ", keys2examine)   
                        # dict_keys(['42x27y86z'])
                        
                        for key2examine in sorted(keys2examine):
                            print("\n (STEP 20OB2/33) OF TEST_BALL4XI - KEY2EXAMINE ", key2examine)  
                            # 42x27y86z
                            
                            ack2x = False 
                            nack2x = True                                  
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # X OK ?
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                            try:
                                index2x=str.find(key2examine,'x')                               
                                x2coordinate = int(key2examine[0:index2x])
                                if x2coordinate >= 0:
                                    if sign2x == '+':
                                        ack2x = True
                                        nack2x = False
                                        print("\n (STEP 20OB3/33/33) OF TEST_BALL4XI - X2COORDINATE ACK: ", ack2x) 
                                else:
                                    if sign2x == '-':
                                        ack2x = True
                                        nack2x = False
                                        print("\n (STEP 20OB4/33/33) OF TEST_BALL4XI - X2COORDINATE ACK: ", ack2x)
                                         
                            except:
                                print("\n (STEP 20B5/33) OF TEST_BALL4XI *** FAILED  WITH KEY2EXAMINE: ", key2examine)
                                print("\n (STEP 20B5/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                                
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # Y OK ?
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
                            ack2y = False 
                            nack2y = True     
                            try:
                                index2y=str.find(key2examine,'y')                               
                                y2coordinate = int(key2examine[index2x+1:index2y])
                                if y2coordinate >= 0:
                                    if sign2y == '+':
                                        ack2y = True
                                        nack2y = False
                                        print("\n (STEP 20OB6/33) OF TEST_BALL4XI - Y2COORDINATE ACK: ", ack2y)                                         
                                else:
                                    if sign2y == '-':
                                        ack2y = True
                                        nack2y = False
                                        print("\n (STEP 20OB7/33) OF TEST_BALL4XI - Y2COORDINATE ACK: ", ack2y)                               
                            except:
                                print("\n (STEP 20OB8/33) OF TEST_BALL4XI *** FAILED  WITH KEY2EXAMINE: ", key2examine)
                                print("\n (STEP 20OB8/33) OF TEST_BALL4XI - INDEX2Y: ", index2y)
                                
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # Z OK ?
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
                            ack2z = False 
                            nack2z = True                                 
                            try:
                                index2z=str.find(key2examine,'z')                               
                                z2coordinate = int(key2examine[index2y+1:index2z])
                                if z2coordinate >= 0:
                                    if sign2z == '+':
                                        ack2z = True
                                        nack2z = False
                                        print("\n (STEP 20OB9/33) OF TEST_BALL4XI - Z2COORDINATE ACK: ", ack2z)                                               
                                else:
                                    if sign2z == '-':
                                        ack2z = True
                                        nack2z = False
                                        print("\n (STEP 20OB10/33) OF TEST_BALL4XI - Z2COORDINATE ACK: ", ack2z)                                  
                            except:
                                print("\n (STEP 20OB11/33) OF TEST_BALL4XI *** FAILED  WITH KEY2EXAMINE: ", key2examine)
                                print("\n (STEP 20OB11/33) OF TEST_BALL4XI - INDEX2Z: ", index2z)
                                
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # (X,Y,Z) OK ?
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
                            try:                                                           
                                if ((ack2x is True) and (ack2y is True) and (ack2z is True)):
                                    print("\n (STEP 20O5A/33) OF TEST_BALL4XI - OK: (" , x2coordinate, ",", y2coordinate, ",", z2coordinate, ")") 
                                    print("\n (STEP 20O5B/33) OF TEST_BALL4XI - EXPECTED: (" , sign2x, ",", sign2y, ",", sign2z, ")") 
                                    count2ok = count2ok + 1 
                                    if count2ok >= max2layer:
                                        ack2layer = True
                                        print("\n (STEP 20O6/33) OF TEST_BALL4XI - ACK2LAYER: " , ack2layer)
                                    else:
                                        ack2layer = False
                                else:
                                    print("\n (STEP 20O8A/33) OF TEST_BALL4XI - REJECTED: (" , x2coordinate, ",", y2coordinate, ",", z2coordinate, ")")
                                    print("\n (STEP 20O8B/33) OF TEST_BALL4XI - EXPECTED: (" , sign2x, ",", sign2y, ",", sign2z, ")")
                                    
                                    count2rejected = count2rejected + 1
                                    ack2layer = False 
                                    # ( 42 , 27 , 86 )
                                    # ( + , + , - )  
                                    
                                    print("\n (STEP 20O8C/33) OF TEST_BALL4XI *** REMEMBER TO DELETE THE SHOT OR LET IT BE AND RETURN ONLY OK SHOTS!!!! *** ")
                                    
                                                        
                            except:
                                print("\n (STEP 20O9/33) OF TEST_BALL4XI *** FAILED  WITH KEY2EXAMINE: ", key2examine)
                                print("\n (STEP 20O9/33) OF TEST_BALL4XI - INDEX2Z: ", index2z)
                        
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # CONTINUE WHILE
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                    

                        print("\n (STEP 20O10/33) OF TEST_BALL4XI - CONTINUING WHILE WITH:")
                        print("\n COUNT2OK:", count2ok)
                        print("\n MAX2COUNT:", max2count)                        
                        print("\n COUNT2ITERATE:", count2iterate)
                        print("\n MAX2ITERATE:", max2iterate)                        
                        print("\n ACK2LAYER:", ack2layer)                        
                        
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # CONTINUE WHILE
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                    
                                                                                                         
                        count2distance = count2distance + increase2distance  #stays the same when a layer is shot
                        if count2distance > max2layer:
                            d2shot = d2shot + interval2distance
                            count2distance = 0
                            count2layer = count2layer + 1 
                            print("\n (STEP 20O10/33) OF TEST_BALL4XI - NEW LAYER NUMBER: ", count2layer, ' NEW DISTANCE: ', d2shot)
                        else:
                            pass 
                               
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # end of while
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # EXAMINE RESULTS 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    time2end = time4xi()           
                    print("\n (STEP 20P1/33) OF TEST_BALL4XI - STATISTICS FOR SHOOTING, WHICH ENDED: ", time2end)                          
                    print("\n SHOTS OK: ", count2ok, " = ", int(100 * count2ok/max2count), " %")                              
                    print("\n SHOTS ORIGINALLY REQUIRED: ", omax2count)      
                    print("\n ITERATIONS NEEDED: ", count2iterate)                              
                    print("\n ITERATIONS ALLOWED: ", max2iterate) 
                    print("\n REJECTED: ", count2rejected, " = : ", int(100 * count2rejected/count2iterate), " %") 

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                           
                    print("\n (STEP 20Y1/33) OF TEST_BALL4XI - WHOLE BALL AFTER ALL OPERATIONS AND WITH MAX2COUNT: ", max2count, 'TIME PRINTED: ', time4xi())  
                    
                    ball2show = ball2xi.get()
                    dict2keys = ball2show.keys()
                    print("\n (STEP 20Y2/33) OF TEST_BALL4XI - KEYS2BALL: ", dict2keys)
                    # 
                    print("\n (STEP 20Y3/33) OF TEST_BALL4XI - SHOOTING SAMPLE OF : ", max2count, " SHOTS", "NUMBER OF LAYERS: ", count2layer, ' LATEST DISTANCE: ', d2shot, ' INTERVAL2DISTANCE: ', interval2distance)    
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    count2plusx = 0
                    count2plusy = 0
                    count2plusz = 0
                           
                    count2minusx = 0
                    count2minusy = 0
                    count2minusz = 0
                    
                    count2accepted = 0
                    count2rejected = 0
                    
                    order2key = 1
                    for key2dict in sorted(dict2keys):
                        try:
                            index2x=str.find(key2dict,'x')                               
                            x2coordinate = int(key2dict[0:index2x])
                            # print("\n (STEP 15L11/33/33) OF TEST_BALL4XI - X2COORDINATE: ",  x2coordinate)
                            if x2coordinate >= 0:
                                count2plusx = count2plusx + 1
                            else:
                                count2minusx = count2minusx + 1    
                        except:
                            print("\n (STEP 20Y4/33) OF TEST_BALL4XI *** FAILED  WITH KEY2DICT: ", key2dict)
                            print("\n (STEP 20Y5/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            
                            
                        try:                                   
                            index2y=str.find(key2dict,'y')
                            y2coordinate = int(key2dict[index2x+1:index2y])
                            # print("\n (STEP 15L11/33) OF TEST_BALL4XI - Y2COORDINATE: ",  y2coordinate)
                            if y2coordinate >= 0:
                                count2plusy = count2plusy + 1
                            else:
                                count2minusy = count2minusy + 1  
                        except:
                            print("\n (STEP 20Y6/33) OF TEST_BALL4XI *** FAILED  WITH KEY2DICT: ", key2dict) 
                            print("\n (STEP 20Y7/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            print("\n (STEP 20Y8/33) OF TEST_BALL4XI - INDEX2Y: ", index2y)
                        
                        try:                                                                         
                            index2z=str.find(key2dict,'z') 
                            z2coordinate = int(key2dict[index2y+1:index2z])
                            # print("\n (STEP 20V/33) OF TEST_BALL4XI - Z2COORDINATE: ",  z2coordinate)
                            if z2coordinate >= 0:
                                count2plusz = count2plusz + 1
                            else:
                                count2minusz = count2minusz + 1
                        except:
                            print("\n (STEP 20Y9/33) OF TEST_BALL4XI *** FAILED  WITH KEY2DICT: ", key2dict)
                            print("\n (STEP 20Y10/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            print("\n (STEP 20Y11/33) OF TEST_BALL4XI - INDEX2Y: ", index2y)
                            print("\n (STEP 20Y12/33) OF TEST_BALL4XI - INDEX2Z: ", index2z)
                        
                        ack2x = False    
                        if ((x2coordinate >= 0) and (sign2x == '+')):
                            ack2x = True
                        if ((x2coordinate <= 0) and (sign2x == '-')):
                            ack2x = True                        
                        
                        ack2y = False    
                        if ((y2coordinate >= 0) and (sign2y == '+')):
                            ack2y = True
                        if ((y2coordinate <= 0) and (sign2y == '-')):
                            ack2y = True     
                        
                        ack2z = False    
                        if ((z2coordinate >= 0) and (sign2z == '+')):
                            ack2z = True
                        if ((z2coordinate <= 0) and (sign2z == '-')):
                            ack2z = True     
                        
                        if ((ack2x is True) and (ack2y is True) and (ack2z is True)):
                            count2accepted = count2accepted + 1                                                                                                      
                            print("\n(STEP 20Y13/33) OF TEST_BALL4XI -  ACCEPTANCE: ", count2accepted, " SHOT: ", order2key, ":", key2dict, " EXPECTED SIGNS: (" , sign2x, ",", sign2y, ",", sign2z, ")") 
                            
                        else:
                            count2rejected = count2rejected + 1
                            # print("\n REJECTION: ", count2rejected, " SHOT ", order2key, ":", key2dict, " EXPECTED SIGNS: (" , sign2x, ",", sign2y, ",", sign2z, ")")   
                                                        
                        order2key = order2key +1 

                    count2tried = count2accepted + count2rejected 
                    
                    sum2plus = count2plusx + count2plusy+ count2plusz
                    sum2minus = count2minusx + count2minusy+ count2minusz
                    sum2total = count2plusx + count2minusx # same also with y and z - coordinate exists only once
                            
                    print('=' *80)
                    print("\n (STEP 20Y15/33) OF TEST_BALL4XI - STATISTICS FOR REQUIRED: ", max2count, " SHOTS")
                    print("\n START TIME: ", time2start)
                    print("\n ACCEPTED: ", count2accepted, " = ", int(100*count2accepted/order2key), " %")
                    print("\n REJECTED: ", count2rejected, " = ", int(100*count2rejected/order2key), " %")
                   
                    print("\n DISTIBUTION OF X, Y AND Z: ") 
                    print("\n +X: ", count2plusx, " = ", int(100*count2plusx/sum2total), " %")
                    print("\n -X: ", count2minusx, " = ", int(100*count2minusx/sum2total), " %") 
                   
                    print("\n +Y: ", count2plusy, " = ", int(100*count2plusy/sum2total), " %")
                    print("\n -Y: ", count2minusy, " = ", int(100*count2minusy/sum2total), " %") 
                   
                    print("\n +Z: ", count2plusz, " = ", int(100*count2plusz/sum2total), " %")
                    print("\n -Z: ", count2minusz, " = ", int(100*count2minusz/sum2total), " %") 
                              
                    count2layer = count2layer + 1 
                    print("\n SUM2TOTAL: ", sum2total, "SUCCESS-RATIO: ", int(100*count2accepted/max2count), " %", " COUNT2LAYER: ", count2layer)
                    print("\n START2DISTANCE: ", start2distance, " INTERVAL2DISTANCE: ", interval2distance, " MAX2LAYER: ", max2layer, " MAX2COUNT : ", max2count)
                    print("\n EXPECTED COORDINATE SIGNS: (X: "  , sign2x, ",Y", sign2y, ",Z", sign2z, ")") 
                    
                    print("\n REASONING: ")
                    if count2accepted >= omax2count:
                        print("\n OK SHOOTING: ACCEPTED SHOTS ", count2accepted, " >= ", omax2count, " ORIGINALLY REQUIRED, MARIGINAL: ", marginal2count)
                    else:
                        print("\n *** FAILED SHOOTING: ACCEPTED SHOT ONLY: ", count2accepted, " < ", omax2count, " REQUIRED !")                                    
                    
                    print("\n END TIME: ", time2end)
                    print('=' *80)

                    # ================================================================================
                    # (STEP 20Y15/33) OF TEST_BALL4XI - STATISTICS FOR REQUIRED:  120  SHOTS
                    #  START TIME:  04:33:19 06/04/10 Pacific Daylight Time
                    #  ACCEPTED:  115  =  11  %
                    #  REJECTED:  879  =  88  %
                    #  DISTIBUTION OF X, Y AND Z: 
                    #  +X:  469  =  47  %
                    #  -X:  525  =  52  %
                    #  +Y:  463  =  46  %
                    #  -Y:  531  =  53  %
                    #  +Z:  531  =  53  %
                    #  -Z:  463  =  46  %
                    #  SUM2TOTAL:  994 SUCCESS-RATIO:  95  %  COUNT2LAYER:  2
                    #  START2DISTANCE:  100  INTERVAL2DISTANCE:  100  MAX2LAYER:  120  MAX2COUNT :  120
                    #  EXPECTED COORDINATE SIGNS: (X:  + ,Y + ,Z - )
                    #  REASONING: 
                    #  OK SHOOTING: ACCEPTED SHOTS  115  >=  100  ORIGINALLY REQUIRED, MARIGINAL:  1.2
                    #  END TIME:  04:33:36 06/04/10 Pacific Daylight Time
                    # ================================================================================                    
                except:
                    # -------------------------------------------------------------------------------------    
                    #
                    # -------------------------------------------------------------------------------------     
                    print("\n (STEP 20Z/33) OF TEST_BALL4XI *** FAILED TO SHOOT (X,Y,Z) - EAST/WEST?, NORT/SOUTH?, FORWARDS/BACKWARDS? *** ") 
                    
                                                     
                # ---------------------------------------------------------------------------------------------
                # SMART SHOOTING (+X,-Y,+Z) - EAST, NORTH, TOWARDS                   
                # ---------------------------------------------------------------------------------------------  
                print("\n (STEP 21A/33) OF TEST_BALL4XI - TRYING SMART SHOOTING (+X,-Y,+Z) - EAST, NORTH, TOWARDS")   
                
                try:        

                    # =============================================================================================                   
                    # INITIALIZATIONS
                    # =============================================================================================                
      
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    ball2xi = Ball4Xi(message2ball = name2xi)

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                        
                    start2distance = 100
                    print("\n (STEP 21B1/33) OF TEST_BALL4XI - DISTANCE: ", d2shot)   

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                     
                    interval2distance = 100  
                    print("\n (STEP 21B2/33) OF TEST_BALL4XI - INTERVAL TO DISTANCE: ", interval2distance)   
                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    max2layer = 100                          
                    marginal2layer = 1.2
                    omax2layer = max2layer
                    max2layer = int(marginal2layer * max2layer)
                    print("\n (STEP 21B3/33) OF TEST_BALL4XI - MAXIMUM SHOTS PER LAYER: ", max2layer, " MARGINAL TO LAYER: ", marginal2layer) 
                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    max2count = 100
                    marginal2count = 1.2
                    omax2count = max2count
                    max2count = int(marginal2count * max2count)
                            
                    print("\n (STEP 21B4/33) OF TEST_BALL4XI - MAXIMUM SHOTS: ", max2count, " MARGINAL TO COUNT: ", marginal2count) 
                    if max2count > 1000:
                        trace2set = False # <-- turn trace off with a large max !

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                    
                    time2start = time4xi()                        
                    print("\n (STEP 21B5/33) OF TEST_BALL4XI - START TIME: ", time2start) 
                                                                                            
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # required signs for (x,y,z)
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    
                    # (+X,-Y,+Z) - EAST, NORTH, TOWARDS
                    sign2x = '+'    
                    sign2y = '-'
                    sign2z = '+'
                    print("\n (STEP 21B6/33) OF TEST_BALL4XI - X-SIGN: ", sign2x, 'Y-SIGN: ', sign2y, 'Z-SIGN: ', sign2z) 
                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                    
                    max2iterate = 1000
                    print("\n (STEP 21B7/33) OF TEST_BALL4XI - MAXIMUM TO ITERATIONS: ", max2iterate) 
                    if max2iterate > 1000:
                        trace2set = False # <-- turn trace off with a large max !  
                                          
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # azimuth and elevation angle initialized
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # ref: http://en.wikipedia.org/wiki/Radian#Conversion_between_radians_and_degrees
                    # one radian is equal to 180/p degrees <=> 1 deg = rad * 180 / pi                             
                    # pi/6 = 30, pi/4 = 45, pi/3 = 60, pi/2 = 90, 2/3*pi = 120, 3/4pi=135, 5/6*pi = 150, pi = 180
                    # 7/6*pi = 210, 5/4*pi = 225...3*pi/2 = 270, 5*pi/3 = 300 ... 2*pi = 0 or 360 degrees
                    # I   = 0...90    (0...pi/2) :     sin+, cos+
                    # II  = 90...180  (pi/2...pi):     sin+, cos- 
                    # III = 180...270 (pi...3*pi/2):   sin-, cos-
                    # IV  = 270...360 (3*pi/2...2*pi): sin-, cos+
                    # ref: http://en.wikipedia.org/wiki/Azimuth

                    # =============================================================================================                   
                    # AZIMUTH
                    # =============================================================================================                
                                                                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                    start2plusa = pi/6                          # start plus azimuth 30 degrees - iterates smaller                                                           
                    print("\n (STEP 21B8/33) OF TEST_BALL4XI - START2PLUSA: ", start2plusa) 
                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
                    max2plusa = 2*pi                            # extreme plus azimuth 360 degrees around sideways
                    print("\n (STEP 21B8/33) OF TEST_BALL4XI - MAX2PLUSA: ", max2plusa) 

                                                                        
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
                    min2plusa = pi/240                          # minum positive azimuth 0.75 degrees sideways 
                    print("\n (STEP 21B8/33) OF TEST_BALL4XI - MIN2PLUSA: ", min2plusa) 
                                                          
                                              
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                    start2minusa = -pi/6                        # start minus azimuth -30 degrees sideways                                                           
                    print("\n (STEP 21B8/33) OF TEST_BALL4XI - START2MINUSA: ", start2minusa) 
                                  
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
                    max2minusa = -0.98*2*pi                     # extreme minus azimuth almost -360 degrees 
                    print("\n (STEP 21B8/33) OF TEST_BALL4XI - MAX2MINUSA: ", max2minusa) 
                                                                            
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
                    min2minusa = -pi/240                        # nearest to zero minus to azimuth
                    print("\n (STEP 21B8/33) min2minusa: ", min2minusa) 
                                                                    
                    # =============================================================================================                   
                    # ELEVATION
                    # =============================================================================================                
                                                      
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                    start2pluse = pi/6                          # start plus elevation 30 degrees up 
                    print("\n (STEP 21B8/33) OF TEST_BALL4XI - START2PLUSE: ", start2pluse) 
                                                          
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
                    max2pluse = pi                              # most flexible elevation 180 degrees 
                    print("\n (STEP 21B8/33) OF TEST_BALL4XI - MAX2PLUSE: ", max2pluse) 
                                      
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
                    min2pluse = pi/240                          # lowest plus to elevation 0.75 degrees                          
                    print("\n (STEP 21B8/33) OF TEST_BALL4XI - MIN2PLUSE: ", min2pluse) 
                                                   
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                    start2minuse = -pi/6                        # start minus elevation -30 degrees down                                                
                    print("\n (STEP 21B8/33) OF TEST_BALL4XI - START2MINUSE: ", start2minuse) 
                  
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
                    max2minuse = -0.98*pi                       # most painful minus elevation almost -180 degrees
                    print("\n (STEP 21B8/33) OF TEST_BALL4XI - MAX2MINUSE: ", max2minuse) 
                                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
                    min2minuse = -pi/240                        # least painful minus elevation -0.75 degrees                              
                    print("\n (STEP 21B8/33) OF TEST_BALL4XI - MIN2MINUSE: ", min2minuse) 
                                                         
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # increments for algorithm 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    increase2distance = 0                       # zero with laeyrs, only new layer increases
                    print("\n (STEP 21B8/33) OF TEST_BALL4XI - INCREASE2DISTANCE: ", increase2distance) 
                                                         
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # increments for algorithm 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    change2a = pi / 60                          # 3 degrees change to azimuth
                    print("\n (STEP 21B8/33) OF TEST_BALL4XI -CHANGE2A: ", change2a) 
                                                         
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # increments for algorithm 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    change2e = pi / 60                          # 3 degrees change to elevation
                    print("\n (STEP 21B8/33) OF TEST_BALL4XI - CHANGE2E: ", change2e) 
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # azimuth settings based on sign, which might get tuned to opposite sign later on
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    sign2a = '+'

                    if sign2a == '+':
                        start2a = start2plusa
                        min2a = min2plusa
                        max2a = max2plusa
                    else:
                        start2a = start2minusa
                        min2a = min2minusa
                        max2a = max2minusa
                        
                    print("\n (STEP 21B9/33) OF TEST_BALL4XI - START AZIMUTH: ", start2a, 'MIN AZIMUTH: ', min2a, 'MAX AZIMUTH: ', max2a) 
                    
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # elevation values used based on sign
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    sign2e = '+'

                    if sign2e == '+':
                        start2e = start2pluse
                        min2e = min2pluse
                        max2e = max2pluse
                    else:
                        start2e = start2minuse
                        min2e = min2minuse
                        max2e = max2minuse
                        
                    print("\n (STEP 21B10/33) OF TEST_BALL4XI - START ELEVATION: ", start2e, 'MIN ELEVATION: ', min2e, 'MAX ELEVATION: ', max2e) 
                    
                  
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # azimuth start setting
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                              
                    a2shot = start2a 
                    
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # elevation start setting
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                              
                    e2shot = start2e                            
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # distance start setting
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                          
                    d2shot = start2distance
            
                                  
                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # initializations for while loop 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    count2layer = 1                                  # layers                                                           
                    
                    count2ok = 0                                     # ok shots with all of (x,y,z) ok 
                    
                    count2distance = 0                               # for none layers when distance increased                        
                    
                    count2iterate = 0                                # hunt for right (x,y,z) combination
                    
                    count2rejected = 0                               # rejected
                  
                    ack2x = False                                    # validation for x-coordinate
                    nack2x = True
                    
                    ack2y = False                                    # validation for y-coordinate
                    nack2y = True                    
                    
                    ack2z = False                                    # validation for z-coordinate
                    nack2z = True
                    
                    ack2layer = False                                # validation for layer
                    nack2layer = True                    
                    
                    print("\n (STEP 21F/33) OF TEST_BALL4XI - START TIME OF SHOOTING: ", time4xi(), " FOR ", max2count, " SHOTS") 
                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                                             
                    while ((count2ok <= max2count) and (count2iterate < max2iterate)   
                           and (ack2layer is False)): 
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # 
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        count2iterate = count2iterate + 1    
                        
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # distance
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        d2shot = d2shot + increase2distance                          # remains the same for a laeyr
                        
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # azimuth changes
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        if a2shot >= 0:        
                            a2shot = a2shot + change2a
                            if a2shot >= max2a:
                                start2a = start2a * 1.01
                                a2shot = start2a 
                                print("\n (STEP 21G/33) OF TEST_BALL4XI - AZIMUTH BECAME BIGGER THAN MAXIMUM: ", max2a , " NEW AZIMUTH: ", a2shot)    
                        else:
                            a2shot = a2shot - change2a
                            if a2shot <= min2a:
                                start2a = start2a * 1.01
                                a2shot = start2a  
                                print("\n (STEP 21H/33) OF TEST_BALL4XI - AZIMUTH BECAME SMALLER THAN MINIMUM: ", min2a , " NEW AZIMUTH: ", a2shot)  
                                
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # azimuth algoritm checking against maximum allowed - restart with tuning, if necessary
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                        if (a2shot >= 2*pi):
                            sign2a = '-'                                             # switch to negative
                            change2a = 0.98 * change2a                               # change2a always positive
                            start2a = change2a * start2minusa                        # new minus azimuth start
                            a2shot = start2a                                         # new azimuth
                            min2a = min2minusa                                       # new minimum to azimuth
                            max2a = max2minusa                                       # new maximum to azimuth
                            print("\n (STEP 21I/33) OF TEST_BALL4XI - AZIMUTH BECAME BIGGER THAN 2*PI , NEW AZIMUTH: ", a2shot) 

                            
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # azimuth algoritm checking against minimum allowed- restart with tuning, if necessary
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                             
                        if (a2shot <= -2*pi):
                            sign2a = '+'                                             # switch to positive
                            change2a = 0.98 * change2a                               # change2a always positive
                            start2a = change2a * start2plusa                         # new positive azimuth start
                            a2shot = start2a                                         # new azimuth
                            min2a = min2plusa                                        # new minimum to azimuth
                            max2a = max2plusa                                        # new maximum to azimuth
                            print("\n (STEP 21J/33) OF TEST_BALL4XI - AZIMUTH BECAME LESS THAN -2*PI, NEW AZIMUTH: ", a2shot) 

                        
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # elevation changes
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        if e2shot <= 0:
                            e2shot = e2shot - increase2e
                            if e2shot <= min2e:
                                change2e = 1.02 * change2e
                                start2e = change2e * start2e
                                e2shot = start2e
                                print("\n (STEP 21K/33) OF TEST_BALL4XI - ELEVATION BECAME LESS THAN MINIMUM: ", min2e, " NEW ELEVATION: ", e2shot)                                   
                        else:
                            e2shot = e2shot + increase2e
                            if e2shot >= max2e:
                                change2e = 1.08 * change2e
                                start2e = change2e * start2e
                                e2shot = start2e
                                print("\n (STEP 21L/33) OF TEST_BALL4XI - ELEVATION BECAME BIGGER THAN MAXIMUM: ", max2e, " NEW ELEVATION: ", e2shot)  
                                                                      
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # elevation algoritm checking against maximum allowed - restart with tuning, if necessary
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                                                   
                        if (e2shot >= pi):
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # start again with a new elevation and new elevation change
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            sign2e = '-'                                             # switch to negative
                            change2e = 0.98 * change2e                               # change2e always positive
                            start2e = change2e * start2minuse                        # new minus elevation start
                            e2shot = start2e                                         # new azimuth
                            min2e = min2minuse                                       # new minimum to elevation
                            max2e = max2minuse                                       # new maximum to elevation
                            print("\n (STEP 21M/33) OF TEST_BALL4XI - ELEVATION BECAME BIGGER THAN PI, NEW ELEVATION: ", e2shot)
                            

                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # elevation algoritm checking against minimum allowed- restart with tuning, if necessary
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
                        
                        if (e2shot <= -pi):
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # start again with a new elevation and new elevation change
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                            
                            sign2e = '+'                                             # switch to positive
                            change2e = 0.98 * change2e                               # change2e always positive
                            start2e = change2e * start2pluse                         # new positive elevation start
                            e2shot = start2e                                         # new azimuth
                            min2e = min2pluse                                        # new minimum to elevation
                            max2e = max2pluse                                        # new maximum to elevation        
                            print("\n (STEP 21N/33) OF TEST_BALL4XI - ELEVATION BECAME LESS THAN -PI, NEW ELEVATION: ", e2shot)
                            

                            
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # shoot
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                                               
                        ball2xi.set(azimuth2shot = a2shot, elevation2shot = e2shot, distance2shot = d2shot, area2shot = int(4*pi*d2shot**2/interval2distance))
                        
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # check shot 
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        shot2examine = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes', area2shot = 'Yes')
                        print("\n (STEP 21OA/33) OF TEST_BALL4XI - SHOT TO EXAMINE ", count2shot, ": ", shot2examine)  
                        # {'42x27y86z': {'x2shot': 42, 'azimuth2shot': 0.5759586531581287, 'area2shot': 1256, 'id2shot': '42x27y86z', 'distance2shot': 100, 'z2shot': 86, 'elevation2shot': 0.5335987755982988, 'y2shot': 27}}
                         
                        keys2examine = shot2examine.keys()
                        print("\n (STEP 21OB1/33) OF TEST_BALL4XI - KEYS2EXAMINE: ", keys2examine)   
                        # dict_keys(['42x27y86z'])
                        
                        for key2examine in sorted(keys2examine):
                            print("\n (STEP 21OB2/33) OF TEST_BALL4XI - KEY2EXAMINE ", key2examine)  
                            # 42x27y86z
                            
                            ack2x = False 
                            nack2x = True                                  
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # X OK ?
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                            try:
                                index2x=str.find(key2examine,'x')                               
                                x2coordinate = int(key2examine[0:index2x])
                                if x2coordinate >= 0:
                                    if sign2x == '+':
                                        ack2x = True
                                        nack2x = False
                                        print("\n (STEP 21OB3/33/33) OF TEST_BALL4XI - X2COORDINATE ACK: ", ack2x) 
                                else:
                                    if sign2x == '-':
                                        ack2x = True
                                        nack2x = False
                                        print("\n (STEP 21OB4/33/33) OF TEST_BALL4XI - X2COORDINATE ACK: ", ack2x)
                                         
                            except:
                                print("\n (STEP 21B5/33) OF TEST_BALL4XI *** FAILED  WITH KEY2EXAMINE: ", key2examine)
                                print("\n (STEP 21B5/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                                
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # Y OK ?
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
                            ack2y = False 
                            nack2y = True     
                            try:
                                index2y=str.find(key2examine,'y')                               
                                y2coordinate = int(key2examine[index2x+1:index2y])
                                if y2coordinate >= 0:
                                    if sign2y == '+':
                                        ack2y = True
                                        nack2y = False
                                        print("\n (STEP 21OB6/33) OF TEST_BALL4XI - Y2COORDINATE ACK: ", ack2y)                                         
                                else:
                                    if sign2y == '-':
                                        ack2y = True
                                        nack2y = False
                                        print("\n (STEP 21OB7/33) OF TEST_BALL4XI - Y2COORDINATE ACK: ", ack2y)                               
                            except:
                                print("\n (STEP 21OB8/33) OF TEST_BALL4XI *** FAILED  WITH KEY2EXAMINE: ", key2examine)
                                print("\n (STEP 21OB8/33) OF TEST_BALL4XI - INDEX2Y: ", index2y)
                                
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # Z OK ?
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
                            ack2z = False 
                            nack2z = True                                 
                            try:
                                index2z=str.find(key2examine,'z')                               
                                z2coordinate = int(key2examine[index2y+1:index2z])
                                if z2coordinate >= 0:
                                    if sign2z == '+':
                                        ack2z = True
                                        nack2z = False
                                        print("\n (STEP 21OB9/33) OF TEST_BALL4XI - Z2COORDINATE ACK: ", ack2z)                                               
                                else:
                                    if sign2z == '-':
                                        ack2z = True
                                        nack2z = False
                                        print("\n (STEP 21OB10/33) OF TEST_BALL4XI - Z2COORDINATE ACK: ", ack2z)                                  
                            except:
                                print("\n (STEP 21OB11/33) OF TEST_BALL4XI *** FAILED  WITH KEY2EXAMINE: ", key2examine)
                                print("\n (STEP 21OB11/33) OF TEST_BALL4XI - INDEX2Z: ", index2z)
                                
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # (X,Y,Z) OK ?
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
                            try:                                                           
                                if ((ack2x is True) and (ack2y is True) and (ack2z is True)):
                                    print("\n (STEP 21O5A/33) OF TEST_BALL4XI - OK: (" , x2coordinate, ",", y2coordinate, ",", z2coordinate, ")")  
                                    print("\n (STEP 21O5B/33) OF TEST_BALL4XI - EXPECTED: (" , sign2x, ",", sign2y, ",", sign2z, ")") 
                                    count2ok = count2ok + 1 
                                    if count2ok >= max2layer:
                                        ack2layer = True
                                        print("\n (STEP 21O6/33) OF TEST_BALL4XI - ACK2LAYER: " , ack2layer)
                                    else:
                                        ack2layer = False
                                else:
                                    print("\n (STEP 21O8A/33) OF TEST_BALL4XI - REJECTED: (" , x2coordinate, ",", y2coordinate, ",", z2coordinate, ")")
                                    print("\n (STEP 21O8B/33) OF TEST_BALL4XI - EXPECTED: (" , sign2x, ",", sign2y, ",", sign2z, ")")
                                    
                                    count2rejected = count2rejected + 1
                                    ack2layer = False 
                                    # ( 42 , 27 , 86 )
                                    # ( + , + , - )  
                                    
                                    print("\n (STEP 21O8C/33) OF TEST_BALL4XI *** REMEMBER TO DELETE THE SHOT OR LET IT BE AND RETURN ONLY OK SHOTS!!!! *** ")
                                    
                                                        
                            except:
                                print("\n (STEP 21O9/33) OF TEST_BALL4XI *** FAILED  WITH KEY2EXAMINE: ", key2examine)
                                print("\n (STEP 21O9/33) OF TEST_BALL4XI - INDEX2Z: ", index2z)
                        
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # CONTINUE WHILE
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                    

                        print("\n (STEP 21O10/33) OF TEST_BALL4XI - CONTINUING WHILE WITH:")
                        print("\n count2ok:", count2ok)
                        print("\n max2count:", max2count)                        
                        print("\n count2iterate:", count2iterate)
                        print("\n max2iterate:", max2iterate)                        
                        print("\n ack2layer:", ack2layer)                        
                        
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # CONTINUE WHILE
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                    
                                                                                                         
                        count2distance = count2distance + increase2distance  #stays the same when a layer is shot
                        if count2distance > max2layer:
                            d2shot = d2shot + interval2distance
                            count2distance = 0
                            count2layer = count2layer + 1 
                            print("\n (STEP 21O10/33) OF TEST_BALL4XI - NEW LAYER NUMBER: ", count2layer, ' NEW DISTANCE: ', d2shot)
                        else:
                            pass 
                               
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # end of while
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # EXAMINE RESULTS 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    time2end = time4xi()           
                    print("\n (STEP 21P1/33) OF TEST_BALL4XI - STATISTICS FOR SHOOTING, WHICH ENDED: ", time2end)                          
                    print("\n SHOTS OK: ", count2ok, " = ", int(100 * count2ok/max2count), " %")                              
                    print("\n SHOTS ORIGINALLY REQUIRED: ", omax2count)      
                    print("\n ITERATIONS NEEDED: ", count2iterate)                              
                    print("\n ITERATIONS ALLOWED: ", max2iterate) 
                    print("\n REJECTED: ", count2rejected, " = : ", int(100 * count2rejected/count2iterate), " %") 

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                           
                    print("\n (STEP 21Y1/33) OF TEST_BALL4XI - WHOLE BALL AFTER ALL OPERATIONS AND WITH MAX2COUNT: ", max2count, 'TIME PRINTED: ', time4xi())  
                    
                    ball2show = ball2xi.get()
                    dict2keys = ball2show.keys()
                    print("\n (STEP 21Y2/33) OF TEST_BALL4XI - KEYS2BALL: ", dict2keys)
                    # 
                    print("\n (STEP 21Y3/33) OF TEST_BALL4XI - SHOOTING SAMPLE OF : ", max2count, " SHOTS", "NUMBER OF LAYERS: ", count2layer, ' LATEST DISTANCE: ', d2shot, ' INTERVAL2DISTANCE: ', interval2distance)    
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    count2plusx = 0
                    count2plusy = 0
                    count2plusz = 0
                           
                    count2minusx = 0
                    count2minusy = 0
                    count2minusz = 0
                    
                    count2accepted = 0
                    count2rejected = 0
                    
                    order2key = 1
                    for key2dict in sorted(dict2keys):
                        try:
                            index2x=str.find(key2dict,'x')                               
                            x2coordinate = int(key2dict[0:index2x])
                            # print("\n (STEP 15L11/33/33) OF TEST_BALL4XI - X2COORDINATE: ",  x2coordinate)
                            if x2coordinate >= 0:
                                count2plusx = count2plusx + 1
                            else:
                                count2minusx = count2minusx + 1    
                        except:
                            print("\n (STEP 21Y4/33) OF TEST_BALL4XI *** FAILED  WITH KEY2DICT: ", key2dict)
                            print("\n (STEP 21Y5/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            
                            
                        try:                                   
                            index2y=str.find(key2dict,'y')
                            y2coordinate = int(key2dict[index2x+1:index2y])
                            # print("\n (STEP 15L11/33) OF TEST_BALL4XI - Y2COORDINATE: ",  y2coordinate)
                            if y2coordinate >= 0:
                                count2plusy = count2plusy + 1
                            else:
                                count2minusy = count2minusy + 1  
                        except:
                            print("\n (STEP 21Y6/33) OF TEST_BALL4XI *** FAILED  WITH KEY2DICT: ", key2dict) 
                            print("\n (STEP 21Y7/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            print("\n (STEP 21Y8/33) OF TEST_BALL4XI - INDEX2Y: ", index2y)
                        
                        try:                                                                         
                            index2z=str.find(key2dict,'z') 
                            z2coordinate = int(key2dict[index2y+1:index2z])
                            # print("\n (STEP 21V/33) OF TEST_BALL4XI - Z2COORDINATE: ",  z2coordinate)
                            if z2coordinate >= 0:
                                count2plusz = count2plusz + 1
                            else:
                                count2minusz = count2minusz + 1
                        except:
                            print("\n (STEP 21Y9/33) OF TEST_BALL4XI *** FAILED  WITH KEY2DICT: ", key2dict)
                            print("\n (STEP 21Y10/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            print("\n (STEP 21Y11/33) OF TEST_BALL4XI - INDEX2Y: ", index2y)
                            print("\n (STEP 21Y12/33) OF TEST_BALL4XI - INDEX2Z: ", index2z)
                        
                        ack2x = False    
                        if ((x2coordinate >= 0) and (sign2x == '+')):
                            ack2x = True
                        if ((x2coordinate <= 0) and (sign2x == '-')):
                            ack2x = True                        
                        
                        ack2y = False    
                        if ((y2coordinate >= 0) and (sign2y == '+')):
                            ack2y = True
                        if ((y2coordinate <= 0) and (sign2y == '-')):
                            ack2y = True     
                        
                        ack2z = False    
                        if ((z2coordinate >= 0) and (sign2z == '+')):
                            ack2z = True
                        if ((z2coordinate <= 0) and (sign2z == '-')):
                            ack2z = True     
                        
                        if ((ack2x is True) and (ack2y is True) and (ack2z is True)):
                            count2accepted = count2accepted + 1                                                                                                      
                            print("\n ACCEPTANCE: ", count2accepted, " SHOT: ", order2key, ":", key2dict, " EXPECTED SIGNS: (" , sign2x, ",", sign2y, ",", sign2z, ")") 
                            
                        else:
                            count2rejected = count2rejected + 1
                            # print("\n REJECTION: ", count2rejected, " SHOT ", order2key, ":", key2dict, " EXPECTED SIGNS: (" , sign2x, ",", sign2y, ",", sign2z, ")")   
                                                        
                        order2key = order2key +1 

                    count2tried = count2accepted + count2rejected 
                    
                    sum2plus = count2plusx + count2plusy+ count2plusz
                    sum2minus = count2minusx + count2minusy+ count2minusz
                    sum2total = count2plusx + count2minusx # same also with y and z - coordinate exists only once
                            
                    print('=' *80)
                    print("\n (STEP 21Y15/33) OF TEST_BALL4XI - STATISTICS FOR REQUIRED: ", max2count, " SHOTS")
                    print("\n START TIME: ", time2start)
                    print("\n ACCEPTED: ", count2accepted, " = ", int(100*count2accepted/order2key), " %")
                    print("\n REJECTED: ", count2rejected, " = ", int(100*count2rejected/order2key), " %")
                   
                    print("\n DISTIBUTION OF X, Y AND Z: ") 
                    print("\n +X: ", count2plusx, " = ", int(100*count2plusx/sum2total), " %")
                    print("\n -X: ", count2minusx, " = ", int(100*count2minusx/sum2total), " %") 
                   
                    print("\n +Y: ", count2plusy, " = ", int(100*count2plusy/sum2total), " %")
                    print("\n -Y: ", count2minusy, " = ", int(100*count2minusy/sum2total), " %") 
                   
                    print("\n +Z: ", count2plusz, " = ", int(100*count2plusz/sum2total), " %")
                    print("\n -Z: ", count2minusz, " = ", int(100*count2minusz/sum2total), " %") 
                              
                    count2layer = count2layer + 1 
                    print("\n SUM2TOTAL: ", sum2total, "SUCCESS-RATIO: ", int(100*count2accepted/max2count), " %", " COUNT2LAYER: ", count2layer)
                    print("\n START2DISTANCE: ", start2distance, " INTERVAL2DISTANCE: ", interval2distance, " MAX2LAYER: ", max2layer, " MAX2COUNT : ", max2count)
                    print("\n EXPECTED COORDINATE SIGNS: (X: "  , sign2x, ",Y", sign2y, ",Z", sign2z, ")") 
                    
                    print("\n REASONING: ")
                    if count2accepted >= omax2count:
                        print("\n OK SHOOTING: ACCEPTED SHOTS ", count2accepted, " >= ", omax2count, " ORIGINALLY REQUIRED, MARIGINAL: ", marginal2count)
                    else:
                        print("\n *** FAILED SHOOTING: ACCEPTED SHOT ONLY: ", count2accepted, " < ", omax2count, " REQUIRED !")                                    
                    
                    print("\n END TIME: ", time2end)
                    print('=' *80)

                    # ================================================================================
                    #  (STEP 21Y15/33) OF TEST_BALL4XI - STATISTICS FOR REQUIRED:  120  SHOTS
                    #  START TIME:  04:43:29 06/04/10 Pacific Daylight Time
                    #  ACCEPTED:  123  =  12  %
                    #  REJECTED:  855  =  87  %
                    #  DISTIBUTION OF X, Y AND Z: 
                    #  +X:  453  =  46  %
                    #  -X:  525  =  53  %
                    #  +Y:  451  =  46  %
                    #  -Y:  527  =  53  %
                    #  +Z:  515  =  52  %
                    #  -Z:  463  =  47  %
                    #  SUM2TOTAL:  978 SUCCESS-RATIO:  102  %  COUNT2LAYER:  2
                    #  START2DISTANCE:  100  INTERVAL2DISTANCE:  100  MAX2LAYER:  120  MAX2COUNT :  120
                    #  EXPECTED COORDINATE SIGNS: (X:  + ,Y - ,Z + )
                    #  REASONING: 
                    #  OK SHOOTING: ACCEPTED SHOTS  123  >=  100  ORIGINALLY REQUIRED, MARIGINAL:  1.2
                    #  END TIME:  04:43:46 06/04/10 Pacific Daylight Time
                    # ================================================================================                    
                except:
                    # -------------------------------------------------------------------------------------    
                    #
                    # -------------------------------------------------------------------------------------     
                    print("\n (STEP 21Z/33) OF TEST_BALL4XI *** FAILED TO SHOOT (+X,-Y,+Z) - EAST, NORTH, TOWARDS")
                    
                                                                             
                # ---------------------------------------------------------------------------------------------
                # SMART SHOOTING (-X,+Y,-Z) - WEST, SOUTH  BACKWARDS               
                # ---------------------------------------------------------------------------------------------                                                               
                print("\n (STEP 22A/33) OF TEST_BALL4XI - TRYING SMART SHOOTING (-X,+Y,-Z) - WEST, SOUTH  BACKWARDS")   
                
                try:        

                    # =============================================================================================                   
                    # INITIALIZATIONS
                    # =============================================================================================                
      
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    ball2xi = Ball4Xi(message2ball = name2xi)

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                        
                    start2distance = 100
                    print("\n (STEP 22B1/33) OF TEST_BALL4XI - DISTANCE: ", d2shot)   

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                     
                    interval2distance = 100  
                    print("\n (STEP 22B2/33) OF TEST_BALL4XI - INTERVAL TO DISTANCE: ", interval2distance)   
                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    max2layer = 100                          
                    marginal2layer = 1.2
                    omax2layer = max2layer
                    max2layer = int(marginal2layer * max2layer)
                    print("\n (STEP 22B3/33) OF TEST_BALL4XI - MAXIMUM SHOTS PER LAYER: ", max2layer, " MARGINAL TO LAYER: ", marginal2layer) 
                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    max2count = 100
                    marginal2count = 1.2
                    omax2count = max2count
                    max2count = int(marginal2count * max2count)
                            
                    print("\n (STEP 22B4/33) OF TEST_BALL4XI - MAXIMUM SHOTS: ", max2count, " MARGINAL TO COUNT: ", marginal2count) 
                    if max2count > 1000:
                        trace2set = False # <-- turn trace off with a large max !

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                    
                    time2start = time4xi()                        
                    print("\n (STEP 22B5/33) OF TEST_BALL4XI - START TIME: ", time2start) 
                                                                                            
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # required signs for (x,y,z)
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    
                    # (-X,+Y,-Z) - WEST, SOUTH  BACKWARDS
                    sign2x = '-'    
                    sign2y = '+'
                    sign2z = '-'
                    print("\n (STEP 22B6/33) OF TEST_BALL4XI - X-SIGN: ", sign2x, 'Y-SIGN: ', sign2y, 'Z-SIGN: ', sign2z) 
                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                    
                    max2iterate = 1000
                    print("\n (STEP 22B7/33) OF TEST_BALL4XI - MAXIMUM TO ITERATIONS: ", max2iterate) 
                    if max2iterate > 1000:
                        trace2set = False # <-- turn trace off with a large max !  
                                          
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # azimuth and elevation angle initialized
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # ref: http://en.wikipedia.org/wiki/Radian#Conversion_between_radians_and_degrees
                    # one radian is equal to 180/p degrees <=> 1 deg = rad * 180 / pi                             
                    # pi/6 = 30, pi/4 = 45, pi/3 = 60, pi/2 = 90, 2/3*pi = 120, 3/4pi=135, 5/6*pi = 150, pi = 180
                    # 7/6*pi = 210, 5/4*pi = 225...3*pi/2 = 270, 5*pi/3 = 300 ... 2*pi = 0 or 360 degrees
                    # I   = 0...90    (0...pi/2) :     sin+, cos+
                    # II  = 90...180  (pi/2...pi):     sin+, cos- 
                    # III = 180...270 (pi...3*pi/2):   sin-, cos-
                    # IV  = 270...360 (3*pi/2...2*pi): sin-, cos+
                    # ref: http://en.wikipedia.org/wiki/Azimuth

                    # =============================================================================================                   
                    # AZIMUTH
                    # =============================================================================================                
                                                                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                    start2plusa = pi/6                          # start plus azimuth 30 degrees - iterates smaller                                                           
                    print("\n (STEP 22B8/33) OF TEST_BALL4XI - START2PLUSA: ", start2plusa) 
                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
                    max2plusa = 2*pi                            # extreme plus azimuth 360 degrees around sideways
                    print("\n (STEP 22B8/33) OF TEST_BALL4XI - MAX2PLUSA: ", max2plusa) 

                                                                        
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
                    min2plusa = pi/240                          # minum positive azimuth 0.75 degrees sideways 
                    print("\n (STEP 22B8/33) OF TEST_BALL4XI - MIN2PLUSA: ", min2plusa) 
                                                          
                                              
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                    start2minusa = -pi/6                        # start minus azimuth -30 degrees sideways                                                           
                    print("\n (STEP 22B8/33) OF TEST_BALL4XI - START2MINUSA: ", start2minusa) 
                                  
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
                    max2minusa = -0.98*2*pi                     # extreme minus azimuth almost -360 degrees 
                    print("\n (STEP 22B8/33) OF TEST_BALL4XI - MAX2MINUSA: ", max2minusa) 
                                                                            
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
                    min2minusa = -pi/240                        # nearest to zero minus to azimuth
                    print("\n (STEP 22B8/33) min2minusa: ", min2minusa) 
                                                                    
                    # =============================================================================================                   
                    # ELEVATION
                    # =============================================================================================                
                                                      
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                    start2pluse = pi/6                          # start plus elevation 30 degrees up 
                    print("\n (STEP 22B8/33) OF TEST_BALL4XI - START2PLUSE: ", start2pluse) 
                                                          
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
                    max2pluse = pi                              # most flexible elevation 180 degrees 
                    print("\n (STEP 22B8/33) OF TEST_BALL4XI - MAX2PLUSE: ", max2pluse) 
                                      
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
                    min2pluse = pi/240                          # lowest plus to elevation 0.75 degrees                          
                    print("\n (STEP 22B8/33) OF TEST_BALL4XI - MIN2PLUSE: ", min2pluse) 
                                                   
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                    start2minuse = -pi/6                        # start minus elevation -30 degrees down                                                
                    print("\n (STEP 22B8/33) OF TEST_BALL4XI - START2MINUSE: ", start2minuse) 
                  
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
                    max2minuse = -0.98*pi                       # most painful minus elevation almost -180 degrees
                    print("\n (STEP 22B8/33) OF TEST_BALL4XI - MAX2MINUSE: ", max2minuse) 
                                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
                    min2minuse = -pi/240                        # least painful minus elevation -0.75 degrees                              
                    print("\n (STEP 22B8/33) OF TEST_BALL4XI - MIN2MINUSE: ", min2minuse) 
                                                         
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # increments for algorithm 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    increase2distance = 0                       # zero with laeyrs, only new layer increases
                    print("\n (STEP 22B8/33) OF TEST_BALL4XI - INCREASE2DISTANCE: ", increase2distance) 
                                                         
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # increments for algorithm 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    change2a = pi / 60                          # 3 degrees change to azimuth
                    print("\n (STEP 22B8/33) OF TEST_BALL4XI -CHANGE2A: ", change2a) 
                                                         
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # increments for algorithm 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    change2e = pi / 60                          # 3 degrees change to elevation
                    print("\n (STEP 22B8/33) OF TEST_BALL4XI - CHANGE2E: ", change2e) 
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # azimuth settings based on sign, which might get tuned to opposite sign later on
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    sign2a = '+'

                    if sign2a == '+':
                        start2a = start2plusa
                        min2a = min2plusa
                        max2a = max2plusa
                    else:
                        start2a = start2minusa
                        min2a = min2minusa
                        max2a = max2minusa
                        
                    print("\n (STEP 22B9/33) OF TEST_BALL4XI - START AZIMUTH: ", start2a, 'MIN AZIMUTH: ', min2a, 'MAX AZIMUTH: ', max2a) 
                    
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # elevation values used based on sign
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    sign2e = '+'

                    if sign2e == '+':
                        start2e = start2pluse
                        min2e = min2pluse
                        max2e = max2pluse
                    else:
                        start2e = start2minuse
                        min2e = min2minuse
                        max2e = max2minuse
                        
                    print("\n (STEP 22B10/33) OF TEST_BALL4XI - START ELEVATION: ", start2e, 'MIN ELEVATION: ', min2e, 'MAX ELEVATION: ', max2e) 
                    
                  
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # azimuth start setting
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                              
                    a2shot = start2a 
                    
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # elevation start setting
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                              
                    e2shot = start2e                            
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # distance start setting
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                          
                    d2shot = start2distance
            
                                  
                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # initializations for while loop 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    count2layer = 1                                  # layers                                                           
                    
                    count2ok = 0                                     # ok shots with all of (x,y,z) ok 
                    
                    count2distance = 0                               # for none layers when distance increased                        
                    
                    count2iterate = 0                                # hunt for right (x,y,z) combination
                    
                    count2rejected = 0                               # rejected
                  
                    ack2x = False                                    # validation for x-coordinate
                    nack2x = True
                    
                    ack2y = False                                    # validation for y-coordinate
                    nack2y = True                    
                    
                    ack2z = False                                    # validation for z-coordinate
                    nack2z = True
                    
                    ack2layer = False                                # validation for layer
                    nack2layer = True                    
                    
                    print("\n (STEP 22F/33) OF TEST_BALL4XI - START TIME OF SHOOTING: ", time4xi(), " FOR ", max2count, " SHOTS") 
                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                                             
                    while ((count2ok <= max2count) and (count2iterate < max2iterate)   
                           and (ack2layer is False)): 
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # 
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        count2iterate = count2iterate + 1    
                        
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # distance
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        d2shot = d2shot + increase2distance                          # remains the same for a laeyr
                        
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # azimuth changes
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        if a2shot >= 0:        
                            a2shot = a2shot + change2a
                            if a2shot >= max2a:
                                start2a = start2a * 1.01
                                a2shot = start2a 
                                print("\n (STEP 22G/33) OF TEST_BALL4XI - AZIMUTH BECAME BIGGER THAN MAXIMUM: ", max2a , " NEW AZIMUTH: ", a2shot)    
                        else:
                            a2shot = a2shot - change2a
                            if a2shot <= min2a:
                                start2a = start2a * 1.01
                                a2shot = start2a  
                                print("\n (STEP 22H/33) OF TEST_BALL4XI - AZIMUTH BECAME SMALLER THAN MINIMUM: ", min2a , " NEW AZIMUTH: ", a2shot)  
                                
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # azimuth algoritm checking against maximum allowed - restart with tuning, if necessary
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                        if (a2shot >= 2*pi):
                            sign2a = '-'                                             # switch to negative
                            change2a = 0.98 * change2a                               # change2a always positive
                            start2a = change2a * start2minusa                        # new minus azimuth start
                            a2shot = start2a                                         # new azimuth
                            min2a = min2minusa                                       # new minimum to azimuth
                            max2a = max2minusa                                       # new maximum to azimuth
                            print("\n (STEP 22I/33) OF TEST_BALL4XI - AZIMUTH BECAME BIGGER THAN 2*PI , NEW AZIMUTH: ", a2shot) 

                            
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # azimuth algoritm checking against minimum allowed- restart with tuning, if necessary
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                             
                        if (a2shot <= -2*pi):
                            sign2a = '+'                                             # switch to positive
                            change2a = 0.98 * change2a                               # change2a always positive
                            start2a = change2a * start2plusa                         # new positive azimuth start
                            a2shot = start2a                                         # new azimuth
                            min2a = min2plusa                                        # new minimum to azimuth
                            max2a = max2plusa                                        # new maximum to azimuth
                            print("\n (STEP 22J/33) OF TEST_BALL4XI - AZIMUTH BECAME LESS THAN -2*PI, NEW AZIMUTH: ", a2shot) 

                        
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # elevation changes
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        if e2shot <= 0:
                            e2shot = e2shot - increase2e
                            if e2shot <= min2e:
                                change2e = 1.02 * change2e
                                start2e = change2e * start2e
                                e2shot = start2e
                                print("\n (STEP 22K/33) OF TEST_BALL4XI - ELEVATION BECAME LESS THAN MINIMUM: ", min2e, " NEW ELEVATION: ", e2shot)                                   
                        else:
                            e2shot = e2shot + increase2e
                            if e2shot >= max2e:
                                change2e = 1.08 * change2e
                                start2e = change2e * start2e
                                e2shot = start2e
                                print("\n (STEP 22L/33) OF TEST_BALL4XI - ELEVATION BECAME BIGGER THAN MAXIMUM: ", max2e, " NEW ELEVATION: ", e2shot)  
                                                                      
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # elevation algoritm checking against maximum allowed - restart with tuning, if necessary
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                                                   
                        if (e2shot >= pi):
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # start again with a new elevation and new elevation change
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            sign2e = '-'                                             # switch to negative
                            change2e = 0.98 * change2e                               # change2e always positive
                            start2e = change2e * start2minuse                        # new minus elevation start
                            e2shot = start2e                                         # new azimuth
                            min2e = min2minuse                                       # new minimum to elevation
                            max2e = max2minuse                                       # new maximum to elevation
                            print("\n (STEP 22M/33) OF TEST_BALL4XI - ELEVATION BECAME BIGGER THAN PI, NEW ELEVATION: ", e2shot)
                            

                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # elevation algoritm checking against minimum allowed- restart with tuning, if necessary
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
                        
                        if (e2shot <= -pi):
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # start again with a new elevation and new elevation change
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                            
                            sign2e = '+'                                             # switch to positive
                            change2e = 0.98 * change2e                               # change2e always positive
                            start2e = change2e * start2pluse                         # new positive elevation start
                            e2shot = start2e                                         # new azimuth
                            min2e = min2pluse                                        # new minimum to elevation
                            max2e = max2pluse                                        # new maximum to elevation        
                            print("\n (STEP 22N/33) OF TEST_BALL4XI - ELEVATION BECAME LESS THAN -PI, NEW ELEVATION: ", e2shot)
                            

                            
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # shoot
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                                               
                        ball2xi.set(azimuth2shot = a2shot, elevation2shot = e2shot, distance2shot = d2shot, area2shot = int(4*pi*d2shot**2/interval2distance))
                        
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # check shot 
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        shot2examine = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes', area2shot = 'Yes')
                        print("\n (STEP 22OA/33) OF TEST_BALL4XI - SHOT TO EXAMINE ", count2shot, ": ", shot2examine)  
                        # {'42x27y86z': {'x2shot': 42, 'azimuth2shot': 0.5759586531581287, 'area2shot': 1256, 'id2shot': '42x27y86z', 'distance2shot': 100, 'z2shot': 86, 'elevation2shot': 0.5335987755982988, 'y2shot': 27}}
                         
                        keys2examine = shot2examine.keys()
                        print("\n (STEP 22OB1/33) OF TEST_BALL4XI - KEYS2EXAMINE: ", keys2examine)   
                        # dict_keys(['42x27y86z'])
                        
                        for key2examine in sorted(keys2examine):
                            print("\n (STEP 22OB2/33) OF TEST_BALL4XI - KEY2EXAMINE ", key2examine)  
                            # 42x27y86z
                            
                            ack2x = False 
                            nack2x = True                                  
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # X OK ?
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                            try:
                                index2x=str.find(key2examine,'x')                               
                                x2coordinate = int(key2examine[0:index2x])
                                if x2coordinate >= 0:
                                    if sign2x == '+':
                                        ack2x = True
                                        nack2x = False
                                        print("\n (STEP 22OB3/33/33) OF TEST_BALL4XI - X2COORDINATE ACK: ", ack2x) 
                                else:
                                    if sign2x == '-':
                                        ack2x = True
                                        nack2x = False
                                        print("\n (STEP 22OB4/33/33) OF TEST_BALL4XI - X2COORDINATE ACK: ", ack2x)
                                         
                            except:
                                print("\n (STEP 22B5/33) OF TEST_BALL4XI *** FAILED  WITH KEY2EXAMINE: ", key2examine)
                                print("\n (STEP 22B5/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                                
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # Y OK ?
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
                            ack2y = False 
                            nack2y = True     
                            try:
                                index2y=str.find(key2examine,'y')                               
                                y2coordinate = int(key2examine[index2x+1:index2y])
                                if y2coordinate >= 0:
                                    if sign2y == '+':
                                        ack2y = True
                                        nack2y = False
                                        print("\n (STEP 22OB6/33) OF TEST_BALL4XI - Y2COORDINATE ACK: ", ack2y)                                         
                                else:
                                    if sign2y == '-':
                                        ack2y = True
                                        nack2y = False
                                        print("\n (STEP 22OB7/33) OF TEST_BALL4XI - Y2COORDINATE ACK: ", ack2y)                               
                            except:
                                print("\n (STEP 22OB8/33) OF TEST_BALL4XI *** FAILED  WITH KEY2EXAMINE: ", key2examine)
                                print("\n (STEP 22OB8/33) OF TEST_BALL4XI - INDEX2Y: ", index2y)
                                
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # Z OK ?
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
                            ack2z = False 
                            nack2z = True                                 
                            try:
                                index2z=str.find(key2examine,'z')                               
                                z2coordinate = int(key2examine[index2y+1:index2z])
                                if z2coordinate >= 0:
                                    if sign2z == '+':
                                        ack2z = True
                                        nack2z = False
                                        print("\n (STEP 22OB9/33) OF TEST_BALL4XI - Z2COORDINATE ACK: ", ack2z)                                               
                                else:
                                    if sign2z == '-':
                                        ack2z = True
                                        nack2z = False
                                        print("\n (STEP 22OB10/33) OF TEST_BALL4XI - Z2COORDINATE ACK: ", ack2z)                                  
                            except:
                                print("\n (STEP 22OB11/33) OF TEST_BALL4XI *** FAILED  WITH KEY2EXAMINE: ", key2examine)
                                print("\n (STEP 22OB11/33) OF TEST_BALL4XI - INDEX2Z: ", index2z)
                                
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # (X,Y,Z) OK ?
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
                            try:                                                           
                                if ((ack2x is True) and (ack2y is True) and (ack2z is True)):
                                    print("\n (STEP 22O5A/33) OF TEST_BALL4XI - OK: (" , x2coordinate, ",", y2coordinate, ",", z2coordinate, ")") 
                                    print("\n (STEP 22O5B/33) OF TEST_BALL4XI - EXPECTED: (" , sign2x, ",", sign2y, ",", sign2z, ")") 
                                    count2ok = count2ok + 1 
                                    if count2ok >= max2layer:
                                        ack2layer = True
                                        print("\n (STEP 22O6/33) OF TEST_BALL4XI - ACK2LAYER: " , ack2layer)
                                    else:
                                        ack2layer = False
                                else:
                                    print("\n (STEP 22O8A/33) OF TEST_BALL4XI - REJECTED: (" , x2coordinate, ",", y2coordinate, ",", z2coordinate, ")")
                                    print("\n (STEP 22O8B/33) OF TEST_BALL4XI - EXPECTED: (" , sign2x, ",", sign2y, ",", sign2z, ")")
                                    
                                    count2rejected = count2rejected + 1
                                    ack2layer = False 
                                    # ( 42 , 27 , 86 )
                                    # ( + , + , - )  
                                    
                                    print("\n (STEP 22O8C/33) OF TEST_BALL4XI *** REMEMBER TO DELETE THE SHOT OR LET IT BE AND RETURN ONLY OK SHOTS!!!! *** ")
                                    
                                                        
                            except:
                                print("\n (STEP 22O9/33) OF TEST_BALL4XI *** FAILED  WITH KEY2EXAMINE: ", key2examine)
                                print("\n (STEP 22O9/33) OF TEST_BALL4XI - INDEX2Z: ", index2z)
                        
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # CONTINUE WHILE
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                    

                        print("\n (STEP 22O10/33) OF TEST_BALL4XI - CONTINUING WHILE WITH:")
                        print("\n count2ok:", count2ok)
                        print("\n max2count:", max2count)                        
                        print("\n count2iterate:", count2iterate)
                        print("\n max2iterate:", max2iterate)                        
                        print("\n ack2layer:", ack2layer)                        
                        
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # CONTINUE WHILE
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                    
                                                                                                         
                        count2distance = count2distance + increase2distance  #stays the same when a layer is shot
                        if count2distance > max2layer:
                            d2shot = d2shot + interval2distance
                            count2distance = 0
                            count2layer = count2layer + 1 
                            print("\n (STEP 22O10/33) OF TEST_BALL4XI - NEW LAYER NUMBER: ", count2layer, ' NEW DISTANCE: ', d2shot)
                        else:
                            pass 
                               
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # end of while
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # EXAMINE RESULTS 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    time2end = time4xi()           
                    print("\n (STEP 22P1/33) OF TEST_BALL4XI - STATISTICS FOR SHOOTING, WHICH ENDED: ", time2end)                          
                    print("\n SHOTS OK: ", count2ok, " = ", int(100 * count2ok/max2count), " %")                              
                    print("\n SHOTS ORIGINALLY REQUIRED: ", omax2count)      
                    print("\n ITERATIONS NEEDED: ", count2iterate)                              
                    print("\n ITERATIONS ALLOWED: ", max2iterate) 
                    print("\n REJECTED: ", count2rejected, " = : ", int(100 * count2rejected/count2iterate), " %") 

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                           
                    print("\n (STEP 22Y1/33) OF TEST_BALL4XI - WHOLE BALL AFTER ALL OPERATIONS AND WITH MAX2COUNT: ", max2count, 'TIME PRINTED: ', time4xi())  
                    
                    ball2show = ball2xi.get()
                    dict2keys = ball2show.keys()
                    print("\n (STEP 22Y2/33) OF TEST_BALL4XI - KEYS2BALL: ", dict2keys)
                    # 
                    print("\n (STEP 22Y3/33) OF TEST_BALL4XI - SHOOTING SAMPLE OF : ", max2count, " SHOTS", "NUMBER OF LAYERS: ", count2layer, ' LATEST DISTANCE: ', d2shot, ' INTERVAL2DISTANCE: ', interval2distance)    
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    count2plusx = 0
                    count2plusy = 0
                    count2plusz = 0
                           
                    count2minusx = 0
                    count2minusy = 0
                    count2minusz = 0
                    
                    count2accepted = 0
                    count2rejected = 0
                    
                    order2key = 1
                    for key2dict in sorted(dict2keys):
                        try:
                            index2x=str.find(key2dict,'x')                               
                            x2coordinate = int(key2dict[0:index2x])
                            # print("\n (STEP 15L11/33/33) OF TEST_BALL4XI - X2COORDINATE: ",  x2coordinate)
                            if x2coordinate >= 0:
                                count2plusx = count2plusx + 1
                            else:
                                count2minusx = count2minusx + 1    
                        except:
                            print("\n (STEP 22Y4/33) OF TEST_BALL4XI *** FAILED  WITH KEY2DICT: ", key2dict)
                            print("\n (STEP 22Y5/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            
                            
                        try:                                   
                            index2y=str.find(key2dict,'y')
                            y2coordinate = int(key2dict[index2x+1:index2y])
                            # print("\n (STEP 15L11/33) OF TEST_BALL4XI - Y2COORDINATE: ",  y2coordinate)
                            if y2coordinate >= 0:
                                count2plusy = count2plusy + 1
                            else:
                                count2minusy = count2minusy + 1  
                        except:
                            print("\n (STEP 22Y6/33) OF TEST_BALL4XI *** FAILED  WITH KEY2DICT: ", key2dict) 
                            print("\n (STEP 22Y7/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            print("\n (STEP 22Y8/33) OF TEST_BALL4XI - INDEX2Y: ", index2y)
                        
                        try:                                                                         
                            index2z=str.find(key2dict,'z') 
                            z2coordinate = int(key2dict[index2y+1:index2z])
                            # print("\n (STEP 22V/33) OF TEST_BALL4XI - Z2COORDINATE: ",  z2coordinate)
                            if z2coordinate >= 0:
                                count2plusz = count2plusz + 1
                            else:
                                count2minusz = count2minusz + 1
                        except:
                            print("\n (STEP 22Y9/33) OF TEST_BALL4XI *** FAILED  WITH KEY2DICT: ", key2dict)
                            print("\n (STEP 22Y10/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            print("\n (STEP 22Y11/33) OF TEST_BALL4XI - INDEX2Y: ", index2y)
                            print("\n (STEP 22Y12/33) OF TEST_BALL4XI - INDEX2Z: ", index2z)
                        
                        ack2x = False    
                        if ((x2coordinate >= 0) and (sign2x == '+')):
                            ack2x = True
                        if ((x2coordinate <= 0) and (sign2x == '-')):
                            ack2x = True                        
                        
                        ack2y = False    
                        if ((y2coordinate >= 0) and (sign2y == '+')):
                            ack2y = True
                        if ((y2coordinate <= 0) and (sign2y == '-')):
                            ack2y = True     
                        
                        ack2z = False    
                        if ((z2coordinate >= 0) and (sign2z == '+')):
                            ack2z = True
                        if ((z2coordinate <= 0) and (sign2z == '-')):
                            ack2z = True     
                        
                        if ((ack2x is True) and (ack2y is True) and (ack2z is True)):
                            count2accepted = count2accepted + 1                                                                                                      
                            print("\n ACCEPTANCE: ", count2accepted, " SHOT: ", order2key, ":", key2dict, " EXPECTED SIGNS: (" , sign2x, ",", sign2y, ",", sign2z, ")") 
                            
                        else:
                            count2rejected = count2rejected + 1
                            # print("\n REJECTION: ", count2rejected, " SHOT ", order2key, ":", key2dict, " EXPECTED SIGNS: (" , sign2x, ",", sign2y, ",", sign2z, ")")   
                                                        
                        order2key = order2key +1 

                    count2tried = count2accepted + count2rejected 
                    
                    sum2plus = count2plusx + count2plusy+ count2plusz
                    sum2minus = count2minusx + count2minusy+ count2minusz
                    sum2total = count2plusx + count2minusx # same also with y and z - coordinate exists only once
                            
                    print('=' *80)
                    print("\n (STEP 22Y15/33) OF TEST_BALL4XI - STATISTICS FOR REQUIRED: ", max2count, " SHOTS")
                    print("\n START TIME: ", time2start)
                    print("\n ACCEPTED: ", count2accepted, " = ", int(100*count2accepted/order2key), " %")
                    print("\n REJECTED: ", count2rejected, " = ", int(100*count2rejected/order2key), " %")
                   
                    print("\n DISTIBUTION OF X, Y AND Z: ") 
                    print("\n +X: ", count2plusx, " = ", int(100*count2plusx/sum2total), " %")
                    print("\n -X: ", count2minusx, " = ", int(100*count2minusx/sum2total), " %") 
                   
                    print("\n +Y: ", count2plusy, " = ", int(100*count2plusy/sum2total), " %")
                    print("\n -Y: ", count2minusy, " = ", int(100*count2minusy/sum2total), " %") 
                   
                    print("\n +Z: ", count2plusz, " = ", int(100*count2plusz/sum2total), " %")
                    print("\n -Z: ", count2minusz, " = ", int(100*count2minusz/sum2total), " %") 
                              
                    count2layer = count2layer + 1 
                    print("\n SUM2TOTAL: ", sum2total, "SUCCESS-RATIO: ", int(100*count2accepted/max2count), " %", " COUNT2LAYER: ", count2layer)
                    print("\n START2DISTANCE: ", start2distance, " INTERVAL2DISTANCE: ", interval2distance, " MAX2LAYER: ", max2layer, " MAX2COUNT : ", max2count)
                    print("\n EXPECTED COORDINATE SIGNS: (X: "  , sign2x, ",Y", sign2y, ",Z", sign2z, ")") 
                    
                    print("\n REASONING: ")
                    if count2accepted >= omax2count:
                        print("\n OK SHOOTING: ACCEPTED SHOTS ", count2accepted, " >= ", omax2count, " ORIGINALLY REQUIRED, MARIGINAL: ", marginal2count)
                    else:
                        print("\n *** FAILED SHOOTING: ACCEPTED SHOT ONLY: ", count2accepted, " < ", omax2count, " REQUIRED !")                                    
                    
                    print("\n END TIME: ", time2end)
                    print('=' *80)

                    # ================================================================================
                    #  (STEP 22Y15/33) OF TEST_BALL4XI - STATISTICS FOR REQUIRED:  120  SHOTS
                    #  START TIME:  05:02:58 06/04/10 Pacific Daylight Time
                    #  ACCEPTED:  120  =  12  %
                    #  REJECTED:  874  =  87  %
                    #  DISTIBUTION OF X, Y AND Z: 
                    #  +X:  469  =  47  %
                    #  -X:  525  =  52  %
                    #  +Y:  463  =  46  %
                    #  -Y:  531  =  53  %
                    #  +Z:  531  =  53  %
                    #  -Z:  463  =  46  %
                    # 
                    #  SUM2TOTAL:  994 SUCCESS-RATIO:  100  %  COUNT2LAYER:  2
                    #  START2DISTANCE:  100  INTERVAL2DISTANCE:  100  MAX2LAYER:  120  MAX2COUNT :  120
                    #  EXPECTED COORDINATE SIGNS: (X:  - ,Y + ,Z - )
                    #  REASONING: 
                    #  OK SHOOTING: ACCEPTED SHOTS  120  >=  100  ORIGINALLY REQUIRED, MARIGINAL:  1.2
                    #  END TIME:  05:03:15 06/04/10 Pacific Daylight Time 
                    # ================================================================================                    
                except:
                    # -------------------------------------------------------------------------------------    
                    #
                    # -------------------------------------------------------------------------------------     
                    print("\n (STEP 22Z/33) OF TEST_BALL4XI *** FAILED TO SHOOT (-X,+Y,-Z) - WEST, SOUTH  BACKWARDS")
                    
                                                                                                    
                # ---------------------------------------------------------------------------------------------
                # SMART SHOOTING (-X,-Y,+Z) - WEST, NORTH, TOWARDS               
                # ---------------------------------------------------------------------------------------------  
                print("\n (STEP 23A/33) OF TEST_BALL4XI - TRYING SMART SHOOTING (-X,-Y,+Z) - WEST, NORTH, TOWARDS ")   
                
                try:        

                    # =============================================================================================                   
                    # INITIALIZATIONS
                    # =============================================================================================                
      
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    ball2xi = Ball4Xi(message2ball = name2xi)

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                        
                    start2distance = 100
                    print("\n (STEP 23B1/33) OF TEST_BALL4XI - DISTANCE: ", d2shot)   

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                     
                    interval2distance = 100  
                    print("\n (STEP 23B2/33) OF TEST_BALL4XI - INTERVAL TO DISTANCE: ", interval2distance)   
                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    max2layer = 100                          
                    marginal2layer = 1.2
                    omax2layer = max2layer
                    max2layer = int(marginal2layer * max2layer)
                    print("\n (STEP 23B3/33) OF TEST_BALL4XI - MAXIMUM SHOTS PER LAYER: ", max2layer, " MARGINAL TO LAYER: ", marginal2layer) 
                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    max2count = 100
                    marginal2count = 1.2
                    omax2count = max2count
                    max2count = int(marginal2count * max2count)
                            
                    print("\n (STEP 23B4/33) OF TEST_BALL4XI - MAXIMUM SHOTS: ", max2count, " MARGINAL TO COUNT: ", marginal2count) 
                    if max2count > 1000:
                        trace2set = False # <-- turn trace off with a large max !

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                    
                    time2start = time4xi()                        
                    print("\n (STEP 23B5/33) OF TEST_BALL4XI - START TIME: ", time2start) 
                                                                                            
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # required signs for (x,y,z)
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    
                    # (-X,-Y,+Z) - WEST, NORTH, TOWARDS
                    sign2x = '-'    
                    sign2y = '-'
                    sign2z = '+'
                    print("\n (STEP 23B6/33) OF TEST_BALL4XI - X-SIGN: ", sign2x, 'Y-SIGN: ', sign2y, 'Z-SIGN: ', sign2z) 
                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                    
                    max2iterate = 1000
                    print("\n (STEP 23B7/33) OF TEST_BALL4XI - MAXIMUM TO ITERATIONS: ", max2iterate) 
                    if max2iterate > 1000:
                        trace2set = False # <-- turn trace off with a large max !  
                                          
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # azimuth and elevation angle initialized
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # ref: http://en.wikipedia.org/wiki/Radian#Conversion_between_radians_and_degrees
                    # one radian is equal to 180/p degrees <=> 1 deg = rad * 180 / pi                             
                    # pi/6 = 30, pi/4 = 45, pi/3 = 60, pi/2 = 90, 2/3*pi = 120, 3/4pi=135, 5/6*pi = 150, pi = 180
                    # 7/6*pi = 210, 5/4*pi = 225...3*pi/2 = 270, 5*pi/3 = 300 ... 2*pi = 0 or 360 degrees
                    # I   = 0...90    (0...pi/2) :     sin+, cos+
                    # II  = 90...180  (pi/2...pi):     sin+, cos- 
                    # III = 180...270 (pi...3*pi/2):   sin-, cos-
                    # IV  = 270...360 (3*pi/2...2*pi): sin-, cos+
                    # ref: http://en.wikipedia.org/wiki/Azimuth

                    # =============================================================================================                   
                    # AZIMUTH
                    # =============================================================================================                
                                                                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                    start2plusa = pi/6                          # start plus azimuth 30 degrees - iterates smaller                                                           
                    print("\n (STEP 23B8/33) OF TEST_BALL4XI - START2PLUSA: ", start2plusa) 
                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
                    max2plusa = 2*pi                            # extreme plus azimuth 360 degrees around sideways
                    print("\n (STEP 23B8/33) OF TEST_BALL4XI - MAX2PLUSA: ", max2plusa) 

                                                                        
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
                    min2plusa = pi/240                          # minum positive azimuth 0.75 degrees sideways 
                    print("\n (STEP 23B8/33) OF TEST_BALL4XI - MIN2PLUSA: ", min2plusa) 
                                                          
                                              
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                    start2minusa = -pi/6                        # start minus azimuth -30 degrees sideways                                                           
                    print("\n (STEP 23B8/33) OF TEST_BALL4XI - START2MINUSA: ", start2minusa) 
                                  
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
                    max2minusa = -0.98*2*pi                     # extreme minus azimuth almost -360 degrees 
                    print("\n (STEP 23B8/33) OF TEST_BALL4XI - MAX2MINUSA: ", max2minusa) 
                                                                            
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
                    min2minusa = -pi/240                        # nearest to zero minus to azimuth
                    print("\n (STEP 23B8/33) min2minusa: ", min2minusa) 
                                                                    
                    # =============================================================================================                   
                    # ELEVATION
                    # =============================================================================================                
                                                      
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                    start2pluse = pi/6                          # start plus elevation 30 degrees up 
                    print("\n (STEP 23B8/33) OF TEST_BALL4XI - START2PLUSE: ", start2pluse) 
                                                          
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
                    max2pluse = pi                              # most flexible elevation 180 degrees 
                    print("\n (STEP 23B8/33) OF TEST_BALL4XI - MAX2PLUSE: ", max2pluse) 
                                      
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
                    min2pluse = pi/240                          # lowest plus to elevation 0.75 degrees                          
                    print("\n (STEP 23B8/33) OF TEST_BALL4XI - MIN2PLUSE: ", min2pluse) 
                                                   
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                    start2minuse = -pi/6                        # start minus elevation -30 degrees down                                                
                    print("\n (STEP 23B8/33) OF TEST_BALL4XI - START2MINUSE: ", start2minuse) 
                  
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
                    max2minuse = -0.98*pi                       # most painful minus elevation almost -180 degrees
                    print("\n (STEP 23B8/33) OF TEST_BALL4XI - MAX2MINUSE: ", max2minuse) 
                                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
                    min2minuse = -pi/240                        # least painful minus elevation -0.75 degrees                              
                    print("\n (STEP 23B8/33) OF TEST_BALL4XI - MIN2MINUSE: ", min2minuse) 
                                                         
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # increments for algorithm 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    increase2distance = 0                       # zero with laeyrs, only new layer increases
                    print("\n (STEP 23B8/33) OF TEST_BALL4XI - INCREASE2DISTANCE: ", increase2distance) 
                                                         
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # increments for algorithm 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    change2a = pi / 60                          # 3 degrees change to azimuth
                    print("\n (STEP 23B8/33) OF TEST_BALL4XI -CHANGE2A: ", change2a) 
                                                         
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # increments for algorithm 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    change2e = pi / 60                          # 3 degrees change to elevation
                    print("\n (STEP 23B8/33) OF TEST_BALL4XI - CHANGE2E: ", change2e) 
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # azimuth settings based on sign, which might get tuned to opposite sign later on
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    sign2a = '+'

                    if sign2a == '+':
                        start2a = start2plusa
                        min2a = min2plusa
                        max2a = max2plusa
                    else:
                        start2a = start2minusa
                        min2a = min2minusa
                        max2a = max2minusa
                        
                    print("\n (STEP 23B9/33) OF TEST_BALL4XI - START AZIMUTH: ", start2a, 'MIN AZIMUTH: ', min2a, 'MAX AZIMUTH: ', max2a) 
                    
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # elevation values used based on sign
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    sign2e = '+'

                    if sign2e == '+':
                        start2e = start2pluse
                        min2e = min2pluse
                        max2e = max2pluse
                    else:
                        start2e = start2minuse
                        min2e = min2minuse
                        max2e = max2minuse
                        
                    print("\n (STEP 23B10/33) OF TEST_BALL4XI - START ELEVATION: ", start2e, 'MIN ELEVATION: ', min2e, 'MAX ELEVATION: ', max2e) 
                    
                  
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # azimuth start setting
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                              
                    a2shot = start2a 
                    
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # elevation start setting
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                              
                    e2shot = start2e                            
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # distance start setting
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                          
                    d2shot = start2distance
            
                                  
                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # initializations for while loop 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    count2layer = 1                                  # layers                                                           
                    
                    count2ok = 0                                     # ok shots with all of (x,y,z) ok 
                    
                    count2distance = 0                               # for none layers when distance increased                        
                    
                    count2iterate = 0                                # hunt for right (x,y,z) combination
                    
                    count2rejected = 0                               # rejected
                  
                    ack2x = False                                    # validation for x-coordinate
                    nack2x = True
                    
                    ack2y = False                                    # validation for y-coordinate
                    nack2y = True                    
                    
                    ack2z = False                                    # validation for z-coordinate
                    nack2z = True
                    
                    ack2layer = False                                # validation for layer
                    nack2layer = True                    
                    
                    print("\n (STEP 23F/33) OF TEST_BALL4XI - START TIME OF SHOOTING: ", time4xi(), " FOR ", max2count, " SHOTS") 
                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                                             
                    while ((count2ok <= max2count) and (count2iterate < max2iterate)   
                           and (ack2layer is False)): 
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # 
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        count2iterate = count2iterate + 1    
                        
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # distance
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        d2shot = d2shot + increase2distance                          # remains the same for a laeyr
                        
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # azimuth changes
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        if a2shot >= 0:        
                            a2shot = a2shot + change2a
                            if a2shot >= max2a:
                                start2a = start2a * 1.01
                                a2shot = start2a 
                                print("\n (STEP 23G/33) OF TEST_BALL4XI - AZIMUTH BECAME BIGGER THAN MAXIMUM: ", max2a , " NEW AZIMUTH: ", a2shot)    
                        else:
                            a2shot = a2shot - change2a
                            if a2shot <= min2a:
                                start2a = start2a * 1.01
                                a2shot = start2a  
                                print("\n (STEP 23H/33) OF TEST_BALL4XI - AZIMUTH BECAME SMALLER THAN MINIMUM: ", min2a , " NEW AZIMUTH: ", a2shot)  
                                
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # azimuth algoritm checking against maximum allowed - restart with tuning, if necessary
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                        if (a2shot >= 2*pi):
                            sign2a = '-'                                             # switch to negative
                            change2a = 0.98 * change2a                               # change2a always positive
                            start2a = change2a * start2minusa                        # new minus azimuth start
                            a2shot = start2a                                         # new azimuth
                            min2a = min2minusa                                       # new minimum to azimuth
                            max2a = max2minusa                                       # new maximum to azimuth
                            print("\n (STEP 23I/33) OF TEST_BALL4XI - AZIMUTH BECAME BIGGER THAN 2*PI , NEW AZIMUTH: ", a2shot) 

                            
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # azimuth algoritm checking against minimum allowed- restart with tuning, if necessary
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                             
                        if (a2shot <= -2*pi):
                            sign2a = '+'                                             # switch to positive
                            change2a = 0.98 * change2a                               # change2a always positive
                            start2a = change2a * start2plusa                         # new positive azimuth start
                            a2shot = start2a                                         # new azimuth
                            min2a = min2plusa                                        # new minimum to azimuth
                            max2a = max2plusa                                        # new maximum to azimuth
                            print("\n (STEP 23J/33) OF TEST_BALL4XI - AZIMUTH BECAME LESS THAN -2*PI, NEW AZIMUTH: ", a2shot) 

                        
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # elevation changes
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        if e2shot <= 0:
                            e2shot = e2shot - increase2e
                            if e2shot <= min2e:
                                change2e = 1.02 * change2e
                                start2e = change2e * start2e
                                e2shot = start2e
                                print("\n (STEP 23K/33) OF TEST_BALL4XI - ELEVATION BECAME LESS THAN MINIMUM: ", min2e, " NEW ELEVATION: ", e2shot)                                   
                        else:
                            e2shot = e2shot + increase2e
                            if e2shot >= max2e:
                                change2e = 1.08 * change2e
                                start2e = change2e * start2e
                                e2shot = start2e
                                print("\n (STEP 23L/33) OF TEST_BALL4XI - ELEVATION BECAME BIGGER THAN MAXIMUM: ", max2e, " NEW ELEVATION: ", e2shot)  
                                                                      
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # elevation algoritm checking against maximum allowed - restart with tuning, if necessary
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                                                   
                        if (e2shot >= pi):
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # start again with a new elevation and new elevation change
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            sign2e = '-'                                             # switch to negative
                            change2e = 0.98 * change2e                               # change2e always positive
                            start2e = change2e * start2minuse                        # new minus elevation start
                            e2shot = start2e                                         # new azimuth
                            min2e = min2minuse                                       # new minimum to elevation
                            max2e = max2minuse                                       # new maximum to elevation
                            print("\n (STEP 23M/33) OF TEST_BALL4XI - ELEVATION BECAME BIGGER THAN PI, NEW ELEVATION: ", e2shot)
                            

                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # elevation algoritm checking against minimum allowed- restart with tuning, if necessary
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
                        
                        if (e2shot <= -pi):
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # start again with a new elevation and new elevation change
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                            
                            sign2e = '+'                                             # switch to positive
                            change2e = 0.98 * change2e                               # change2e always positive
                            start2e = change2e * start2pluse                         # new positive elevation start
                            e2shot = start2e                                         # new azimuth
                            min2e = min2pluse                                        # new minimum to elevation
                            max2e = max2pluse                                        # new maximum to elevation        
                            print("\n (STEP 23N/33) OF TEST_BALL4XI - ELEVATION BECAME LESS THAN -PI, NEW ELEVATION: ", e2shot)
                            

                            
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # shoot
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                                               
                        ball2xi.set(azimuth2shot = a2shot, elevation2shot = e2shot, distance2shot = d2shot, area2shot = int(4*pi*d2shot**2/interval2distance))
                        
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # check shot 
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        shot2examine = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes', area2shot = 'Yes')
                        print("\n (STEP 23OA/33) OF TEST_BALL4XI - SHOT TO EXAMINE ", count2shot, ": ", shot2examine)  
                        # {'42x27y86z': {'x2shot': 42, 'azimuth2shot': 0.5759586531581287, 'area2shot': 1256, 'id2shot': '42x27y86z', 'distance2shot': 100, 'z2shot': 86, 'elevation2shot': 0.5335987755982988, 'y2shot': 27}}
                         
                        keys2examine = shot2examine.keys()
                        print("\n (STEP 23OB1/33) OF TEST_BALL4XI - KEYS2EXAMINE: ", keys2examine)   
                        # dict_keys(['42x27y86z'])
                        
                        for key2examine in sorted(keys2examine):
                            print("\n (STEP 23OB2/33) OF TEST_BALL4XI - KEY2EXAMINE ", key2examine)  
                            # 42x27y86z
                            
                            ack2x = False 
                            nack2x = True                                  
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # X OK ?
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                            try:
                                index2x=str.find(key2examine,'x')                               
                                x2coordinate = int(key2examine[0:index2x])
                                if x2coordinate >= 0:
                                    if sign2x == '+':
                                        ack2x = True
                                        nack2x = False
                                        print("\n (STEP 23OB3/33/33) OF TEST_BALL4XI - X2COORDINATE ACK: ", ack2x) 
                                else:
                                    if sign2x == '-':
                                        ack2x = True
                                        nack2x = False
                                        print("\n (STEP 23OB4/33/33) OF TEST_BALL4XI - X2COORDINATE ACK: ", ack2x)
                                         
                            except:
                                print("\n (STEP 23B5/33) OF TEST_BALL4XI *** FAILED  WITH KEY2EXAMINE: ", key2examine)
                                print("\n (STEP 23B5/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                                
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # Y OK ?
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
                            ack2y = False 
                            nack2y = True     
                            try:
                                index2y=str.find(key2examine,'y')                               
                                y2coordinate = int(key2examine[index2x+1:index2y])
                                if y2coordinate >= 0:
                                    if sign2y == '+':
                                        ack2y = True
                                        nack2y = False
                                        print("\n (STEP 23OB6/33) OF TEST_BALL4XI - Y2COORDINATE ACK: ", ack2y)                                         
                                else:
                                    if sign2y == '-':
                                        ack2y = True
                                        nack2y = False
                                        print("\n (STEP 23OB7/33) OF TEST_BALL4XI - Y2COORDINATE ACK: ", ack2y)                               
                            except:
                                print("\n (STEP 23OB8/33) OF TEST_BALL4XI *** FAILED  WITH KEY2EXAMINE: ", key2examine)
                                print("\n (STEP 23OB8/33) OF TEST_BALL4XI - INDEX2Y: ", index2y)
                                
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # Z OK ?
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
                            ack2z = False 
                            nack2z = True                                 
                            try:
                                index2z=str.find(key2examine,'z')                               
                                z2coordinate = int(key2examine[index2y+1:index2z])
                                if z2coordinate >= 0:
                                    if sign2z == '+':
                                        ack2z = True
                                        nack2z = False
                                        print("\n (STEP 23OB9/33) OF TEST_BALL4XI - Z2COORDINATE ACK: ", ack2z)                                               
                                else:
                                    if sign2z == '-':
                                        ack2z = True
                                        nack2z = False
                                        print("\n (STEP 23OB10/33) OF TEST_BALL4XI - Z2COORDINATE ACK: ", ack2z)                                  
                            except:
                                print("\n (STEP 23OB11/33) OF TEST_BALL4XI *** FAILED  WITH KEY2EXAMINE: ", key2examine)
                                print("\n (STEP 23OB11/33) OF TEST_BALL4XI - INDEX2Z: ", index2z)
                                
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # (X,Y,Z) OK ?
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
                            try:                                                           
                                if ((ack2x is True) and (ack2y is True) and (ack2z is True)):
                                    print("\n (STEP 23O5A/33) OF TEST_BALL4XI - OK: (" , x2coordinate, ",", y2coordinate, ",", z2coordinate, ")") 
                                    print("\n (STEP 23O5B/33) OF TEST_BALL4XI - EXPECTED: (" , sign2x, ",", sign2y, ",", sign2z, ")") 
                                    count2ok = count2ok + 1 
                                    if count2ok >= max2layer:
                                        ack2layer = True
                                        print("\n (STEP 23O6/33) OF TEST_BALL4XI - ACK2LAYER: " , ack2layer)
                                    else:
                                        ack2layer = False
                                else:
                                    print("\n (STEP 23O8A/33) OF TEST_BALL4XI - REJECTED: (" , x2coordinate, ",", y2coordinate, ",", z2coordinate, ")")
                                    print("\n (STEP 23O8B/33) OF TEST_BALL4XI - EXPECTED: (" , sign2x, ",", sign2y, ",", sign2z, ")")
                                    
                                    count2rejected = count2rejected + 1
                                    ack2layer = False 
                                    # ( 42 , 27 , 86 )
                                    # ( + , + , - )  
                                    
                                    print("\n (STEP 23O8C/33) OF TEST_BALL4XI *** REMEMBER TO DELETE THE SHOT OR LET IT BE AND RETURN ONLY OK SHOTS!!!! *** ")
                                    
                                                        
                            except:
                                print("\n (STEP 23O9/33) OF TEST_BALL4XI *** FAILED  WITH KEY2EXAMINE: ", key2examine)
                                print("\n (STEP 23O9/33) OF TEST_BALL4XI - INDEX2Z: ", index2z)
                        
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # CONTINUE WHILE
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                    

                        print("\n (STEP 23O10/33) OF TEST_BALL4XI - CONTINUING WHILE WITH:")
                        print("\n count2ok:", count2ok)
                        print("\n max2count:", max2count)                        
                        print("\n count2iterate:", count2iterate)
                        print("\n max2iterate:", max2iterate)                        
                        print("\n ack2layer:", ack2layer)                        
                        
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # CONTINUE WHILE
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                    
                                                                                                         
                        count2distance = count2distance + increase2distance  #stays the same when a layer is shot
                        if count2distance > max2layer:
                            d2shot = d2shot + interval2distance
                            count2distance = 0
                            count2layer = count2layer + 1 
                            print("\n (STEP 23O10/33) OF TEST_BALL4XI - NEW LAYER NUMBER: ", count2layer, ' NEW DISTANCE: ', d2shot)
                        else:
                            pass 
                               
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # end of while
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # EXAMINE RESULTS 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    time2end = time4xi()           
                    print("\n (STEP 23P1/33) OF TEST_BALL4XI - STATISTICS FOR SHOOTING, WHICH ENDED: ", time2end)                          
                    print("\n SHOTS OK: ", count2ok, " = ", int(100 * count2ok/max2count), " %")                              
                    print("\n SHOTS ORIGINALLY REQUIRED: ", omax2count)      
                    print("\n ITERATIONS NEEDED: ", count2iterate)                              
                    print("\n ITERATIONS ALLOWED: ", max2iterate) 
                    print("\n REJECTED: ", count2rejected, " = : ", int(100 * count2rejected/count2iterate), " %") 

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                           
                    print("\n (STEP 23Y1/33) OF TEST_BALL4XI - WHOLE BALL AFTER ALL OPERATIONS AND WITH MAX2COUNT: ", max2count, 'TIME PRINTED: ', time4xi())  
                    
                    ball2show = ball2xi.get()
                    dict2keys = ball2show.keys()
                    print("\n (STEP 23Y2/33) OF TEST_BALL4XI - KEYS2BALL: ", dict2keys)
                    # 
                    print("\n (STEP 23Y3/33) OF TEST_BALL4XI - SHOOTING SAMPLE OF : ", max2count, " SHOTS", "NUMBER OF LAYERS: ", count2layer, ' LATEST DISTANCE: ', d2shot, ' INTERVAL2DISTANCE: ', interval2distance)    
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    count2plusx = 0
                    count2plusy = 0
                    count2plusz = 0
                           
                    count2minusx = 0
                    count2minusy = 0
                    count2minusz = 0
                    
                    count2accepted = 0
                    count2rejected = 0
                    
                    order2key = 1
                    for key2dict in sorted(dict2keys):
                        try:
                            index2x=str.find(key2dict,'x')                               
                            x2coordinate = int(key2dict[0:index2x])
                            # print("\n (STEP 15L11/33/33) OF TEST_BALL4XI - X2COORDINATE: ",  x2coordinate)
                            if x2coordinate >= 0:
                                count2plusx = count2plusx + 1
                            else:
                                count2minusx = count2minusx + 1    
                        except:
                            print("\n (STEP 23Y4/33) OF TEST_BALL4XI *** FAILED  WITH KEY2DICT: ", key2dict)
                            print("\n (STEP 23Y5/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            
                            
                        try:                                   
                            index2y=str.find(key2dict,'y')
                            y2coordinate = int(key2dict[index2x+1:index2y])
                            # print("\n (STEP 15L11/33) OF TEST_BALL4XI - Y2COORDINATE: ",  y2coordinate)
                            if y2coordinate >= 0:
                                count2plusy = count2plusy + 1
                            else:
                                count2minusy = count2minusy + 1  
                        except:
                            print("\n (STEP 23Y6/33) OF TEST_BALL4XI *** FAILED  WITH KEY2DICT: ", key2dict) 
                            print("\n (STEP 23Y7/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            print("\n (STEP 23Y8/33) OF TEST_BALL4XI - INDEX2Y: ", index2y)
                        
                        try:                                                                         
                            index2z=str.find(key2dict,'z') 
                            z2coordinate = int(key2dict[index2y+1:index2z])
                            # print("\n (STEP 23V/33) OF TEST_BALL4XI - Z2COORDINATE: ",  z2coordinate)
                            if z2coordinate >= 0:
                                count2plusz = count2plusz + 1
                            else:
                                count2minusz = count2minusz + 1
                        except:
                            print("\n (STEP 23Y9/33) OF TEST_BALL4XI *** FAILED  WITH KEY2DICT: ", key2dict)
                            print("\n (STEP 23Y10/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            print("\n (STEP 23Y11/33) OF TEST_BALL4XI - INDEX2Y: ", index2y)
                            print("\n (STEP 23Y12/33) OF TEST_BALL4XI - INDEX2Z: ", index2z)
                        
                        ack2x = False    
                        if ((x2coordinate >= 0) and (sign2x == '+')):
                            ack2x = True
                        if ((x2coordinate <= 0) and (sign2x == '-')):
                            ack2x = True                        
                        
                        ack2y = False    
                        if ((y2coordinate >= 0) and (sign2y == '+')):
                            ack2y = True
                        if ((y2coordinate <= 0) and (sign2y == '-')):
                            ack2y = True     
                        
                        ack2z = False    
                        if ((z2coordinate >= 0) and (sign2z == '+')):
                            ack2z = True
                        if ((z2coordinate <= 0) and (sign2z == '-')):
                            ack2z = True     
                        
                        if ((ack2x is True) and (ack2y is True) and (ack2z is True)):
                            count2accepted = count2accepted + 1                                                                                                      
                            print("\n ACCEPTANCE: ", count2accepted, " SHOT: ", order2key, ":", key2dict, " EXPECTED SIGNS: (" , sign2x, ",", sign2y, ",", sign2z, ")") 
                            
                        else:
                            count2rejected = count2rejected + 1
                            # print("\n REJECTION: ", count2rejected, " SHOT ", order2key, ":", key2dict, " EXPECTED SIGNS: (" , sign2x, ",", sign2y, ",", sign2z, ")")   
                                                        
                        order2key = order2key +1 

                    count2tried = count2accepted + count2rejected 
                    
                    sum2plus = count2plusx + count2plusy+ count2plusz
                    sum2minus = count2minusx + count2minusy+ count2minusz
                    sum2total = count2plusx + count2minusx # same also with y and z - coordinate exists only once
                            
                    print('=' *80)
                    print("\n (STEP 23Y15/33) OF TEST_BALL4XI - STATISTICS FOR REQUIRED: ", max2count, " SHOTS") 
                    print("\n START TIME: ", time2start)
                    print("\n ACCEPTED: ", count2accepted, " = ", int(100*count2accepted/order2key), " %")
                    print("\n REJECTED: ", count2rejected, " = ", int(100*count2rejected/order2key), " %")
                   
                    print("\n DISTIBUTION OF X, Y AND Z: ") 
                    print("\n +X: ", count2plusx, " = ", int(100*count2plusx/sum2total), " %")
                    print("\n -X: ", count2minusx, " = ", int(100*count2minusx/sum2total), " %") 
                   
                    print("\n +Y: ", count2plusy, " = ", int(100*count2plusy/sum2total), " %")
                    print("\n -Y: ", count2minusy, " = ", int(100*count2minusy/sum2total), " %") 
                   
                    print("\n +Z: ", count2plusz, " = ", int(100*count2plusz/sum2total), " %")
                    print("\n -Z: ", count2minusz, " = ", int(100*count2minusz/sum2total), " %") 
                              
                    count2layer = count2layer + 1 
                    print("\n SUM2TOTAL: ", sum2total, "SUCCESS-RATIO: ", int(100*count2accepted/max2count), " %", " COUNT2LAYER: ", count2layer)
                    print("\n START2DISTANCE: ", start2distance, " INTERVAL2DISTANCE: ", interval2distance, " MAX2LAYER: ", max2layer, " MAX2COUNT : ", max2count)
                    print("\n EXPECTED COORDINATE SIGNS: (X: "  , sign2x, ",Y", sign2y, ",Z", sign2z, ")") 
                    
                    print("\n REASONING: ")
                    if count2accepted >= omax2count:
                        print("\n OK SHOOTING: ACCEPTED SHOTS ", count2accepted, " >= ", omax2count, " ORIGINALLY REQUIRED, MARIGINAL: ", marginal2count)
                    else:
                        print("\n *** FAILED SHOOTING: ACCEPTED SHOT ONLY: ", count2accepted, " < ", omax2count, " REQUIRED !")                                    
                    
                    print("\n END TIME: ", time2end)
                    print('=' *80)

                    # ================================================================================
                    #  (STEP 23Y15/33) OF TEST_BALL4XI - STATISTICS FOR REQUIRED:  120  SHOTS
                    #  START TIME:  04:58:13 06/04/10 Pacific Daylight Time
                    #  ACCEPTED:  132  =  18  %
                    #  REJECTED:  580  =  81  %
                    #  DISTIBUTION OF X, Y AND Z: 
                    #  +X:  330  =  46  %
                    #  -X:  382  =  53  %
                    #  +Y:  354  =  49  %
                    #  -Y:  358  =  50  %
                    #  +Z:  403  =  56  %
                    #  -Z:  309  =  43  %
                    #  SUM2TOTAL:  712 SUCCESS-RATIO:  110  %  COUNT2LAYER:  2
                    #  START2DISTANCE:  100  INTERVAL2DISTANCE:  100  MAX2LAYER:  120  MAX2COUNT :  120
                    #  EXPECTED COORDINATE SIGNS: (X:  - ,Y - ,Z + )
                    #  REASONING: 
                    #  OK SHOOTING: ACCEPTED SHOTS  132  >=  100  ORIGINALLY REQUIRED, MARIGINAL:  1.2
                    #  END TIME:  04:58:21 06/04/10 Pacific Daylight Time
                    # ================================================================================                    
                except:
                    # -------------------------------------------------------------------------------------    
                    #
                    # -------------------------------------------------------------------------------------     
                    print("\n (STEP 23Z/33) OF TEST_BALL4XI *** FAILED TO SHOOT (-X,-Y,+Z) - WEST, NORTH, TOWARDS ")
                    
                                                                    
                # ---------------------------------------------------------------------------------------------
                # SMART SHOOTING (-X,-Y,+Z) - WEST, NORTH, TOWARDS                  
                # ---------------------------------------------------------------------------------------------                                                               
                print("\n (STEP 23A/33) OF TEST_BALL4XI - TRYING SMART SHOOTING (-X,-Y,+Z) - WEST, NORTH, TOWARDS ")   
                
                try:        

                    # =============================================================================================                   
                    # INITIALIZATIONS
                    # =============================================================================================                
      
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    ball2xi = Ball4Xi(message2ball = name2xi)

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                        
                    start2distance = 100
                    print("\n (STEP 23B1/33) OF TEST_BALL4XI - DISTANCE: ", d2shot)   

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                     
                    interval2distance = 100  
                    print("\n (STEP 23B2/33) OF TEST_BALL4XI - INTERVAL TO DISTANCE: ", interval2distance)   
                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    max2layer = 100                          
                    marginal2layer = 1.2
                    omax2layer = max2layer
                    max2layer = int(marginal2layer * max2layer)
                    print("\n (STEP 23B3/33) OF TEST_BALL4XI - MAXIMUM SHOTS PER LAYER: ", max2layer, " MARGINAL TO LAYER: ", marginal2layer) 
                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    max2count = 100
                    marginal2count = 1.2
                    omax2count = max2count
                    max2count = int(marginal2count * max2count)
                            
                    print("\n (STEP 23B4/33) OF TEST_BALL4XI - MAXIMUM SHOTS: ", max2count, " MARGINAL TO COUNT: ", marginal2count) 
                    if max2count > 1000:
                        trace2set = False # <-- turn trace off with a large max !

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                    
                    time2start = time4xi()                        
                    print("\n (STEP 23B5/33) OF TEST_BALL4XI - START TIME: ", time2start) 
                                                                                            
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # required signs for (x,y,z)
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    
                    # (-X,-Y,+Z) - WEST, NORTH, TOWARDS
                    sign2x = '-'    
                    sign2y = '-'
                    sign2z = '+'
                    print("\n (STEP 23B6/33) OF TEST_BALL4XI - X-SIGN: ", sign2x, 'Y-SIGN: ', sign2y, 'Z-SIGN: ', sign2z) 
                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                    
                    max2iterate = 1000
                    print("\n (STEP 23B7/33) OF TEST_BALL4XI - MAXIMUM TO ITERATIONS: ", max2iterate) 
                    if max2iterate > 1000:
                        trace2set = False # <-- turn trace off with a large max !  
                                          
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # azimuth and elevation angle initialized
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # ref: http://en.wikipedia.org/wiki/Radian#Conversion_between_radians_and_degrees
                    # one radian is equal to 180/p degrees <=> 1 deg = rad * 180 / pi                             
                    # pi/6 = 30, pi/4 = 45, pi/3 = 60, pi/2 = 90, 2/3*pi = 120, 3/4pi=135, 5/6*pi = 150, pi = 180
                    # 7/6*pi = 210, 5/4*pi = 225...3*pi/2 = 270, 5*pi/3 = 300 ... 2*pi = 0 or 360 degrees
                    # I   = 0...90    (0...pi/2) :     sin+, cos+
                    # II  = 90...180  (pi/2...pi):     sin+, cos- 
                    # III = 180...270 (pi...3*pi/2):   sin-, cos-
                    # IV  = 270...360 (3*pi/2...2*pi): sin-, cos+
                    # ref: http://en.wikipedia.org/wiki/Azimuth

                    # =============================================================================================                   
                    # AZIMUTH
                    # =============================================================================================                
                                                                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                    start2plusa = pi/6                          # start plus azimuth 30 degrees - iterates smaller                                                           
                    print("\n (STEP 23B8/33) OF TEST_BALL4XI - START2PLUSA: ", start2plusa) 
                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
                    max2plusa = 2*pi                            # extreme plus azimuth 360 degrees around sideways
                    print("\n (STEP 23B8/33) OF TEST_BALL4XI - MAX2PLUSA: ", max2plusa) 

                                                                        
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
                    min2plusa = pi/240                          # minum positive azimuth 0.75 degrees sideways 
                    print("\n (STEP 23B8/33) OF TEST_BALL4XI - MIN2PLUSA: ", min2plusa) 
                                                          
                                              
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                    start2minusa = -pi/6                        # start minus azimuth -30 degrees sideways                                                           
                    print("\n (STEP 23B8/33) OF TEST_BALL4XI - START2MINUSA: ", start2minusa) 
                                  
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
                    max2minusa = -0.98*2*pi                     # extreme minus azimuth almost -360 degrees 
                    print("\n (STEP 23B8/33) OF TEST_BALL4XI - MAX2MINUSA: ", max2minusa) 
                                                                            
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
                    min2minusa = -pi/240                        # nearest to zero minus to azimuth
                    print("\n (STEP 23B8/33) min2minusa: ", min2minusa) 
                                                                    
                    # =============================================================================================                   
                    # ELEVATION
                    # =============================================================================================                
                                                      
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                    start2pluse = pi/6                          # start plus elevation 30 degrees up 
                    print("\n (STEP 23B8/33) OF TEST_BALL4XI - START2PLUSE: ", start2pluse) 
                                                          
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
                    max2pluse = pi                              # most flexible elevation 180 degrees 
                    print("\n (STEP 23B8/33) OF TEST_BALL4XI - MAX2PLUSE: ", max2pluse) 
                                      
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
                    min2pluse = pi/240                          # lowest plus to elevation 0.75 degrees                          
                    print("\n (STEP 23B8/33) OF TEST_BALL4XI - MIN2PLUSE: ", min2pluse) 
                                                   
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                    start2minuse = -pi/6                        # start minus elevation -30 degrees down                                                
                    print("\n (STEP 23B8/33) OF TEST_BALL4XI - START2MINUSE: ", start2minuse) 
                  
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
                    max2minuse = -0.98*pi                       # most painful minus elevation almost -180 degrees
                    print("\n (STEP 23B8/33) OF TEST_BALL4XI - MAX2MINUSE: ", max2minuse) 
                                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
                    min2minuse = -pi/240                        # least painful minus elevation -0.75 degrees                              
                    print("\n (STEP 23B8/33) OF TEST_BALL4XI - MIN2MINUSE: ", min2minuse) 
                                                         
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # increments for algorithm 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    increase2distance = 0                       # zero with laeyrs, only new layer increases
                    print("\n (STEP 23B8/33) OF TEST_BALL4XI - INCREASE2DISTANCE: ", increase2distance) 
                                                         
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # increments for algorithm 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    change2a = pi / 60                          # 3 degrees change to azimuth
                    print("\n (STEP 23B8/33) OF TEST_BALL4XI -CHANGE2A: ", change2a) 
                                                         
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # increments for algorithm 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    change2e = pi / 60                          # 3 degrees change to elevation
                    print("\n (STEP 23B8/33) OF TEST_BALL4XI - CHANGE2E: ", change2e) 
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # azimuth settings based on sign, which might get tuned to opposite sign later on
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    sign2a = '+'

                    if sign2a == '+':
                        start2a = start2plusa
                        min2a = min2plusa
                        max2a = max2plusa
                    else:
                        start2a = start2minusa
                        min2a = min2minusa
                        max2a = max2minusa
                        
                    print("\n (STEP 23B9/33) OF TEST_BALL4XI - START AZIMUTH: ", start2a, 'MIN AZIMUTH: ', min2a, 'MAX AZIMUTH: ', max2a) 
                    
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # elevation values used based on sign
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    sign2e = '+'

                    if sign2e == '+':
                        start2e = start2pluse
                        min2e = min2pluse
                        max2e = max2pluse
                    else:
                        start2e = start2minuse
                        min2e = min2minuse
                        max2e = max2minuse
                        
                    print("\n (STEP 23B10/33) OF TEST_BALL4XI - START ELEVATION: ", start2e, 'MIN ELEVATION: ', min2e, 'MAX ELEVATION: ', max2e) 
                    
                  
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # azimuth start setting
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                              
                    a2shot = start2a 
                    
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # elevation start setting
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                              
                    e2shot = start2e                            
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # distance start setting
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                          
                    d2shot = start2distance
            
                                  
                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # initializations for while loop 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    count2layer = 1                                  # layers                                                           
                    
                    count2ok = 0                                     # ok shots with all of (x,y,z) ok 
                    
                    count2distance = 0                               # for none layers when distance increased                        
                    
                    count2iterate = 0                                # hunt for right (x,y,z) combination
                    
                    count2rejected = 0                               # rejected
                  
                    ack2x = False                                    # validation for x-coordinate
                    nack2x = True
                    
                    ack2y = False                                    # validation for y-coordinate
                    nack2y = True                    
                    
                    ack2z = False                                    # validation for z-coordinate
                    nack2z = True
                    
                    ack2layer = False                                # validation for layer
                    nack2layer = True                    
                    
                    print("\n (STEP 23F/33) OF TEST_BALL4XI - START TIME OF SHOOTING: ", time4xi(), " FOR ", max2count, " SHOTS") 
                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                                             
                    while ((count2ok <= max2count) and (count2iterate < max2iterate)   
                           and (ack2layer is False)): 
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # 
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        count2iterate = count2iterate + 1    
                        
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # distance
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        d2shot = d2shot + increase2distance                          # remains the same for a laeyr
                        
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # azimuth changes
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        if a2shot >= 0:        
                            a2shot = a2shot + change2a
                            if a2shot >= max2a:
                                start2a = start2a * 1.01
                                a2shot = start2a 
                                print("\n (STEP 23G/33) OF TEST_BALL4XI - AZIMUTH BECAME BIGGER THAN MAXIMUM: ", max2a , " NEW AZIMUTH: ", a2shot)    
                        else:
                            a2shot = a2shot - change2a
                            if a2shot <= min2a:
                                start2a = start2a * 1.01
                                a2shot = start2a  
                                print("\n (STEP 23H/33) OF TEST_BALL4XI - AZIMUTH BECAME SMALLER THAN MINIMUM: ", min2a , " NEW AZIMUTH: ", a2shot)  
                                
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # azimuth algoritm checking against maximum allowed - restart with tuning, if necessary
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                        if (a2shot >= 2*pi):
                            sign2a = '-'                                             # switch to negative
                            change2a = 0.98 * change2a                               # change2a always positive
                            start2a = change2a * start2minusa                        # new minus azimuth start
                            a2shot = start2a                                         # new azimuth
                            min2a = min2minusa                                       # new minimum to azimuth
                            max2a = max2minusa                                       # new maximum to azimuth
                            print("\n (STEP 23I/33) OF TEST_BALL4XI - AZIMUTH BECAME BIGGER THAN 2*PI , NEW AZIMUTH: ", a2shot) 

                            
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # azimuth algoritm checking against minimum allowed- restart with tuning, if necessary
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                             
                        if (a2shot <= -2*pi):
                            sign2a = '+'                                             # switch to positive
                            change2a = 0.98 * change2a                               # change2a always positive
                            start2a = change2a * start2plusa                         # new positive azimuth start
                            a2shot = start2a                                         # new azimuth
                            min2a = min2plusa                                        # new minimum to azimuth
                            max2a = max2plusa                                        # new maximum to azimuth
                            print("\n (STEP 23J/33) OF TEST_BALL4XI - AZIMUTH BECAME LESS THAN -2*PI, NEW AZIMUTH: ", a2shot) 

                        
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # elevation changes
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        if e2shot <= 0:
                            e2shot = e2shot - increase2e
                            if e2shot <= min2e:
                                change2e = 1.02 * change2e
                                start2e = change2e * start2e
                                e2shot = start2e
                                print("\n (STEP 23K/33) OF TEST_BALL4XI - ELEVATION BECAME LESS THAN MINIMUM: ", min2e, " NEW ELEVATION: ", e2shot)                                   
                        else:
                            e2shot = e2shot + increase2e
                            if e2shot >= max2e:
                                change2e = 1.08 * change2e
                                start2e = change2e * start2e
                                e2shot = start2e
                                print("\n (STEP 23L/33) OF TEST_BALL4XI - ELEVATION BECAME BIGGER THAN MAXIMUM: ", max2e, " NEW ELEVATION: ", e2shot)  
                                                                      
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # elevation algoritm checking against maximum allowed - restart with tuning, if necessary
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                                                   
                        if (e2shot >= pi):
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # start again with a new elevation and new elevation change
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            sign2e = '-'                                             # switch to negative
                            change2e = 0.98 * change2e                               # change2e always positive
                            start2e = change2e * start2minuse                        # new minus elevation start
                            e2shot = start2e                                         # new azimuth
                            min2e = min2minuse                                       # new minimum to elevation
                            max2e = max2minuse                                       # new maximum to elevation
                            print("\n (STEP 23M/33) OF TEST_BALL4XI - ELEVATION BECAME BIGGER THAN PI, NEW ELEVATION: ", e2shot)
                            

                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # elevation algoritm checking against minimum allowed- restart with tuning, if necessary
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
                        
                        if (e2shot <= -pi):
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # start again with a new elevation and new elevation change
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                            
                            sign2e = '+'                                             # switch to positive
                            change2e = 0.98 * change2e                               # change2e always positive
                            start2e = change2e * start2pluse                         # new positive elevation start
                            e2shot = start2e                                         # new azimuth
                            min2e = min2pluse                                        # new minimum to elevation
                            max2e = max2pluse                                        # new maximum to elevation        
                            print("\n (STEP 23N/33) OF TEST_BALL4XI - ELEVATION BECAME LESS THAN -PI, NEW ELEVATION: ", e2shot)
                            

                            
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # shoot
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                                               
                        ball2xi.set(azimuth2shot = a2shot, elevation2shot = e2shot, distance2shot = d2shot, area2shot = int(4*pi*d2shot**2/interval2distance))
                        
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # check shot 
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        shot2examine = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes', area2shot = 'Yes')
                        print("\n (STEP 23OA/33) OF TEST_BALL4XI - SHOT TO EXAMINE ", count2shot, ": ", shot2examine)  
                        # {'42x27y86z': {'x2shot': 42, 'azimuth2shot': 0.5759586531581287, 'area2shot': 1256, 'id2shot': '42x27y86z', 'distance2shot': 100, 'z2shot': 86, 'elevation2shot': 0.5335987755982988, 'y2shot': 27}}
                         
                        keys2examine = shot2examine.keys()
                        print("\n (STEP 23OB1/33) OF TEST_BALL4XI - KEYS2EXAMINE: ", keys2examine)   
                        # dict_keys(['42x27y86z'])
                        
                        for key2examine in sorted(keys2examine):
                            print("\n (STEP 23OB2/33) OF TEST_BALL4XI - KEY2EXAMINE ", key2examine)  
                            # 42x27y86z
                            
                            ack2x = False 
                            nack2x = True                                  
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # X OK ?
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                            try:
                                index2x=str.find(key2examine,'x')                               
                                x2coordinate = int(key2examine[0:index2x])
                                if x2coordinate >= 0:
                                    if sign2x == '+':
                                        ack2x = True
                                        nack2x = False
                                        print("\n (STEP 23OB3/33/33) OF TEST_BALL4XI - X2COORDINATE ACK: ", ack2x) 
                                else:
                                    if sign2x == '-':
                                        ack2x = True
                                        nack2x = False
                                        print("\n (STEP 23OB4/33/33) OF TEST_BALL4XI - X2COORDINATE ACK: ", ack2x)
                                         
                            except:
                                print("\n (STEP 23B5/33) OF TEST_BALL4XI *** FAILED  WITH KEY2EXAMINE: ", key2examine)
                                print("\n (STEP 23B5/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                                
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # Y OK ?
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
                            ack2y = False 
                            nack2y = True     
                            try:
                                index2y=str.find(key2examine,'y')                               
                                y2coordinate = int(key2examine[index2x+1:index2y])
                                if y2coordinate >= 0:
                                    if sign2y == '+':
                                        ack2y = True
                                        nack2y = False
                                        print("\n (STEP 23OB6/33) OF TEST_BALL4XI - Y2COORDINATE ACK: ", ack2y)                                         
                                else:
                                    if sign2y == '-':
                                        ack2y = True
                                        nack2y = False
                                        print("\n (STEP 23OB7/33) OF TEST_BALL4XI - Y2COORDINATE ACK: ", ack2y)                               
                            except:
                                print("\n (STEP 23OB8/33) OF TEST_BALL4XI *** FAILED  WITH KEY2EXAMINE: ", key2examine)
                                print("\n (STEP 23OB8/33) OF TEST_BALL4XI - INDEX2Y: ", index2y)
                                
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # Z OK ?
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
                            ack2z = False 
                            nack2z = True                                 
                            try:
                                index2z=str.find(key2examine,'z')                               
                                z2coordinate = int(key2examine[index2y+1:index2z])
                                if z2coordinate >= 0:
                                    if sign2z == '+':
                                        ack2z = True
                                        nack2z = False
                                        print("\n (STEP 23OB9/33) OF TEST_BALL4XI - Z2COORDINATE ACK: ", ack2z)                                               
                                else:
                                    if sign2z == '-':
                                        ack2z = True
                                        nack2z = False
                                        print("\n (STEP 23OB10/33) OF TEST_BALL4XI - Z2COORDINATE ACK: ", ack2z)                                  
                            except:
                                print("\n (STEP 23OB11/33) OF TEST_BALL4XI *** FAILED  WITH KEY2EXAMINE: ", key2examine)
                                print("\n (STEP 23OB11/33) OF TEST_BALL4XI - INDEX2Z: ", index2z)
                                
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # (X,Y,Z) OK ?
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
                            try:                                                           
                                if ((ack2x is True) and (ack2y is True) and (ack2z is True)):
                                    print("\n (STEP 23O5A/33) OF TEST_BALL4XI - OK: (" , x2coordinate, ",", y2coordinate, ",", z2coordinate, ")") 
                                    print("\n (STEP 23O5B/33) OF TEST_BALL4XI - EXPECTED: (" , sign2x, ",", sign2y, ",", sign2z, ")") 
                                    count2ok = count2ok + 1 
                                    if count2ok >= max2layer:
                                        ack2layer = True
                                        print("\n (STEP 23O6/33) OF TEST_BALL4XI - ACK2LAYER: " , ack2layer)
                                    else:
                                        ack2layer = False
                                else:
                                    print("\n (STEP 23O8A/33) OF TEST_BALL4XI - REJECTED: (" , x2coordinate, ",", y2coordinate, ",", z2coordinate, ")")
                                    print("\n (STEP 23O8B/33) OF TEST_BALL4XI - EXPECTED: (" , sign2x, ",", sign2y, ",", sign2z, ")")
                                    
                                    count2rejected = count2rejected + 1
                                    ack2layer = False 
                                    # ( 42 , 27 , 86 )
                                    # ( + , + , - )  
                                    
                                    print("\n (STEP 23O8C/33) OF TEST_BALL4XI *** REMEMBER TO DELETE THE SHOT OR LET IT BE AND RETURN ONLY OK SHOTS!!!! *** ")
                                    
                                                        
                            except:
                                print("\n (STEP 23O9/33) OF TEST_BALL4XI *** FAILED  WITH KEY2EXAMINE: ", key2examine)
                                print("\n (STEP 23O9/33) OF TEST_BALL4XI - INDEX2Z: ", index2z)
                        
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # CONTINUE WHILE
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                    

                        print("\n (STEP 23O10/33) OF TEST_BALL4XI - CONTINUING WHILE WITH:")
                        print("\n count2ok:", count2ok)
                        print("\n max2count:", max2count)                        
                        print("\n count2iterate:", count2iterate)
                        print("\n max2iterate:", max2iterate)                        
                        print("\n ack2layer:", ack2layer)                        
                        
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # CONTINUE WHILE
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                    
                                                                                                         
                        count2distance = count2distance + increase2distance  #stays the same when a layer is shot
                        if count2distance > max2layer:
                            d2shot = d2shot + interval2distance
                            count2distance = 0
                            count2layer = count2layer + 1 
                            print("\n (STEP 23O10/33) OF TEST_BALL4XI - NEW LAYER NUMBER: ", count2layer, ' NEW DISTANCE: ', d2shot)
                        else:
                            pass 
                               
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # end of while
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # EXAMINE RESULTS 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    time2end = time4xi()           
                    print("\n (STEP 23P1/33) OF TEST_BALL4XI - STATISTICS FOR SHOOTING, WHICH ENDED: ", time2end)                          
                    print("\n SHOTS OK: ", count2ok, " = ", int(100 * count2ok/max2count), " %")                              
                    print("\n SHOTS ORIGINALLY REQUIRED: ", omax2count)      
                    print("\n ITERATIONS NEEDED: ", count2iterate)                              
                    print("\n ITERATIONS ALLOWED: ", max2iterate) 
                    print("\n REJECTED: ", count2rejected, " = : ", int(100 * count2rejected/count2iterate), " %") 

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                           
                    print("\n (STEP 23Y1/33) OF TEST_BALL4XI - WHOLE BALL AFTER ALL OPERATIONS AND WITH MAX2COUNT: ", max2count, 'TIME PRINTED: ', time4xi())  
                    
                    ball2show = ball2xi.get()
                    dict2keys = ball2show.keys()
                    print("\n (STEP 23Y2/33) OF TEST_BALL4XI - KEYS2BALL: ", dict2keys)
                    # 
                    print("\n (STEP 23Y3/33) OF TEST_BALL4XI - SHOOTING SAMPLE OF : ", max2count, " SHOTS", "NUMBER OF LAYERS: ", count2layer, ' LATEST DISTANCE: ', d2shot, ' INTERVAL2DISTANCE: ', interval2distance)    
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    count2plusx = 0
                    count2plusy = 0
                    count2plusz = 0
                           
                    count2minusx = 0
                    count2minusy = 0
                    count2minusz = 0
                    
                    count2accepted = 0
                    count2rejected = 0
                    
                    order2key = 1
                    for key2dict in sorted(dict2keys):
                        try:
                            index2x=str.find(key2dict,'x')                               
                            x2coordinate = int(key2dict[0:index2x])
                            # print("\n (STEP 15L11/33/33) OF TEST_BALL4XI - X2COORDINATE: ",  x2coordinate)
                            if x2coordinate >= 0:
                                count2plusx = count2plusx + 1
                            else:
                                count2minusx = count2minusx + 1    
                        except:
                            print("\n (STEP 23Y4/33) OF TEST_BALL4XI *** FAILED  WITH KEY2DICT: ", key2dict)
                            print("\n (STEP 23Y5/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            
                            
                        try:                                   
                            index2y=str.find(key2dict,'y')
                            y2coordinate = int(key2dict[index2x+1:index2y])
                            # print("\n (STEP 15L11/33) OF TEST_BALL4XI - Y2COORDINATE: ",  y2coordinate)
                            if y2coordinate >= 0:
                                count2plusy = count2plusy + 1
                            else:
                                count2minusy = count2minusy + 1  
                        except:
                            print("\n (STEP 23Y6/33) OF TEST_BALL4XI *** FAILED  WITH KEY2DICT: ", key2dict) 
                            print("\n (STEP 23Y7/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            print("\n (STEP 23Y8/33) OF TEST_BALL4XI - INDEX2Y: ", index2y)
                        
                        try:                                                                         
                            index2z=str.find(key2dict,'z') 
                            z2coordinate = int(key2dict[index2y+1:index2z])
                            # print("\n (STEP 23V/33) OF TEST_BALL4XI - Z2COORDINATE: ",  z2coordinate)
                            if z2coordinate >= 0:
                                count2plusz = count2plusz + 1
                            else:
                                count2minusz = count2minusz + 1
                        except:
                            print("\n (STEP 23Y9/33) OF TEST_BALL4XI *** FAILED  WITH KEY2DICT: ", key2dict)
                            print("\n (STEP 23Y10/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            print("\n (STEP 23Y11/33) OF TEST_BALL4XI - INDEX2Y: ", index2y)
                            print("\n (STEP 23Y12/33) OF TEST_BALL4XI - INDEX2Z: ", index2z)
                        
                        ack2x = False    
                        if ((x2coordinate >= 0) and (sign2x == '+')):
                            ack2x = True
                        if ((x2coordinate <= 0) and (sign2x == '-')):
                            ack2x = True                        
                        
                        ack2y = False    
                        if ((y2coordinate >= 0) and (sign2y == '+')):
                            ack2y = True
                        if ((y2coordinate <= 0) and (sign2y == '-')):
                            ack2y = True     
                        
                        ack2z = False    
                        if ((z2coordinate >= 0) and (sign2z == '+')):
                            ack2z = True
                        if ((z2coordinate <= 0) and (sign2z == '-')):
                            ack2z = True     
                        
                        if ((ack2x is True) and (ack2y is True) and (ack2z is True)):
                            count2accepted = count2accepted + 1                                                                                                      
                            print("\n ACCEPTANCE: ", count2accepted, " SHOT: ", order2key, ":", key2dict, " EXPECTED SIGNS: (" , sign2x, ",", sign2y, ",", sign2z, ")") 
                            
                        else:
                            count2rejected = count2rejected + 1
                            # print("\n REJECTION: ", count2rejected, " SHOT ", order2key, ":", key2dict, " EXPECTED SIGNS: (" , sign2x, ",", sign2y, ",", sign2z, ")")   
                                                        
                        order2key = order2key +1 

                    count2tried = count2accepted + count2rejected 
                    
                    sum2plus = count2plusx + count2plusy+ count2plusz
                    sum2minus = count2minusx + count2minusy+ count2minusz
                    sum2total = count2plusx + count2minusx # same also with y and z - coordinate exists only once
                            
                    print('=' *80)
                    print("\n (STEP 23Y15/33) OF TEST_BALL4XI - STATISTICS FOR REQUIRED: ", max2count, " SHOTS") 
                    print("\n START TIME: ", time2start)
                    print("\n ACCEPTED: ", count2accepted, " = ", int(100*count2accepted/order2key), " %")
                    print("\n REJECTED: ", count2rejected, " = ", int(100*count2rejected/order2key), " %")
                   
                    print("\n DISTIBUTION OF X, Y AND Z: ") 
                    print("\n +X: ", count2plusx, " = ", int(100*count2plusx/sum2total), " %")
                    print("\n -X: ", count2minusx, " = ", int(100*count2minusx/sum2total), " %") 
                   
                    print("\n +Y: ", count2plusy, " = ", int(100*count2plusy/sum2total), " %")
                    print("\n -Y: ", count2minusy, " = ", int(100*count2minusy/sum2total), " %") 
                   
                    print("\n +Z: ", count2plusz, " = ", int(100*count2plusz/sum2total), " %")
                    print("\n -Z: ", count2minusz, " = ", int(100*count2minusz/sum2total), " %") 
                              
                    count2layer = count2layer + 1 
                    print("\n SUM2TOTAL: ", sum2total, "SUCCESS-RATIO: ", int(100*count2accepted/max2count), " %", " COUNT2LAYER: ", count2layer)
                    print("\n START2DISTANCE: ", start2distance, " INTERVAL2DISTANCE: ", interval2distance, " MAX2LAYER: ", max2layer, " MAX2COUNT : ", max2count)
                    print("\n EXPECTED COORDINATE SIGNS: (X: "  , sign2x, ",Y", sign2y, ",Z", sign2z, ")") 
                    
                    print("\n REASONING: ")
                    if count2accepted >= omax2count:
                        print("\n OK SHOOTING: ACCEPTED SHOTS ", count2accepted, " >= ", omax2count, " ORIGINALLY REQUIRED, MARIGINAL: ", marginal2count)
                    else:
                        print("\n *** FAILED SHOOTING: ACCEPTED SHOT ONLY: ", count2accepted, " < ", omax2count, " REQUIRED !")                                    
                    
                    print("\n END TIME: ", time2end)
                    print('=' *80)

                    # ================================================================================
                    #  (STEP 23Y15/33) OF TEST_BALL4XI - STATISTICS FOR REQUIRED:  120  SHOTS
                    #  START TIME:  04:58:13 06/04/10 Pacific Daylight Time
                    #  ACCEPTED:  132  =  18  %
                    #  REJECTED:  580  =  81  %
                    #  DISTIBUTION OF X, Y AND Z: 
                    #  +X:  330  =  46  %
                    #  -X:  382  =  53  %
                    #  +Y:  354  =  49  %
                    #  -Y:  358  =  50  %
                    #  +Z:  403  =  56  %
                    #  -Z:  309  =  43  %
                    #  SUM2TOTAL:  712 SUCCESS-RATIO:  110  %  COUNT2LAYER:  2
                    #  START2DISTANCE:  100  INTERVAL2DISTANCE:  100  MAX2LAYER:  120  MAX2COUNT :  120
                    #  EXPECTED COORDINATE SIGNS: (X:  - ,Y - ,Z + )
                    #  REASONING: 
                    #  OK SHOOTING: ACCEPTED SHOTS  132  >=  100  ORIGINALLY REQUIRED, MARIGINAL:  1.2
                    #  END TIME:  04:58:21 06/04/10 Pacific Daylight Time
                    # ================================================================================                    
                except:
                    # -------------------------------------------------------------------------------------    
                    #
                    # -------------------------------------------------------------------------------------     
                    print("\n (STEP 23Z/33) OF TEST_BALL4XI *** FAILED TO SHOOT (-X,-Y,+Z) - WEST, NORTH, TOWARDS ")
                    
                                                                                   
                # ---------------------------------------------------------------------------------------------
                # SMART SHOOTING (+X,+Y,+Z) - EAST, SOUTH, TOWARDS                 
                # ---------------------------------------------------------------------------------------------  
                print("\n (STEP 24A/33) OF TEST_BALL4XI - TRYING SMART SHOOTING (+X,+Y,+Z) - EAST, SOUTH, TOWARDS")   
                
                try:        

                    # =============================================================================================                   
                    # INITIALIZATIONS
                    # =============================================================================================                
      
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    ball2xi = Ball4Xi(message2ball = name2xi)

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                        
                    start2distance = 100
                    print("\n (STEP 24B1/33) OF TEST_BALL4XI - DISTANCE: ", d2shot)   

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                     
                    interval2distance = 100  
                    print("\n (STEP 24B2/33) OF TEST_BALL4XI - INTERVAL TO DISTANCE: ", interval2distance)   
                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    max2layer = 100                          
                    marginal2layer = 1.2
                    omax2layer = max2layer
                    max2layer = int(marginal2layer * max2layer)
                    print("\n (STEP 24B3/33) OF TEST_BALL4XI - MAXIMUM SHOTS PER LAYER: ", max2layer, " MARGINAL TO LAYER: ", marginal2layer) 
                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    max2count = 100
                    marginal2count = 1.2
                    omax2count = max2count
                    max2count = int(marginal2count * max2count)
                            
                    print("\n (STEP 24B4/33) OF TEST_BALL4XI - MAXIMUM SHOTS: ", max2count, " MARGINAL TO COUNT: ", marginal2count) 
                    if max2count > 1000:
                        trace2set = False # <-- turn trace off with a large max !

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                    
                    time2start = time4xi()                        
                    print("\n (STEP 24B5/33) OF TEST_BALL4XI - START TIME: ", time2start) 
                                                                                            
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # required signs for (x,y,z)
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    
                    # (+X,+Y,+Z)
                    sign2x = '+'    
                    sign2y = '+'
                    sign2z = '+'
                    print("\n (STEP 24B6/33) OF TEST_BALL4XI - X-SIGN: ", sign2x, 'Y-SIGN: ', sign2y, 'Z-SIGN: ', sign2z) 
                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                    
                    max2iterate = 1500     # 1000 gave only 87 !
                    print("\n (STEP 24B7/33) OF TEST_BALL4XI - MAXIMUM TO ITERATIONS: ", max2iterate) 
                    if max2iterate > 1000:
                        trace2set = False # <-- turn trace off with a large max !  
                                          
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # azimuth and elevation angle initialized
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # ref: http://en.wikipedia.org/wiki/Radian#Conversion_between_radians_and_degrees
                    # one radian is equal to 180/p degrees <=> 1 deg = rad * 180 / pi                             
                    # pi/6 = 30, pi/4 = 45, pi/3 = 60, pi/2 = 90, 2/3*pi = 120, 3/4pi=135, 5/6*pi = 150, pi = 180
                    # 7/6*pi = 210, 5/4*pi = 225...3*pi/2 = 270, 5*pi/3 = 300 ... 2*pi = 0 or 360 degrees
                    # I   = 0...90    (0...pi/2) :     sin+, cos+
                    # II  = 90...180  (pi/2...pi):     sin+, cos- 
                    # III = 180...270 (pi...3*pi/2):   sin-, cos-
                    # IV  = 270...360 (3*pi/2...2*pi): sin-, cos+
                    # ref: http://en.wikipedia.org/wiki/Azimuth

                    # =============================================================================================                   
                    # AZIMUTH
                    # =============================================================================================                
                                                                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                    start2plusa = pi/6                          # start plus azimuth 30 degrees - iterates smaller                                                           
                    print("\n (STEP 24B8/33) OF TEST_BALL4XI - START2PLUSA: ", start2plusa) 
                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
                    max2plusa = 2*pi                            # extreme plus azimuth 360 degrees around sideways
                    print("\n (STEP 24B8/33) OF TEST_BALL4XI - MAX2PLUSA: ", max2plusa) 

                                                                        
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
                    min2plusa = pi/240                          # minum positive azimuth 0.75 degrees sideways 
                    print("\n (STEP 24B8/33) OF TEST_BALL4XI - MIN2PLUSA: ", min2plusa) 
                                                          
                                              
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                    start2minusa = -pi/6                        # start minus azimuth -30 degrees sideways                                                           
                    print("\n (STEP 24B8/33) OF TEST_BALL4XI - START2MINUSA: ", start2minusa) 
                                  
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
                    max2minusa = -0.98*2*pi                     # extreme minus azimuth almost -360 degrees 
                    print("\n (STEP 24B8/33) OF TEST_BALL4XI - MAX2MINUSA: ", max2minusa) 
                                                                            
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
                    min2minusa = -pi/240                        # nearest to zero minus to azimuth
                    print("\n (STEP 24B8/33) min2minusa: ", min2minusa) 
                                                                    
                    # =============================================================================================                   
                    # ELEVATION
                    # =============================================================================================                
                                                      
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                    start2pluse = pi/6                          # start plus elevation 30 degrees up 
                    print("\n (STEP 24B8/33) OF TEST_BALL4XI - START2PLUSE: ", start2pluse) 
                                                          
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
                    max2pluse = pi                              # most flexible elevation 180 degrees 
                    print("\n (STEP 24B8/33) OF TEST_BALL4XI - MAX2PLUSE: ", max2pluse) 
                                      
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
                    min2pluse = pi/240                          # lowest plus to elevation 0.75 degrees                          
                    print("\n (STEP 24B8/33) OF TEST_BALL4XI - MIN2PLUSE: ", min2pluse) 
                                                   
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                    start2minuse = -pi/6                        # start minus elevation -30 degrees down                                                
                    print("\n (STEP 24B8/33) OF TEST_BALL4XI - START2MINUSE: ", start2minuse) 
                  
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
                    max2minuse = -0.98*pi                       # most painful minus elevation almost -180 degrees
                    print("\n (STEP 24B8/33) OF TEST_BALL4XI - MAX2MINUSE: ", max2minuse) 
                                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
                    min2minuse = -pi/240                        # least painful minus elevation -0.75 degrees                              
                    print("\n (STEP 24B8/33) OF TEST_BALL4XI - MIN2MINUSE: ", min2minuse) 
                                                         
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # increments for algorithm 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    increase2distance = 0                       # zero with laeyrs, only new layer increases
                    print("\n (STEP 24B8/33) OF TEST_BALL4XI - INCREASE2DISTANCE: ", increase2distance) 
                                                         
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # increments for algorithm 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    change2a = pi / 60                          # 3 degrees change to azimuth
                    print("\n (STEP 24B8/33) OF TEST_BALL4XI -CHANGE2A: ", change2a) 
                                                         
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # increments for algorithm 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    change2e = pi / 60                          # 3 degrees change to elevation
                    print("\n (STEP 24B8/33) OF TEST_BALL4XI - CHANGE2E: ", change2e) 
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # azimuth settings based on sign, which might get tuned to opposite sign later on
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    sign2a = '+'

                    if sign2a == '+':
                        start2a = start2plusa
                        min2a = min2plusa
                        max2a = max2plusa
                    else:
                        start2a = start2minusa
                        min2a = min2minusa
                        max2a = max2minusa
                        
                    print("\n (STEP 24B9/33) OF TEST_BALL4XI - START AZIMUTH: ", start2a, 'MIN AZIMUTH: ', min2a, 'MAX AZIMUTH: ', max2a) 
                    
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # elevation values used based on sign
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    sign2e = '+'

                    if sign2e == '+':
                        start2e = start2pluse
                        min2e = min2pluse
                        max2e = max2pluse
                    else:
                        start2e = start2minuse
                        min2e = min2minuse
                        max2e = max2minuse
                        
                    print("\n (STEP 24B10/33) OF TEST_BALL4XI - START ELEVATION: ", start2e, 'MIN ELEVATION: ', min2e, 'MAX ELEVATION: ', max2e) 
                    
                  
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # azimuth start setting
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                              
                    a2shot = start2a 
                    
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # elevation start setting
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                              
                    e2shot = start2e                            
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # distance start setting
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                          
                    d2shot = start2distance
            
                                  
                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # initializations for while loop 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    count2layer = 1                                  # layers                                                           
                    
                    count2ok = 0                                     # ok shots with all of (x,y,z) ok 
                    
                    count2distance = 0                               # for none layers when distance increased                        
                    
                    count2iterate = 0                                # hunt for right (x,y,z) combination
                    
                    count2rejected = 0                               # rejected
                  
                    ack2x = False                                    # validation for x-coordinate
                    nack2x = True
                    
                    ack2y = False                                    # validation for y-coordinate
                    nack2y = True                    
                    
                    ack2z = False                                    # validation for z-coordinate
                    nack2z = True
                    
                    ack2layer = False                                # validation for layer
                    nack2layer = True                    
                    
                    print("\n (STEP 24F/33) OF TEST_BALL4XI - START TIME OF SHOOTING: ", time4xi(), " FOR ", max2count, " SHOTS") 
                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                                             
                    while ((count2ok <= max2count) and (count2iterate < max2iterate)   
                           and (ack2layer is False)): 
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # 
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        count2iterate = count2iterate + 1    
                        
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # distance
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        d2shot = d2shot + increase2distance                          # remains the same for a laeyr
                        
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # azimuth changes
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        if a2shot >= 0:        
                            a2shot = a2shot + change2a
                            if a2shot >= max2a:
                                start2a = start2a * 1.01
                                a2shot = start2a 
                                print("\n (STEP 24G/33) OF TEST_BALL4XI - AZIMUTH BECAME BIGGER THAN MAXIMUM: ", max2a , " NEW AZIMUTH: ", a2shot)    
                        else:
                            a2shot = a2shot - change2a
                            if a2shot <= min2a:
                                start2a = start2a * 1.01
                                a2shot = start2a  
                                print("\n (STEP 24H/33) OF TEST_BALL4XI - AZIMUTH BECAME SMALLER THAN MINIMUM: ", min2a , " NEW AZIMUTH: ", a2shot)  
                                
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # azimuth algoritm checking against maximum allowed - restart with tuning, if necessary
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                        if (a2shot >= 2*pi):
                            sign2a = '-'                                             # switch to negative
                            change2a = 0.98 * change2a                               # change2a always positive
                            start2a = change2a * start2minusa                        # new minus azimuth start
                            a2shot = start2a                                         # new azimuth
                            min2a = min2minusa                                       # new minimum to azimuth
                            max2a = max2minusa                                       # new maximum to azimuth
                            print("\n (STEP 24I/33) OF TEST_BALL4XI - AZIMUTH BECAME BIGGER THAN 2*PI , NEW AZIMUTH: ", a2shot) 

                            
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # azimuth algoritm checking against minimum allowed- restart with tuning, if necessary
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                             
                        if (a2shot <= -2*pi):
                            sign2a = '+'                                             # switch to positive
                            change2a = 0.98 * change2a                               # change2a always positive
                            start2a = change2a * start2plusa                         # new positive azimuth start
                            a2shot = start2a                                         # new azimuth
                            min2a = min2plusa                                        # new minimum to azimuth
                            max2a = max2plusa                                        # new maximum to azimuth
                            print("\n (STEP 24J/33) OF TEST_BALL4XI - AZIMUTH BECAME LESS THAN -2*PI, NEW AZIMUTH: ", a2shot) 

                        
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # elevation changes
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        if e2shot <= 0:
                            e2shot = e2shot - increase2e
                            if e2shot <= min2e:
                                change2e = 1.02 * change2e
                                start2e = change2e * start2e
                                e2shot = start2e
                                print("\n (STEP 24K/33) OF TEST_BALL4XI - ELEVATION BECAME LESS THAN MINIMUM: ", min2e, " NEW ELEVATION: ", e2shot)                                   
                        else:
                            e2shot = e2shot + increase2e
                            if e2shot >= max2e:
                                change2e = 1.08 * change2e
                                start2e = change2e * start2e
                                e2shot = start2e
                                print("\n (STEP 24L/33) OF TEST_BALL4XI - ELEVATION BECAME BIGGER THAN MAXIMUM: ", max2e, " NEW ELEVATION: ", e2shot)  
                                                                      
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # elevation algoritm checking against maximum allowed - restart with tuning, if necessary
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                                                   
                        if (e2shot >= pi):
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # start again with a new elevation and new elevation change
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            sign2e = '-'                                             # switch to negative
                            change2e = 0.98 * change2e                               # change2e always positive
                            start2e = change2e * start2minuse                        # new minus elevation start
                            e2shot = start2e                                         # new azimuth
                            min2e = min2minuse                                       # new minimum to elevation
                            max2e = max2minuse                                       # new maximum to elevation
                            print("\n (STEP 24M/33) OF TEST_BALL4XI - ELEVATION BECAME BIGGER THAN PI, NEW ELEVATION: ", e2shot)
                            

                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # elevation algoritm checking against minimum allowed- restart with tuning, if necessary
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
                        
                        if (e2shot <= -pi):
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # start again with a new elevation and new elevation change
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                            
                            sign2e = '+'                                             # switch to positive
                            change2e = 0.98 * change2e                               # change2e always positive
                            start2e = change2e * start2pluse                         # new positive elevation start
                            e2shot = start2e                                         # new azimuth
                            min2e = min2pluse                                        # new minimum to elevation
                            max2e = max2pluse                                        # new maximum to elevation        
                            print("\n (STEP 24N/33) OF TEST_BALL4XI - ELEVATION BECAME LESS THAN -PI, NEW ELEVATION: ", e2shot)
                            

                            
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # shoot
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                                               
                        ball2xi.set(azimuth2shot = a2shot, elevation2shot = e2shot, distance2shot = d2shot, area2shot = int(4*pi*d2shot**2/interval2distance))
                        
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # check shot 
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        shot2examine = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes', area2shot = 'Yes')
                        print("\n (STEP 24OA/33) OF TEST_BALL4XI - SHOT TO EXAMINE ", count2shot, ": ", shot2examine)  
                        # {'42x27y86z': {'x2shot': 42, 'azimuth2shot': 0.5759586531581287, 'area2shot': 1256, 'id2shot': '42x27y86z', 'distance2shot': 100, 'z2shot': 86, 'elevation2shot': 0.5335987755982988, 'y2shot': 27}}
                         
                        keys2examine = shot2examine.keys()
                        print("\n (STEP 24OB1/33) OF TEST_BALL4XI - KEYS2EXAMINE: ", keys2examine)   
                        # dict_keys(['42x27y86z'])
                        
                        for key2examine in sorted(keys2examine):
                            print("\n (STEP 24OB2/33) OF TEST_BALL4XI - KEY2EXAMINE ", key2examine)  
                            # 42x27y86z
                            
                            ack2x = False 
                            nack2x = True                                  
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # X OK ?
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                            try:
                                index2x=str.find(key2examine,'x')                               
                                x2coordinate = int(key2examine[0:index2x])
                                if x2coordinate >= 0:
                                    if sign2x == '+':
                                        ack2x = True
                                        nack2x = False
                                        print("\n (STEP 24OB3/33/33) OF TEST_BALL4XI - X2COORDINATE ACK: ", ack2x) 
                                else:
                                    if sign2x == '-':
                                        ack2x = True
                                        nack2x = False
                                        print("\n (STEP 24OB4/33/33) OF TEST_BALL4XI - X2COORDINATE ACK: ", ack2x)
                                         
                            except:
                                print("\n (STEP 24B5/33) OF TEST_BALL4XI *** FAILED  WITH KEY2EXAMINE: ", key2examine)
                                print("\n (STEP 24B5/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                                
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # Y OK ?
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
                            ack2y = False 
                            nack2y = True     
                            try:
                                index2y=str.find(key2examine,'y')                               
                                y2coordinate = int(key2examine[index2x+1:index2y])
                                if y2coordinate >= 0:
                                    if sign2y == '+':
                                        ack2y = True
                                        nack2y = False
                                        print("\n (STEP 24OB6/33) OF TEST_BALL4XI - Y2COORDINATE ACK: ", ack2y)                                         
                                else:
                                    if sign2y == '-':
                                        ack2y = True
                                        nack2y = False
                                        print("\n (STEP 24OB7/33) OF TEST_BALL4XI - Y2COORDINATE ACK: ", ack2y)                               
                            except:
                                print("\n (STEP 24OB8/33) OF TEST_BALL4XI *** FAILED  WITH KEY2EXAMINE: ", key2examine)
                                print("\n (STEP 24OB8/33) OF TEST_BALL4XI - INDEX2Y: ", index2y)
                                
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # Z OK ?
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
                            ack2z = False 
                            nack2z = True                                 
                            try:
                                index2z=str.find(key2examine,'z')                               
                                z2coordinate = int(key2examine[index2y+1:index2z])
                                if z2coordinate >= 0:
                                    if sign2z == '+':
                                        ack2z = True
                                        nack2z = False
                                        print("\n (STEP 24OB9/33) OF TEST_BALL4XI - Z2COORDINATE ACK: ", ack2z)                                               
                                else:
                                    if sign2z == '-':
                                        ack2z = True
                                        nack2z = False
                                        print("\n (STEP 24OB10/33) OF TEST_BALL4XI - Z2COORDINATE ACK: ", ack2z)                                  
                            except:
                                print("\n (STEP 24OB11/33) OF TEST_BALL4XI *** FAILED  WITH KEY2EXAMINE: ", key2examine)
                                print("\n (STEP 24OB11/33) OF TEST_BALL4XI - INDEX2Z: ", index2z)
                                
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # (X,Y,Z) OK ?
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
                            try:                                                           
                                if ((ack2x is True) and (ack2y is True) and (ack2z is True)):
                                    print("\n (STEP 24O5A/33) OF TEST_BALL4XI - OK: (" , x2coordinate, ",", y2coordinate, ",", z2coordinate, ")") 
                                    print("\n (STEP 24O5B/33) OF TEST_BALL4XI - EXPECTED: (" , sign2x, ",", sign2y, ",", sign2z, ")") 
                                    count2ok = count2ok + 1 
                                    if count2ok >= max2layer:
                                        ack2layer = True
                                        print("\n (STEP 24O6/33) OF TEST_BALL4XI - ACK2LAYER: " , ack2layer)
                                    else:
                                        ack2layer = False
                                else:
                                    print("\n (STEP 24O8A/33) OF TEST_BALL4XI - REJECTED: (" , x2coordinate, ",", y2coordinate, ",", z2coordinate, ")")
                                    print("\n (STEP 24O8B/33) OF TEST_BALL4XI - EXPECTED: (" , sign2x, ",", sign2y, ",", sign2z, ")")
                                    
                                    count2rejected = count2rejected + 1
                                    ack2layer = False 
                                    # ( 42 , 27 , 86 )
                                    # ( + , + , - )  
                                    
                                    print("\n (STEP 24O8C/33) OF TEST_BALL4XI *** REMEMBER TO DELETE THE SHOT OR LET IT BE AND RETURN ONLY OK SHOTS!!!! *** ")
                                    
                                                        
                            except:
                                print("\n (STEP 24O9/33) OF TEST_BALL4XI *** FAILED  WITH KEY2EXAMINE: ", key2examine)
                                print("\n (STEP 24O9/33) OF TEST_BALL4XI - INDEX2Z: ", index2z)
                        
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # CONTINUE WHILE
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                    

                        print("\n (STEP 24O10/33) OF TEST_BALL4XI - CONTINUING WHILE WITH:")
                        print("\n count2ok:", count2ok)
                        print("\n max2count:", max2count)                        
                        print("\n count2iterate:", count2iterate)
                        print("\n max2iterate:", max2iterate)                        
                        print("\n ack2layer:", ack2layer)                        
                        
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # CONTINUE WHILE
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                    
                                                                                                         
                        count2distance = count2distance + increase2distance  #stays the same when a layer is shot
                        if count2distance > max2layer:
                            d2shot = d2shot + interval2distance
                            count2distance = 0
                            count2layer = count2layer + 1 
                            print("\n (STEP 24O10/33) OF TEST_BALL4XI - NEW LAYER NUMBER: ", count2layer, ' NEW DISTANCE: ', d2shot)
                        else:
                            pass 
                               
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # end of while
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # EXAMINE RESULTS 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    time2end = time4xi()           
                    print("\n (STEP 24P1/33) OF TEST_BALL4XI - STATISTICS FOR SHOOTING, WHICH ENDED: ", time2end)                          
                    print("\n SHOTS OK: ", count2ok, " = ", int(100 * count2ok/max2count), " %")                              
                    print("\n SHOTS ORIGINALLY REQUIRED: ", omax2count)      
                    print("\n ITERATIONS NEEDED: ", count2iterate)                              
                    print("\n ITERATIONS ALLOWED: ", max2iterate) 
                    print("\n REJECTED: ", count2rejected, " = : ", int(100 * count2rejected/count2iterate), " %") 

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                           
                    print("\n (STEP 24Y1/33) OF TEST_BALL4XI - WHOLE BALL AFTER ALL OPERATIONS AND WITH MAX2COUNT: ", max2count, 'TIME PRINTED: ', time4xi())  
                    
                    ball2show = ball2xi.get()
                    dict2keys = ball2show.keys()
                    print("\n (STEP 24Y2/33) OF TEST_BALL4XI - KEYS2BALL: ", dict2keys)
                    # 
                    print("\n (STEP 24Y3/33) OF TEST_BALL4XI - SHOOTING SAMPLE OF : ", max2count, " SHOTS", "NUMBER OF LAYERS: ", count2layer, ' LATEST DISTANCE: ', d2shot, ' INTERVAL2DISTANCE: ', interval2distance)    
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    count2plusx = 0
                    count2plusy = 0
                    count2plusz = 0
                           
                    count2minusx = 0
                    count2minusy = 0
                    count2minusz = 0
                    
                    count2accepted = 0
                    count2rejected = 0
                    
                    order2key = 1
                    for key2dict in sorted(dict2keys):
                        try:
                            index2x=str.find(key2dict,'x')                               
                            x2coordinate = int(key2dict[0:index2x])
                            # print("\n (STEP 15L11/33/33) OF TEST_BALL4XI - X2COORDINATE: ",  x2coordinate)
                            if x2coordinate >= 0:
                                count2plusx = count2plusx + 1
                            else:
                                count2minusx = count2minusx + 1    
                        except:
                            print("\n (STEP 24Y4/33) OF TEST_BALL4XI *** FAILED  WITH KEY2DICT: ", key2dict)
                            print("\n (STEP 24Y5/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            
                            
                        try:                                   
                            index2y=str.find(key2dict,'y')
                            y2coordinate = int(key2dict[index2x+1:index2y])
                            # print("\n (STEP 15L11/33) OF TEST_BALL4XI - Y2COORDINATE: ",  y2coordinate)
                            if y2coordinate >= 0:
                                count2plusy = count2plusy + 1
                            else:
                                count2minusy = count2minusy + 1  
                        except:
                            print("\n (STEP 24Y6/33) OF TEST_BALL4XI *** FAILED  WITH KEY2DICT: ", key2dict) 
                            print("\n (STEP 24Y7/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            print("\n (STEP 24Y8/33) OF TEST_BALL4XI - INDEX2Y: ", index2y)
                        
                        try:                                                                         
                            index2z=str.find(key2dict,'z') 
                            z2coordinate = int(key2dict[index2y+1:index2z])
                            # print("\n (STEP 24V/33) OF TEST_BALL4XI - Z2COORDINATE: ",  z2coordinate)
                            if z2coordinate >= 0:
                                count2plusz = count2plusz + 1
                            else:
                                count2minusz = count2minusz + 1
                        except:
                            print("\n (STEP 24Y9/33) OF TEST_BALL4XI *** FAILED  WITH KEY2DICT: ", key2dict)
                            print("\n (STEP 24Y10/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            print("\n (STEP 24Y11/33) OF TEST_BALL4XI - INDEX2Y: ", index2y)
                            print("\n (STEP 24Y12/33) OF TEST_BALL4XI - INDEX2Z: ", index2z)
                        
                        ack2x = False    
                        if ((x2coordinate >= 0) and (sign2x == '+')):
                            ack2x = True
                        if ((x2coordinate <= 0) and (sign2x == '-')):
                            ack2x = True                        
                        
                        ack2y = False    
                        if ((y2coordinate >= 0) and (sign2y == '+')):
                            ack2y = True
                        if ((y2coordinate <= 0) and (sign2y == '-')):
                            ack2y = True     
                        
                        ack2z = False    
                        if ((z2coordinate >= 0) and (sign2z == '+')):
                            ack2z = True
                        if ((z2coordinate <= 0) and (sign2z == '-')):
                            ack2z = True     
                        
                        if ((ack2x is True) and (ack2y is True) and (ack2z is True)):
                            count2accepted = count2accepted + 1                                                                                                      
                            print("\n ACCEPTANCE: ", count2accepted, " SHOT: ", order2key, ":", key2dict, " EXPECTED SIGNS: (" , sign2x, ",", sign2y, ",", sign2z, ")") 
                            
                        else:
                            count2rejected = count2rejected + 1
                            # print("\n REJECTION: ", count2rejected, " SHOT ", order2key, ":", key2dict, " EXPECTED SIGNS: (" , sign2x, ",", sign2y, ",", sign2z, ")")   
                                                        
                        order2key = order2key +1 

                    count2tried = count2accepted + count2rejected 
                    
                    sum2plus = count2plusx + count2plusy+ count2plusz
                    sum2minus = count2minusx + count2minusy+ count2minusz
                    sum2total = count2plusx + count2minusx # same also with y and z - coordinate exists only once
                            
                    print('=' *80)
                    print("\n (STEP 24Y15/33) OF TEST_BALL4XI - STATISTICS FOR REQUIRED: ", max2count, " SHOTS")  
                    print("\n START TIME: ", time2start)
                    print("\n ACCEPTED: ", count2accepted, " = ", int(100*count2accepted/order2key), " %")
                    print("\n REJECTED: ", count2rejected, " = ", int(100*count2rejected/order2key), " %")
                   
                    print("\n DISTIBUTION OF X, Y AND Z: ") 
                    print("\n +X: ", count2plusx, " = ", int(100*count2plusx/sum2total), " %")
                    print("\n -X: ", count2minusx, " = ", int(100*count2minusx/sum2total), " %") 
                   
                    print("\n +Y: ", count2plusy, " = ", int(100*count2plusy/sum2total), " %")
                    print("\n -Y: ", count2minusy, " = ", int(100*count2minusy/sum2total), " %") 
                   
                    print("\n +Z: ", count2plusz, " = ", int(100*count2plusz/sum2total), " %")
                    print("\n -Z: ", count2minusz, " = ", int(100*count2minusz/sum2total), " %") 
                              
                    
                    print("\n SUM2TOTAL: ", sum2total, "SUCCESS-RATIO: ", int(100*count2accepted/max2count), " %", " COUNT2LAYER: ", count2layer)
                    print("\n START2DISTANCE: ", start2distance, " INTERVAL2DISTANCE: ", interval2distance, " MAX2LAYER: ", max2layer, " MAX2COUNT : ", max2count)
                    print("\n EXPECTED COORDINATE SIGNS: (X: "  , sign2x, ",Y", sign2y, ",Z", sign2z, ")") 
                    
                    print("\n REASONING: ")
                    if count2accepted >= omax2count:
                        print("\n OK SHOOTING: ACCEPTED SHOTS ", count2accepted, " >= ", omax2count, " ORIGINALLY REQUIRED, MARIGINAL: ", marginal2count)
                    else:
                        print("\n *** FAILED SHOOTING: ACCEPTED SHOT ONLY: ", count2accepted, " < ", omax2count, " REQUIRED !")                                    
                    
                    print("\n END TIME: ", time2end)
                    print('=' *80)

                    # ================================================================================
                    #  (STEP 24Y15/33) OF TEST_BALL4XI - STATISTICS FOR REQUIRED:  120  SHOTS
                    #  START TIME:  05:22:56 06/04/10 Pacific Daylight Time
                    #  ACCEPTED:  117  =  9  %
                    #  REJECTED:  1097  =  90  %
                    #  DISTIBUTION OF X, Y AND Z: 
                    #  +X:  571  =  47  %
                    #  -X:  643  =  52  %
                    #  +Y:  575  =  47  %
                    #  -Y:  639  =  52  %
                    #  +Z:  598  =  49  %
                    #  -Z:  616  =  50  %
                    #  SUM2TOTAL:  1214 SUCCESS-RATIO:  97  %  COUNT2LAYER:  1
                    #  START2DISTANCE:  100  INTERVAL2DISTANCE:  100  MAX2LAYER:  120  MAX2COUNT :  120
                    #  EXPECTED COORDINATE SIGNS: (X:  + ,Y + ,Z + )
                    #  REASONING: 
                    #  OK SHOOTING: ACCEPTED SHOTS  117  >=  100  ORIGINALLY REQUIRED, MARIGINAL:  1.2
                    #  END TIME:  05:23:21 06/04/10 Pacific Daylight Time
                    # ================================================================================                    
                except:
                    # -------------------------------------------------------------------------------------    
                    #
                    # -------------------------------------------------------------------------------------     
                    print("\n (STEP 24Z/33) OF TEST_BALL4XI *** FAILED TO SHOOT (+X,+Y,+Z) - EAST, SOUTH, TOWARDS")
                    
                                                                                  
                # ---------------------------------------------------------------------------------------------
                # SMART SHOOTING (-X,+Y,+Z) - WEST, SOUTH, TOWARDS                  
                # ---------------------------------------------------------------------------------------------                                                               
                print("\n (STEP 25A/33) OF TEST_BALL4XI - TRYING SMART SHOOTING (-X,+Y,+Z) - WEST, SOUTH, TOWARDS")   
                
                try:        

                    # =============================================================================================                   
                    # INITIALIZATIONS
                    # =============================================================================================                
      
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    ball2xi = Ball4Xi(message2ball = name2xi)

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                        
                    start2distance = 100
                    print("\n (STEP 25B1/33) OF TEST_BALL4XI - DISTANCE: ", d2shot)   

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                     
                    interval2distance = 100  
                    print("\n (STEP 25B2/33) OF TEST_BALL4XI - INTERVAL TO DISTANCE: ", interval2distance)   
                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    max2layer = 100                          
                    marginal2layer = 1.2
                    omax2layer = max2layer
                    max2layer = int(marginal2layer * max2layer)
                    print("\n (STEP 25B3/33) OF TEST_BALL4XI - MAXIMUM SHOTS PER LAYER: ", max2layer, " MARGINAL TO LAYER: ", marginal2layer) 
                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    max2count = 100
                    marginal2count = 1.2
                    omax2count = max2count
                    max2count = int(marginal2count * max2count)
                            
                    print("\n (STEP 25B4/33) OF TEST_BALL4XI - MAXIMUM SHOTS: ", max2count, " MARGINAL TO COUNT: ", marginal2count) 
                    if max2count > 1000:
                        trace2set = False # <-- turn trace off with a large max !

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                    
                    time2start = time4xi()                        
                    print("\n (STEP 25B5/33) OF TEST_BALL4XI - START TIME: ", time2start) 
                                                                                            
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # required signs for (x,y,z)
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    
                    # (-X,+Y,+Z) - WEST, SOUTH, TOWARDS
                    sign2x = '-'    
                    sign2y = '+'
                    sign2z = '+'
                    print("\n (STEP 25B6/33) OF TEST_BALL4XI - X-SIGN: ", sign2x, 'Y-SIGN: ', sign2y, 'Z-SIGN: ', sign2z) 
                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                    
                    max2iterate = 1500     # 1000 gave only 87 !
                    print("\n (STEP 25B7/33) OF TEST_BALL4XI - MAXIMUM TO ITERATIONS: ", max2iterate) 
                    if max2iterate > 1000:
                        trace2set = False # <-- turn trace off with a large max !  
                                          
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # azimuth and elevation angle initialized
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # ref: http://en.wikipedia.org/wiki/Radian#Conversion_between_radians_and_degrees
                    # one radian is equal to 180/p degrees <=> 1 deg = rad * 180 / pi                             
                    # pi/6 = 30, pi/4 = 45, pi/3 = 60, pi/2 = 90, 2/3*pi = 120, 3/4pi=135, 5/6*pi = 150, pi = 180
                    # 7/6*pi = 210, 5/4*pi = 225...3*pi/2 = 270, 5*pi/3 = 300 ... 2*pi = 0 or 360 degrees
                    # I   = 0...90    (0...pi/2) :     sin+, cos+
                    # II  = 90...180  (pi/2...pi):     sin+, cos- 
                    # III = 180...270 (pi...3*pi/2):   sin-, cos-
                    # IV  = 270...360 (3*pi/2...2*pi): sin-, cos+
                    # ref: http://en.wikipedia.org/wiki/Azimuth

                    # =============================================================================================                   
                    # AZIMUTH
                    # =============================================================================================                
                                                                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                    start2plusa = pi/6                          # start plus azimuth 30 degrees - iterates smaller                                                           
                    print("\n (STEP 25B8/33) OF TEST_BALL4XI - START2PLUSA: ", start2plusa) 
                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
                    max2plusa = 2*pi                            # extreme plus azimuth 360 degrees around sideways
                    print("\n (STEP 25B8/33) OF TEST_BALL4XI - MAX2PLUSA: ", max2plusa) 

                                                                        
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
                    min2plusa = pi/240                          # minum positive azimuth 0.75 degrees sideways 
                    print("\n (STEP 25B8/33) OF TEST_BALL4XI - MIN2PLUSA: ", min2plusa) 
                                                          
                                              
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                    start2minusa = -pi/6                        # start minus azimuth -30 degrees sideways                                                           
                    print("\n (STEP 25B8/33) OF TEST_BALL4XI - START2MINUSA: ", start2minusa) 
                                  
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
                    max2minusa = -0.98*2*pi                     # extreme minus azimuth almost -360 degrees 
                    print("\n (STEP 25B8/33) OF TEST_BALL4XI - MAX2MINUSA: ", max2minusa) 
                                                                            
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
                    min2minusa = -pi/240                        # nearest to zero minus to azimuth
                    print("\n (STEP 25B8/33) min2minusa: ", min2minusa) 
                                                                    
                    # =============================================================================================                   
                    # ELEVATION
                    # =============================================================================================                
                                                      
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                    start2pluse = pi/6                          # start plus elevation 30 degrees up 
                    print("\n (STEP 25B8/33) OF TEST_BALL4XI - START2PLUSE: ", start2pluse) 
                                                          
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
                    max2pluse = pi                              # most flexible elevation 180 degrees 
                    print("\n (STEP 25B8/33) OF TEST_BALL4XI - MAX2PLUSE: ", max2pluse) 
                                      
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
                    min2pluse = pi/240                          # lowest plus to elevation 0.75 degrees                          
                    print("\n (STEP 25B8/33) OF TEST_BALL4XI - MIN2PLUSE: ", min2pluse) 
                                                   
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                    start2minuse = -pi/6                        # start minus elevation -30 degrees down                                                
                    print("\n (STEP 25B8/33) OF TEST_BALL4XI - START2MINUSE: ", start2minuse) 
                  
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
                    max2minuse = -0.98*pi                       # most painful minus elevation almost -180 degrees
                    print("\n (STEP 25B8/33) OF TEST_BALL4XI - MAX2MINUSE: ", max2minuse) 
                                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
                    min2minuse = -pi/240                        # least painful minus elevation -0.75 degrees                              
                    print("\n (STEP 25B8/33) OF TEST_BALL4XI - MIN2MINUSE: ", min2minuse) 
                                                         
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # increments for algorithm 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    increase2distance = 0                       # zero with laeyrs, only new layer increases
                    print("\n (STEP 25B8/33) OF TEST_BALL4XI - INCREASE2DISTANCE: ", increase2distance) 
                                                         
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # increments for algorithm 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    change2a = pi / 60                          # 3 degrees change to azimuth
                    print("\n (STEP 25B8/33) OF TEST_BALL4XI -CHANGE2A: ", change2a) 
                                                         
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # increments for algorithm 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    change2e = pi / 60                          # 3 degrees change to elevation
                    print("\n (STEP 25B8/33) OF TEST_BALL4XI - CHANGE2E: ", change2e) 
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # azimuth settings based on sign, which might get tuned to opposite sign later on
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    sign2a = '+'

                    if sign2a == '+':
                        start2a = start2plusa
                        min2a = min2plusa
                        max2a = max2plusa
                    else:
                        start2a = start2minusa
                        min2a = min2minusa
                        max2a = max2minusa
                        
                    print("\n (STEP 25B9/33) OF TEST_BALL4XI - START AZIMUTH: ", start2a, 'MIN AZIMUTH: ', min2a, 'MAX AZIMUTH: ', max2a) 
                    
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # elevation values used based on sign
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    sign2e = '+'

                    if sign2e == '+':
                        start2e = start2pluse
                        min2e = min2pluse
                        max2e = max2pluse
                    else:
                        start2e = start2minuse
                        min2e = min2minuse
                        max2e = max2minuse
                        
                    print("\n (STEP 25B10/33) OF TEST_BALL4XI - START ELEVATION: ", start2e, 'MIN ELEVATION: ', min2e, 'MAX ELEVATION: ', max2e) 
                    
                  
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # azimuth start setting
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                              
                    a2shot = start2a 
                    
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # elevation start setting
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                              
                    e2shot = start2e                            
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # distance start setting
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                          
                    d2shot = start2distance
            
                                  
                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # initializations for while loop 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    count2layer = 1                                  # layers                                                           
                    
                    count2ok = 0                                     # ok shots with all of (x,y,z) ok 
                    
                    count2distance = 0                               # for none layers when distance increased                        
                    
                    count2iterate = 0                                # hunt for right (x,y,z) combination
                    
                    count2rejected = 0                               # rejected
                  
                    ack2x = False                                    # validation for x-coordinate
                    nack2x = True
                    
                    ack2y = False                                    # validation for y-coordinate
                    nack2y = True                    
                    
                    ack2z = False                                    # validation for z-coordinate
                    nack2z = True
                    
                    ack2layer = False                                # validation for layer
                    nack2layer = True                    
                    
                    print("\n (STEP 25F/33) OF TEST_BALL4XI - START TIME OF SHOOTING: ", time4xi(), " FOR ", max2count, " SHOTS") 
                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                                             
                    while ((count2ok <= max2count) and (count2iterate < max2iterate)   
                           and (ack2layer is False)): 
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # 
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        count2iterate = count2iterate + 1    
                        
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # distance
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        d2shot = d2shot + increase2distance                          # remains the same for a laeyr
                        
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # azimuth changes
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        if a2shot >= 0:        
                            a2shot = a2shot + change2a
                            if a2shot >= max2a:
                                start2a = start2a * 1.01
                                a2shot = start2a 
                                print("\n (STEP 25G/33) OF TEST_BALL4XI - AZIMUTH BECAME BIGGER THAN MAXIMUM: ", max2a , " NEW AZIMUTH: ", a2shot)    
                        else:
                            a2shot = a2shot - change2a
                            if a2shot <= min2a:
                                start2a = start2a * 1.01
                                a2shot = start2a  
                                print("\n (STEP 25H/33) OF TEST_BALL4XI - AZIMUTH BECAME SMALLER THAN MINIMUM: ", min2a , " NEW AZIMUTH: ", a2shot)  
                                
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # azimuth algoritm checking against maximum allowed - restart with tuning, if necessary
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                        if (a2shot >= 2*pi):
                            sign2a = '-'                                             # switch to negative
                            change2a = 0.98 * change2a                               # change2a always positive
                            start2a = change2a * start2minusa                        # new minus azimuth start
                            a2shot = start2a                                         # new azimuth
                            min2a = min2minusa                                       # new minimum to azimuth
                            max2a = max2minusa                                       # new maximum to azimuth
                            print("\n (STEP 25I/33) OF TEST_BALL4XI - AZIMUTH BECAME BIGGER THAN 2*PI , NEW AZIMUTH: ", a2shot) 

                            
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # azimuth algoritm checking against minimum allowed- restart with tuning, if necessary
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                             
                        if (a2shot <= -2*pi):
                            sign2a = '+'                                             # switch to positive
                            change2a = 0.98 * change2a                               # change2a always positive
                            start2a = change2a * start2plusa                         # new positive azimuth start
                            a2shot = start2a                                         # new azimuth
                            min2a = min2plusa                                        # new minimum to azimuth
                            max2a = max2plusa                                        # new maximum to azimuth
                            print("\n (STEP 25J/33) OF TEST_BALL4XI - AZIMUTH BECAME LESS THAN -2*PI, NEW AZIMUTH: ", a2shot) 

                        
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # elevation changes
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        if e2shot <= 0:
                            e2shot = e2shot - increase2e
                            if e2shot <= min2e:
                                change2e = 1.02 * change2e
                                start2e = change2e * start2e
                                e2shot = start2e
                                print("\n (STEP 25K/33) OF TEST_BALL4XI - ELEVATION BECAME LESS THAN MINIMUM: ", min2e, " NEW ELEVATION: ", e2shot)                                   
                        else:
                            e2shot = e2shot + increase2e
                            if e2shot >= max2e:
                                change2e = 1.08 * change2e
                                start2e = change2e * start2e
                                e2shot = start2e
                                print("\n (STEP 25L/33) OF TEST_BALL4XI - ELEVATION BECAME BIGGER THAN MAXIMUM: ", max2e, " NEW ELEVATION: ", e2shot)  
                                                                      
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # elevation algoritm checking against maximum allowed - restart with tuning, if necessary
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                                                   
                        if (e2shot >= pi):
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # start again with a new elevation and new elevation change
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            sign2e = '-'                                             # switch to negative
                            change2e = 0.98 * change2e                               # change2e always positive
                            start2e = change2e * start2minuse                        # new minus elevation start
                            e2shot = start2e                                         # new azimuth
                            min2e = min2minuse                                       # new minimum to elevation
                            max2e = max2minuse                                       # new maximum to elevation
                            print("\n (STEP 25M/33) OF TEST_BALL4XI - ELEVATION BECAME BIGGER THAN PI, NEW ELEVATION: ", e2shot)
                            

                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # elevation algoritm checking against minimum allowed- restart with tuning, if necessary
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
                        
                        if (e2shot <= -pi):
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # start again with a new elevation and new elevation change
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                            
                            sign2e = '+'                                             # switch to positive
                            change2e = 0.98 * change2e                               # change2e always positive
                            start2e = change2e * start2pluse                         # new positive elevation start
                            e2shot = start2e                                         # new azimuth
                            min2e = min2pluse                                        # new minimum to elevation
                            max2e = max2pluse                                        # new maximum to elevation        
                            print("\n (STEP 25N/33) OF TEST_BALL4XI - ELEVATION BECAME LESS THAN -PI, NEW ELEVATION: ", e2shot)
                            

                            
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # shoot
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                                               
                        ball2xi.set(azimuth2shot = a2shot, elevation2shot = e2shot, distance2shot = d2shot, area2shot = int(4*pi*d2shot**2/interval2distance))
                        
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # check shot 
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        shot2examine = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes', area2shot = 'Yes')
                        print("\n (STEP 25OA/33) OF TEST_BALL4XI - SHOT TO EXAMINE ", count2shot, ": ", shot2examine)  
                        # {'42x27y86z': {'x2shot': 42, 'azimuth2shot': 0.5759586531581287, 'area2shot': 1256, 'id2shot': '42x27y86z', 'distance2shot': 100, 'z2shot': 86, 'elevation2shot': 0.5335987755982988, 'y2shot': 27}}
                         
                        keys2examine = shot2examine.keys()
                        print("\n (STEP 25OB1/33) OF TEST_BALL4XI - KEYS2EXAMINE: ", keys2examine)   
                        # dict_keys(['42x27y86z'])
                        
                        for key2examine in sorted(keys2examine):
                            print("\n (STEP 25OB2/33) OF TEST_BALL4XI - KEY2EXAMINE ", key2examine)  
                            # 42x27y86z
                            
                            ack2x = False 
                            nack2x = True                                  
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # X OK ?
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                            try:
                                index2x=str.find(key2examine,'x')                               
                                x2coordinate = int(key2examine[0:index2x])
                                if x2coordinate >= 0:
                                    if sign2x == '+':
                                        ack2x = True
                                        nack2x = False
                                        print("\n (STEP 25OB3/33/33) OF TEST_BALL4XI - X2COORDINATE ACK: ", ack2x) 
                                else:
                                    if sign2x == '-':
                                        ack2x = True
                                        nack2x = False
                                        print("\n (STEP 25OB4/33/33) OF TEST_BALL4XI - X2COORDINATE ACK: ", ack2x)
                                         
                            except:
                                print("\n (STEP 25B5/33) OF TEST_BALL4XI *** FAILED  WITH KEY2EXAMINE: ", key2examine)
                                print("\n (STEP 25B5/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                                
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # Y OK ?
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
                            ack2y = False 
                            nack2y = True     
                            try:
                                index2y=str.find(key2examine,'y')                               
                                y2coordinate = int(key2examine[index2x+1:index2y])
                                if y2coordinate >= 0:
                                    if sign2y == '+':
                                        ack2y = True
                                        nack2y = False
                                        print("\n (STEP 25OB6/33) OF TEST_BALL4XI - Y2COORDINATE ACK: ", ack2y)                                         
                                else:
                                    if sign2y == '-':
                                        ack2y = True
                                        nack2y = False
                                        print("\n (STEP 25OB7/33) OF TEST_BALL4XI - Y2COORDINATE ACK: ", ack2y)                               
                            except:
                                print("\n (STEP 25OB8/33) OF TEST_BALL4XI *** FAILED  WITH KEY2EXAMINE: ", key2examine)
                                print("\n (STEP 25OB8/33) OF TEST_BALL4XI - INDEX2Y: ", index2y)
                                
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # Z OK ?
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
                            ack2z = False 
                            nack2z = True                                 
                            try:
                                index2z=str.find(key2examine,'z')                               
                                z2coordinate = int(key2examine[index2y+1:index2z])
                                if z2coordinate >= 0:
                                    if sign2z == '+':
                                        ack2z = True
                                        nack2z = False
                                        print("\n (STEP 25OB9/33) OF TEST_BALL4XI - Z2COORDINATE ACK: ", ack2z)                                               
                                else:
                                    if sign2z == '-':
                                        ack2z = True
                                        nack2z = False
                                        print("\n (STEP 25OB10/33) OF TEST_BALL4XI - Z2COORDINATE ACK: ", ack2z)                                  
                            except:
                                print("\n (STEP 25OB11/33) OF TEST_BALL4XI *** FAILED  WITH KEY2EXAMINE: ", key2examine)
                                print("\n (STEP 25OB11/33) OF TEST_BALL4XI - INDEX2Z: ", index2z)
                                
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # (X,Y,Z) OK ?
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
                            try:                                                           
                                if ((ack2x is True) and (ack2y is True) and (ack2z is True)):
                                    print("\n (STEP 25O5A/33) OF TEST_BALL4XI - OK: (" , x2coordinate, ",", y2coordinate, ",", z2coordinate, ")") 
                                    print("\n (STEP 25O5B/33) OF TEST_BALL4XI - EXPECTED: (" , sign2x, ",", sign2y, ",", sign2z, ")") 
                                    count2ok = count2ok + 1 
                                    if count2ok >= max2layer:
                                        ack2layer = True
                                        print("\n (STEP 25O6/33) OF TEST_BALL4XI - ACK2LAYER: " , ack2layer)
                                    else:
                                        ack2layer = False
                                else:
                                    print("\n (STEP 25O8A/33) OF TEST_BALL4XI - REJECTED: (" , x2coordinate, ",", y2coordinate, ",", z2coordinate, ")")
                                    print("\n (STEP 25O8B/33) OF TEST_BALL4XI - EXPECTED: (" , sign2x, ",", sign2y, ",", sign2z, ")")
                                    
                                    count2rejected = count2rejected + 1
                                    ack2layer = False 
                                    # ( 42 , 27 , 86 )
                                    # ( + , + , - )  
                                    
                                    print("\n (STEP 25O8C/33) OF TEST_BALL4XI *** REMEMBER TO DELETE THE SHOT OR LET IT BE AND RETURN ONLY OK SHOTS!!!! *** ")
                                    
                                                        
                            except:
                                print("\n (STEP 25O9/33) OF TEST_BALL4XI *** FAILED  WITH KEY2EXAMINE: ", key2examine)
                                print("\n (STEP 25O9/33) OF TEST_BALL4XI - INDEX2Z: ", index2z)
                        
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # CONTINUE WHILE
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                    

                        print("\n (STEP 25O10/33) OF TEST_BALL4XI - CONTINUING WHILE WITH:")
                        print("\n count2ok:", count2ok)
                        print("\n max2count:", max2count)                        
                        print("\n count2iterate:", count2iterate)
                        print("\n max2iterate:", max2iterate)                        
                        print("\n ack2layer:", ack2layer)                        
                        
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # CONTINUE WHILE
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                    
                                                                                                         
                        count2distance = count2distance + increase2distance  #stays the same when a layer is shot
                        if count2distance > max2layer:
                            d2shot = d2shot + interval2distance
                            count2distance = 0
                            count2layer = count2layer + 1 
                            print("\n (STEP 25O10/33) OF TEST_BALL4XI - NEW LAYER NUMBER: ", count2layer, ' NEW DISTANCE: ', d2shot)
                        else:
                            pass 
                               
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # end of while
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # EXAMINE RESULTS 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    time2end = time4xi()           
                    print("\n (STEP 25P1/33) OF TEST_BALL4XI - STATISTICS FOR SHOOTING, WHICH ENDED: ", time2end)                          
                    print("\n SHOTS OK: ", count2ok, " = ", int(100 * count2ok/max2count), " %")                              
                    print("\n SHOTS ORIGINALLY REQUIRED: ", omax2count)      
                    print("\n ITERATIONS NEEDED: ", count2iterate)                              
                    print("\n ITERATIONS ALLOWED: ", max2iterate) 
                    print("\n REJECTED: ", count2rejected, " = : ", int(100 * count2rejected/count2iterate), " %") 

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                           
                    print("\n (STEP 25Y1/33) OF TEST_BALL4XI - WHOLE BALL AFTER ALL OPERATIONS AND WITH MAX2COUNT: ", max2count, 'TIME PRINTED: ', time4xi())  
                    
                    ball2show = ball2xi.get()
                    dict2keys = ball2show.keys()
                    print("\n (STEP 25Y2/33) OF TEST_BALL4XI - KEYS2BALL: ", dict2keys)
                    # 
                    print("\n (STEP 25Y3/33) OF TEST_BALL4XI - SHOOTING SAMPLE OF : ", max2count, " SHOTS", "NUMBER OF LAYERS: ", count2layer, ' LATEST DISTANCE: ', d2shot, ' INTERVAL2DISTANCE: ', interval2distance)    
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    count2plusx = 0
                    count2plusy = 0
                    count2plusz = 0
                           
                    count2minusx = 0
                    count2minusy = 0
                    count2minusz = 0
                    
                    count2accepted = 0
                    count2rejected = 0
                    
                    order2key = 1
                    for key2dict in sorted(dict2keys):
                        try:
                            index2x=str.find(key2dict,'x')                               
                            x2coordinate = int(key2dict[0:index2x])
                            # print("\n (STEP 15L11/33/33) OF TEST_BALL4XI - X2COORDINATE: ",  x2coordinate)
                            if x2coordinate >= 0:
                                count2plusx = count2plusx + 1
                            else:
                                count2minusx = count2minusx + 1    
                        except:
                            print("\n (STEP 25Y4/33) OF TEST_BALL4XI *** FAILED  WITH KEY2DICT: ", key2dict)
                            print("\n (STEP 25Y5/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            
                            
                        try:                                   
                            index2y=str.find(key2dict,'y')
                            y2coordinate = int(key2dict[index2x+1:index2y])
                            # print("\n (STEP 15L11/33) OF TEST_BALL4XI - Y2COORDINATE: ",  y2coordinate)
                            if y2coordinate >= 0:
                                count2plusy = count2plusy + 1
                            else:
                                count2minusy = count2minusy + 1  
                        except:
                            print("\n (STEP 25Y6/33) OF TEST_BALL4XI *** FAILED  WITH KEY2DICT: ", key2dict) 
                            print("\n (STEP 25Y7/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            print("\n (STEP 25Y8/33) OF TEST_BALL4XI - INDEX2Y: ", index2y)
                        
                        try:                                                                         
                            index2z=str.find(key2dict,'z') 
                            z2coordinate = int(key2dict[index2y+1:index2z])
                            # print("\n (STEP 25V/33) OF TEST_BALL4XI - Z2COORDINATE: ",  z2coordinate)
                            if z2coordinate >= 0:
                                count2plusz = count2plusz + 1
                            else:
                                count2minusz = count2minusz + 1
                        except:
                            print("\n (STEP 25Y9/33) OF TEST_BALL4XI *** FAILED  WITH KEY2DICT: ", key2dict)
                            print("\n (STEP 25Y10/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            print("\n (STEP 25Y11/33) OF TEST_BALL4XI - INDEX2Y: ", index2y)
                            print("\n (STEP 25Y12/33) OF TEST_BALL4XI - INDEX2Z: ", index2z)
                        
                        ack2x = False    
                        if ((x2coordinate >= 0) and (sign2x == '+')):
                            ack2x = True
                        if ((x2coordinate <= 0) and (sign2x == '-')):
                            ack2x = True                        
                        
                        ack2y = False    
                        if ((y2coordinate >= 0) and (sign2y == '+')):
                            ack2y = True
                        if ((y2coordinate <= 0) and (sign2y == '-')):
                            ack2y = True     
                        
                        ack2z = False    
                        if ((z2coordinate >= 0) and (sign2z == '+')):
                            ack2z = True
                        if ((z2coordinate <= 0) and (sign2z == '-')):
                            ack2z = True     
                        
                        if ((ack2x is True) and (ack2y is True) and (ack2z is True)):
                            count2accepted = count2accepted + 1                                                                                                      
                            print("\n ACCEPTANCE: ", count2accepted, " SHOT: ", order2key, ":", key2dict, " EXPECTED SIGNS: (" , sign2x, ",", sign2y, ",", sign2z, ")") 
                            
                        else:
                            count2rejected = count2rejected + 1
                            # print("\n REJECTION: ", count2rejected, " SHOT ", order2key, ":", key2dict, " EXPECTED SIGNS: (" , sign2x, ",", sign2y, ",", sign2z, ")")   
                                                        
                        order2key = order2key +1 

                    count2tried = count2accepted + count2rejected 
                    
                    sum2plus = count2plusx + count2plusy+ count2plusz
                    sum2minus = count2minusx + count2minusy+ count2minusz
                    sum2total = count2plusx + count2minusx # same also with y and z - coordinate exists only once
                            
                    print('=' *80)
                    print("\n (STEP 25Y15/33) OF TEST_BALL4XI - STATISTICS FOR REQUIRED: ", max2count, " SHOTS")   
                    print("\n START TIME: ", time2start)
                    print("\n ACCEPTED: ", count2accepted, " = ", int(100*count2accepted/order2key), " %")
                    print("\n REJECTED: ", count2rejected, " = ", int(100*count2rejected/order2key), " %")
                   
                    print("\n DISTIBUTION OF X, Y AND Z: ") 
                    print("\n +X: ", count2plusx, " = ", int(100*count2plusx/sum2total), " %")
                    print("\n -X: ", count2minusx, " = ", int(100*count2minusx/sum2total), " %") 
                   
                    print("\n +Y: ", count2plusy, " = ", int(100*count2plusy/sum2total), " %")
                    print("\n -Y: ", count2minusy, " = ", int(100*count2minusy/sum2total), " %") 
                   
                    print("\n +Z: ", count2plusz, " = ", int(100*count2plusz/sum2total), " %")
                    print("\n -Z: ", count2minusz, " = ", int(100*count2minusz/sum2total), " %") 
                              
                    
                    print("\n SUM2TOTAL: ", sum2total, "SUCCESS-RATIO: ", int(100*count2accepted/max2count), " %", " COUNT2LAYER: ", count2layer)
                    print("\n START2DISTANCE: ", start2distance, " INTERVAL2DISTANCE: ", interval2distance, " MAX2LAYER: ", max2layer, " MAX2COUNT : ", max2count)
                    print("\n EXPECTED COORDINATE SIGNS: (X: "  , sign2x, ",Y", sign2y, ",Z", sign2z, ")") 
                    
                    print("\n REASONING: ")
                    if count2accepted >= omax2count:
                        print("\n OK SHOOTING: ACCEPTED SHOTS ", count2accepted, " >= ", omax2count, " ORIGINALLY REQUIRED, MARIGINAL: ", marginal2count)
                    else:
                        print("\n *** FAILED SHOOTING: ACCEPTED SHOT ONLY: ", count2accepted, " < ", omax2count, " REQUIRED !")                                    
                    
                    print("\n END TIME: ", time2end)
                    print('=' *80)

                    # ================================================================================
                    #  (STEP 25Y15/33) OF TEST_BALL4XI - STATISTICS FOR REQUIRED:  120  SHOTS
                    #  START TIME:  05:31:01 06/04/10 Pacific Daylight Time
                    #  ACCEPTED:  126  =  17  %
                    #  REJECTED:  578  =  81  %
                    #  DISTIBUTION OF X, Y AND Z: 
                    #  +X:  330  =  46  %
                    #  -X:  374  =  53  %
                    #  +Y:  350  =  49  %
                    #  -Y:  354  =  50  %
                    #  +Z:  395  =  56  %
                    #  -Z:  309  =  43  %
                    #  SUM2TOTAL:  704 SUCCESS-RATIO:  105  %  COUNT2LAYER:  1
                    #  START2DISTANCE:  100  INTERVAL2DISTANCE:  100  MAX2LAYER:  120  MAX2COUNT :  120
                    #  EXPECTED COORDINATE SIGNS: (X:  - ,Y + ,Z + )
                    #  REASONING: 
                    #  OK SHOOTING: ACCEPTED SHOTS  126  >=  100  ORIGINALLY REQUIRED, MARIGINAL:  1.2
                    #  END TIME:  05:31:09 06/04/10 Pacific Daylight Time
                    # ================================================================================                    
                except:
                    # -------------------------------------------------------------------------------------    
                    #
                    # -------------------------------------------------------------------------------------     
                    print("\n (STEP 25Z/33) OF TEST_BALL4XI *** FAILED TO SHOOT (-X,+Y,+Z) - WEST, SOUTH, TOWARDS")
                    
                                                                                                                                           
                # ---------------------------------------------------------------------------------------------
                # SMART SHOOTING (-X,-Y,-Z) - WEST, NORTH, BACKWARDS                
                # ---------------------------------------------------------------------------------------------  
                print("\n (STEP 26A/33) OF TEST_BALL4XI - TRYING SMART SHOOTING (-X,-Y,-Z) - WEST, NORTH, BACKWARDS")   
                
                try:        

                    # =============================================================================================                   
                    # INITIALIZATIONS
                    # =============================================================================================                
      
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    ball2xi = Ball4Xi(message2ball = name2xi)

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                        
                    start2distance = 100
                    print("\n (STEP 26B1/33) OF TEST_BALL4XI - DISTANCE: ", d2shot)   

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                     
                    interval2distance = 100  
                    print("\n (STEP 26B2/33) OF TEST_BALL4XI - INTERVAL TO DISTANCE: ", interval2distance)   
                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    max2layer = 100                          
                    marginal2layer = 1.2
                    omax2layer = max2layer
                    max2layer = int(marginal2layer * max2layer)
                    print("\n (STEP 26B3/33) OF TEST_BALL4XI - MAXIMUM SHOTS PER LAYER: ", max2layer, " MARGINAL TO LAYER: ", marginal2layer) 
                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    max2count = 100
                    marginal2count = 1.2
                    omax2count = max2count
                    max2count = int(marginal2count * max2count)
                            
                    print("\n (STEP 26B4/33) OF TEST_BALL4XI - MAXIMUM SHOTS: ", max2count, " MARGINAL TO COUNT: ", marginal2count) 
                    if max2count > 1000:
                        trace2set = False # <-- turn trace off with a large max !

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                    
                    time2start = time4xi()                        
                    print("\n (STEP 26B5/33) OF TEST_BALL4XI - START TIME: ", time2start) 
                                                                                            
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # required signs for (x,y,z)
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    
                    # (-X,-Y,-Z) - WEST, NORTH, BACKWARDS
                    sign2x = '-'    
                    sign2y = '-'
                    sign2z = '-'
                    print("\n (STEP 26B6/33) OF TEST_BALL4XI - X-SIGN: ", sign2x, 'Y-SIGN: ', sign2y, 'Z-SIGN: ', sign2z) 
                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                    
                    max2iterate = 1500     # 1000 gave only 87 !
                    print("\n (STEP 26B7/33) OF TEST_BALL4XI - MAXIMUM TO ITERATIONS: ", max2iterate) 
                    if max2iterate > 1000:
                        trace2set = False # <-- turn trace off with a large max !  
                                          
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # azimuth and elevation angle initialized
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # ref: http://en.wikipedia.org/wiki/Radian#Conversion_between_radians_and_degrees
                    # one radian is equal to 180/p degrees <=> 1 deg = rad * 180 / pi                             
                    # pi/6 = 30, pi/4 = 45, pi/3 = 60, pi/2 = 90, 2/3*pi = 120, 3/4pi=135, 5/6*pi = 150, pi = 180
                    # 7/6*pi = 210, 5/4*pi = 225...3*pi/2 = 270, 5*pi/3 = 300 ... 2*pi = 0 or 360 degrees
                    # I   = 0...90    (0...pi/2) :     sin+, cos+
                    # II  = 90...180  (pi/2...pi):     sin+, cos- 
                    # III = 180...270 (pi...3*pi/2):   sin-, cos-
                    # IV  = 270...360 (3*pi/2...2*pi): sin-, cos+
                    # ref: http://en.wikipedia.org/wiki/Azimuth

                    # =============================================================================================                   
                    # AZIMUTH
                    # =============================================================================================                
                                                                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                    start2plusa = pi/6                          # start plus azimuth 30 degrees - iterates smaller                                                           
                    print("\n (STEP 26B8/33) OF TEST_BALL4XI - START2PLUSA: ", start2plusa) 
                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
                    max2plusa = 2*pi                            # extreme plus azimuth 360 degrees around sideways
                    print("\n (STEP 26B8/33) OF TEST_BALL4XI - MAX2PLUSA: ", max2plusa) 

                                                                        
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
                    min2plusa = pi/240                          # minum positive azimuth 0.75 degrees sideways 
                    print("\n (STEP 26B8/33) OF TEST_BALL4XI - MIN2PLUSA: ", min2plusa) 
                                                          
                                              
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                    start2minusa = -pi/6                        # start minus azimuth -30 degrees sideways                                                           
                    print("\n (STEP 26B8/33) OF TEST_BALL4XI - START2MINUSA: ", start2minusa) 
                                  
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
                    max2minusa = -0.98*2*pi                     # extreme minus azimuth almost -360 degrees 
                    print("\n (STEP 26B8/33) OF TEST_BALL4XI - MAX2MINUSA: ", max2minusa) 
                                                                            
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
                    min2minusa = -pi/240                        # nearest to zero minus to azimuth
                    print("\n (STEP 26B8/33) min2minusa: ", min2minusa) 
                                                                    
                    # =============================================================================================                   
                    # ELEVATION
                    # =============================================================================================                
                                                      
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                    start2pluse = pi/6                          # start plus elevation 30 degrees up 
                    print("\n (STEP 26B8/33) OF TEST_BALL4XI - START2PLUSE: ", start2pluse) 
                                                          
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
                    max2pluse = pi                              # most flexible elevation 180 degrees 
                    print("\n (STEP 26B8/33) OF TEST_BALL4XI - MAX2PLUSE: ", max2pluse) 
                                      
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
                    min2pluse = pi/240                          # lowest plus to elevation 0.75 degrees                          
                    print("\n (STEP 26B8/33) OF TEST_BALL4XI - MIN2PLUSE: ", min2pluse) 
                                                   
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                    start2minuse = -pi/6                        # start minus elevation -30 degrees down                                                
                    print("\n (STEP 26B8/33) OF TEST_BALL4XI - START2MINUSE: ", start2minuse) 
                  
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
                    max2minuse = -0.98*pi                       # most painful minus elevation almost -180 degrees
                    print("\n (STEP 26B8/33) OF TEST_BALL4XI - MAX2MINUSE: ", max2minuse) 
                                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
                    min2minuse = -pi/240                        # least painful minus elevation -0.75 degrees                              
                    print("\n (STEP 26B8/33) OF TEST_BALL4XI - MIN2MINUSE: ", min2minuse) 
                                                         
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # increments for algorithm 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    increase2distance = 0                       # zero with laeyrs, only new layer increases
                    print("\n (STEP 26B8/33) OF TEST_BALL4XI - INCREASE2DISTANCE: ", increase2distance) 
                                                         
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # increments for algorithm 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    change2a = pi / 60                          # 3 degrees change to azimuth
                    print("\n (STEP 26B8/33) OF TEST_BALL4XI -CHANGE2A: ", change2a) 
                                                         
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # increments for algorithm 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    change2e = pi / 60                          # 3 degrees change to elevation
                    print("\n (STEP 26B8/33) OF TEST_BALL4XI - CHANGE2E: ", change2e) 
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # azimuth settings based on sign, which might get tuned to opposite sign later on
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    sign2a = '+'

                    if sign2a == '+':
                        start2a = start2plusa
                        min2a = min2plusa
                        max2a = max2plusa
                    else:
                        start2a = start2minusa
                        min2a = min2minusa
                        max2a = max2minusa
                        
                    print("\n (STEP 26B9/33) OF TEST_BALL4XI - START AZIMUTH: ", start2a, 'MIN AZIMUTH: ', min2a, 'MAX AZIMUTH: ', max2a) 
                    
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # elevation values used based on sign
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    sign2e = '+'

                    if sign2e == '+':
                        start2e = start2pluse
                        min2e = min2pluse
                        max2e = max2pluse
                    else:
                        start2e = start2minuse
                        min2e = min2minuse
                        max2e = max2minuse
                        
                    print("\n (STEP 26B10/33) OF TEST_BALL4XI - START ELEVATION: ", start2e, 'MIN ELEVATION: ', min2e, 'MAX ELEVATION: ', max2e) 
                    
                  
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # azimuth start setting
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                              
                    a2shot = start2a 
                    
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # elevation start setting
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                              
                    e2shot = start2e                            
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # distance start setting
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                          
                    d2shot = start2distance
            
                                  
                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # initializations for while loop 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    count2layer = 1                                  # layers                                                           
                    
                    count2ok = 0                                     # ok shots with all of (x,y,z) ok 
                    
                    count2distance = 0                               # for none layers when distance increased                        
                    
                    count2iterate = 0                                # hunt for right (x,y,z) combination
                    
                    count2rejected = 0                               # rejected
                  
                    ack2x = False                                    # validation for x-coordinate
                    nack2x = True
                    
                    ack2y = False                                    # validation for y-coordinate
                    nack2y = True                    
                    
                    ack2z = False                                    # validation for z-coordinate
                    nack2z = True
                    
                    ack2layer = False                                # validation for layer
                    nack2layer = True                    
                    
                    print("\n (STEP 26F/33) OF TEST_BALL4XI - START TIME OF SHOOTING: ", time4xi(), " FOR ", max2count, " SHOTS") 
                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                                             
                    while ((count2ok <= max2count) and (count2iterate < max2iterate)   
                           and (ack2layer is False)): 
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # 
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        count2iterate = count2iterate + 1    
                        
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # distance
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        d2shot = d2shot + increase2distance                          # remains the same for a laeyr
                        
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # azimuth changes
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        if a2shot >= 0:        
                            a2shot = a2shot + change2a
                            if a2shot >= max2a:
                                start2a = start2a * 1.01
                                a2shot = start2a 
                                print("\n (STEP 26G/33) OF TEST_BALL4XI - AZIMUTH BECAME BIGGER THAN MAXIMUM: ", max2a , " NEW AZIMUTH: ", a2shot)    
                        else:
                            a2shot = a2shot - change2a
                            if a2shot <= min2a:
                                start2a = start2a * 1.01
                                a2shot = start2a  
                                print("\n (STEP 26H/33) OF TEST_BALL4XI - AZIMUTH BECAME SMALLER THAN MINIMUM: ", min2a , " NEW AZIMUTH: ", a2shot)  
                                
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # azimuth algoritm checking against maximum allowed - restart with tuning, if necessary
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                        if (a2shot >= 2*pi):
                            sign2a = '-'                                             # switch to negative
                            change2a = 0.98 * change2a                               # change2a always positive
                            start2a = change2a * start2minusa                        # new minus azimuth start
                            a2shot = start2a                                         # new azimuth
                            min2a = min2minusa                                       # new minimum to azimuth
                            max2a = max2minusa                                       # new maximum to azimuth
                            print("\n (STEP 26I/33) OF TEST_BALL4XI - AZIMUTH BECAME BIGGER THAN 2*PI , NEW AZIMUTH: ", a2shot) 

                            
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # azimuth algoritm checking against minimum allowed- restart with tuning, if necessary
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                             
                        if (a2shot <= -2*pi):
                            sign2a = '+'                                             # switch to positive
                            change2a = 0.98 * change2a                               # change2a always positive
                            start2a = change2a * start2plusa                         # new positive azimuth start
                            a2shot = start2a                                         # new azimuth
                            min2a = min2plusa                                        # new minimum to azimuth
                            max2a = max2plusa                                        # new maximum to azimuth
                            print("\n (STEP 26J/33) OF TEST_BALL4XI - AZIMUTH BECAME LESS THAN -2*PI, NEW AZIMUTH: ", a2shot) 

                        
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # elevation changes
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        if e2shot <= 0:
                            e2shot = e2shot - increase2e
                            if e2shot <= min2e:
                                change2e = 1.02 * change2e
                                start2e = change2e * start2e
                                e2shot = start2e
                                print("\n (STEP 26K/33) OF TEST_BALL4XI - ELEVATION BECAME LESS THAN MINIMUM: ", min2e, " NEW ELEVATION: ", e2shot)                                   
                        else:
                            e2shot = e2shot + increase2e
                            if e2shot >= max2e:
                                change2e = 1.08 * change2e
                                start2e = change2e * start2e
                                e2shot = start2e
                                print("\n (STEP 26L/33) OF TEST_BALL4XI - ELEVATION BECAME BIGGER THAN MAXIMUM: ", max2e, " NEW ELEVATION: ", e2shot)  
                                                                      
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # elevation algoritm checking against maximum allowed - restart with tuning, if necessary
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                                                   
                        if (e2shot >= pi):
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # start again with a new elevation and new elevation change
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            sign2e = '-'                                             # switch to negative
                            change2e = 0.98 * change2e                               # change2e always positive
                            start2e = change2e * start2minuse                        # new minus elevation start
                            e2shot = start2e                                         # new azimuth
                            min2e = min2minuse                                       # new minimum to elevation
                            max2e = max2minuse                                       # new maximum to elevation
                            print("\n (STEP 26M/33) OF TEST_BALL4XI - ELEVATION BECAME BIGGER THAN PI, NEW ELEVATION: ", e2shot)
                            

                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # elevation algoritm checking against minimum allowed- restart with tuning, if necessary
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
                        
                        if (e2shot <= -pi):
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # start again with a new elevation and new elevation change
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                            
                            sign2e = '+'                                             # switch to positive
                            change2e = 0.98 * change2e                               # change2e always positive
                            start2e = change2e * start2pluse                         # new positive elevation start
                            e2shot = start2e                                         # new azimuth
                            min2e = min2pluse                                        # new minimum to elevation
                            max2e = max2pluse                                        # new maximum to elevation        
                            print("\n (STEP 26N/33) OF TEST_BALL4XI - ELEVATION BECAME LESS THAN -PI, NEW ELEVATION: ", e2shot)
                            

                            
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # shoot
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                                               
                        ball2xi.set(azimuth2shot = a2shot, elevation2shot = e2shot, distance2shot = d2shot, area2shot = int(4*pi*d2shot**2/interval2distance))
                        
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # check shot 
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        shot2examine = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes', area2shot = 'Yes')
                        print("\n (STEP 26OA/33) OF TEST_BALL4XI - SHOT TO EXAMINE ", count2shot, ": ", shot2examine)  
                        # {'42x27y86z': {'x2shot': 42, 'azimuth2shot': 0.5759586531581287, 'area2shot': 1256, 'id2shot': '42x27y86z', 'distance2shot': 100, 'z2shot': 86, 'elevation2shot': 0.5335987755982988, 'y2shot': 27}}
                         
                        keys2examine = shot2examine.keys()
                        print("\n (STEP 26OB1/33) OF TEST_BALL4XI - KEYS2EXAMINE: ", keys2examine)   
                        # dict_keys(['42x27y86z'])
                        
                        for key2examine in sorted(keys2examine):
                            print("\n (STEP 26OB2/33) OF TEST_BALL4XI - KEY2EXAMINE ", key2examine)  
                            # 42x27y86z
                            
                            ack2x = False 
                            nack2x = True                                  
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # X OK ?
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                            try:
                                index2x=str.find(key2examine,'x')                               
                                x2coordinate = int(key2examine[0:index2x])
                                if x2coordinate >= 0:
                                    if sign2x == '+':
                                        ack2x = True
                                        nack2x = False
                                        print("\n (STEP 26OB3/33/33) OF TEST_BALL4XI - X2COORDINATE ACK: ", ack2x) 
                                else:
                                    if sign2x == '-':
                                        ack2x = True
                                        nack2x = False
                                        print("\n (STEP 26OB4/33/33) OF TEST_BALL4XI - X2COORDINATE ACK: ", ack2x)
                                         
                            except:
                                print("\n (STEP 26B5/33) OF TEST_BALL4XI *** FAILED  WITH KEY2EXAMINE: ", key2examine)
                                print("\n (STEP 26B5/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                                
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # Y OK ?
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
                            ack2y = False 
                            nack2y = True     
                            try:
                                index2y=str.find(key2examine,'y')                               
                                y2coordinate = int(key2examine[index2x+1:index2y])
                                if y2coordinate >= 0:
                                    if sign2y == '+':
                                        ack2y = True
                                        nack2y = False
                                        print("\n (STEP 26OB6/33) OF TEST_BALL4XI - Y2COORDINATE ACK: ", ack2y)                                         
                                else:
                                    if sign2y == '-':
                                        ack2y = True
                                        nack2y = False
                                        print("\n (STEP 26OB7/33) OF TEST_BALL4XI - Y2COORDINATE ACK: ", ack2y)                               
                            except:
                                print("\n (STEP 26OB8/33) OF TEST_BALL4XI *** FAILED  WITH KEY2EXAMINE: ", key2examine)
                                print("\n (STEP 26OB8/33) OF TEST_BALL4XI - INDEX2Y: ", index2y)
                                
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # Z OK ?
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
                            ack2z = False 
                            nack2z = True                                 
                            try:
                                index2z=str.find(key2examine,'z')                               
                                z2coordinate = int(key2examine[index2y+1:index2z])
                                if z2coordinate >= 0:
                                    if sign2z == '+':
                                        ack2z = True
                                        nack2z = False
                                        print("\n (STEP 26OB9/33) OF TEST_BALL4XI - Z2COORDINATE ACK: ", ack2z)                                               
                                else:
                                    if sign2z == '-':
                                        ack2z = True
                                        nack2z = False
                                        print("\n (STEP 26OB10/33) OF TEST_BALL4XI - Z2COORDINATE ACK: ", ack2z)                                  
                            except:
                                print("\n (STEP 26OB11/33) OF TEST_BALL4XI *** FAILED  WITH KEY2EXAMINE: ", key2examine)
                                print("\n (STEP 26OB11/33) OF TEST_BALL4XI - INDEX2Z: ", index2z)
                                
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # (X,Y,Z) OK ?
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
                            try:                                                           
                                if ((ack2x is True) and (ack2y is True) and (ack2z is True)):
                                    print("\n (STEP 26O5A/33) OF TEST_BALL4XI - OK: (" , x2coordinate, ",", y2coordinate, ",", z2coordinate, ")") 
                                    print("\n (STEP 26O5B/33) OF TEST_BALL4XI - EXPECTED: (" , sign2x, ",", sign2y, ",", sign2z, ")") 
                                    count2ok = count2ok + 1 
                                    if count2ok >= max2layer:
                                        ack2layer = True
                                        print("\n (STEP 26O6/33) OF TEST_BALL4XI - ACK2LAYER: " , ack2layer)
                                    else:
                                        ack2layer = False
                                else:
                                    print("\n (STEP 26O8A/33) OF TEST_BALL4XI - REJECTED: (" , x2coordinate, ",", y2coordinate, ",", z2coordinate, ")")
                                    print("\n (STEP 26O8B/33) OF TEST_BALL4XI - EXPECTED: (" , sign2x, ",", sign2y, ",", sign2z, ")")
                                    
                                    count2rejected = count2rejected + 1
                                    ack2layer = False 
                                    # ( 42 , 27 , 86 )
                                    # ( + , + , - )  
                                    
                                    print("\n (STEP 26O8C/33) OF TEST_BALL4XI *** REMEMBER TO DELETE THE SHOT OR LET IT BE AND RETURN ONLY OK SHOTS!!!! *** ")
                                    
                                                        
                            except:
                                print("\n (STEP 26O9/33) OF TEST_BALL4XI *** FAILED  WITH KEY2EXAMINE: ", key2examine)
                                print("\n (STEP 26O9/33) OF TEST_BALL4XI - INDEX2Z: ", index2z)
                        
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # CONTINUE WHILE
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                    

                        print("\n (STEP 26O10/33) OF TEST_BALL4XI - CONTINUING WHILE WITH:")
                        print("\n count2ok:", count2ok)
                        print("\n max2count:", max2count)                        
                        print("\n count2iterate:", count2iterate)
                        print("\n max2iterate:", max2iterate)                        
                        print("\n ack2layer:", ack2layer)                        
                        
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # CONTINUE WHILE
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                    
                                                                                                         
                        count2distance = count2distance + increase2distance  #stays the same when a layer is shot
                        if count2distance > max2layer:
                            d2shot = d2shot + interval2distance
                            count2distance = 0
                            count2layer = count2layer + 1 
                            print("\n (STEP 26O10/33) OF TEST_BALL4XI - NEW LAYER NUMBER: ", count2layer, ' NEW DISTANCE: ', d2shot)
                        else:
                            pass 
                               
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # end of while
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # EXAMINE RESULTS 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    time2end = time4xi()           
                    print("\n (STEP 26P1/33) OF TEST_BALL4XI - STATISTICS FOR SHOOTING, WHICH ENDED: ", time2end)                          
                    print("\n SHOTS OK: ", count2ok, " = ", int(100 * count2ok/max2count), " %")                              
                    print("\n SHOTS ORIGINALLY REQUIRED: ", omax2count)      
                    print("\n ITERATIONS NEEDED: ", count2iterate)                              
                    print("\n ITERATIONS ALLOWED: ", max2iterate) 
                    print("\n REJECTED: ", count2rejected, " = : ", int(100 * count2rejected/count2iterate), " %") 

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                           
                    print("\n (STEP 26Y1/33) OF TEST_BALL4XI - WHOLE BALL AFTER ALL OPERATIONS AND WITH MAX2COUNT: ", max2count, 'TIME PRINTED: ', time4xi())  
                    
                    ball2show = ball2xi.get()
                    dict2keys = ball2show.keys()
                    print("\n (STEP 26Y2/33) OF TEST_BALL4XI - KEYS2BALL: ", dict2keys)
                    # 
                    print("\n (STEP 26Y3/33) OF TEST_BALL4XI - SHOOTING SAMPLE OF : ", max2count, " SHOTS", "NUMBER OF LAYERS: ", count2layer, ' LATEST DISTANCE: ', d2shot, ' INTERVAL2DISTANCE: ', interval2distance)    
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    count2plusx = 0
                    count2plusy = 0
                    count2plusz = 0
                           
                    count2minusx = 0
                    count2minusy = 0
                    count2minusz = 0
                    
                    count2accepted = 0
                    count2rejected = 0
                    
                    order2key = 1
                    for key2dict in sorted(dict2keys):
                        try:
                            index2x=str.find(key2dict,'x')                               
                            x2coordinate = int(key2dict[0:index2x])
                            # print("\n (STEP 15L11/33/33) OF TEST_BALL4XI - X2COORDINATE: ",  x2coordinate)
                            if x2coordinate >= 0:
                                count2plusx = count2plusx + 1
                            else:
                                count2minusx = count2minusx + 1    
                        except:
                            print("\n (STEP 26Y4/33) OF TEST_BALL4XI *** FAILED  WITH KEY2DICT: ", key2dict)
                            print("\n (STEP 26Y5/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            
                            
                        try:                                   
                            index2y=str.find(key2dict,'y')
                            y2coordinate = int(key2dict[index2x+1:index2y])
                            # print("\n (STEP 15L11/33) OF TEST_BALL4XI - Y2COORDINATE: ",  y2coordinate)
                            if y2coordinate >= 0:
                                count2plusy = count2plusy + 1
                            else:
                                count2minusy = count2minusy + 1  
                        except:
                            print("\n (STEP 26Y6/33) OF TEST_BALL4XI *** FAILED  WITH KEY2DICT: ", key2dict) 
                            print("\n (STEP 26Y7/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            print("\n (STEP 26Y8/33) OF TEST_BALL4XI - INDEX2Y: ", index2y)
                        
                        try:                                                                         
                            index2z=str.find(key2dict,'z') 
                            z2coordinate = int(key2dict[index2y+1:index2z])
                            # print("\n (STEP 26V/33) OF TEST_BALL4XI - Z2COORDINATE: ",  z2coordinate)
                            if z2coordinate >= 0:
                                count2plusz = count2plusz + 1
                            else:
                                count2minusz = count2minusz + 1
                        except:
                            print("\n (STEP 26Y9/33) OF TEST_BALL4XI *** FAILED  WITH KEY2DICT: ", key2dict)
                            print("\n (STEP 26Y10/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            print("\n (STEP 26Y11/33) OF TEST_BALL4XI - INDEX2Y: ", index2y)
                            print("\n (STEP 26Y12/33) OF TEST_BALL4XI - INDEX2Z: ", index2z)
                        
                        ack2x = False    
                        if ((x2coordinate >= 0) and (sign2x == '+')):
                            ack2x = True
                        if ((x2coordinate <= 0) and (sign2x == '-')):
                            ack2x = True                        
                        
                        ack2y = False    
                        if ((y2coordinate >= 0) and (sign2y == '+')):
                            ack2y = True
                        if ((y2coordinate <= 0) and (sign2y == '-')):
                            ack2y = True     
                        
                        ack2z = False    
                        if ((z2coordinate >= 0) and (sign2z == '+')):
                            ack2z = True
                        if ((z2coordinate <= 0) and (sign2z == '-')):
                            ack2z = True     
                        
                        if ((ack2x is True) and (ack2y is True) and (ack2z is True)):
                            count2accepted = count2accepted + 1                                                                                                      
                            print("\n ACCEPTANCE: ", count2accepted, " SHOT: ", order2key, ":", key2dict, " EXPECTED SIGNS: (" , sign2x, ",", sign2y, ",", sign2z, ")") 
                            
                        else:
                            count2rejected = count2rejected + 1
                            # print("\n REJECTION: ", count2rejected, " SHOT ", order2key, ":", key2dict, " EXPECTED SIGNS: (" , sign2x, ",", sign2y, ",", sign2z, ")")   
                                                        
                        order2key = order2key +1 

                    count2tried = count2accepted + count2rejected 
                    
                    sum2plus = count2plusx + count2plusy+ count2plusz
                    sum2minus = count2minusx + count2minusy+ count2minusz
                    sum2total = count2plusx + count2minusx # same also with y and z - coordinate exists only once
                            
                    print('=' *80)
                    print("\n (STEP 26Y15/33) OF TEST_BALL4XI - STATISTICS FOR REQUIRED: ", max2count, " SHOTS")   
                    print("\n START TIME: ", time2start)
                    print("\n ACCEPTED: ", count2accepted, " = ", int(100*count2accepted/order2key), " %")
                    print("\n REJECTED: ", count2rejected, " = ", int(100*count2rejected/order2key), " %")
                   
                    print("\n DISTIBUTION OF X, Y AND Z: ") 
                    print("\n +X: ", count2plusx, " = ", int(100*count2plusx/sum2total), " %")
                    print("\n -X: ", count2minusx, " = ", int(100*count2minusx/sum2total), " %") 
                   
                    print("\n +Y: ", count2plusy, " = ", int(100*count2plusy/sum2total), " %")
                    print("\n -Y: ", count2minusy, " = ", int(100*count2minusy/sum2total), " %") 
                   
                    print("\n +Z: ", count2plusz, " = ", int(100*count2plusz/sum2total), " %")
                    print("\n -Z: ", count2minusz, " = ", int(100*count2minusz/sum2total), " %") 
                              
                    
                    print("\n SUM2TOTAL: ", sum2total, "SUCCESS-RATIO: ", int(100*count2accepted/max2count), " %", " COUNT2LAYER: ", count2layer)
                    print("\n START2DISTANCE: ", start2distance, " INTERVAL2DISTANCE: ", interval2distance, " MAX2LAYER: ", max2layer, " MAX2COUNT : ", max2count)
                    print("\n EXPECTED COORDINATE SIGNS: (X: "  , sign2x, ",Y", sign2y, ",Z", sign2z, ")") 
                    
                    print("\n REASONING: ")
                    if count2accepted >= omax2count:
                        print("\n OK SHOOTING: ACCEPTED SHOTS ", count2accepted, " >= ", omax2count, " ORIGINALLY REQUIRED, MARIGINAL: ", marginal2count)
                    else:
                        print("\n *** FAILED SHOOTING: ACCEPTED SHOT ONLY: ", count2accepted, " < ", omax2count, " REQUIRED !")                                    
                    
                    print("\n END TIME: ", time2end)
                    print('=' *80)

                    # ================================================================================
                    #  (STEP 26Y15/33) OF TEST_BALL4XI - STATISTICS FOR REQUIRED:  120  SHOTS
                    #  START TIME:  05:38:11 06/04/10 Pacific Daylight Time
                    #  ACCEPTED:  133  =  11  %
                    #  REJECTED:  1012  =  88  %
                    #  DISTIBUTION OF X, Y AND Z: 
                    #  +X:  529  =  46  %
                    #  -X:  616  =  53  %
                    #  +Y:  553  =  48  %
                    #  -Y:  592  =  51  %
                    #  +Z:  577  =  50  %
                    #  -Z:  568  =  49  %
                    #  SUM2TOTAL:  1145 SUCCESS-RATIO:  110  %  COUNT2LAYER:  1
                    #  START2DISTANCE:  100  INTERVAL2DISTANCE:  100  MAX2LAYER:  120  MAX2COUNT :  120
                    #  EXPECTED COORDINATE SIGNS: (X:  - ,Y - ,Z - )
                    #  REASONING: 
                    #  OK SHOOTING: ACCEPTED SHOTS  133  >=  100  ORIGINALLY REQUIRED, MARIGINAL:  1.2
                    #  END TIME:  05:38:33 06/04/10 Pacific Daylight Time
                    # ================================================================================                    
                except:
                    # -------------------------------------------------------------------------------------    
                    #
                    # -------------------------------------------------------------------------------------     
                    print("\n (STEP 26Z/33) OF TEST_BALL4XI *** FAILED TO SHOOT (-X,-Y,-Z) - WEST, NORTH, BACKWARDS")
                                            
                # ---------------------------------------------------------------------------------------------
                # SMART SHOOTING (+X,-Y,-Z) - EAST, NORTH, BACKWARDS             
                # ---------------------------------------------------------------------------------------------                                                               
                print("\n (STEP 27A/33) OF TEST_BALL4XI - TRYING SMART SHOOTING (+X,-Y,-Z) - EAST, NORTH, BACKWARDS")   
                
                try:        

                    # =============================================================================================                   
                    # INITIALIZATIONS
                    # =============================================================================================                
      
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    ball2xi = Ball4Xi(message2ball = name2xi)

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                        
                    start2distance = 100
                    print("\n (STEP 27B1/33) OF TEST_BALL4XI - DISTANCE: ", d2shot)   

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                     
                    interval2distance = 100  
                    print("\n (STEP 27B2/33) OF TEST_BALL4XI - INTERVAL TO DISTANCE: ", interval2distance)   
                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    max2layer = 100                          
                    marginal2layer = 1.2
                    omax2layer = max2layer
                    max2layer = int(marginal2layer * max2layer)
                    print("\n (STEP 27B3/33) OF TEST_BALL4XI - MAXIMUM SHOTS PER LAYER: ", max2layer, " MARGINAL TO LAYER: ", marginal2layer) 
                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    max2count = 100
                    marginal2count = 1.2
                    omax2count = max2count
                    max2count = int(marginal2count * max2count)
                            
                    print("\n (STEP 27B4/33) OF TEST_BALL4XI - MAXIMUM SHOTS: ", max2count, " MARGINAL TO COUNT: ", marginal2count) 
                    if max2count > 1000:
                        trace2set = False # <-- turn trace off with a large max !

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                    
                    time2start = time4xi()                        
                    print("\n (STEP 27B5/33) OF TEST_BALL4XI - START TIME: ", time2start) 
                                                                                            
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # required signs for (x,y,z)
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    
                    # (+X,-Y,-Z) - EAST, NORTH, BACKWARDS
                    sign2x = '+'    
                    sign2y = '-'
                    sign2z = '-'
                    print("\n (STEP 27B6/33) OF TEST_BALL4XI - X-SIGN: ", sign2x, 'Y-SIGN: ', sign2y, 'Z-SIGN: ', sign2z) 
                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                    
                    max2iterate = 1500     # 1000 gave only 87 !
                    print("\n (STEP 27B7/33) OF TEST_BALL4XI - MAXIMUM TO ITERATIONS: ", max2iterate) 
                    if max2iterate > 1000:
                        trace2set = False # <-- turn trace off with a large max !  
                                          
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # azimuth and elevation angle initialized
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # ref: http://en.wikipedia.org/wiki/Radian#Conversion_between_radians_and_degrees
                    # one radian is equal to 180/p degrees <=> 1 deg = rad * 180 / pi                             
                    # pi/6 = 30, pi/4 = 45, pi/3 = 60, pi/2 = 90, 2/3*pi = 120, 3/4pi=135, 5/6*pi = 150, pi = 180
                    # 7/6*pi = 210, 5/4*pi = 225...3*pi/2 = 270, 5*pi/3 = 300 ... 2*pi = 0 or 360 degrees
                    # I   = 0...90    (0...pi/2) :     sin+, cos+
                    # II  = 90...180  (pi/2...pi):     sin+, cos- 
                    # III = 180...270 (pi...3*pi/2):   sin-, cos-
                    # IV  = 270...360 (3*pi/2...2*pi): sin-, cos+
                    # ref: http://en.wikipedia.org/wiki/Azimuth

                    # =============================================================================================                   
                    # AZIMUTH
                    # =============================================================================================                
                                                                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                    start2plusa = pi/6                          # start plus azimuth 30 degrees - iterates smaller                                                           
                    print("\n (STEP 27B8/33) OF TEST_BALL4XI - START2PLUSA: ", start2plusa) 
                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
                    max2plusa = 2*pi                            # extreme plus azimuth 360 degrees around sideways
                    print("\n (STEP 27B8/33) OF TEST_BALL4XI - MAX2PLUSA: ", max2plusa) 

                                                                        
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
                    min2plusa = pi/240                          # minum positive azimuth 0.75 degrees sideways 
                    print("\n (STEP 27B8/33) OF TEST_BALL4XI - MIN2PLUSA: ", min2plusa) 
                                                          
                                              
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                    start2minusa = -pi/6                        # start minus azimuth -30 degrees sideways                                                           
                    print("\n (STEP 27B8/33) OF TEST_BALL4XI - START2MINUSA: ", start2minusa) 
                                  
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
                    max2minusa = -0.98*2*pi                     # extreme minus azimuth almost -360 degrees 
                    print("\n (STEP 27B8/33) OF TEST_BALL4XI - MAX2MINUSA: ", max2minusa) 
                                                                            
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
                    min2minusa = -pi/240                        # nearest to zero minus to azimuth
                    print("\n (STEP 27B8/33) min2minusa: ", min2minusa) 
                                                                    
                    # =============================================================================================                   
                    # ELEVATION
                    # =============================================================================================                
                                                      
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                    start2pluse = pi/6                          # start plus elevation 30 degrees up 
                    print("\n (STEP 27B8/33) OF TEST_BALL4XI - START2PLUSE: ", start2pluse) 
                                                          
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
                    max2pluse = pi                              # most flexible elevation 180 degrees 
                    print("\n (STEP 27B8/33) OF TEST_BALL4XI - MAX2PLUSE: ", max2pluse) 
                                      
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
                    min2pluse = pi/240                          # lowest plus to elevation 0.75 degrees                          
                    print("\n (STEP 27B8/33) OF TEST_BALL4XI - MIN2PLUSE: ", min2pluse) 
                                                   
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                    start2minuse = -pi/6                        # start minus elevation -30 degrees down                                                
                    print("\n (STEP 27B8/33) OF TEST_BALL4XI - START2MINUSE: ", start2minuse) 
                  
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
                    max2minuse = -0.98*pi                       # most painful minus elevation almost -180 degrees
                    print("\n (STEP 27B8/33) OF TEST_BALL4XI - MAX2MINUSE: ", max2minuse) 
                                                                
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
                    min2minuse = -pi/240                        # least painful minus elevation -0.75 degrees                              
                    print("\n (STEP 27B8/33) OF TEST_BALL4XI - MIN2MINUSE: ", min2minuse) 
                                                         
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # increments for algorithm 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    increase2distance = 0                       # zero with laeyrs, only new layer increases
                    print("\n (STEP 27B8/33) OF TEST_BALL4XI - INCREASE2DISTANCE: ", increase2distance) 
                                                         
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # increments for algorithm 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    change2a = pi / 60                          # 3 degrees change to azimuth
                    print("\n (STEP 27B8/33) OF TEST_BALL4XI -CHANGE2A: ", change2a) 
                                                         
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # increments for algorithm 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    change2e = pi / 60                          # 3 degrees change to elevation
                    print("\n (STEP 27B8/33) OF TEST_BALL4XI - CHANGE2E: ", change2e) 
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # azimuth settings based on sign, which might get tuned to opposite sign later on
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    sign2a = '+'

                    if sign2a == '+':
                        start2a = start2plusa
                        min2a = min2plusa
                        max2a = max2plusa
                    else:
                        start2a = start2minusa
                        min2a = min2minusa
                        max2a = max2minusa
                        
                    print("\n (STEP 27B9/33) OF TEST_BALL4XI - START AZIMUTH: ", start2a, 'MIN AZIMUTH: ', min2a, 'MAX AZIMUTH: ', max2a) 
                    
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # elevation values used based on sign
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    sign2e = '+'

                    if sign2e == '+':
                        start2e = start2pluse
                        min2e = min2pluse
                        max2e = max2pluse
                    else:
                        start2e = start2minuse
                        min2e = min2minuse
                        max2e = max2minuse
                        
                    print("\n (STEP 27B10/33) OF TEST_BALL4XI - START ELEVATION: ", start2e, 'MIN ELEVATION: ', min2e, 'MAX ELEVATION: ', max2e) 
                    
                  
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # azimuth start setting
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                              
                    a2shot = start2a 
                    
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # elevation start setting
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                              
                    e2shot = start2e                            
                                                                                                                                     
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # distance start setting
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                          
                    d2shot = start2distance
            
                                  
                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # initializations for while loop 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    count2layer = 1                                  # layers                                                           
                    
                    count2ok = 0                                     # ok shots with all of (x,y,z) ok 
                    
                    count2distance = 0                               # for none layers when distance increased                        
                    
                    count2iterate = 0                                # hunt for right (x,y,z) combination
                    
                    count2rejected = 0                               # rejected
                  
                    ack2x = False                                    # validation for x-coordinate
                    nack2x = True
                    
                    ack2y = False                                    # validation for y-coordinate
                    nack2y = True                    
                    
                    ack2z = False                                    # validation for z-coordinate
                    nack2z = True
                    
                    ack2layer = False                                # validation for layer
                    nack2layer = True                    
                    
                    print("\n (STEP 27F/33) OF TEST_BALL4XI - START TIME OF SHOOTING: ", time4xi(), " FOR ", max2count, " SHOTS") 
                    
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                                             
                    while ((count2ok <= max2count) and (count2iterate < max2iterate)   
                           and (ack2layer is False)): 
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # 
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        count2iterate = count2iterate + 1    
                        
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # distance
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        d2shot = d2shot + increase2distance                          # remains the same for a laeyr
                        
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # azimuth changes
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        if a2shot >= 0:        
                            a2shot = a2shot + change2a
                            if a2shot >= max2a:
                                start2a = start2a * 1.01
                                a2shot = start2a 
                                print("\n (STEP 27G/33) OF TEST_BALL4XI - AZIMUTH BECAME BIGGER THAN MAXIMUM: ", max2a , " NEW AZIMUTH: ", a2shot)    
                        else:
                            a2shot = a2shot - change2a
                            if a2shot <= min2a:
                                start2a = start2a * 1.01
                                a2shot = start2a  
                                print("\n (STEP 27H/33) OF TEST_BALL4XI - AZIMUTH BECAME SMALLER THAN MINIMUM: ", min2a , " NEW AZIMUTH: ", a2shot)  
                                
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # azimuth algoritm checking against maximum allowed - restart with tuning, if necessary
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                        if (a2shot >= 2*pi):
                            sign2a = '-'                                             # switch to negative
                            change2a = 0.98 * change2a                               # change2a always positive
                            start2a = change2a * start2minusa                        # new minus azimuth start
                            a2shot = start2a                                         # new azimuth
                            min2a = min2minusa                                       # new minimum to azimuth
                            max2a = max2minusa                                       # new maximum to azimuth
                            print("\n (STEP 27I/33) OF TEST_BALL4XI - AZIMUTH BECAME BIGGER THAN 2*PI , NEW AZIMUTH: ", a2shot) 

                            
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # azimuth algoritm checking against minimum allowed- restart with tuning, if necessary
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                             
                        if (a2shot <= -2*pi):
                            sign2a = '+'                                             # switch to positive
                            change2a = 0.98 * change2a                               # change2a always positive
                            start2a = change2a * start2plusa                         # new positive azimuth start
                            a2shot = start2a                                         # new azimuth
                            min2a = min2plusa                                        # new minimum to azimuth
                            max2a = max2plusa                                        # new maximum to azimuth
                            print("\n (STEP 27J/33) OF TEST_BALL4XI - AZIMUTH BECAME LESS THAN -2*PI, NEW AZIMUTH: ", a2shot) 

                        
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # elevation changes
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        if e2shot <= 0:
                            e2shot = e2shot - increase2e
                            if e2shot <= min2e:
                                change2e = 1.02 * change2e
                                start2e = change2e * start2e
                                e2shot = start2e
                                print("\n (STEP 27K/33) OF TEST_BALL4XI - ELEVATION BECAME LESS THAN MINIMUM: ", min2e, " NEW ELEVATION: ", e2shot)                                   
                        else:
                            e2shot = e2shot + increase2e
                            if e2shot >= max2e:
                                change2e = 1.08 * change2e
                                start2e = change2e * start2e
                                e2shot = start2e
                                print("\n (STEP 27L/33) OF TEST_BALL4XI - ELEVATION BECAME BIGGER THAN MAXIMUM: ", max2e, " NEW ELEVATION: ", e2shot)  
                                                                      
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # elevation algoritm checking against maximum allowed - restart with tuning, if necessary
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                                                   
                        if (e2shot >= pi):
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # start again with a new elevation and new elevation change
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            sign2e = '-'                                             # switch to negative
                            change2e = 0.98 * change2e                               # change2e always positive
                            start2e = change2e * start2minuse                        # new minus elevation start
                            e2shot = start2e                                         # new azimuth
                            min2e = min2minuse                                       # new minimum to elevation
                            max2e = max2minuse                                       # new maximum to elevation
                            print("\n (STEP 27M/33) OF TEST_BALL4XI - ELEVATION BECAME BIGGER THAN PI, NEW ELEVATION: ", e2shot)
                            

                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # elevation algoritm checking against minimum allowed- restart with tuning, if necessary
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
                        
                        if (e2shot <= -pi):
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # start again with a new elevation and new elevation change
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                            
                            sign2e = '+'                                             # switch to positive
                            change2e = 0.98 * change2e                               # change2e always positive
                            start2e = change2e * start2pluse                         # new positive elevation start
                            e2shot = start2e                                         # new azimuth
                            min2e = min2pluse                                        # new minimum to elevation
                            max2e = max2pluse                                        # new maximum to elevation        
                            print("\n (STEP 27N/33) OF TEST_BALL4XI - ELEVATION BECAME LESS THAN -PI, NEW ELEVATION: ", e2shot)
                            

                            
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # shoot
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                                               
                        ball2xi.set(azimuth2shot = a2shot, elevation2shot = e2shot, distance2shot = d2shot, area2shot = int(4*pi*d2shot**2/interval2distance))
                        
                    
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # check shot 
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        shot2examine = ball2xi.get(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes', area2shot = 'Yes')
                        print("\n (STEP 27OA/33) OF TEST_BALL4XI - SHOT TO EXAMINE ", count2shot, ": ", shot2examine)  
                        # {'42x27y86z': {'x2shot': 42, 'azimuth2shot': 0.5759586531581287, 'area2shot': 1256, 'id2shot': '42x27y86z', 'distance2shot': 100, 'z2shot': 86, 'elevation2shot': 0.5335987755982988, 'y2shot': 27}}
                         
                        keys2examine = shot2examine.keys()
                        print("\n (STEP 27OB1/33) OF TEST_BALL4XI - KEYS2EXAMINE: ", keys2examine)   
                        # dict_keys(['42x27y86z'])
                        
                        for key2examine in sorted(keys2examine):
                            print("\n (STEP 27OB2/33) OF TEST_BALL4XI - KEY2EXAMINE ", key2examine)  
                            # 42x27y86z
                            
                            ack2x = False 
                            nack2x = True                                  
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # X OK ?
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
                            try:
                                index2x=str.find(key2examine,'x')                               
                                x2coordinate = int(key2examine[0:index2x])
                                if x2coordinate >= 0:
                                    if sign2x == '+':
                                        ack2x = True
                                        nack2x = False
                                        print("\n (STEP 27OB3/33/33) OF TEST_BALL4XI - X2COORDINATE ACK: ", ack2x) 
                                else:
                                    if sign2x == '-':
                                        ack2x = True
                                        nack2x = False
                                        print("\n (STEP 27OB4/33/33) OF TEST_BALL4XI - X2COORDINATE ACK: ", ack2x)
                                         
                            except:
                                print("\n (STEP 27B5/33) OF TEST_BALL4XI *** FAILED  WITH KEY2EXAMINE: ", key2examine)
                                print("\n (STEP 27B5/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                                
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # Y OK ?
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
                            ack2y = False 
                            nack2y = True     
                            try:
                                index2y=str.find(key2examine,'y')                               
                                y2coordinate = int(key2examine[index2x+1:index2y])
                                if y2coordinate >= 0:
                                    if sign2y == '+':
                                        ack2y = True
                                        nack2y = False
                                        print("\n (STEP 27OB6/33) OF TEST_BALL4XI - Y2COORDINATE ACK: ", ack2y)                                         
                                else:
                                    if sign2y == '-':
                                        ack2y = True
                                        nack2y = False
                                        print("\n (STEP 27OB7/33) OF TEST_BALL4XI - Y2COORDINATE ACK: ", ack2y)                               
                            except:
                                print("\n (STEP 27OB8/33) OF TEST_BALL4XI *** FAILED  WITH KEY2EXAMINE: ", key2examine)
                                print("\n (STEP 27OB8/33) OF TEST_BALL4XI - INDEX2Y: ", index2y)
                                
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # Z OK ?
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
                            ack2z = False 
                            nack2z = True                                 
                            try:
                                index2z=str.find(key2examine,'z')                               
                                z2coordinate = int(key2examine[index2y+1:index2z])
                                if z2coordinate >= 0:
                                    if sign2z == '+':
                                        ack2z = True
                                        nack2z = False
                                        print("\n (STEP 27OB9/33) OF TEST_BALL4XI - Z2COORDINATE ACK: ", ack2z)                                               
                                else:
                                    if sign2z == '-':
                                        ack2z = True
                                        nack2z = False
                                        print("\n (STEP 27OB10/33) OF TEST_BALL4XI - Z2COORDINATE ACK: ", ack2z)                                  
                            except:
                                print("\n (STEP 27OB11/33) OF TEST_BALL4XI *** FAILED  WITH KEY2EXAMINE: ", key2examine)
                                print("\n (STEP 27OB11/33) OF TEST_BALL4XI - INDEX2Z: ", index2z)
                                
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                            # (X,Y,Z) OK ?
                            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
                            try:                                                           
                                if ((ack2x is True) and (ack2y is True) and (ack2z is True)):
                                    print("\n (STEP 27O5A/33) OF TEST_BALL4XI - OK: (" , x2coordinate, ",", y2coordinate, ",", z2coordinate, ")") 
                                    print("\n (STEP 27O5B/33) OF TEST_BALL4XI - EXPECTED: (" , sign2x, ",", sign2y, ",", sign2z, ")") 
                                    count2ok = count2ok + 1 
                                    if count2ok >= max2layer:
                                        ack2layer = True
                                        print("\n (STEP 27O6/33) OF TEST_BALL4XI - ACK2LAYER: " , ack2layer)
                                    else:
                                        ack2layer = False
                                else:
                                    print("\n (STEP 27O8A/33) OF TEST_BALL4XI - REJECTED: (" , x2coordinate, ",", y2coordinate, ",", z2coordinate, ")")
                                    print("\n (STEP 27O8B/33) OF TEST_BALL4XI - EXPECTED: (" , sign2x, ",", sign2y, ",", sign2z, ")")
                                    
                                    count2rejected = count2rejected + 1
                                    ack2layer = False 
                                    # ( 42 , 27 , 86 )
                                    # ( + , + , - )  
                                    
                                    print("\n (STEP 27O8C/33) OF TEST_BALL4XI *** REMEMBER TO DELETE THE SHOT OR LET IT BE AND RETURN ONLY OK SHOTS!!!! *** ")
                                    
                                                        
                            except:
                                print("\n (STEP 27O9/33) OF TEST_BALL4XI *** FAILED  WITH KEY2EXAMINE: ", key2examine)
                                print("\n (STEP 27O9/33) OF TEST_BALL4XI - INDEX2Z: ", index2z)
                        
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # CONTINUE WHILE
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                    

                        print("\n (STEP 27O10/33) OF TEST_BALL4XI - CONTINUING WHILE WITH:")
                        print("\n count2ok:", count2ok)
                        print("\n max2count:", max2count)                        
                        print("\n count2iterate:", count2iterate)
                        print("\n max2iterate:", max2iterate)                        
                        print("\n ack2layer:", ack2layer)                        
                        
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # CONTINUE WHILE
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                    
                                                                                                         
                        count2distance = count2distance + increase2distance  #stays the same when a layer is shot
                        if count2distance > max2layer:
                            d2shot = d2shot + interval2distance
                            count2distance = 0
                            count2layer = count2layer + 1 
                            print("\n (STEP 27O10/33) OF TEST_BALL4XI - NEW LAYER NUMBER: ", count2layer, ' NEW DISTANCE: ', d2shot)
                        else:
                            pass 
                               
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        # end of while
                        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                        
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # EXAMINE RESULTS 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    time2end = time4xi()           
                    print("\n (STEP 27P1/33) OF TEST_BALL4XI - STATISTICS FOR SHOOTING, WHICH ENDED: ", time2end)                          
                    print("\n SHOTS OK: ", count2ok, " = ", int(100 * count2ok/max2count), " %")                              
                    print("\n SHOTS ORIGINALLY REQUIRED: ", omax2count)      
                    print("\n ITERATIONS NEEDED: ", count2iterate)                              
                    print("\n ITERATIONS ALLOWED: ", max2iterate) 
                    print("\n REJECTED: ", count2rejected, " = : ", int(100 * count2rejected/count2iterate), " %") 

                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # WHOLE BALL 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                           
                    print("\n (STEP 27Y1/33) OF TEST_BALL4XI - WHOLE BALL AFTER ALL OPERATIONS AND WITH MAX2COUNT: ", max2count, 'TIME PRINTED: ', time4xi())  
                    
                    ball2show = ball2xi.get()
                    dict2keys = ball2show.keys()
                    print("\n (STEP 27Y2/33) OF TEST_BALL4XI - KEYS2BALL: ", dict2keys)
                    # 
                    print("\n (STEP 27Y3/33) OF TEST_BALL4XI - SHOOTING SAMPLE OF : ", max2count, " SHOTS", "NUMBER OF LAYERS: ", count2layer, ' LATEST DISTANCE: ', d2shot, ' INTERVAL2DISTANCE: ', interval2distance)    
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    # 
                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                    count2plusx = 0
                    count2plusy = 0
                    count2plusz = 0
                           
                    count2minusx = 0
                    count2minusy = 0
                    count2minusz = 0
                    
                    count2accepted = 0
                    count2rejected = 0
                    
                    order2key = 1
                    for key2dict in sorted(dict2keys):
                        try:
                            index2x=str.find(key2dict,'x')                               
                            x2coordinate = int(key2dict[0:index2x])
                            # print("\n (STEP 15L11/33/33) OF TEST_BALL4XI - X2COORDINATE: ",  x2coordinate)
                            if x2coordinate >= 0:
                                count2plusx = count2plusx + 1
                            else:
                                count2minusx = count2minusx + 1    
                        except:
                            print("\n (STEP 27Y4/33) OF TEST_BALL4XI *** FAILED  WITH KEY2DICT: ", key2dict)
                            print("\n (STEP 27Y5/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            
                            
                        try:                                   
                            index2y=str.find(key2dict,'y')
                            y2coordinate = int(key2dict[index2x+1:index2y])
                            # print("\n (STEP 15L11/33) OF TEST_BALL4XI - Y2COORDINATE: ",  y2coordinate)
                            if y2coordinate >= 0:
                                count2plusy = count2plusy + 1
                            else:
                                count2minusy = count2minusy + 1  
                        except:
                            print("\n (STEP 27Y6/33) OF TEST_BALL4XI *** FAILED  WITH KEY2DICT: ", key2dict) 
                            print("\n (STEP 27Y7/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            print("\n (STEP 27Y8/33) OF TEST_BALL4XI - INDEX2Y: ", index2y)
                        
                        try:                                                                         
                            index2z=str.find(key2dict,'z') 
                            z2coordinate = int(key2dict[index2y+1:index2z])
                            # print("\n (STEP 27V/33) OF TEST_BALL4XI - Z2COORDINATE: ",  z2coordinate)
                            if z2coordinate >= 0:
                                count2plusz = count2plusz + 1
                            else:
                                count2minusz = count2minusz + 1
                        except:
                            print("\n (STEP 27Y9/33) OF TEST_BALL4XI *** FAILED  WITH KEY2DICT: ", key2dict)
                            print("\n (STEP 27Y10/33) OF TEST_BALL4XI - INDEX2X: ", index2x)
                            print("\n (STEP 27Y11/33) OF TEST_BALL4XI - INDEX2Y: ", index2y)
                            print("\n (STEP 27Y12/33) OF TEST_BALL4XI - INDEX2Z: ", index2z)
                        
                        ack2x = False    
                        if ((x2coordinate >= 0) and (sign2x == '+')):
                            ack2x = True
                        if ((x2coordinate <= 0) and (sign2x == '-')):
                            ack2x = True                        
                        
                        ack2y = False    
                        if ((y2coordinate >= 0) and (sign2y == '+')):
                            ack2y = True
                        if ((y2coordinate <= 0) and (sign2y == '-')):
                            ack2y = True     
                        
                        ack2z = False    
                        if ((z2coordinate >= 0) and (sign2z == '+')):
                            ack2z = True
                        if ((z2coordinate <= 0) and (sign2z == '-')):
                            ack2z = True     
                        
                        if ((ack2x is True) and (ack2y is True) and (ack2z is True)):
                            count2accepted = count2accepted + 1                                                                                                      
                            print("\n ACCEPTANCE: ", count2accepted, " SHOT: ", order2key, ":", key2dict, " EXPECTED SIGNS: (" , sign2x, ",", sign2y, ",", sign2z, ")") 
                            
                        else:
                            count2rejected = count2rejected + 1
                            # print("\n REJECTION: ", count2rejected, " SHOT ", order2key, ":", key2dict, " EXPECTED SIGNS: (" , sign2x, ",", sign2y, ",", sign2z, ")")   
                                                        
                        order2key = order2key +1 

                    count2tried = count2accepted + count2rejected 
                    
                    sum2plus = count2plusx + count2plusy+ count2plusz
                    sum2minus = count2minusx + count2minusy+ count2minusz
                    sum2total = count2plusx + count2minusx # same also with y and z - coordinate exists only once
                            
                    print('=' *80)
                    print("\n (STEP 27Y15/33) OF TEST_BALL4XI - STATISTICS FOR REQUIRED: ", max2count, " SHOTS")   
                    print("\n START TIME: ", time2start)
                    print("\n ACCEPTED: ", count2accepted, " = ", int(100*count2accepted/order2key), " %")
                    print("\n REJECTED: ", count2rejected, " = ", int(100*count2rejected/order2key), " %")
                   
                    print("\n DISTIBUTION OF X, Y AND Z: ") 
                    print("\n +X: ", count2plusx, " = ", int(100*count2plusx/sum2total), " %")
                    print("\n -X: ", count2minusx, " = ", int(100*count2minusx/sum2total), " %") 
                   
                    print("\n +Y: ", count2plusy, " = ", int(100*count2plusy/sum2total), " %")
                    print("\n -Y: ", count2minusy, " = ", int(100*count2minusy/sum2total), " %") 
                   
                    print("\n +Z: ", count2plusz, " = ", int(100*count2plusz/sum2total), " %")
                    print("\n -Z: ", count2minusz, " = ", int(100*count2minusz/sum2total), " %") 
                              
                    
                    print("\n SUM2TOTAL: ", sum2total, "SUCCESS-RATIO: ", int(100*count2accepted/max2count), " %", " COUNT2LAYER: ", count2layer)
                    print("\n START2DISTANCE: ", start2distance, " INTERVAL2DISTANCE: ", interval2distance, " MAX2LAYER: ", max2layer, " MAX2COUNT : ", max2count)
                    print("\n EXPECTED COORDINATE SIGNS: (X: "  , sign2x, ",Y", sign2y, ",Z", sign2z, ")") 
                    
                    print("\n REASONING: ")
                    if count2accepted >= omax2count:
                        print("\n OK SHOOTING: ACCEPTED SHOTS ", count2accepted, " >= ", omax2count, " ORIGINALLY REQUIRED, MARIGINAL: ", marginal2count)
                    else:
                        print("\n *** FAILED SHOOTING: ACCEPTED SHOT ONLY: ", count2accepted, " < ", omax2count, " REQUIRED !")                                    
                    
                    print("\n END TIME: ", time2end)
                    print('=' *80)

                    # ================================================================================
                    #  (STEP 27Y15/33) OF TEST_BALL4XI - STATISTICS FOR REQUIRED:  120  SHOTS
                    #  START TIME:  05:45:19 06/04/10 Pacific Daylight Time
                    #  ACCEPTED:  127  =  14  %
                    #  REJECTED:  725  =  84  %
                    #  DISTIBUTION OF X, Y AND Z: 
                    #  +X:  385  =  45  %
                    #  -X:  467  =  54  %
                    #  +Y:  404  =  47  %
                    #  -Y:  448  =  52  %
                    #  +Z:  421  =  49  %
                    #  -Z:  431  =  50  %
                    # 
                    #  SUM2TOTAL:  852 SUCCESS-RATIO:  105  %  COUNT2LAYER:  1
                    #  START2DISTANCE:  100  INTERVAL2DISTANCE:  100  MAX2LAYER:  120  MAX2COUNT :  120
                    #  EXPECTED COORDINATE SIGNS: (X:  + ,Y - ,Z - )
                    #  REASONING: 
                    #  OK SHOOTING: ACCEPTED SHOTS  127  >=  100  ORIGINALLY REQUIRED, MARIGINAL:  1.2
                    #  END TIME:  05:45:32 06/04/10 Pacific Daylight Time
                    # ================================================================================                    
                except:
                    # -------------------------------------------------------------------------------------    
                    #
                    # -------------------------------------------------------------------------------------     
                    print("\n (STEP 27Z/33) OF TEST_BALL4XI *** FAILED TO SHOOT (+X,-Y,-Z) - EAST, NORTH, BACKWARDS")

                print("\n (STEP 27Y/33) OF TEST_BALL4XI - END OF SMART SHOOTING ", time4xi())    
                 
                print("\n (STEP 28/33) OF TEST_BALL4XI - CONTINUING SMART SHOOTING WITH TUNED - 100 SHOTS TO 8 DIRECTIONS INTO SEVERAL LAYER ", time4xi())      
                try:    
                    # ---------------------------------------------------------------------------------------------
                    #                       
                    # ---------------------------------------------------------------------------------------------                                                               
                    
                    # ONE LAYER WITH ALL 8 SLOTS WITH SMART 100 SHOTS:
                                                           
                    # STEP 24: (+X,+Y,+Z) - EAST, SOUTH, TOWARDS    - EST
                    # STEP 27: (+X,-Y,-Z) - EAST, NORTH, BACKWARDS  - ENB 
                    # STEP 20: (+X,+Y,-Z) - EAST, SOUTH, BACKWARDS  - ESB
                    # STEP 21: (+X,-Y,+Z) - EAST, NORTH, TOWARDS    - ENT
                    
                    # STEP 25: (-X,+Y,+Z) - WEST, SOUTH, TOWARDS    - WST
                    # STEP 22: (-X,+Y,-Z) - WEST, SOUTH  BACKWARDS  - WSB
                    # STEP 23: (-X,-Y,+Z) - WEST, NORTH, TOWARDS    - WNT
                    # STEP 26: (-X,-Y,-Z) - WEST, NORTH, BACKWARDS  - WNB
    
                                                                                                                                                   
                    # ---------------------------------------------------------------------------------------------------
                    # FUNCTION SHOOT4XI - 8 LAYERS, EACH TO DIFFERENT SLOT WITH OWN DISTANCE                      
                    # ---------------------------------------------------------------------------------------------------  
                    print("\n (STEP 28A/33) OF TEST_BALL4XI - STARTING TO USE SHOOT4XI FUNCTION WITH PARAMETERS LEARNED IN PREVIOUS STEPS ")  
                    
                    # STEP 24: (+X,+Y,+Z) - EAST, SOUTH, TOWARDS    - EST
                    # find: (STEP 24O5A/33) OF TEST_BALL4XI - OK in test_ball4xi.txt
                    ball2est = shoot4xi(start2distance = 100,  interval2distance = 100, max2layer = 100, max2count = 200, marginal2count = 1.2, sign2x = '+', sign2y = '+', sign2z = '+',
                                           max2iterate = 4200, increase2distance = None, change2a = pi/60 , change2e = pi/60, increase2a = 0.01, increase2e = 0.01,
                                           start2plusa = 0.5759586531581287, max2plusa = 2*pi, min2plusa = pi/240, start2minusa = -pi/6 , max2minusa = -0.98*2*pi, min2minusa = -pi/240,
                                           start2pluse = 0.5335987755982988, max2pluse = pi, min2pluse = pi/240, start2minuse = -pi/6, max2minuse = -0.98*pi, min2minuse = -pi/240)
                       
                    print("\n (STEP 28B/33) (+X,+Y,+Z) - EAST, SOUTH, TOWARDS: ", ball2est) 
                    
                    # STEP 27: (+X,-Y,-Z) - EAST, NORTH, BACKWARDS  - ENB 
                    # find: (STEP 27M1/33) OF SHOOT4XI - OK  in test_ball4xi.txt
                    ball2enb = shoot4xi(start2distance = 100, interval2distance = 100, max2layer = 100, max2count = 200, marginal2count = 1.2, sign2x = '+', sign2y = '-', sign2z = '-',
                                           max2iterate = 4200, increase2distance = None, change2a = pi/60 , change2e = pi/60, increase2a = 0.01, increase2e = 0.01,
                                           start2plusa = 0.5759586531581287, max2plusa = 2*pi, min2plusa = pi/240, start2minusa = -pi/6 , max2minusa = -0.98*2*pi, min2minusa = -pi/240,
                                           start2pluse = 0.5335987755982988, max2pluse = pi, min2pluse = pi/240, start2minuse = -pi/6, max2minuse = -0.98*pi, min2minuse = -pi/240)                    
                    print("\n (STEP 28C/33) (+X,-Y,-Z) - EAST, NORTH, BACKWARDS  - ENB : ", ball2enb)
                    
                             
                    # STEP 20: (+X,+Y,-Z) - EAST, SOUTH, BACKWARDS  - ESB
                    # find: (STEP 20O5A/33) OF TEST_BALL4XI - OK in test_ball4xi.txt
                    ball2esb = shoot4xi(start2distance = 100, interval2distance = 100, max2layer = 100, max2count = 200, marginal2count = 1.2, sign2x = '+', sign2y = '+', sign2z = '-',
                                           max2iterate = 4200, increase2distance = None, change2a = pi/60 , change2e = pi/60, increase2a = 0.01, increase2e = 0.01,
                                           start2plusa = 0.5288347633542818, max2plusa = 2*pi, min2plusa = pi/240, start2minusa = -pi/6 , max2minusa = -0.98*2*pi, min2minusa = -pi/240,
                                           start2pluse = 1.6235987755982997, max2pluse = pi, min2pluse = pi/240, start2minuse = -pi/6, max2minuse = -0.98*pi, min2minuse = -pi/240)                    
                    print("\n (STEP 28D/33) (+X,+Y,-Z) - EAST, SOUTH, BACKWARDS  - ESB : ", ball2esb)
                             
                    # STEP 21: (+X,-Y,+Z) - EAST, NORTH, TOWARDS    - ENT
                    # find: (STEP 21O5A/33) OF TEST_BALL4XI - OK in test_ball4xi.txt
                    ball2ent = shoot4xi(start2distance = 100, interval2distance = 100, max2layer = 100, max2count = 200, marginal2count = 1.2, sign2x = '+', sign2y = '-', sign2z = '+',
                                           max2iterate = 4200, increase2distance = None, change2a = pi/60 , change2e = pi/60, increase2a = 0.01, increase2e = 0.01,
                                           start2plusa = 4.712388980384689, max2plusa = 2*pi, min2plusa = pi/240, start2minusa = -pi/6 , max2minusa = -0.98*2*pi, min2minusa = -pi/240,
                                           start2pluse = 1.3235987755982994, max2pluse = pi, min2pluse = pi/240, start2minuse = -pi/6, max2minuse = -0.98*pi, min2minuse = -pi/240)                    
                    print("\n (STEP 28E/33) (+X,-Y,+Z) - EAST, NORTH, TOWARDS    - ENT : ", ball2ent)
                    
                                 
                    # STEP 25: (-X,+Y,+Z) - WEST, SOUTH, TOWARDS    - WST
                    # find: (STEP 25O5A/33) OF TEST_BALL4XI - OK in test_ball4xi.txt
                    ball2wst = shoot4xi(start2distance = 100, interval2distance = 100, max2layer = 100, max2count = 200, marginal2count = 1.2, sign2x = '-', sign2y = '+', sign2z = '+',
                                           max2iterate = 4200, increase2distance = None, change2a = pi/60 , change2e = pi/60, increase2a = 0.01, increase2e = 0.01,
                                           start2plusa = 1.623156204354727, max2plusa = 2*pi, min2plusa = pi/240, start2minusa = -pi/6 , max2minusa = -0.98*2*pi, min2minusa = -pi/240,
                                           start2pluse = 0.733598775598299, max2pluse = pi, min2pluse = pi/240, start2minuse = -pi/6, max2minuse = -0.98*pi, min2minuse = -pi/240)                    
                    print("\n (STEP 28F/33) (-X,+Y,+Z) - WEST, SOUTH, TOWARDS    - WST: ", ball2wst)
                                
                    # STEP 22: (-X,+Y,-Z) - WEST, SOUTH  BACKWARDS  - WSB
                    # find: (STEP 22O5A/33) OF TEST_BALL4XI - OK in test_ball4xi.txt
                    ball2wsb = shoot4xi(start2distance = 100, interval2distance = 100, max2layer = 100, max2count = 200, marginal2count = 1.2, sign2x = '-', sign2y = '+', sign2z = '-',
                                           max2iterate = 4200, increase2distance = None, change2a = pi/60 , change2e = pi/60, increase2a = 0.01, increase2e = 0.01,
                                           start2plusa = 1.62839219211071, max2plusa = 2*pi, min2plusa = pi/240, start2minusa = -pi/6 , max2minusa = -0.98*2*pi, min2minusa = -pi/240,
                                           start2pluse = 1.8335987755982999, max2pluse = pi, min2pluse = pi/240, start2minuse = -pi/6, max2minuse = -0.98*pi, min2minuse = -pi/240)                    
                    print("\n (STEP 28G/33) (-X,+Y,-Z) - WEST, SOUTH  BACKWARDS  - WSB: ", ball2wsb)

                    
                    # STEP 23: (-X,-Y,+Z) - WEST, NORTH, TOWARDS    - WNT
                    # find: (STEP 23O5A/33) OF TEST_BALL4XI - OK in test_ball4xi.txt
                    ball2wnt = shoot4xi(start2distance = 100, interval2distance = 100, max2layer = 100, max2count = 200, marginal2count = 1.2, sign2x = '-', sign2y = '-', sign2z = '+',
                                           max2iterate = 4200, increase2distance = None, change2a = pi/60 , change2e = pi/60, increase2a = 0.01, increase2e = 0.01,
                                           start2plusa = 3.1939525311496206, max2plusa = 2*pi, min2plusa = pi/240, start2minusa = -pi/6 , max2minusa = -0.98*2*pi, min2minusa = -pi/240,
                                           start2pluse = 1.0335987755982992, max2pluse = pi, min2pluse = pi/240, start2minuse = -pi/6, max2minuse = -0.98*pi, min2minuse = -pi/240)                    
                    print("\n (STEP 28H/33) (-X,-Y,+Z) - WEST, NORTH, TOWARDS    - WNT: ", ball2wnt)
                    
                    # STEP 26: (-X,-Y,-Z) - WEST, NORTH, BACKWARDS  - WNB
                    # find: (STEP 26O5A/33) OF TEST_BALL4XI - OK in test_ball4xi.txt
                    ball2wnb = shoot4xi(start2distance = 100, interval2distance = 100, max2layer = 100, max2count = 200, marginal2count = 1.2, sign2x = '-', sign2y = '-', sign2z = '-',
                                           max2iterate = 4200, increase2distance = None, change2a = pi/60 , change2e = pi/60, increase2a = 0.01, increase2e = 0.01,
                                           start2plusa = 3.1991885189056037, max2plusa = 2*pi, min2plusa = pi/240, start2minusa = -pi/6 , max2minusa = -0.98*2*pi, min2minusa = -pi/240,
                                           start2pluse = 2.1335987755982972, max2pluse = pi, min2pluse = pi/240, start2minuse = -pi/6, max2minuse = -0.98*pi, min2minuse = -pi/240)                    
                    print("\n (STEP 28I/33) (-X,-Y,-Z) - WEST, NORTH, BACKWARDS  - WNB: ", ball2wnb)
                                
                    print("\n (STEP 28J/33) OF TEST_BALL4XI - COMPLETED SMART SHOOTING WITH TUNED - 100 SHOTS TO 8 DIRECTIONS INTO SEVERAL LAYER ", time4xi())      
                except:
                    # -------------------------------------------------------------------------------------    
                    #
                    # -------------------------------------------------------------------------------------     
                    print("\n (STEP 28Z/33) OF TEST_BALL4XI *** FAILED SHOOTING WITH SHOOT4XI FUNCTION ***") 
                                                                                        
            # -------------------------------------------------------------------------------------------------
            # MULTIPROCESSING TRIALS EXCEPTION                      
            # -------------------------------------------------------------------------------------------------                              
            except:
                print('~' *33)          
                print("(STEP 21/33) OF TEST_BALL4XI *** FAILED IN SOME MULTIPROCESSING TESTS ", time4xi()) 
                print('~' *33)
                                                                                  
            # ---------------------------------------------------------------------------------------------
            #                       
            # ---------------------------------------------------------------------------------------------                          
            print('~' *33)          
            print('(STEP 22/33) OF TEST_BALL4XI - ALL MULTIPROCESSING4XI TESTS TRIED ', time4xi()) 
            print('~' *33)  
            
        # ----------------------------------------------------------------------------------------------------
        #                       
        # ----------------------------------------------------------------------------------------------------               
        else:
           print('~' *33)          
           print('** (STEP 24/33) OF TEST_BALL4XI - SKIPPED MULTIPROCESSING TESTS ! ', time4xi()) 
           print('~' *33)

                          
        # ---------------------------------------------------------------------------------------------
        # END OF TESTS                          
        # ---------------------------------------------------------------------------------------------    
             
    # -------------------------------------------------------------------------------------------------    
    # 
    # -------------------------------------------------------------------------------------------------   
    except:
        print('~' *33)          
        print('(STEP 33/33z) OF TEST_BALL4XI *** ERRORS IN SOME TESTS *** ', time4xi()) 
        print('~' *33)
            
    # -------------------------------------------------------------------------------------------------    
    # 
    # -------------------------------------------------------------------------------------------------   
                                                               
    finally:        
            
        # ---------------------------------------------------------------------------------------------    
        # Print Trace
        # ---------------------------------------------------------------------------------------------     
        try:  
   
            print("(STEP 33A/33) OF TEST_BALL4XI: CALLING PRINT_TRACE4XI ", time4xi()) 
        
            print_trace4xi(t2xi)
                                      
            print("(STEP 33B/33) OF TEST_BALL4XI: PERFORMED PRINT_TRACE4XI ", time4xi())
                
        except:
            pass
       
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   main function for test_ball4xi
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def main():

    print('=' *33)
    print("SENSING IT WITH YOURDRAGONXI ", time4xi())  
    # 21:41:57 02/16/13 Pacific Standard Time
    print('=' *33)
        
    test_ball4xi()    
    
    print('=' *33)
    print("SENSED IT WITH YOURDRAGONXI ", time4xi())    
    # 21:49:06 02/16/13 Pacific Standard Time
    print('=' *33) 
                              
#</function4xi>
     

# -------------------------------------------------------------------------------------------------
# __main__                              
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()
    
#</program4xi>
 

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_ball4xi.txt
#   sense-test-test-ball4xi.xml
#   reason-test-test-ball4xi.xml
#   ace-test-test-ball4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of test_ball4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
